####################### [Firebook] - guestbook ################################
# always.pl		                                                              #
###############################################################################

use strict;
use warnings;
#use diagnostics;

package fb;

sub json_class {

	my $add_to_fi_string = $_[0] || "main";

	unless ($fb::loaded{'sub_json_class'}) {
		$fb::gl{'load_image'} = qq~<div id="loadImage" style="visibility: hidden; position: absolute; width:100px; height:100px; margin-top: -50px; margin-left: -50px; left: 50%; top: 50%; border: 10px solid grey; 	filter:alpha(opacity=50); -moz-opacity:0.5;	-khtml-opacity: 0.5; opacity: 0.5; background-color: #ffffff;">
				<img style="position: absolute; left: 50%; top: 50%; margin-top: -27px; margin-left: -27px; -moz-opacity:1.0;	-khtml-opacity: 1.0; opacity: 1.0; " src="$fb::fi{'bilderurlsk'}/allgemein/ajax-loader.gif" /></div>~;

		$fb::fi{$add_to_fi_string} .= qq~

		<script type="text/javascript">
			function JSONscriptRequest(fullUrl) {

				this.fullUrl = fullUrl; 
				this.noCacheIE = '&noCacheIE=' + (new Date()).getTime();
				this.headLoc = document.getElementsByTagName("head").item(0);
				this.scriptId = 'JscriptId' + JSONscriptRequest.scriptCounter++;
			}

			JSONscriptRequest.scriptCounter = 1;

			JSONscriptRequest.prototype.buildScriptTag = function () {

				this.scriptObj = document.createElement("script");
				
				this.scriptObj.setAttribute("type", "text/javascript");
				this.scriptObj.setAttribute("charset", "utf-8");
				this.scriptObj.setAttribute("src", this.fullUrl + this.noCacheIE);
				this.scriptObj.setAttribute("id", this.scriptId);
			}
			 
			JSONscriptRequest.prototype.removeScriptTag = function () {
				this.headLoc.removeChild(this.scriptObj);  
			}

			JSONscriptRequest.prototype.addScriptTag = function () {
				this.headLoc.appendChild(this.scriptObj);
			}
		</script>
		~;
		$fb::loaded{'sub_json_class'} = 1;
	}

}

sub fatal_error {
	
	my $e = $_[0];

	if (-e "$fb::cf{'ordnerdir'}/stop.lock") { &dounlink("$fb::cf{'ordnerdir'}/stop.lock"); }
	
	if ($fb::FORM{'file'}) { &clear_temp; }

		$fb::fi{'title'} = "$fb::txt{'gl'}{'35'}";
		$fb::fi{'main'} = "";
		
		$fb::inp{"m_backbutton"} = "[ <a href=\"javascript:history.go(-1)\">$fb::txt{'gl'}{'37'}</a> ]";
		$fb::inp{"m_errortext"} = $e;

		if ($fb::INFO{'errormessage'}) { 
			
			$fb::inp{"m_errortext"} = $fb::INFO{'errormessage'}; 
			if ($fb::cf{'htmlredir'} == 1) { $fb::inp{"m_backbutton"} = "[ <a href=\"javascript:history.go(-2)\">$fb::txt{'gl'}{'37'}</a> ]"; } 
			
		}
	
	
	if ($fb::gl{'save_error_data'}) {
			
			my $chop_action;
			
			# return action -> "message2" --> "message"
			$chop_action = $fb::gl{'action'};
			$chop_action =~ s/2//ig;
			
			my ($key,$secvalue,$writeErrorFile);

			while( ($key,$secvalue) = each(%fb::FORM) ) {
				$secvalue =~ s/\\/\\\\/g;
				$secvalue =~ s/~/\\~/ig;
				$secvalue =~ s/@/\\@/ig;
				$secvalue =~ s/"/\&quot;/g;
				$secvalue =~ s/</&lt;/g;
				$secvalue =~ s/>/&gt;/g;
				$secvalue =~ s/\$/\&\#36\;/g;
				$writeErrorFile .= qq~\$fb::FORM{'$key'} = qq\~$secvalue\~\;\n~;
			}
			my $currtime = time;
			unless (-e "$fb::gl{'datadir'}/errors/$currtime.dat") {
				if ($writeErrorFile) {
					&writefile("$fb::gl{'datadir'}/errors/$currtime.dat",$writeErrorFile . "\n1;\n");
					chmod (0666, "$fb::gl{'datadir'}/errors/$currtime.dat");
				}
			}

			unless ($fb::FORM{'ida'}) { $fb::FORM{'ida'} = ""; }
			
			$fb::inp{"m_backbutton"} = "[ <a href=\"$fb::gl{'scriptac2'}=$chop_action;load_error=$currtime;id=$fb::FORM{'ida'}\">$fb::txt{'gl'}{'37'}</a> ]";

			my @saved_errors = &opendirectory("$fb::gl{'datadir'}/errors");
			foreach my $saved_error (@saved_errors) {
				if ($saved_error =~ m/dat/) {
					my ($saved_time, $unw) = split(/\./, $saved_error);
					if (($saved_time+100) < time) {
						$saved_time =~ /^(\w+)$/;
						$saved_time = $1;
						unlink("$fb::gl{'datadir'}/errors/$saved_time.dat"); 
					}
				}
			}
			
			# we have an error for message size exceeding maximum - > no data can be saved!
			if ($fb::gl{'error_maxsize'}) {
				$fb::inp{"m_backbutton"} = "[ <a href=\"javascript:history.go(-1)\">$fb::txt{'gl'}{'37'}</a> ]";
			}

	}



	if ($fb::FORM{'inc'}) {
		$fb::inp{"m_errortext"} = convert_to_hex($fb::inp{"m_errortext"});
		my $set_location = "$fb::cf{'url_ssi'}?action=fatal_error;errormessage=$fb::inp{'m_errortext'}";
		&redirect($set_location);
	}

	$fb::fi{'main'} .= &doskin("template_fatalerror");
	
	# mod_comm hack
	if ($fb::gl{'popup_activate'}) { if ($fb::cf{'popup_act'} == 1) { &freetemp; } else { &template; } }
	elsif ($fb::gl{'popup_force'}) { &freetemp; }
	else { &template; }
	&database_disconnect;
	exit;
}
sub viewpages {

	my $start = $fb::INFO{'start'} || 0;
	&isadmin2;

	#@speicher = @fb::datainc;

	$fb::fi{'count'} = $fb::dbh->selectrow_array("SELECT COUNT(*) FROM $fb::cf{'db_prefix'}" . "datainc WHERE frei <> ?", undef, "1");

	my $maxindex_temp = $fb::cf{'maxindex'};

	#if ($fb::cf{'allp'} == 1) { $fb::cf{'maxindex'} = @speicher; }
	if (($fb::cf{'allp'} == 1) && ($fb::fi{'count'})) { $maxindex_temp = $fb::fi{'count'}; }


#	foreach $entra (@speicher) {
#		chomp $entra;
#		@entry = split(/\|/, $entra);
#		if ($entry[22] == 1) { 
#			if ($entry[16] == 1) { }
#			elsif (($fb::gl{'nocookie'} == 1) && ($entry[21] == 1)) { }
#			elsif (($fb::gl{'nocookie'} == 2) && ($entry[21] == 1)) { push(@sticky,$entrys[$count]); $fb::fi{'count'}++; }
#			else { push(@sticky,$entrys[$count]); $fb::fi{'count'}++; } 
#		}
#		else {
#			if ($entry[16] == 1) { }
#			elsif (($fb::gl{'nocookie'} == 1) && ($entry[21] == 1)) { }
#			elsif (($fb::gl{'nocookie'} == 2) && ($entry[21] == 1)) { push(@realentrys,$entrys[$count]); $fb::fi{'count'}++; }
#			else { push(@realentrys,$entrys[$count]); $fb::fi{'count'}++; } 
#		}
#		$count++;
#	}
	if( $start > $fb::fi{'count'} ) { $start = int( $fb::fi{'count'} % $maxindex_temp ) * $maxindex_temp; }
	elsif( $start < 0 ) { $start = 0; }
	my $indexdisplaynum = 5;
	my $tmpa = 1;
	my $tmpx = int( $fb::fi{'count'} / $maxindex_temp );

	my ($startpage, $endpage, $counter, $outerpn, $lastptn);
	$startpage = 0;
	$counter = 0;

	if ($start >= (($indexdisplaynum-1) * $maxindex_temp)) { $startpage = $start - (($indexdisplaynum-1) * $maxindex_temp); $tmpa = int( $startpage / $maxindex_temp ) + 1; }
	if ($fb::fi{'count'} >= $start + ($indexdisplaynum * $maxindex_temp)) { $endpage = $start + ($indexdisplaynum * $maxindex_temp); } else { $endpage = $fb::fi{'count'} }
	if ($startpage > 0) { $fb::fi{'pages'} = qq~<a href="$fb::gl{'scriptac'}=;start=0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $maxindex_temp) { $fb::fi{'pages'} = qq~<a href="$fb::gl{'scriptac'}=;start=0">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $maxindex_temp ) {
		$fb::fi{'pages'} .= $start == $counter ? qq~<B><U>$tmpa</u></B>&nbsp;~ : qq~<a href="$fb::gl{'scriptac'}=;start=$counter">$tmpa</a>&nbsp;~;
		++$tmpa;
	}

	my $pagecount;
	my $pagesadd = "";

	$tmpx = $fb::fi{'count'} - 1 - $maxindex_temp;
	$outerpn = int($tmpx / $maxindex_temp);
	$pagecount = int(($fb::fi{'count'} - 1) / $maxindex_temp) + 1;
	$lastptn = ($pagecount - 1) * $maxindex_temp;
	if ($endpage < $fb::fi{'count'} - $maxindex_temp ) {$pagesadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $fb::fi{'count'}) {$pagesadd .= qq~&nbsp;<a href="$fb::gl{'scriptac'}=;start=$lastptn">$pagecount</a>~;}
	
	$fb::fi{'pages'} .= $pagesadd;
	$fb::fi{'pagecount'} = $pagecount;

	$fb::gl{'start'} = $start;
	$fb::gl{'lastpage'} = $lastptn;
}
sub template {


	if ($fb::error{'db_error'}) {
		$fb::fi{'main'} = "<b><font color=red>" . $fb::txt{'gl'}{'642'} . ":</b><br>" . $fb::error{'db_error'} . $fb::fi{'main'};
	}	
		

	my $altorder = ($fb::cf{'verkehrt'}) ? "alt" : "neu";
	$fb::INFO{'order'} = ($fb::INFO{'order'}) ? $fb::INFO{'order'} : $altorder;
	$fb::INFO{'maxindex'} = $fb::INFO{'maxindex'} || "";
	$fb::INFO{'suche'} = $fb::INFO{'suche'} || "";

	$fb::fi{'version'} .= qq~<b>$fb::gl{'thisscriptcode'} $fb::gl{'thisversion'}</b>~;


	#my $date = &get_month.&get_day.&get_year;
	if (($fb::cf{'versioncheckdeact'} != 1) && $fb::gl{'logged_in'} && $fb::gl{'is_admin'} && ($fb::gl{'action'} eq "admin")) { 
		
		if ($fb::INFO{'saveversion'}) {
			# save version
			my $saveversion = $fb::INFO{'saveversion'};
			$fb::gl{'checked_lastversion'} = time . "|" . $saveversion;
			&write_extconfig('checked_lastversion',$fb::gl{'checked_lastversion'});
		}

		my ($time_checked, $version_checked);
		if ($fb::gl{'checked_lastversion'}) {
			($time_checked, $version_checked) = split(/\|/, $fb::gl{'checked_lastversion'});
		}
		
		# check for new version every 30 days
		if ((!$fb::gl{'checked_lastversion'}) || ((time - $time_checked) > (30*24*60*60))) {
			
			$fb::gl{'load_image'} = qq~<div id="loadImage" style="visibility: hidden; position: absolute; width:100px; height:100px; margin-top: -50px; margin-left: -50px; left: 50%; top: 50%; border: 10px solid grey; 	filter:alpha(opacity=50); -moz-opacity:0.5;	-khtml-opacity: 0.5; opacity: 0.5; background-color: #ffffff;">
		<img style="position: absolute; left: 50%; top: 50%; margin-top: -27px; margin-left: -27px; -moz-opacity:1.0;	-khtml-opacity: 1.0; opacity: 1.0; " src="$fb::fi{'bilderurlsk'}/allgemein/ajax-loader.gif" /></div>~;
			
			$fb::fi{'main'} .= $fb::gl{'load_image'};


		&json_class; # embedds json class into otherjava

		# load jason contents
		$fb::fi{'javaeffectsstart'} .= qq~
		<script type="text/javascript">
		 
			// callback function
			function write_version_contents(jsonData) {

				var version = jsonData.version;
				var follow_url = jsonData.followurl;

				if (version != "$fb::gl{'thisversion'}") {
					if (confirm("$fb::txt{'gl'}{'153'}")) {
						window.location.href=follow_url;
					}
					else {
						// forward internally to save new version code
						window.location.href= "$fb::gl{'scriptac'}=admin;saveversion="+version;
					}
					
				}
				else {
					// forward internally to save new version code
					window.location.href= "$fb::gl{'scriptac'}=admin;saveversion="+version;
				}			

				jsVersionObj.removeScriptTag();
			
			}

			var poststr = "";
			  
			poststr += "action=" + encodeURIComponent('check_version') + "&gb_url=" + encodeURIComponent('$fb::gl{'script'}') +  "&script=" + encodeURIComponent('$fb::gl{'thisscriptcode'}') + "&version=" + encodeURIComponent('$fb::gl{'thisversion'}');

			poststr += "&callback=" + encodeURIComponent('write_version_contents');
			  
			var req  = '$fb::gl{'serverurl'}?' + poststr; 

			// Create a new request object
			var jsVersionObj = new JSONscriptRequest(req); 
			jsVersionObj.buildScriptTag(); 
			jsVersionObj.addScriptTag();

		</script>
		~;	

			$fb::fi{'lastversion'} = "$fb::txt{'gl'}{'154'}";

		}
		else {
			$fb::fi{'lastversion'} = "<b>$fb::gl{'thisscriptcode'} $version_checked</b>";
		}
		
		
	}
	else { $fb::fi{'lastversion'} = qq~$fb::txt{'gl'}{'53'}~; }

	if ($fb::cf{'act_sprachw'}) {

		$fb::fi{'lang'} .= qq~<table border=0 cellspacing=0 cellpadding=0><form action="$fb::gl{'script'}" method="get" name="jump"><tr><td>~;
		$fb::fi{'lang'} .= qq~$fb::gl{'hiddenscro2'}<input type=hidden name=skin value="$fb::INFO{'skin'}"><input type=hidden name=maxindex value="$fb::INFO{'maxindex'}"><input type=hidden name=order value="$fb::INFO{'order'}">$fb::txt{'gl'}{'23'}: <select name="lang">~;
			
			my @contents = &opendirectory("$fb::gl{'datadir'}/language");
			@contents = sort{uc($a) cmp uc($b)} (@contents);
			foreach my $line (@contents){
				if ((-d "$fb::gl{'datadir'}/language/$line") && ($line ne ".") && ($line ne "..")) {
					
					my $selected = "";
					my ($urlprint,$tbilderurl);
					$tbilderurl = "";

					if ($line eq $fb::gl{'sprache2'}) { $selected = " selected" }
					if ($fb::gl{'skin'} eq "admin") { $urlprint = qq~$fb::gl{'scriptac2'}=admin;lang=$line;skin=$fb::INFO{'skin'}~; }
					else { $urlprint = qq~$fb::gl{'scriptac2'}=;maxindex=$fb::INFO{'maxindex'};order=$fb::INFO{'order'};lang=$line;skin=$fb::INFO{'skin'}~; }
					if (-e "$fb::cf{'bilderdir'}/skins/$fb::gl{'skin'}/lang/$line.gif") { $tbilderurl = qq~$fb::fi{'bilderurlsk'}/lang/$line.gif~; }
					elsif (-e "$fb::cf{'bilderdir'}/skins/$fb::gl{'skin'}/lang/$line.png") { $tbilderurl = qq~$fb::fi{'bilderurlsk'}/lang/$line.png~; }
					elsif (-e "$fb::cf{'bilderdir'}/skins/$fb::gl{'skin'}/lang/$line.jpeg") { $tbilderurl = qq~$fb::fi{'bilderurlsk'}/lang/$line.jpeg~; }
					elsif (-e "$fb::cf{'bilderdir'}/skins/$fb::gl{'skin'}/lang/$line.jpg") { $tbilderurl = qq~$fb::fi{'bilderurlsk'}/lang/$line.jpg~; }
					elsif (-e "$fb::cf{'bilderdir'}/skins/$fb::gl{'skin'}/lang/$line.bmp") { $tbilderurl = qq~$fb::fi{'bilderurlsk'}/lang/$line.bmp~; }
					
					$fb::fi{'lang'} .= qq~<option value=\"$line\"$selected>$line</option>\n~; 
					unless ($tbilderurl) {
						$fb::fi{'langbutt'} .= qq~&nbsp; [ <a href="$urlprint">$line</a> ] &nbsp;~;
					} else {
						$fb::fi{'langbutt'} .= qq~<a href="$urlprint"><img border=0 src="$tbilderurl" alt="$line" title="$line"></a> ~;
					}
				}
			}

			$fb::fi{'lang'} .= qq~</select><input type="submit" value="$fb::txt{'gl'}{'65'}"></td></tr></form></table>~;

	}

	if (($fb::cf{'logolink'} eq "") && ($fb::cf{'logourl'} ne "")) { $fb::fi{'logo'} = "<img border=0 src='$fb::cf{'logourl'}'>"; }
	elsif (($fb::cf{'logolink'} ne "") && ($fb::cf{'logourl'} ne "")) { $fb::fi{'logo'} = "<a href='$fb::cf{'logolink'}' target='_blank'><img border=0 src='$fb::cf{'logourl'}'></a>"; }
	elsif (($fb::cf{'logolink'} ne "") && ($fb::cf{'logourl'} eq "")) { $fb::fi{'logo'} = "<a href='$fb::cf{'logolink'}' target='_blank'>$fb::cf{'logolink'}</a>"; }
	else { $fb::fi{'logo'} = ""; }

	if ($fb::cf{'wartung'} != 1) {

	if ($fb::loaded{'sub_timelastvisit'}) {
		my $currtime = time();
		
		push(@{$fb::gl{'cookies'}},"fbtimelastvisit=$currtime; expires=$fb::gl{'expires'};");
	}
	
	# Bewertungstext
	my $bewalt;

	if ($fb::cf{'f_bewertung'} == 1) {
	
#	@speicher = @fb::datainc;
#	$beweg = 0;
#	$countminus = 0;
#	$counta = @speicher;
#
#	foreach $entry (@speicher) {
#			chomp $entry;
#			($u1, $u2, $u3, $u4, $u5, $u6, $u7, $u8, $u9, $u10, $u11, $u12, $u13, $bewee, $u14) = split(/\|/, $entry);
#			$editentries[$countedit] = $u1;
#			$countedit++;
#			($bewef, $u1) = split(/\./, $bewee);
#			if ($bewee != 0) {	$beweg = $beweg + $bewee; }
#			else { $countminus++; }
#	}
#
#
#	$counta = $counta - $countminus;
#	if ($counta != 0) { $beweh = $beweg / $counta; }
#	else { $beweh = "0.0"; }	
#	$beweh = substr($beweh, 0, 3);
#
#	$fb::fi{'middlerate'} = $beweh;

		my $beweh =  $fb::dbh->selectrow_array("SELECT AVG(bewertung) FROM $fb::cf{'db_prefix'}" . "datainc WHERE bewertung <> 0 AND bewertung IS NOT NULL", undef);
		$beweh = ($beweh) ? substr($beweh, 0, 3) : "0.0";
		$fb::fi{'middlerate'} = $beweh;
		
		my($nr1,$nr2,$showgif);

		($nr1, $nr2) = split(/\./, $beweh);
		if (($beweh >= 1) && ($beweh < 1.5)) { $bewalt = qq~$fb::txt{'gl'}{'58'}~; }
		elsif (($beweh >= 1.5) && ($beweh < 2.5)) { $bewalt = qq~$fb::txt{'gl'}{'57'}~;  }
		elsif (($beweh >= 2.5) && ($beweh < 3.5)) { $bewalt = qq~$fb::txt{'gl'}{'56'}~; }
		elsif (($beweh >= 3.5) && ($beweh < 4.5)) { $bewalt = qq~$fb::txt{'gl'}{'55'}~;  }
		elsif (($beweh >= 4.5) && ($beweh <= 5)) { $bewalt = qq~$fb::txt{'gl'}{'54'}~;  }
		else { $bewalt = qq~$fb::txt{'gl'}{'59'}~; $showgif = "none"; }
		for (my $ia = 1; $ia <= $nr1; ++$ia){
			$fb::fi{'rating'} .= qq~<img src="$fb::fi{'bilderurlsk'}/bewertung/full.gif" valign=middle border=0 alt="$bewalt" title="$bewalt">~;
		}
		if ($nr2 >= 5) {
			$fb::fi{'rating'} .= qq~<img src="$fb::fi{'bilderurlsk'}/bewertung/half.gif" valign=middle border=0 alt="$bewalt" title="$bewalt">~;
			$nr1++;
		}
		for (my $ia = $nr1; $ia <= 4; ++$ia){
			$fb::fi{'rating'} .= qq~<img src="$fb::fi{'bilderurlsk'}/bewertung/empty.gif" valign=middle border=0 alt="$bewalt" title="$bewalt">~;
		}
		
	}
	else { $fb::fi{'rating'} .= qq~<img src="$fb::fi{'bilderurlsk'}/bewertung/0.gif" valign=middle border=0 alt="$fb::txt{'gl'}{'59'}" title="$fb::txt{'gl'}{'59'}">~; }
	
	$fb::fi{'rating'} .= qq~ <font style="font-size: 9px; vertical-align: middle; text-transform: uppercase;">$bewalt</font>~;
	

	$fb::fi{'printinfo'} = qq~<a href="$fb::gl{'scriptac2'}=;lang=$fb::gl{'sprache2'};skin=$fb::cf{'skinchosen'}">$fb::txt{'gl'}{'137'}</a>~;
	
	my ($neuc, $altc);
	
	if ($fb::INFO{'order'} eq "neu") { $neuc = " selected"; $altc = "";	}
	elsif ($fb::INFO{'order'} eq "alt") { $altc = " selected"; $neuc = "";	}

	my @getnpages = split(/\,/, $fb::cf{'getnpages'});
	if (($fb::gl{'action'} ne "message") && ($fb::gl{'hiddenscro'})) {
		$fb::fi{'jump'} .= qq~<table border=0 cellspacing=0 cellpadding=0><form action="$fb::gl{'script'}" method="get" name="jump"><tr><td><b>$fb::txt{'gl'}{'60'} &nbsp;</b></td><td>~;
		$fb::fi{'jump'} .= qq~<select name="maxindex">~;
			foreach my $nr (@getnpages) {
				my $sel;
				if ($fb::INFO{'maxindex'} && $nr eq "$fb::INFO{'maxindex'}") { $sel = " selected"; }
				else { $sel = ""; }
				$fb::fi{'jump'} .= qq~<option value="$nr"$sel>$nr\n~;
			}
	$fb::fi{'jump'} .= qq~</select></td><td><b>&nbsp; $fb::txt{'gl'}{'61'}, &nbsp;</b></td><td><select name="order">
			<option value="neu"$neuc>$fb::txt{'gl'}{'62'}</option>
			<option value="alt"$altc>$fb::txt{'gl'}{'63'}</option>
			</select></td> <td><b>&nbsp;$fb::txt{'gl'}{'64'}&nbsp;</b></td><td> $fb::gl{'hiddenscro'} <input type="submit" value="$fb::txt{'gl'}{'65'}"> </td><td>~;
				$fb::fi{'jump'} .= qq~</tr></form></table>~;
	}
	else {
	 $fb::fi{'jump'} = $fb::fi{'showentrys'};
	}

my $skinselect;

my @contents = &opendirectory("$fb::gl{'datadir'}/skins");
@contents = sort{uc($a) cmp uc($b)} (@contents);
foreach my $line (@contents){
	if ((-d "$fb::gl{'datadir'}/skins/$line") && (($line ne ".") && ($line ne ".."))){
		my $selected = "";
		if ($line eq "admin") { next; }
		if ($line eq $fb::gl{'skin'}) { $selected = " selected";	}
		$skinselect .= qq~<option value=\"$line\"$selected>$line</option>\n~;
	}
}



$fb::fi{'skinbox'} = qq~<table border=0 cellspacing=0 cellpadding=2>
	<form action="$fb::gl{'script'}" method="get" name="jump"><tr><td>
$fb::gl{'hiddenscro2'}
<input type=hidden name=maxindex value="$fb::INFO{'maxindex'}"><input type=hidden name=order value="$fb::INFO{'order'}"><select name="skin">$skinselect</select></td><td><input type="submit" value="$fb::txt{'gl'}{'65'}"></td></tr></form></table>~;



	if ($fb::gl{'hiddenscro'}) {
		$fb::fi{'searchform'} = qq~<table border=0 cellspacing=0 cellpadding=2 width=100%>
			<form action="$fb::gl{'script'}" method="get" name="jump"><tr><td width=100%>
		$fb::gl{'hiddenscro'}<input type=hidden name=maxindex value="$fb::INFO{'maxindex'}"><input type=hidden name=order value="$fb::INFO{'order'}"><input STYLE="width:100%;" type=text name=suche value="$fb::INFO{'suche'}"></td><td><input type="submit" value="$fb::txt{'gl'}{'65'}"></td></tr></form></table>~;
	}
	my $start = $fb::gl{'start'} || "0";
	my $lastptn = $fb::gl{'lastpage'} || "0";

	if ($start == 0) { $fb::fi{'prevpage'} = "$fb::txt{'gl'}{'68'}"; }
	elsif ($fb::fi{'pagecount'} > 1) { my $pageprevious = $start - $fb::cf{'maxindex'}; $fb::fi{'prevpage'} = qq~<a href="$fb::gl{'scriptac'}=;start=$pageprevious">$fb::txt{'gl'}{'67'}</a>~; }
	if ($start == $lastptn) { $fb::fi{'nextpage'} = "$fb::txt{'gl'}{'69'}"; }
	elsif ($fb::fi{'pagecount'} > 1) { my $pagenext = $start + $fb::cf{'maxindex'}; $fb::fi{'nextpage'} = qq~<a href="$fb::gl{'scriptac'}=;start=$pagenext">$fb::txt{'gl'}{'66'}</a>~; }
	else { $fb::fi{'nextpage'} = qq~$fb::txt{'gl'}{'70'} $fb::txt{'gl'}{'66'}~; }
	if (!$fb::fi{'count'}) { $fb::fi{'count'} = "0"; }	


}




	#$fb::inp{"m_setlocation"};

	my $output = &formattemplate("template");

	if ($fb::gl{'noRedirectReplace'}) { $fb::INFO{'inc'} = ""; $fb::FORM{'inc'} = "";	}
	if (($fb::INFO{'inc'}) || ($fb::FORM{'inc'})) { 

		my $inctype = $fb::INFO{'inc'} || $fb::INFO{'inc'};
		
		unless ($fb::cf{'url_ssi'}) { $fb::cf{'url_ssi'} = "http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}"; }
	
		my @ssitemplate = split(/\n/, $output);
		
		$output = "";
		foreach my $line (@ssitemplate) {
				if (($line =~ m/<form(.*?)method="get"(.*?)>/i)) {
				$line =~ s/<form(.*?)method="get"(.*?)>/<form$1 method="get"$2><input type=hidden name=inc value=$inctype>/ig;
			}
			if (($line =~ m/<form(.*?)method="post"(.*?)>/i)) {
				my $er1 = $1;
				my $er2 = $2;
				$line =~ s/<form(.*?) method="post"(.*?)>/%formwhere%/ig;
				if ($fb::cf{'url_ssi'} =~ m/\?/) {
					$line =~ s/\=(\"|\'|)$fb::gl{'script'}\?/\=$1$fb::cf{'url_ssi'}\;inc=$inctype\;/ig;
					$line =~ s/\=(\"|\'|)$fb::gl{'script'}/\=$1$fb::cf{'url_ssi'}\;inc=$inctype/ig;
				}
				else {
					$line =~ s/\=(\"|\'|)$fb::gl{'script'}\?/\=$1$fb::cf{'url_ssi'}\?inc=$inctype\;/ig;
					$line =~ s/\=(\"|\'|)$fb::gl{'script'}/\=$1$fb::cf{'url_ssi'}\?inc=$inctype/ig;					
				}
				$line =~ s/%formwhere%/<form$er1 method="post"$er2><input type=hidden name=inc value=$inctype>/ig;
			}
			else {
				unless ($line =~ m/action\=validate/ig) {
					if ($fb::cf{'url_ssi'} =~ m/\?/) {
					$line =~ s/\=(\"|\'|)$fb::gl{'script'}\?/\=$1$fb::cf{'url_ssi'}\;inc=$inctype\;/ig;
					$line =~ s/\=(\"|\'|)$fb::gl{'script'}/\=$fb::cf{'url_ssi'}\;inc=$inctype/ig;
					}
					else {
					$line =~ s/\=(\"|\'|)$fb::gl{'script'}\?/\=$1$fb::cf{'url_ssi'}\?inc=$inctype\;/ig;
					$line =~ s/\=(\"|\'|)$fb::gl{'script'}/\=$1$fb::cf{'url_ssi'}\?inc=$inctype/ig;
					}
				}
			}
			$output .= qq~$line\n ~;
		}
		$fb::cf{'gzcomp'} = 0;
	}
	
	my $gzaccept;

	if ($ENV{'HTTP_ACCEPT_ENCODING'} && $ENV{'HTTP_ACCEPT_ENCODING'}=~/\bgzip\b/) { $gzaccept = 1;	}	
	else { $gzaccept = 0; }

	if ($fb::cf{'gzcomp'} && $gzaccept) {
	  if(defined(@{$fb::gl{'cookies'}})) { print header(-status=>"200 OK", -charset=>$fb::cf{'charset'}, -cookies=>\@{$fb::gl{'cookies'}}, 'Content-Encoding' => 'gzip'); }
	  else { print header(-status=>'200 OK', -charset=>$fb::cf{'charset'}, 'Content-Encoding' => 'gzip'); }
	} 
	else { 
	if(defined(@{$fb::gl{'cookies'}})) { print header(-status=>"200 OK", -cookies=>\@{$fb::gl{'cookies'}}, -charset=>$fb::cf{'charset'}); }
	else { print header(-status=>"200 OK", -charset=>$fb::cf{'charset'}); }
	}

	
	if ($fb::cf{'gzcomp'} && $gzaccept) {
		if ($fb::cf{'gzcomp'}==1) {
			$| = 1; 
			open(GZIP, "| gzip -f");
			print GZIP $output;
			close(GZIP);
		} elsif ($fb::cf{'gzcomp'}==2)  {
			
			my $zipinchere = 0;
			foreach $_ (@INC) {
				if (-e "$_/Compress/Zlib.pm") { $zipinchere = 1;	}
			}
			if ($zipinchere == 1) { 
				require Compress::Zlib;
				binmode STDOUT;
				print Compress::Zlib::memGzip($output);
			}
			else { print $output; }
		}
	} 
	else { print $output; }
&database_disconnect;
exit;
}


sub refcheck 
{
	
	# we don't do referer checks for module interface actions
	if (($fb::gl{'action'} ne "interf_modules") && ($fb::cf{'refon'} == 1)) {
		
		my ($referencedomain2);

		if ($fb::INFO{'inc'}) { $referencedomain2 = substr ($fb::cf{'url_ssi'},7,(index($fb::cf{'url_ssi'},"/",7))-7);	}
		
		my $referencedomain = substr ($fb::cf{'ordnerurl'},7,(index($fb::cf{'ordnerurl'},"/",7))-7);
		my $refererdomain = "";
		if ($ENV{HTTP_REFERER}) { $refererdomain = substr ($ENV{HTTP_REFERER},7,(index($ENV{HTTP_REFERER},"/",7))-7); }
		
		if ($referencedomain2) {
				if(($refererdomain !~ /$referencedomain2/i) && ($ENV{QUERY_STRING} ne "") && (length($refererdomain) > 0)){
						&fatal_error("$fb::txt{'gl'}{'144'}");
				}
		}
		else { 
			if(($refererdomain !~ /$referencedomain/i) && ($ENV{QUERY_STRING} ne "") && (length($refererdomain) > 0)){
					&fatal_error("$fb::txt{'gl'}{'144'}");
			}
		}

	}
}

sub VNFileLoad {
     	my $fname = shift;
     	my $file;
     	$fname =~ s/([\&;\`'\|\"*\?\~\^\(\)\[\]\{\}\$\n\r])//g;
     	open(FILE, $fname) || return '[an error occured while processing this directive]';
     	my @file = <FILE>;
     	close(FILE);
     	$file = join('', @file);
     	return $file;
}  
sub redirect {

#if ($db_error) { die($db_error);}

my $set_location = $_[0];

# open popup template instead
my $poptemplate = $_[1] || "0";

	if ($fb::cf{'htmlredir'} == 1) {
		
		$fb::fi{'title'} = "$fb::txt{'gl'}{'42'}";
		$set_location =~ s/ /%20/g;
		$fb::inp{"m_setlocation"} = $set_location;
			
		$fb::fi{'main'} .= &doskin("template_redirect");

		 if ($poptemplate == 1) { 
			$fb::fi{'title'} = "$fb::txt{'gl'}{'42'}";
			&freetemp;
			exit;
		 }
		 else {
			&template;
			exit;
		 }
	}
	else {

		if (($fb::INFO{'inc'}) || ($fb::FORM{'inc'})) { 

			my $inctype = $fb::INFO{'inc'} || $fb::INFO{'inc'};

				if ($fb::cf{'url_ssi'} =~ m/\?/) {
					$set_location =~ s/$fb::gl{'script'}\?/$fb::cf{'url_ssi'}\;inc=$inctype\;/ig;
					$set_location =~ s/$fb::gl{'script'}/$fb::cf{'url_ssi'}\;inc=$inctype/ig;
				}
				else {
					$set_location =~ s/$fb::gl{'script'}\?/$fb::cf{'url_ssi'}\?inc=$inctype\;/ig;
					$set_location =~ s/$fb::gl{'script'}/$fb::cf{'url_ssi'}\?inc=$inctype/ig;
				}
		}


		if(defined(@{$fb::gl{'cookies'}})) {
			print header(
				-status=>'302 Moved Temporarily',
				-cookies=>\@{$fb::gl{'cookies'}},
				-location=>$set_location
			); 
		} else { 
			print header(
				-status=>'302 Moved Temporarily',
				-location=>$set_location
			);
		}
		&database_disconnect;
		exit;
	}
}
sub wandleum {
	
	## reference to actual string to be edited
	my $reference = $_[0];

	while (${$reference} =~ m~\<FIRE IF(.*?)\>~i) {
		my$ifcount = $1;
		
		${$reference} =~ m~\<FIRE IF$ifcount\>(.*?)\<\/FIRE IF$ifcount\>~sgi;
		my $var = $1;
		${$reference} =~ s~\<FIRE IF$ifcount\>(.*?)\<\/FIRE IF$ifcount\>~~sgi;

		if ($var =~ "VAR") {
			$var =~ m~\<VAR (.*?)\>~sgi;
			my $newvar = $1;
			$var =~ s~\<VAR (.*?)\>~~sgi;
			my @fullnewvars = "";
			if ($newvar =~ m/\+/i) { @fullnewvars = split(/\+/, $newvar);  }
			else { $fullnewvars[0] = $newvar; }
			
			my $thisyes = 1;

			foreach $_ (@fullnewvars) {
				my ($qualifier, @qual_name) = split(/\_/, $_);
				my $qual_name = join('_',@qual_name);
				
				if ($qualifier eq "conf") {
					unless ($fb::cf{$qual_name}) { $thisyes = 0; }
				}
				elsif ($qualifier eq "fbinput") {
					unless ($fb::inp{"m_".$qual_name}) { $thisyes = 0; }
				}
				elsif ($qualifier eq "fi") {
					unless ($fb::fi{$qual_name}) { $thisyes = 0; }
				}
				#$print_test =" $qualifier $qual_name $thisyes";
			}
			#die($print_test);
			if ($thisyes) {
				${$reference} =~ s~\<FIRE DO$ifcount\>(.*?)\<\/FIRE DO$ifcount\>~$1~sgi;
				${$reference} =~ s~\<FIRE ELSE$ifcount\>(.*?)\<\/FIRE ELSE$ifcount\>~~sgi;
			}
			else {
				${$reference} =~ s~\<FIRE DO$ifcount\>(.*?)\<\/FIRE DO$ifcount\>~~sgi;
				${$reference} =~ s~\<FIRE ELSE$ifcount\>(.*?)\<\/FIRE ELSE$ifcount\>~$1~sgi;
			}

		}
	}


}
sub formattemplate {

	my ($opentemplate) = $_[0];

	if ($fb::cf{'astats'} == 1) {
		
		my $stat_is_admin = 0;
		if ($fb::gl{'skin'} eq "admin") { $stat_is_admin = 1; 	}
		
		$fb::dbh->do("INSERT INTO $fb::cf{'db_prefix'}" . "stats_detail (ip, time, admin) VALUES(?, ?, ?)", undef, $fb::gl{'user_ip'}, time, $stat_is_admin);
	}

	my @template = &openfile("$fb::gl{'datadir'}/skins/$fb::gl{'skin'}/$opentemplate.html");

	## replace css with preview css
	if ($fb::INFO{'preview'}) {
		my $newcss = join('', &openfile("$fb::gl{'datadir'}/styles/preview.html"));
		$fb::fi{'css'} = $newcss;
	}
	else {
		unless ($fb::fi{'css'}) {
			$fb::fi{'css'} = join('', &openfile("$fb::gl{'datadir'}/skins/$fb::gl{'skin'}/style.css"));
		}
	}


#	my @schluesseleff = keys %{$fb::gl{'effectsstartadd'}};
#
#	foreach (@schluesseleff) {
#		$fb::fi{'javaeffectsstart'} .= $fb::gl{'effectsstartadd'}{$_};
#	}

	foreach (@template){
		$_ =~ s/\<include file\=\"(.+?)\"\>/${\(VNFileLoad($1))}/gi;
	} 
	my $template = join('', @template);


	## possibility to define extra tags in additonal modules -> quick reply box

	if ($fb::mod{'action_modules'}{'formattemplate'}) {
		foreach my $mod (@{$fb::mod{'action_modules'}{'formattemplate'}}) {
			if ($fb::mod{'modules_info'}{$mod->[0]}[0]) {
				unless ($fb::loaded{$mod->[1]}) {
					require "$fb::gl{'subsdir'}/$mod->[1].pl";
					$fb::loaded{$mod->[1]} = 1;
				}
				my $check = $mod->[2]->($template);
			}
		}
	}																																																															my($OOO,$OO00O);if(length($fb::cf{"\x6c\x69\x63\x65\x6e\x63\x65"})>4){use Crypt::PasswdMD5("\x75\x6e\x69\x78\x5f\x6d\x64\x35\x5f\x63\x72\x79\x70\x74");my $OOO0=$fb::cf{"\x6c\x69\x63\x65\x6e\x63\x65"};my $OOOO="";my $OOOOO="";for(my $OO00OO=0;$OO00OO<length($OOO0);$OO00OO++){$OOOO .=substr($OOO0,$OO00OO,1);if($OO00OO<=20){$OO00OO++;$OOOOO .=substr($OOO0,$OO00OO,1);}}my $OO00=substr($OOOO,length($OOOO)-7,7);$OO00O=substr($OOOO,0,length($OOOO)-7);$OOO=unix_md5_crypt($fb::gl{"\x73\x63\x72\x69\x70\x74"},$OO00);$OOO=substr($OOO,11,length($OOO));}if((!$OOO)||($OOO ne $OO00O)){$fb::fi{"\x6d\x61\x69\x6e"}.="\x3c\x62\x72\x3e\x3c\x74\x61\x62\x6c\x65\x20\x77\x69\x64\x74\x68\x3d\x27\x39\x30\x25\x27\x20\x62\x6f\x72\x64\x65\x72\x3d\x30\x20\x63\x65\x6c\x6c\x73\x70\x61\x63\x69\x6e\x67\x3d\x31\x20\x63\x65\x6c\x6c\x70\x61\x64\x64\x69\x6e\x67\x3d\x31\x20\x63\x6c\x61\x73\x73\x3d\x66\x62\x62\x6f\x72\x64\x65\x72\x20\x61\x6c\x69\x67\x6e\x3d\x63\x65\x6e\x74\x65\x72\x3e";$fb::fi{"\x6d\x61\x69\x6e"}.="\x3c\x74\x72\x3e\x3c\x74\x64\x20\x61\x6c\x69\x67\x6e\x3d\x63\x65\x6e\x74\x65\x72\x20\x63\x6c\x61\x73\x73\x3d\x66\x62\x32\x3e\x3c\x66\x6f\x6e\x74\x20\x73\x69\x7a\x65\x3d\x31\x3e\x26\x63\x6f\x70\x79\x20\x32\x30\x30\x32\x2d\x32\x30\x30\x39\x20\x46\x69\x72\x65\x62\x6f\x6f\x6b\x20\x26\x6d\x69\x64\x64\x6f\x74\x3b\x20\x61\x6c\x6c\x20\x72\x69\x67\x68\x74\x73\x20\x72\x65\x73\x65\x72\x76\x65\x64\x2e\x3c\x62\x72\x3e";if($fb::gl{"\x73\x70\x72\x61\x63\x68\x65\x32"}eq "\x64\x65\x75\x74\x73\x63\x68"){$fb::fi{"\x6d\x61\x69\x6e"}.="\x3c\x61\x20\x68\x72\x65\x66\x3d\x27\x68\x74\x74\x70\x3a\x2f\x2f\x77\x77\x77\x2e\x66\x69\x72\x65\x62\x6f\x6f\x6b\x2e\x64\x65\x27\x20\x74\x61\x72\x67\x65\x74\x3d\x27\x5f\x62\x6c\x61\x6e\x6b\x27\x3e\x46\x69\x72\x65\x62\x6f\x6f\x6b\x20\x47\xe4\x73\x74\x65\x62\x75\x63\x68\x3c\x2f\x61\x3e\x20\x7c\x20\x3c\x61\x20\x68\x72\x65\x66\x3d\x27\x68\x74\x74\x70\x3a\x2f\x2f\x77\x77\x77\x2e\x66\x69\x72\x65\x62\x6f\x6f\x6b\x2e\x64\x65\x27\x20\x74\x61\x72\x67\x65\x74\x3d\x27\x5f\x62\x6c\x61\x6e\x6b\x27\x3e\x6b\x6f\x73\x74\x65\x6e\x6c\x6f\x73\x65\x73\x20\x47\xe4\x73\x74\x65\x62\x75\x63\x68\x20\x7a\x75\x6d\x20\x44\x6f\x77\x6e\x6c\x6f\x61\x64\x65\x6e\x3c\x2f\x61\x3e";}else{$fb::fi{"\x6d\x61\x69\x6e"}.="\x3c\x61\x20\x68\x72\x65\x66\x3d\x27\x68\x74\x74\x70\x3a\x2f\x2f\x77\x77\x77\x2e\x66\x69\x72\x65\x62\x6f\x6f\x6b\x2e\x64\x65\x27\x20\x74\x61\x72\x67\x65\x74\x3d\x27\x5f\x62\x6c\x61\x6e\x6b\x27\x3e\x46\x69\x72\x65\x62\x6f\x6f\x6b\x20\x47\x75\x65\x73\x74\x62\x6f\x6f\x6b\x3c\x2f\x61\x3e\x20\x7c\x20\x3c\x61\x20\x68\x72\x65\x66\x3d\x27\x68\x74\x74\x70\x3a\x2f\x2f\x77\x77\x77\x2e\x66\x69\x72\x65\x62\x6f\x6f\x6b\x2e\x64\x65\x27\x20\x74\x61\x72\x67\x65\x74\x3d\x27\x5f\x62\x6c\x61\x6e\x6b\x27\x3e\x66\x72\x65\x65\x20\x67\x75\x65\x73\x74\x62\x6f\x6f\x6b\x20\x64\x6f\x77\x6e\x6c\x6f\x61\x64\x3c\x2f\x61\x3e";}$fb::fi{"\x6d\x61\x69\x6e"}.="\x3c\x2f\x66\x6f\x6e\x74\x3e\x3c\x2f\x74\x64\x3e\x3c\x2f\x74\x72\x3e\x3c\x2f\x74\x61\x62\x6c\x65\x3e\x3c\x62\x72\x3e\x26\x6e\x62\x73\x70\x3b";$template=~ s~\x3c\x2f\x74\x69\x74\x6c\x65\x3e~\x20\x28\x70\x6f\x77\x65\x72\x65\x64\x20\x62\x79\x20\x66\x69\x72\x65\x62\x6f\x6f\x6b\x5b\x2e\x64\x65\x5d\x20\x67\x75\x65\x73\x74\x62\x6f\x6f\x6b\x29\x3c\x2f\x74\x69\x74\x6c\x65\x3e~ig;}

		
																																																																																																																																																									if(($fb::mod{"\x70\x72\x65"}&&($fb::mod{"\x70\x72\x65"}>0))||(!defined($fb::mod{"\x70\x72\x65"}))){my $OO="\x3c\x62\x72\x3e\x3c\x74\x61\x62\x6c\x65\x20\x62\x6f\x72\x64\x65\x72\x3d\x30\x20\x69\x64\x3d\x22\x66\x62\x61\x64\x73\x74\x61\x62\x6c\x65\x22\x20\x63\x65\x6c\x6c\x73\x70\x61\x63\x69\x6e\x67\x3d\x31\x20\x63\x65\x6c\x6c\x70\x61\x64\x64\x69\x6e\x67\x3d\x30\x20\x61\x6c\x69\x67\x6e\x3d\x63\x65\x6e\x74\x65\x72\x20\x77\x69\x64\x74\x68\x3d\x22\x31\x30\x30\x25\x22\x20\x63\x6c\x61\x73\x73\x3d\x22\x66\x62\x62\x6f\x72\x64\x65\x72\x22\x3e\x0d\x0a\x09\x09\x09\x3c\x74\x72\x3e\x3c\x74\x64\x20\x69\x64\x3d\x22\x66\x62\x61\x64\x73\x74\x64\x22\x20\x63\x6c\x61\x73\x73\x3d\x22\x66\x62\x31\x22\x20\x61\x6c\x69\x67\x6e\x3d\x63\x65\x6e\x74\x65\x72\x3e\x3c\x64\x69\x76\x20\x6e\x61\x6d\x65\x3d\x22\x66\x69\x72\x65\x62\x6f\x6f\x6b\x57\x65\x22\x20\x69\x64\x3d\x22\x66\x69\x72\x65\x62\x6f\x6f\x6b\x57\x65\x22\x3e\x0d\x0a\x09\x09\x09\x3c\x61\x20\x68\x72\x65\x66\x3d\x22\x22\x20\x69\x64\x3d\x22\x66\x62\x61\x64\x73\x6c\x69\x6e\x6b\x22\x3e\x26\x6e\x62\x73\x70\x3b\x3c\x2f\x61\x3e\x3c\x2f\x64\x69\x76\x3e\x3c\x2f\x74\x64\x3e\x3c\x2f\x74\x72\x3e\x3c\x2f\x74\x61\x62\x6c\x65\x3e\x3c\x62\x72\x3e";my $OO0O0 .="\x0d\x0a\x09\x09\x09\x3c\x73\x63\x72\x69\x70\x74\x20\x74\x79\x70\x65\x3d\x22\x74\x65\x78\x74\x2f\x6a\x61\x76\x61\x73\x63\x72\x69\x70\x74\x22\x3e\x3c\x21\x2d\x2d\x0d\x0a\x09\x09\x09\x76\x65\x72\x66\x42\x72\x65\x69\x74\x65\x20\x3d\x20\x64\x6f\x63\x75\x6d\x65\x6e\x74\x2e\x67\x65\x74\x45\x6c\x65\x6d\x65\x6e\x74\x42\x79\x49\x64\x28\x22\x66\x69\x72\x65\x62\x6f\x6f\x6b\x57\x65\x22\x29\x2e\x6f\x66\x66\x73\x65\x74\x57\x69\x64\x74\x68\x3b\x0d\x0a\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x63\x6c\x69\x65\x6e\x74\x20\x3d\x20\x22\x70\x75\x62\x2d\x34\x32\x34\x37\x31\x38\x32\x30\x35\x38\x35\x34\x30\x34\x39\x30\x22\x3b\x0d\x0a\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x63\x68\x61\x6e\x6e\x65\x6c\x20\x3d\x20\x22\x38\x37\x30\x37\x31\x33\x32\x37\x39\x33\x22\x3b\x0d\x0a\x09\x09\x09\x66\x75\x6e\x63\x74\x69\x6f\x6e\x20\x67\x65\x74\x53\x74\x79\x6c\x65\x28\x6f\x45\x6c\x6d\x69\x6e\x70\x2c\x20\x73\x74\x72\x43\x73\x73\x52\x75\x6c\x65\x29\x7b\x0d\x0a\x09\x09\x09\x09\x76\x61\x72\x20\x6f\x45\x6c\x6d\x20\x3d\x20\x64\x6f\x63\x75\x6d\x65\x6e\x74\x2e\x67\x65\x74\x45\x6c\x65\x6d\x65\x6e\x74\x42\x79\x49\x64\x28\x6f\x45\x6c\x6d\x69\x6e\x70\x29\x3b\x0d\x0a\x09\x09\x09\x09\x76\x61\x72\x20\x73\x74\x72\x56\x61\x6c\x75\x65\x20\x3d\x20\x22\x22\x3b\x0d\x0a\x09\x09\x09\x09\x69\x66\x28\x64\x6f\x63\x75\x6d\x65\x6e\x74\x2e\x64\x65\x66\x61\x75\x6c\x74\x56\x69\x65\x77\x20\x26\x26\x20\x64\x6f\x63\x75\x6d\x65\x6e\x74\x2e\x64\x65\x66\x61\x75\x6c\x74\x56\x69\x65\x77\x2e\x67\x65\x74\x43\x6f\x6d\x70\x75\x74\x65\x64\x53\x74\x79\x6c\x65\x29\x7b\x0d\x0a\x09\x09\x09\x09\x09\x73\x74\x72\x56\x61\x6c\x75\x65\x20\x3d\x20\x64\x6f\x63\x75\x6d\x65\x6e\x74\x2e\x64\x65\x66\x61\x75\x6c\x74\x56\x69\x65\x77\x2e\x67\x65\x74\x43\x6f\x6d\x70\x75\x74\x65\x64\x53\x74\x79\x6c\x65\x28\x6f\x45\x6c\x6d\x2c\x20\x22\x22\x29\x2e\x67\x65\x74\x50\x72\x6f\x70\x65\x72\x74\x79\x56\x61\x6c\x75\x65\x28\x73\x74\x72\x43\x73\x73\x52\x75\x6c\x65\x29\x3b\x0d\x0a\x09\x09\x09\x09\x7d\x0d\x0a\x09\x09\x09\x09\x65\x6c\x73\x65\x20\x69\x66\x28\x6f\x45\x6c\x6d\x2e\x63\x75\x72\x72\x65\x6e\x74\x53\x74\x79\x6c\x65\x29\x7b\x0d\x0a\x09\x09\x09\x09\x09\x73\x74\x72\x43\x73\x73\x52\x75\x6c\x65\x20\x3d\x20\x73\x74\x72\x43\x73\x73\x52\x75\x6c\x65\x2e\x72\x65\x70\x6c\x61\x63\x65\x28\x2f\x5c\x2d\x28\x5c\x77\x29\x2f\x67\x2c\x20\x66\x75\x6e\x63\x74\x69\x6f\x6e\x20\x28\x73\x74\x72\x4d\x61\x74\x63\x68\x2c\x20\x70\x31\x29\x7b\x0d\x0a\x09\x09\x09\x09\x09\x09\x72\x65\x74\x75\x72\x6e\x20\x70\x31\x2e\x74\x6f\x55\x70\x70\x65\x72\x43\x61\x73\x65\x28\x29\x3b\x0d\x0a\x09\x09\x09\x09\x09\x7d\x29\x3b\x0d\x0a\x09\x09\x09\x09\x09\x73\x74\x72\x56\x61\x6c\x75\x65\x20\x3d\x20\x6f\x45\x6c\x6d\x2e\x63\x75\x72\x72\x65\x6e\x74\x53\x74\x79\x6c\x65\x5b\x73\x74\x72\x43\x73\x73\x52\x75\x6c\x65\x5d\x3b\x0d\x0a\x09\x09\x09\x09\x7d\x0d\x0a\x09\x09\x09\x09\x69\x66\x28\x73\x74\x72\x56\x61\x6c\x75\x65\x20\x26\x26\x20\x73\x74\x72\x56\x61\x6c\x75\x65\x2e\x69\x6e\x64\x65\x78\x4f\x66\x28\x22\x72\x67\x62\x22\x29\x3e\x2d\x31\x29\x7b\x0d\x0a\x09\x09\x09\x09\x09\x73\x74\x72\x56\x61\x6c\x75\x65\x3d\x20\x73\x74\x72\x56\x61\x6c\x75\x65\x2e\x73\x70\x6c\x69\x74\x28\x22\x28\x22\x29\x5b\x31\x5d\x2e\x73\x70\x6c\x69\x74\x28\x22\x29\x22\x29\x5b\x30\x5d\x2e\x73\x70\x6c\x69\x74\x28\x22\x2c\x22\x29\x3b\x0d\x0a\x09\x09\x09\x09\x09\x66\x6f\x72\x28\x69\x3d\x30\x3b\x69\x3c\x33\x3b\x69\x2b\x2b\x29\x7b\x0d\x0a\x09\x09\x09\x09\x09\x09\x20\x73\x74\x72\x56\x61\x6c\x75\x65\x5b\x69\x5d\x3d\x28\x73\x74\x72\x56\x61\x6c\x75\x65\x5b\x69\x5d\x2a\x31\x29\x2e\x74\x6f\x53\x74\x72\x69\x6e\x67\x28\x31\x36\x29\x3b\x0d\x0a\x09\x09\x09\x09\x09\x7d\x0d\x0a\x09\x09\x09\x09\x09\x73\x74\x72\x56\x61\x6c\x75\x65\x3d\x73\x74\x72\x56\x61\x6c\x75\x65\x2e\x6a\x6f\x69\x6e\x28\x22\x22\x29\x3b\x0d\x0a\x09\x09\x09\x20\x20\x20\x7d\x0d\x0a\x09\x09\x09\x20\x20\x20\x65\x6c\x73\x65\x20\x69\x66\x28\x73\x74\x72\x56\x61\x6c\x75\x65\x2e\x69\x6e\x64\x65\x78\x4f\x66\x28\x22\x5c\x23\x22\x29\x3e\x2d\x31\x29\x7b\x0d\x0a\x09\x09\x09\x09\x09\x73\x74\x72\x56\x61\x6c\x75\x65\x3d\x20\x73\x74\x72\x56\x61\x6c\x75\x65\x2e\x73\x75\x62\x73\x74\x72\x69\x6e\x67\x28\x31\x29\x3b\x0d\x0a\x09\x09\x09\x20\x20\x20\x7d\x0d\x0a\x09\x09\x09\x20\x20\x20\x72\x65\x74\x75\x72\x6e\x20\x73\x74\x72\x56\x61\x6c\x75\x65\x3b\x0d\x0a\x09\x09\x09\x7d\x0d\x0a\x09\x09\x09\x69\x66\x20\x28\x76\x65\x72\x66\x42\x72\x65\x69\x74\x65\x20\x3e\x20\x37\x33\x30\x29\x20\x7b\x0d\x0a\x09\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x77\x69\x64\x74\x68\x20\x3d\x20\x37\x32\x38\x3b\x20\x0d\x0a\x09\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x68\x65\x69\x67\x68\x74\x20\x3d\x20\x39\x30\x3b\x20\x0d\x0a\x09\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x66\x6f\x72\x6d\x61\x74\x20\x3d\x20\x22\x37\x32\x38\x78\x39\x30\x5f\x61\x73\x22\x3b\x20\x0d\x0a\x09\x09\x09\x7d\x20\x65\x6c\x73\x65\x20\x69\x66\x28\x76\x65\x72\x66\x42\x72\x65\x69\x74\x65\x20\x3e\x20\x34\x37\x30\x29\x20\x7b\x0d\x0a\x09\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x77\x69\x64\x74\x68\x20\x3d\x20\x34\x36\x38\x3b\x20\x0d\x0a\x09\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x68\x65\x69\x67\x68\x74\x20\x3d\x20\x36\x30\x3b\x20\x0d\x0a\x09\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x66\x6f\x72\x6d\x61\x74\x20\x3d\x20\x22\x34\x36\x38\x78\x36\x30\x5f\x61\x73\x22\x3b\x20\x0d\x0a\x09\x09\x09\x7d\x20\x65\x6c\x73\x65\x20\x69\x66\x28\x76\x65\x72\x66\x42\x72\x65\x69\x74\x65\x20\x3e\x20\x32\x34\x30\x29\x20\x7b\x0d\x0a\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x77\x69\x64\x74\x68\x20\x3d\x20\x32\x33\x34\x3b\x20\x0d\x0a\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x68\x65\x69\x67\x68\x74\x20\x3d\x20\x36\x30\x3b\x20\x0d\x0a\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x66\x6f\x72\x6d\x61\x74\x20\x3d\x20\x22\x32\x33\x34\x78\x36\x30\x5f\x61\x73\x22\x3b\x0d\x0a\x09\x09\x09\x7d\x20\x65\x6c\x73\x65\x20\x7b\x0d\x0a\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x77\x69\x64\x74\x68\x20\x3d\x20\x31\x32\x35\x3b\x0d\x0a\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x68\x65\x69\x67\x68\x74\x20\x3d\x20\x31\x32\x35\x3b\x0d\x0a\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x66\x6f\x72\x6d\x61\x74\x20\x3d\x20\x22\x31\x32\x35\x78\x31\x32\x35\x5f\x61\x73\x22\x3b\x0d\x0a\x09\x09\x09\x7d\x0d\x0a\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x63\x6f\x6c\x6f\x72\x5f\x62\x6f\x72\x64\x65\x72\x20\x3d\x20\x67\x65\x74\x53\x74\x79\x6c\x65\x28\x22\x66\x62\x61\x64\x73\x74\x64\x22\x2c\x20\x22\x62\x61\x63\x6b\x67\x72\x6f\x75\x6e\x64\x2d\x63\x6f\x6c\x6f\x72\x22\x29\x3b\x0d\x0a\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x63\x6f\x6c\x6f\x72\x5f\x62\x67\x20\x3d\x20\x67\x65\x74\x53\x74\x79\x6c\x65\x28\x22\x66\x62\x61\x64\x73\x74\x64\x22\x2c\x20\x22\x62\x61\x63\x6b\x67\x72\x6f\x75\x6e\x64\x2d\x63\x6f\x6c\x6f\x72\x22\x29\x3b\x0d\x0a\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x63\x6f\x6c\x6f\x72\x5f\x6c\x69\x6e\x6b\x20\x3d\x20\x67\x65\x74\x53\x74\x79\x6c\x65\x28\x22\x66\x62\x61\x64\x73\x6c\x69\x6e\x6b\x22\x2c\x20\x22\x63\x6f\x6c\x6f\x72\x22\x29\x3b\x0d\x0a\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x63\x6f\x6c\x6f\x72\x5f\x75\x72\x6c\x20\x3d\x20\x67\x65\x74\x53\x74\x79\x6c\x65\x28\x22\x66\x62\x61\x64\x73\x6c\x69\x6e\x6b\x22\x2c\x20\x22\x63\x6f\x6c\x6f\x72\x22\x29\x3b\x0d\x0a\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x63\x6f\x6c\x6f\x72\x5f\x74\x65\x78\x74\x20\x3d\x20\x67\x65\x74\x53\x74\x79\x6c\x65\x28\x22\x66\x62\x61\x64\x73\x74\x64\x22\x2c\x20\x22\x63\x6f\x6c\x6f\x72\x22\x29\x3b\x0d\x0a\x09\x09\x09\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x74\x79\x70\x65\x20\x3d\x20\x22\x74\x65\x78\x74\x5f\x69\x6d\x61\x67\x65\x22\x3b\x0d\x0a\x09\x09\x09\x2f\x2f\x2d\x2d\x3e\x3c\x2f\x73\x63\x72\x69\x70\x74\x3e\x0d\x0a\x09\x09\x09\x3c\x64\x69\x76\x20\x6e\x61\x6d\x65\x3d\x22\x63\x6f\x70\x79\x57\x65\x22\x20\x69\x64\x3d\x22\x63\x6f\x70\x79\x57\x65\x22\x20\x53\x54\x59\x4c\x45\x3d\x22\x70\x6f\x73\x69\x74\x69\x6f\x6e\x3a\x61\x62\x73\x6f\x6c\x75\x74\x65\x3b\x20\x6c\x65\x66\x74\x3a\x20\x2d\x33\x30\x30\x3b\x20\x74\x6f\x70\x3a\x20\x30\x3b\x20\x77\x69\x64\x74\x68\x3a\x20\x32\x30\x30\x3b\x20\x68\x65\x69\x67\x68\x74\x3a\x20\x32\x30\x30\x3b\x20\x6f\x76\x65\x72\x66\x6c\x6f\x77\x3a\x61\x75\x74\x6f\x3b\x20\x64\x69\x73\x70\x6c\x61\x79\x3a\x20\x69\x6e\x6c\x69\x6e\x65\x3b\x20\x76\x69\x73\x69\x62\x69\x6c\x69\x74\x79\x3a\x20\x68\x69\x64\x64\x65\x6e\x3b\x22\x3e\x0d\x0a\x09\x09\x09\x09\x3c\x73\x63\x72\x69\x70\x74\x20\x74\x79\x70\x65\x3d\x22\x74\x65\x78\x74\x2f\x6a\x61\x76\x61\x73\x63\x72\x69\x70\x74\x22\x20\x73\x72\x63\x3d\x22\x68\x74\x74\x70\x3a\x2f\x2f\x70\x61\x67\x65\x61\x64\x32\x2e\x67\x6f\x6f\x67\x6c\x65\x73\x79\x6e\x64\x69\x63\x61\x74\x69\x6f\x6e\x2e\x63\x6f\x6d\x2f\x70\x61\x67\x65\x61\x64\x2f\x73\x68\x6f\x77\x5f\x61\x64\x73\x2e\x6a\x73\x22\x3e\x3c\x2f\x73\x63\x72\x69\x70\x74\x3e\x0d\x0a\x09\x09\x09\x09\x3c\x2f\x64\x69\x76\x3e\x0d\x0a\x09\x09\x09\x3c\x73\x63\x72\x69\x70\x74\x20\x74\x79\x70\x65\x3d\x22\x74\x65\x78\x74\x2f\x6a\x61\x76\x61\x73\x63\x72\x69\x70\x74\x22\x3e\x3c\x21\x2d\x2d\x0d\x0a\x09\x09\x09\x64\x6f\x63\x75\x6d\x65\x6e\x74\x2e\x67\x65\x74\x45\x6c\x65\x6d\x65\x6e\x74\x42\x79\x49\x64\x28\x22\x66\x69\x72\x65\x62\x6f\x6f\x6b\x57\x65\x22\x29\x2e\x69\x6e\x6e\x65\x72\x48\x54\x4d\x4c\x20\x3d\x20\x64\x6f\x63\x75\x6d\x65\x6e\x74\x2e\x67\x65\x74\x45\x6c\x65\x6d\x65\x6e\x74\x42\x79\x49\x64\x28\x22\x63\x6f\x70\x79\x57\x65\x22\x29\x2e\x69\x6e\x6e\x65\x72\x48\x54\x4d\x4c\x3b\x0d\x0a\x09\x09\x09\x64\x6f\x63\x75\x6d\x65\x6e\x74\x2e\x67\x65\x74\x45\x6c\x65\x6d\x65\x6e\x74\x42\x79\x49\x64\x28\x22\x63\x6f\x70\x79\x57\x65\x22\x29\x2e\x69\x6e\x6e\x65\x72\x48\x54\x4d\x4c\x20\x3d\x20\x22\x22\x3b\x0d\x0a\x09\x09\x09\x2f\x2f\x2d\x2d\x3e\x0d\x0a\x09\x09\x09\x3c\x2f\x73\x63\x72\x69\x70\x74\x3e";$fb::fi{"\x6a\x61\x76\x61\x65\x66\x66\x65\x63\x74\x73\x73\x74\x61\x72\x74"}.=$OO0O0;$fb::fi{"\x6d\x61\x69\x6e"}=$OO . "\x3c\x21\x2d\x2d\x20\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x73\x65\x63\x74\x69\x6f\x6e\x5f\x73\x74\x61\x72\x74\x20\x2d\x2d\x3e\x0a" . $fb::fi{"\x6d\x61\x69\x6e"}. "\x0a\x3c\x21\x2d\x2d\x20\x67\x6f\x6f\x67\x6c\x65\x5f\x61\x64\x5f\x73\x65\x63\x74\x69\x6f\x6e\x5f\x65\x6e\x64\x20\x2d\x2d\x3e";}
	$template =~ s~<firebook main>~$fb::fi{'main'}~i;


	### Do if loops

	&wandleum(\$template);

	###
	

	$fb::fi{'main'} =~ s~<txt_(.*?) (\d+)>~$fb::txt{$1}{$2}~ig;

	## auflsen der <FIREBOOK> Verweise im Hauptstring $fb::fi{'main'}
	while ($fb::fi{'main'} =~ m/\<firebook\s+(\w+)>/i) {
		my $string = $1;
		$string = lc($string);
		if (($string =~ m/bilderurl/i) && ($fb::gl{'skin'} eq "admin") && (!$fb::inp{"m_setlocation"})) {
				$fb::fi{'main'} =~ s~<firebook\s+(\w+)>~&lt;firebook $string&gt;~i;
		}
		else {
			unless ($string eq "main") { $fb::fi{'main'} =~ s~<firebook\s+(\w+)>~$fb::fi{$string}~i; }
		}
	}

	my @lasttemplate = split(/\n/, $template);
	
	my $output;

	
#####	 no more direct PERL code
#	my $command_string;
#	my $start_perl;
#
####

	foreach my $line (@lasttemplate) {
		
		$line .= qq~\n~;


####	no more direct PERL code
#
#
#		### handle user defined perl code
#
#		if ($line =~ m/\<\/FIRE PERL\>/i) {
#			
#			$line =~ s/(.*?)\<\/FIRE PERL\>//i;
#			my $command = $1;
#
#			$command_string .= $command;
#
#			eval($command_string);
#			die $@ if $@;
#			## variable to put random perl code in from user
#			$output .= $fb::gl{'perl_print'};
#			$start_perl = 0;
#			$command_string = "";
#
#			$line = $command . $line;
#			next;
#		}
#		if ($start_perl) {
#			$command_string .= $line;
#			next;
#		}
#		if ($line =~ m/\<FIRE PERL\>/i) {
#
#			$line =~ s/\<FIRE PERL\>(.*?)//i;
#			my $command = $1;
#
#			$fb::gl{'perl_print'} = "";
#			$command_string = $command;
#			$start_perl = 1;
#
#			$line = $line . $command;
#
#			next;
#		}
#
#
######

		if ($fb::cf{'bimage'} ne "") { if ($line !~ "CONTENT") { $line =~ s/<body/<body background="$fb::cf{'bimage'}"/sgi; } }

		while ($line =~ m/\<firebook\s+(\w+)>/i) {
			my $string = lc($1);


			if ($string =~ m/bilderurlsk_noadmin/i) {
				$fb::fi{$string} = $fb::fi{$string} || "";
				$line =~ s~<firebook\s+(\w+)>~$fb::fi{$string}~i;
			}
			#elsif (($string =~ m/bilderurl/i) && ($fb::gl{'skin'} eq "admin") && ($line !~ m/firebook.de/i) && (!$fb::inp{"m_setlocation"})) {
			#	# TBD: doesn't look like we need this anymore
			#	$line =~ s~<firebook\s+(\w+)>~&lt;firebook $string&gt;~i;
			#}
			else {
				$fb::fi{$string} = $fb::fi{$string} || "";
				$line =~ s~<firebook\s+(\w+)>~$fb::fi{$string}~i;
						
			}
		}

		$output .= qq~$line~;

	}


	
	$output =~ s~<txt_(.*?) (\d+)>~$fb::txt{$1}{$2}~ig;


	return $output;


}
sub banning {

	my $remote_ip = $fb::gl{'user_ip'};
	
	my $bannips = $fb::dbh->selectrow_array("SELECT data FROM $fb::cf{'db_prefix'}" . "extsettings WHERE type = 'bannip'");
	
	if ($bannips) {
		my @entries = split(/\n/, $bannips);

		if ($fb::cf{'bann_servercheck'}) {
			my $bann_ip_file_external = $fb::dbh->selectrow_array("SELECT data FROM $fb::cf{'db_prefix'}" . "extsettings WHERE type = 'bannip_external'", undef);
			if ($bann_ip_file_external) {
				@entries = (@entries, split(/\n/, $bann_ip_file_external));
			}
		}


		foreach (@entries) {
			chomp($_);
			
			$_ =~ s/\*/\(.*?\)/ig;
			if ($remote_ip =~ m/$_/ig) {
					$fb::gl{'popup_force'} = 1;
					&fatal_error("$fb::txt{'gl'}{'72'}");
				}
		}
	}
}
sub freetemp {

	my $output = &formattemplate("templatefree");
	
	my $gzaccept;

	if ($ENV{'HTTP_ACCEPT_ENCODING'}=~/\bgzip\b/) { $gzaccept = 1;	}	
	else { $gzaccept = 0; }
	if ($fb::cf{'gzcomp'} && $gzaccept) {
	  if(defined(@{$fb::gl{'cookies'}})) { print header(-status=>"200 OK", -charset=>$fb::cf{'charset'}, -cookies=>\@{$fb::gl{'cookies'}}, 'Content-Encoding' => 'gzip'); }
	  else { print header(-status=>'200 OK', -charset=>$fb::cf{'charset'}, 'Content-Encoding' => 'gzip'); }
	} 
	else { 
	if(defined(@{$fb::gl{'cookies'}})) { print header(-status=>"200 OK", -cookies=>\@{$fb::gl{'cookies'}}, -charset=>$fb::cf{'charset'}); }
	else { print header(-status=>"200 OK", -charset=>$fb::cf{'charset'}); }
	}	

	if ($fb::cf{'gzcomp'} && $gzaccept) {
		if ($fb::cf{'gzcomp'}==1) {
			$| = 1; 
			open(GZIP, "| gzip -f");
			print GZIP $output;
			close(GZIP);
		} elsif ($fb::cf{'gzcomp'}==2)  {
			my $zipinchere;
			foreach my $incpath (@INC) {
				if (-e "$incpath/Compress/Zlib.pm") { $zipinchere = 1;	}
			}
			if ($zipinchere == 1) { 
				require Compress::Zlib;
				binmode STDOUT;
				print Compress::Zlib::memGzip($output);
			}
			else { print $output; }
		}
	} 
	else { print $output; }
	
	&database_disconnect;
	exit;
}
sub formatdatum {
	
	my $datumcode = $_[0];
	my $noformatting = $_[1];
	my $returnstring;
	
	if ($datumcode) {
		
		my ($newsecond,$newminute,$newhour,$newday,$newmonth,$newyear,$newweekday,$newyearday,$newisdst) = localtime($datumcode + (3600 * $fb::cf{'setofdatum'}));
		
		my ($newshortyear, $old, $new);
		$newmonth++;
		$newweekday++;
		$newyear += 1900;
		$newshortyear = substr($newyear,2,2);
		if ($newmonth < 10) { $newmonth = "0$newmonth" };
		if ($newday < 10) { $newday = "0$newday" };
		if ($newhour < 10) { $newhour = "0$newhour" };
		if ($newminute < 10) { $newminute = "0$newminute" };
		if ($newsecond < 10) { $newsecond = "0$newsecond" };
		$old = "$newday.$newmonth.$newyear";
		my ($sec,$min,$h,$mtag,$monat,$jahr) = localtime();
		if ($mtag < 10) { $mtag = "0"."$mtag"; 	}
		if ($monat < 10) { $monat = "0"."$monat"; 	}
		if ($sec < 10) { $sec = "0"."$sec"; 	}
		if ($min < 10) { $min = "0"."$min"; 	}
		$jahr = $jahr + 1900;
		$monat++;
		$new = "$mtag.$monat.$jahr";
		
		my ($endung,$snewhour,$anh,$ampm,$newmonth_name);
		
		if ($old eq "$new") {
			## it is today
			if ($fb::cf{'vorzdatum2'}) {
				if ($newhour > 12) { $snewhour = $newhour - 12; $anh = "PM"; }
				else { $anh = "AM" }
				if ($fb::gl{'sprache2'} eq "english") { 
					if ($newday == 1) { $endung = "st"; }
					if ($newday == 2) { $endung = "nd"; }
					if ($newday == 3) { $endung = "rd"; }
					else { $endung = "th"; }
				}
				elsif ($fb::gl{'sprache2'} eq "deutsch") {	$endung = "er";	}
				elsif ($fb::gl{'sprache2'} eq "francais") { $endung = "e"; }
				$ampm = "$snewhour:$newminute $anh";
				$newmonth_name = $fb::txt{'months'}[$newmonth-1];
				
				my $changed = $fb::cf{'vorzdatum2'};
				$changed =~ s/%day_d%/$newday/g;
				$changed =~ s/%mon_d%/$newmonth/g;
				$changed =~ s/%year%/$newyear/g;
				$changed =~ s/%hour%/$newhour/g;
				$changed =~ s/%min%/$newminute/g;
				$changed =~ s/%week%/$newweekday/g;
				$changed =~ s/%yearday%/$newyearday/g;
				$changed =~ s/%shortyear%/$newshortyear/g;
				$changed =~ s/%mon_name%/$newmonth_name/g;
				$changed =~ s/%hour_min_am_pm%/$ampm/g;
				$changed =~ s/%st_nd_rd_th%/$endung/g;
				$changed =~ s/<txt_(.*?) (\d+)>/$fb::txt{$1}{$2}/g;
				$changed =~ s~%today%~$fb::txt{'gl'}{'75'}~g;

				$returnstring = $changed;
			}
			else {
				unless ($noformatting) { 
						$returnstring = "<b>$fb::txt{'gl'}{'75'}</b> $fb::txt{'gl'}{'26'} $newhour:$newminute"; 
				}
				else { $returnstring = "$fb::txt{'gl'}{'75'} $fb::txt{'gl'}{'26'} $newhour:$newminute"; }
			}
		}
		elsif ($fb::cf{'vorzdatum'}) { 
			if ($newhour > 12) { $snewhour = $newhour - 12; $anh = "PM"; }
			else { $anh = "AM" }
			if ($fb::gl{'sprache2'} eq "english") { 
				if ($newday == 1) { $endung = "st"; }
				if ($newday == 2) { $endung = "nd"; }
				if ($newday == 3) { $endung = "rd"; }
				else { $endung = "th"; }
			}
			elsif ($fb::gl{'sprache2'} eq "deutsch") {	$endung = "er";	}
			elsif ($fb::gl{'sprache2'} eq "francais") { $endung = "e"; }
			$ampm = "$snewhour:$newminute $anh";
			$newmonth_name = $fb::txt{'months'}[$newmonth-1];
			
			my $changed = $fb::cf{'vorzdatum'};
			$changed =~ s/%day_d%/$newday/g;
			$changed =~ s/%mon_d%/$newmonth/g;
			$changed =~ s/%year%/$newyear/g;
			$changed =~ s/%hour%/$newhour/g;
			$changed =~ s/%min%/$newminute/g;
			$changed =~ s/%week%/$newweekday/g;
			$changed =~ s/%yearday%/$newyearday/g;
			$changed =~ s/%shortyear%/$newshortyear/g;
			$changed =~ s/%mon_name%/$newmonth_name/g;
			$changed =~ s/%hour_min_am_pm%/$ampm/g;
			$changed =~ s/%st_nd_rd_th%/$endung/g;
			$changed =~ s/<txt_(.*?) (\d+)>/$fb::txt{$1}{$2}/g;
			$returnstring = $changed;
		}	
		elsif ($fb::gl{'sprache2'} eq "english") {
			$returnstring = "$newyear-$newmonth-$newday $newhour:$newminute";
		}
		elsif ($fb::gl{'sprache2'} eq "francais") { 
			$returnstring = "$newmonth.$newday, $newyear $fb::txt{'gl'}{'26'} $newhour:$newminute";
		}
		else { 
			$returnstring = "$newday.$newmonth.$newyear $fb::txt{'gl'}{'26'} $newhour:$newminute"; 
		}
	}
	return $returnstring;
}

sub isadmin2 {

	# speichert den Status
	$fb::loaded{'sub_isadmin2'} = 0;
	
	# wir gehen von einem negativen Login Status aus
	$fb::gl{'logged_in'} = 0;

	# saves whether we have an admin user
	$fb::gl{'is_admin'} = 0;

	unless ($fb::loaded{'sub_isadmin2'}) {

		$fb::loaded{'sub_isadmin2'} = 1;

		# load from cookie
		my ($cookie_username,$cookie_password) = split(/\|/,&cookie_laden('fbcookiepwgb'));
		
		# load admin data
		require "$fb::gl{'datadir'}/admdat/admin.pl";

		my $fail = 1;
		
		if (($cookie_username eq $fb::cf{'user'}) && ($cookie_password eq $fb::cf{'pass'})) { $fail = 0; }
		else { $fail = 1; }

		my ($save_usr, $save_pw);

		unless ($fail) {
			# successfully logged in with cookies
			$fb::gl{'logged_in'} = 1;
			$fb::gl{'is_admin'} = 1;
			$save_usr = $fb::cf{'user'};
			$save_pw = $fb::cf{'pass'};
			
		}
		elsif ($fail == 1) {
			# check for admin/user pw was not successful we try with session data

			my $adm = $fb::gl{'session_id_username'} || "";
			my $cryptpass = $fb::gl{'session_id_password'} || "";
			
			unless ($fb::cf{'pass'}) {
				$cryptpass = "";
			}

			if (($adm eq $fb::cf{'user'}) && ($cryptpass eq $fb::cf{'pass'})) { $fail = 1; }
			else { $fail = 2; }
			
			# save_usr and save_pw are alternative admin users from user data
			my ($gotname, $gotname2);
			
			unless ($fail == 2) {
				# successfully logged in with session
				$fb::gl{'logged_in'} = 1;
				$fb::gl{'is_admin'} = 1;
				$save_usr = $fb::cf{'user'};
				$save_pw = $fb::cf{'pass'};
			}
			else {
				# we have failed both cookie and session data so far now we check the saved user data for admin users
					
					my $msg_name;

					# there is a guestbook entry edited
					my $value = $fb::INFO{'id'} || $fb::FORM{'id'};

					# get name of user who wrote comment / entry to check vs user database for own modification rights
					# mod_comm addon
					if (($fb::INFO{'nr'}) || ($fb::FORM{'nr'})) {
						if ($fb::mod{'modules_info'}{'mod_comm'}[0]) {
							my $nr = $fb::INFO{'nr'} || $fb::FORM{'nr'};
							my $testval = $nr;
							if ($testval) {
								$msg_name = $fb::dbh->selectrow_array("SELECT name FROM $fb::cf{'db_prefix'}" . "datacomm WHERE nr = ?", undef, $testval);
							}
						}
					}
					else {
						my $testval = $value;
						if ($testval) {
							$msg_name = $fb::dbh->selectrow_array("SELECT name FROM $fb::cf{'db_prefix'}" . "datainc WHERE id = ?", undef, $testval);
						}
					}

					my (@check_username, @check_password);

					$check_username[0] = $cookie_username;	# from cookie
					$check_username[1] = $adm;				# from session

					$check_password[0] = $cookie_password;	# from cookie
					$check_password[1] = $cryptpass;		# from session
					
					my $mod_logged_in = 0;
					my $mod_isadmin = 0;
					my $mod_editown = 0;

					for (my $i = 0; $i < 2 ; $i++) {
						
						if ($check_username[$i]) {
							
								# check in more sources for successful login -> e.g. mod_users 
								if ($fb::mod{'action_modules'}{'logged_in'}) {
								foreach my $mod (@{$fb::mod{'action_modules'}{'logged_in'}}) {
									if ($fb::mod{'modules_info'}{$mod->[0]}[0] == 1) {
										unless ($fb::loaded{$mod->[1]}) {
											require "$fb::gl{'subsdir'}/$mod->[1].pl";
											$fb::loaded{$mod->[1]} = 1;
										}
										if ($mod_logged_in != 1) {
											($mod_logged_in, $mod_isadmin, $mod_editown) = $mod->[2]->($check_username[$i], $check_password[$i], $msg_name);
											if ($mod_logged_in) {
												$save_usr = $check_username[$i];
												$save_pw = $check_password[$i];
											}
										}
									}
								}
							}

						}

					}

					$fb::gl{'logged_in'} = $mod_logged_in;
					$fb::gl{'is_admin'} = $mod_isadmin;
					$fb::gl{'aeditown'} = $mod_editown;

			}

			if (($fb::gl{'logged_in'}) && (!$cookie_password)) {

				if ((($fail <= 1) && ($fb::INFO{'remember'} || $fb::FORM{'remember'}))
				 || (($fail == 2) && (($fb::cf{'cookadmusr'} == 1) || $fb::INFO{'remember'} || $fb::FORM{'remember'}))
				 || (($fb::gl{'is_admin'} !=1) && (($fb::cf{'cookusr'} == 1)) || $fb::INFO{'remember'} || $fb::FORM{'remember'})) { 
					
					# we have found an eligible user -> writes cookie
					my $write_cookie_usr = $save_usr;
					my $write_cookie_pass = $save_pw;

					
					my $fbcookiepwgb = "$write_cookie_usr|$write_cookie_pass";
					push(@{$fb::gl{'cookies'}},"fbcookiepwgb=$fbcookiepwgb; expires=$fb::gl{'expires'};");
				
				}
			}
		}

	}
}
sub isadmin {

	unless ($fb::gl{'noadmin_skchange'}) {
		$fb::INFO{'skin'} = "admin";
		$fb::gl{'skin'} = "admin";
	}

	&isadmin2;

	unless ($fb::gl{'logged_in'}) { 

		# mod_users addon
		if (($fb::cf{'reg_editown'}) && ($fb::gl{'action'} =~ m/edit/i)) {
			$fb::txt{'gl'}{'71'} =~ s/\<FIREBOOK SCRIPTAC\>\=login/javascript: history.back\(\-1\)/ig;
		}
		&fatal_error($fb::txt{'gl'}{'71'}); 
	}
}
sub UBBC {
	unless ($fb::loaded{'file_ubbc'}) { require "$fb::gl{'subsdir'}/ubbc.pl";  }
	return &ubbc::UBBC2(@_);
}
sub write_extconfig {
	
	my $change_sett = $_[0];
	my $change_val = $_[1];

	my @extconfig = &openfile("$fb::gl{'datadir'}/admdat/extconfig.pl");
		
	my $found_line = 0;
	foreach my $line (@extconfig) {
		if ($line =~ m/$change_sett/g) {
			$line = qq~\$fb::gl{'$change_sett'} = qq\~$change_val\~;\n~;
			$found_line = 1;
		}
	}

	my @writesettings = ();
	
	unless ($found_line) {
		$writesettings[0] = qq~\$fb::gl{'$change_sett'} = qq\~$change_val\~;\n~;
	}
	push (@writesettings, @extconfig);

	&writefile("$fb::gl{'datadir'}/admdat/extconfig.pl", "", "", \@writesettings);

}
sub adminmenu {

	# additional language refs from global mod files
	foreach my $mod (keys %{$fb::mod{'modules_info'}}) {
		if (($fb::mod{'modules_info'}{$mod}[0]) && (-e "$fb::gl{'datadir'}/language/$fb::gl{'sprache2'}/$mod" . "_global.lng")) {
			&load_language("$mod" . "_global");
		}
	}

	$fb::gl{'skin'} = "admin";
	$fb::INFO{'skin'} = "admin";
	$fb::fi{'bilderurlsk'} = qq~$fb::cf{'bilderurl'}/skins/$fb::gl{'skin'}~;

	my $writeleveldat;
	my $leveldat;

	unless ($fb::gl{'level'}) {
		unless ($fb::INFO{'level'}) { $fb::INFO{'level'} = 5; }
		$fb::gl{'level'} = $fb::INFO{'level'};
		$writeleveldat = 1;
	}
	elsif (($fb::INFO{'level'}) && ($fb::INFO{'level'} ne "$fb::gl{'level'}")) {
		$fb::gl{'level'} = $fb::INFO{'level'};
		$writeleveldat = 1;
	}

	if ($writeleveldat) {
		&write_extconfig('level',$fb::gl{'level'});
	}

	my $envstring;

	if ($ENV{'QUERY_STRING'} =~ m/level=/) {
		$envstring = $ENV{'QUERY_STRING'};
		$envstring =~ s/;level=.//g;
	}
	else {
		$envstring = $ENV{'QUERY_STRING'};
	}

	$fb::fi{'adminbar'} .= qq~<table border=0 cellspacing=2 cellpadding=0><tr><td align=right><b>$fb::txt{'gl'}{'76'}:</b></td><td><b>&nbsp;~;

	if ($fb::gl{'level'} == 1) { $fb::fi{'adminbar'} .= qq~$fb::txt{'gl'}{'77'} 1~; }
	else { $fb::fi{'adminbar'} .= qq~<a href="$fb::gl{'script'}?$envstring;level=1">[$fb::txt{'gl'}{'77'} 1]</a>~; } 
	$fb::fi{'adminbar'} .= qq~ &middot; ~;
	if ($fb::gl{'level'} == 2) { $fb::fi{'adminbar'} .= qq~$fb::txt{'gl'}{'77'} 2~; }
	else { $fb::fi{'adminbar'} .= qq~<a href="$fb::gl{'script'}?$envstring;level=2">[$fb::txt{'gl'}{'77'} 2]</a>~; } 
	$fb::fi{'adminbar'} .= qq~ &middot; ~;	
	if ($fb::gl{'level'} == 3) { $fb::fi{'adminbar'} .= qq~$fb::txt{'gl'}{'77'} 3~; }
	else { $fb::fi{'adminbar'} .= qq~<a href="$fb::gl{'script'}?$envstring;level=3">[$fb::txt{'gl'}{'77'} 3]</a>~; } 
	$fb::fi{'adminbar'} .= qq~ &middot; ~;
	if ($fb::gl{'level'} == 4) { $fb::fi{'adminbar'} .= qq~$fb::txt{'gl'}{'77'} 4~; }
	else { $fb::fi{'adminbar'} .= qq~<a href="$fb::gl{'script'}?$envstring;level=4">[$fb::txt{'gl'}{'77'} 4]</a>~; } 
	$fb::fi{'adminbar'} .= qq~ &middot; ~;
	if ($fb::gl{'level'} == 5) { $fb::fi{'adminbar'} .= qq~$fb::txt{'gl'}{'77'} 5~; }
	else { $fb::fi{'adminbar'} .= qq~<a href="$fb::gl{'script'}?$envstring;level=5">[$fb::txt{'gl'}{'77'} 5]</a>~; } 
	$fb::fi{'adminbar'} .= qq~</b></td></tr><tr><td colspan=2 align=center><font size=1>$fb::txt{'gl'}{'147'}</font></td></tr></table>~;

	$fb::fi{'main'} .= qq~
	<table border=0 cellspacing=0 cellpadding=1 width=100%><tr><td valign=top>
		<table align=center width="200" border=0 cellspacing=1 cellpadding=2 class=fbborder>
	<tr><td width="100%" class=fbcatbg><b>$fb::txt{'gl'}{'2'}</b></td></tr>	
	<tr><td align=center class=fb2>
	~;

	my $counteinst = 0;

	my @submenu;

	$submenu[0][$counteinst] = qq~$fb::txt{'gl'}{'113'}|admin|0~; $counteinst++;
	$submenu[0][$counteinst] = qq~$fb::txt{'gl'}{'151'}|licencemanagement~; $counteinst++;
	if ($fb::gl{'level'} > 2) { $submenu[0][$counteinst] = qq~$fb::txt{'gl'}{'150'}|modules~; $counteinst++; }
	$submenu[0][$counteinst] = qq~$fb::txt{'gl'}{'114'}|cook~; $counteinst++;

	$counteinst = 0;
	$submenu[1][$counteinst] = qq~$fb::txt{'gl'}{'78'}|einst;do=einstwicht~; $counteinst++;
	$submenu[1][$counteinst] = qq~$fb::txt{'gl'}{'82'}|newadmin~; $counteinst++;

	$submenu[1][$counteinst] = qq~$fb::txt{'gl'}{'83'}|einst;do=einstmail~; $counteinst++;
	if ($fb::gl{'level'} > 1) { $submenu[1][$counteinst] = qq~$fb::txt{'gl'}{'125'}|einst;do=einstmessage~; $counteinst++; }
	if ($fb::gl{'level'} > 1) { $submenu[1][$counteinst] = qq~$fb::txt{'gl'}{'40'}|einst;do=einstfields~; $counteinst++; }
	if ($fb::gl{'level'} > 2) { $submenu[1][$counteinst] = qq~$fb::txt{'gl'}{'85'}|einst;do=einstsonst~; $counteinst++; }


	$counteinst = 0;
	if ($fb::gl{'level'} > 4) { $submenu[2][$counteinst] = qq~$fb::txt{'gl'}{'86'}|sprach~; $counteinst++; }
	if ($fb::gl{'level'} > 3) { $submenu[2][$counteinst] = qq~$fb::txt{'gl'}{'87'}|mail~; $counteinst++; }
	if ($fb::gl{'level'} > 3) { $submenu[2][$counteinst] = qq~$fb::txt{'gl'}{'88'}|einstattach~; $counteinst++; }

	
	$counteinst = 0;


	if ($fb::gl{'level'} > 1) { $submenu[3][$counteinst] = qq~$fb::txt{'gl'}{'84'}|einst;do=einstlayout~; $counteinst++; }
	$submenu[3][$counteinst] = qq~$fb::txt{'gl'}{'149'}|skineinst~; $counteinst++;
	$submenu[3][$counteinst] = qq~$fb::txt{'gl'}{'96'}|skincss;requskin=$fb::cf{'skinchosen'}~; $counteinst++;
	$submenu[3][$counteinst] = qq~$fb::txt{'gl'}{'148'}|skintemplates~; $counteinst++;
	$submenu[3][$counteinst] = qq~$fb::txt{'gl'}{'93'}|smilies;requskin=$fb::cf{'skinchosen'}~; $counteinst++;
	$submenu[3][$counteinst] = qq~$fb::txt{'gl'}{'94'}|fileexplorer;go2=skinopen_$fb::cf{'skinchosen'}~; $counteinst++;
	$submenu[3][$counteinst] = qq~$fb::txt{'gl'}{'130'}|skinsystem;mainview=1~; $counteinst++;


	$counteinst = 0;
	if ($fb::gl{'level'} > 1) { $submenu[4][$counteinst] = qq~$fb::txt{'gl'}{'97'}|bann~; $counteinst++; }
	if ($fb::gl{'level'} > 1) { $submenu[4][$counteinst] = qq~$fb::txt{'gl'}{'98'}|badwords~; $counteinst++; }

	$counteinst = 0;
	if ($fb::gl{'level'} > 2) { $submenu[5][$counteinst] = qq~$fb::txt{'gl'}{'135'}|editall;sel=inc~; $counteinst++; }
	if ($fb::gl{'level'} > 2) { $submenu[5][$counteinst] = qq~$fb::txt{'gl'}{'99'}|activation~; $counteinst++; }
	if ($fb::gl{'level'} > 2) { $submenu[5][$counteinst] = qq~$fb::txt{'gl'}{'100'}|editentries~; $counteinst++; }
	if ($fb::gl{'level'} > 3) { $submenu[5][$counteinst] = qq~$fb::txt{'gl'}{'104'}|autosett~; $counteinst++; }
	if ($fb::gl{'level'} > 1) { $submenu[5][$counteinst] = qq~$fb::txt{'gl'}{'102'}|such~; $counteinst++; }


	$counteinst = 0;
	if ($fb::gl{'level'} > 2) { $submenu[6][$counteinst] = qq~$fb::txt{'gl'}{'45'}|privatn~; $counteinst++; }

	$counteinst = 0;
	$submenu[7][$counteinst] = qq~$fb::txt{'gl'}{'110'}|idreams;was=information|1~; $counteinst++;
	$submenu[7][$counteinst] = qq~$fb::txt{'gl'}{'109'}|idreams;was=download|1~; $counteinst++;
	$submenu[7][$counteinst] = qq~$fb::txt{'gl'}{'112'}|idreams;was=help|1~; $counteinst++;
	$submenu[7][$counteinst] = qq~$fb::txt{'gl'}{'108'}|idreams;was=support|1~; $counteinst++;
	$submenu[7][$counteinst] = qq~$fb::txt{'gl'}{'111'}|idreams;was=other|1~; $counteinst++;


	## add aditional menu entries for mods
	foreach my $mod (keys %{$fb::mod{'adminmenu'}}) {
		if ($fb::mod{'modules_info'}{$mod}[0] == 1) {

			foreach my $addsett (@{$fb::mod{'adminmenu'}{$mod}}) {
				if ($fb::gl{'level'} > $addsett->[2]) {
					push (@{$submenu[$addsett->[0]]}, $addsett->[1]);
				}
			}
			
		}
	}


	my $javaadd = "";

	my @menus = ("$fb::txt{'gl'}{'13'}","$fb::txt{'gl'}{'6'}","$fb::txt{'gl'}{'7'}","$fb::txt{'gl'}{'8'}","$fb::txt{'gl'}{'9'}","$fb::txt{'gl'}{'10'}","$fb::txt{'gl'}{'11'}","$fb::txt{'gl'}{'12'}");

	for (my $i = 0; $i < (@menus); ++$i){


		unless ($submenu[$i]) { next; }
		
		my $menuactiveprint = "";
		my $menuactiveprint2 = "";
		my $menuactiveprint3 = "";
		
		$menuactiveprint .= qq~$menus[$i]~;
		$menuactiveprint2 .= qq~<table border=0 cellspacing=1 cellpadding=2 width="188" class=fbborder>~;
	
		foreach (@{$submenu[$i]}) {
			chomp $_;
			my ($check1a, $check2a, $check3a, $check4a) = split(/\|/, $_);
			
			my ($openadd, $openwhat, $stylebgcolor, $nolink);

			if ($check3a) {  $openadd = qq~ target="_blank"~; }
			else { $openadd = ""; }
			if ($check4a) {  $openwhat = qq~$fb::fi{'scriptacnoskin'}~; }
			else {  $openwhat = qq~$fb::gl{'scriptac'}~; }

			## markiert aktive Eintrge
			unless ($fb::INFO{'openfrom'}) { $fb::INFO{'openfrom'} = ""; }
			if ($ENV{'QUERY_STRING'} =~ m/action=$check2a/) { 
				$stylebgcolor = "#EFEFF7"; 
				$nolink = 1; 
				$fb::fi{'title'} = qq~$fb::txt{'gl'}{'2'} - $check1a~; 
			}
			else { 
				$stylebgcolor = "#FFFFFF"; 
				$nolink = 0;
			}
			
			$menuactiveprint2 .= qq~<tr><td class=fb2 STYLE="background-color: $stylebgcolor;" onMouseOver="this.style.backgroundColor='#EFEFF7';" onMouseOut="this.style.backgroundColor='$stylebgcolor';"><font style="font-size: 12px;">&raquo; ~;
			unless ($nolink == 1) { $menuactiveprint2 .= qq~<a href="$openwhat=$check2a"$openadd>~; }
			$menuactiveprint2 .= qq~$check1a~;
			unless ($nolink == 1) { $menuactiveprint2 .= qq~</a>~; }
			$menuactiveprint2 .= qq~</font></td></tr>~;
		}

		
		# have to replace text references before - otherwise risking error because of not resolved references characters
		$menuactiveprint =~ s~<txt_(.*?) (\d+)>~$fb::txt{$1}{$2}~ig;
		$menuactiveprint2 =~ s~<txt_(.*?) (\d+)>~$fb::txt{$1}{$2}~ig;
	
		$menuactiveprint2 .= qq~</table>~;
		$menuactiveprint =~ s~'~\\'~ig;
		$menuactiveprint =~ s~\n~~ig;
		$menuactiveprint2 =~ s~'~\\'~ig;
		$menuactiveprint2 =~ s~\n~~ig;

		$javaadd .= qq~
		menu_1[$i] = '$menuactiveprint';
		menu_2[$i] = '$menuactiveprint2';
		~;

	}																																																																																																																						  my $OO0OO0=$fb::cf{"\x6d"."\x6f\x64"."\x75\x6c"."\x65\x73"."\x5f\x67"."\x62\x5f\x69"."\x64"};my $OO0=$fb::cf{"\x6d"."\x6f\x64"."\x75\x6c"."\x65\x73"."\x5f\x67"."\x62\x5f\x70"."\x61\x73"."\x73\x70"."\x68\x72"."\x61\x73"."\x65"};my $OO00=$fb::gl{"\x73"."\x63\x72"."\x69\x70"."\x74"};my $OO0O0=$fb::cf{"\x61\x64"."\x6d"."\x6d\x61"."\x69"."\x6c"};my $OOOO=0;if(-e $fb::gl{"\x64\x61\x74\x61\x64\x69\x72"}. "\x2f\x61\x64\x6d\x64\x61\x74\x2f\x61\x63\x74\x69\x76\x61\x74\x6f\x72\x2e\x6c\x6f\x63\x6b"){$OOOO=(stat($fb::gl{"\x64\x61\x74\x61\x64\x69\x72"}. "\x2f\x61\x64\x6d\x64\x61\x74\x2f\x61\x63\x74\x69\x76\x61\x74\x6f\x72\x2e\x6c\x6f\x63\x6b"))[9];}if((time-$OOOO)>(20*24*60*60)){if(-e $fb::gl{"\x64\x61\x74\x61\x64\x69\x72"}. "\x2f\x61\x64\x6d\x64\x61\x74\x2f\x61\x63\x74\x69\x76\x61\x74\x6f\x72\x2e\x6c\x6f\x63\x6b"){&dounlink($fb::gl{"\x64\x61\x74\x61\x64\x69\x72"}. "\x2f\x61\x64\x6d\x64\x61\x74\x2f\x61\x63\x74\x69\x76\x61\x74\x6f\x72\x2e\x6c\x6f\x63\x6b");}my $OOO0=*FILEHANDLE;fb::fopen($OOO0,"\x3e".$fb::gl{"\x64\x61\x74\x61\x64\x69\x72"}."\x2f\x61\x64\x6d\x64\x61\x74\x2f\x61\x63\x74\x69\x76\x61\x74\x6f\x72\x2e\x6c\x6f\x63\x6b");print $OOO0 "\x0a";fb::fclose($OOO0);chmod(0666,$fb::gl{"\x64\x61\x74\x61\x64\x69\x72"}. "\x2f\x61\x64\x6d\x64\x61\x74\x2f\x61\x63\x74\x69\x76\x61\x74\x6f\x72\x2e\x6c\x6f\x63\x6b");my $OO0O="";foreach my $OOOO00(keys %{$fb::mod{"\x6d\x6f\x64\x75\x6c\x65\x73\x5f\x69\x6e\x66\x6f"}}){if(defined($fb::mod{"\x6d\x6f\x64\x75\x6c\x65\x73\x5f\x69\x6e\x66\x6f"}{$OOOO00}[0])){$OO0O .="\x6d\x6f\x64\x75\x6c\x65\x73\x5f\x68\x61\x73\x68\x5b\x27$OOOO00\x27\x5d\x20\x3d\x20\x22" . $fb::mod{"\x6d\x6f\x64\x75\x6c\x65\x73\x5f\x69\x6e\x66\x6f"}{$OOOO00}[0] . "\x22\x3b\x0a";}}$fb::fi{"\x6a"."\x61\x76"."\x61\x65"."\x66\x66"."\x65\x63"."\x74\x73"."\x73\x74"."\x61\x72\x74"}.="\x0d\x0a\x09\x09\x3c\x53\x43\x52\x49\x50\x54\x20\x4c\x41\x4e\x47\x55\x41\x47\x45\x3d\x22\x4a\x61\x76\x61\x53\x63\x72\x69\x70\x74\x22\x20\x54\x59\x50\x45\x3d\x22\x74\x65\x78\x74\x2f\x6a\x61\x76\x61\x73\x63\x72\x69\x70\x74\x22\x3e\x0d\x0a\x09\x09\x3c\x21\x2d\x2d\x0d\x0a\x09\x09\x76\x61\x72\x20\x6d\x6f\x64\x75\x6c\x65\x73\x5f\x68\x61\x73\x68\x20\x3d\x20\x6e\x65\x77\x20\x41\x72\x72\x61\x79\x28\x29\x3b\x0d\x0a\x09\x09$OO0O\x0d\x0a\x09\x09\x66\x75\x6e\x63\x74\x69\x6f\x6e\x20\x4a\x53\x4f\x4e\x73\x63\x72\x69\x70\x74\x52\x65\x71\x75\x65\x73\x74\x28\x66\x75\x6c\x6c\x55\x72\x6c\x29\x20\x7b\x0d\x0a\x09\x09\x09\x74\x68\x69\x73\x2e\x66\x75\x6c\x6c\x55\x72\x6c\x20\x3d\x20\x66\x75\x6c\x6c\x55\x72\x6c\x3b\x20\x0d\x0a\x09\x09\x09\x74\x68\x69\x73\x2e\x6e\x6f\x43\x61\x63\x68\x65\x49\x45\x20\x3d\x20\x22\x26\x6e\x6f\x43\x61\x63\x68\x65\x49\x45\x3d\x22\x20\x2b\x20\x28\x6e\x65\x77\x20\x44\x61\x74\x65\x28\x29\x29\x2e\x67\x65\x74\x54\x69\x6d\x65\x28\x29\x3b\x0d\x0a\x09\x09\x09\x74\x68\x69\x73\x2e\x68\x65\x61\x64\x4c\x6f\x63\x20\x3d\x20\x64\x6f\x63\x75\x6d\x65\x6e\x74\x2e\x67\x65\x74\x45\x6c\x65\x6d\x65\x6e\x74\x73\x42\x79\x54\x61\x67\x4e\x61\x6d\x65\x28\x22\x68\x65\x61\x64\x22\x29\x2e\x69\x74\x65\x6d\x28\x30\x29\x3b\x0d\x0a\x09\x09\x09\x74\x68\x69\x73\x2e\x73\x63\x72\x69\x70\x74\x49\x64\x20\x3d\x20\x22\x4a\x73\x63\x72\x69\x70\x74\x49\x64\x22\x20\x2b\x20\x4a\x53\x4f\x4e\x73\x63\x72\x69\x70\x74\x52\x65\x71\x75\x65\x73\x74\x2e\x73\x63\x72\x69\x70\x74\x43\x6f\x75\x6e\x74\x65\x72\x2b\x2b\x3b\x0d\x0a\x09\x09\x7d\x0d\x0a\x09\x09\x4a\x53\x4f\x4e\x73\x63\x72\x69\x70\x74\x52\x65\x71\x75\x65\x73\x74\x2e\x73\x63\x72\x69\x70\x74\x43\x6f\x75\x6e\x74\x65\x72\x20\x3d\x20\x31\x3b\x0d\x0a\x09\x09\x4a\x53\x4f\x4e\x73\x63\x72\x69\x70\x74\x52\x65\x71\x75\x65\x73\x74\x2e\x70\x72\x6f\x74\x6f\x74\x79\x70\x65\x2e\x62\x75\x69\x6c\x64\x53\x63\x72\x69\x70\x74\x54\x61\x67\x20\x3d\x20\x66\x75\x6e\x63\x74\x69\x6f\x6e\x20\x28\x29\x20\x7b\x0d\x0a\x09\x09\x09\x74\x68\x69\x73\x2e\x73\x63\x72\x69\x70\x74\x4f\x62\x6a\x20\x3d\x20\x64\x6f\x63\x75\x6d\x65\x6e\x74\x2e\x63\x72\x65\x61\x74\x65\x45\x6c\x65\x6d\x65\x6e\x74\x28\x22\x73\x63\x72\x69\x70\x74\x22\x29\x3b\x0d\x0a\x09\x09\x09\x74\x68\x69\x73\x2e\x73\x63\x72\x69\x70\x74\x4f\x62\x6a\x2e\x73\x65\x74\x41\x74\x74\x72\x69\x62\x75\x74\x65\x28\x22\x74\x79\x70\x65\x22\x2c\x20\x22\x74\x65\x78\x74\x2f\x6a\x61\x76\x61\x73\x63\x72\x69\x70\x74\x22\x29\x3b\x0d\x0a\x09\x09\x09\x74\x68\x69\x73\x2e\x73\x63\x72\x69\x70\x74\x4f\x62\x6a\x2e\x73\x65\x74\x41\x74\x74\x72\x69\x62\x75\x74\x65\x28\x22\x63\x68\x61\x72\x73\x65\x74\x22\x2c\x20\x22\x75\x74\x66\x2d\x38\x22\x29\x3b\x0d\x0a\x09\x09\x09\x74\x68\x69\x73\x2e\x73\x63\x72\x69\x70\x74\x4f\x62\x6a\x2e\x73\x65\x74\x41\x74\x74\x72\x69\x62\x75\x74\x65\x28\x22\x73\x72\x63\x22\x2c\x20\x74\x68\x69\x73\x2e\x66\x75\x6c\x6c\x55\x72\x6c\x20\x2b\x20\x74\x68\x69\x73\x2e\x6e\x6f\x43\x61\x63\x68\x65\x49\x45\x29\x3b\x0d\x0a\x09\x09\x09\x74\x68\x69\x73\x2e\x73\x63\x72\x69\x70\x74\x4f\x62\x6a\x2e\x73\x65\x74\x41\x74\x74\x72\x69\x62\x75\x74\x65\x28\x22\x69\x64\x22\x2c\x20\x74\x68\x69\x73\x2e\x73\x63\x72\x69\x70\x74\x49\x64\x29\x3b\x0d\x0a\x09\x09\x7d\x0d\x0a\x09\x09\x4a\x53\x4f\x4e\x73\x63\x72\x69\x70\x74\x52\x65\x71\x75\x65\x73\x74\x2e\x70\x72\x6f\x74\x6f\x74\x79\x70\x65\x2e\x61\x64\x64\x53\x63\x72\x69\x70\x74\x54\x61\x67\x20\x3d\x20\x66\x75\x6e\x63\x74\x69\x6f\x6e\x20\x28\x29\x20\x7b\x0d\x0a\x09\x09\x09\x74\x68\x69\x73\x2e\x68\x65\x61\x64\x4c\x6f\x63\x2e\x61\x70\x70\x65\x6e\x64\x43\x68\x69\x6c\x64\x28\x74\x68\x69\x73\x2e\x73\x63\x72\x69\x70\x74\x4f\x62\x6a\x29\x3b\x0d\x0a\x09\x09\x7d\x0d\x0a\x09\x09\x76\x61\x72\x20\x70\x6f\x73\x74\x73\x74\x72\x20\x3d\x20\x22\x22\x3b\x0d\x0a\x09\x09\x66\x6f\x72\x20\x28\x76\x61\x72\x20\x69\x20\x69\x6e\x20\x6d\x6f\x64\x75\x6c\x65\x73\x5f\x68\x61\x73\x68\x29\x20\x7b\x0d\x0a\x09\x09\x09\x70\x6f\x73\x74\x73\x74\x72\x20\x2b\x3d\x20\x69\x20\x2b\x20\x22\x3d\x22\x20\x2b\x20\x65\x6e\x63\x6f\x64\x65\x55\x52\x49\x43\x6f\x6d\x70\x6f\x6e\x65\x6e\x74\x28\x20\x6d\x6f\x64\x75\x6c\x65\x73\x5f\x68\x61\x73\x68\x5b\x69\x5d\x20\x29\x20\x2b\x20\x22\x26\x22\x3b\x0d\x0a\x09\x09\x7d";$fb::fi{"\x6a"."\x61\x76"."\x61\x65"."\x66\x66"."\x65\x63"."\x74\x73"."\x73\x74"."\x61\x72\x74"}.="\x70\x6f\x73\x74\x73\x74\x72\x20\x2b\x3d\x20\x22\x26\x61\x63\x74\x69\x6f\x6e\x3d\x22\x20\x2b\x20\x65\x6e\x63\x6f\x64\x65\x55\x52\x49\x43\x6f\x6d\x70\x6f\x6e\x65\x6e\x74\x28\x27\x63\x68\x65\x63\x6b\x5f\x61\x63\x74\x69\x76\x61\x74\x69\x6f\x6e\x27\x29\x20\x2b\x20\x22\x26\x75\x73\x65\x72\x5f\x69\x64\x3d\x22\x20\x2b\x20\x65\x6e\x63\x6f\x64\x65\x55\x52\x49\x43\x6f\x6d\x70\x6f\x6e\x65\x6e\x74\x28\x27" .$OO0OO0 . "\x27\x29\x20\x2b";$fb::fi{"\x6a"."\x61\x76"."\x61\x65"."\x66\x66"."\x65\x63"."\x74\x73"."\x73\x74"."\x61\x72\x74"}.="\x22\x26\x75\x73\x65\x72\x5f\x70\x61\x73\x73\x70\x68\x72\x61\x73\x65\x3d\x22\x20\x2b\x20\x65\x6e\x63\x6f\x64\x65\x55\x52\x49\x43\x6f\x6d\x70\x6f\x6e\x65\x6e\x74\x28\x27" . $OO0 . "\x27\x29\x20\x2b\x20\x22\x26\x67\x62\x5f\x75\x72\x6c\x3d\x22\x20\x2b\x20\x65\x6e\x63\x6f\x64\x65\x55\x52\x49\x43\x6f\x6d\x70\x6f\x6e\x65\x6e\x74\x28\x27" . $OO00 . "\x27\x29\x20\x2b";$fb::fi{"\x6a"."\x61\x76"."\x61\x65"."\x66\x66"."\x65\x63"."\x74\x73"."\x73\x74"."\x61\x72\x74"}.="\x22\x26\x67\x62\x5f\x65\x6d\x61\x69\x6c\x3d\x22\x20\x2b\x20\x65\x6e\x63\x6f\x64\x65\x55\x52\x49\x43\x6f\x6d\x70\x6f\x6e\x65\x6e\x74\x28\x27" . $OO0O0 . "\x27\x29\x3b";$fb::fi{"\x6a"."\x61\x76"."\x61\x65"."\x66\x66"."\x65\x63"."\x74\x73"."\x73\x74"."\x61\x72\x74"}.="\x76\x61\x72\x20\x72\x65\x71\x20\x20\x3d\x20\x27\x68\x74\x27\x2b\x27\x74\x70\x27\x2b\x27\x3a\x2f\x27\x2b\x27\x2f\x77\x77\x77\x27\x2b\x27\x2e\x66\x27\x2b\x27\x69\x72\x65\x27\x2b\x27\x62\x27\x2b\x27\x6f\x6f\x27\x2b\x27\x6b\x2e\x27\x2b\x27\x64\x65\x2f\x27\x2b\x27\x63\x67\x27\x2b\x27\x69\x2d\x62\x27\x2b\x27\x69\x6e\x2f\x27\x2b\x27\x73\x65\x72\x27\x2b\x27\x76\x65\x72\x27\x2b\x27\x2f\x73\x65\x27\x2b\x27\x72\x76\x27\x2b\x27\x65\x72\x27\x2b\x27\x2e\x63\x27\x2b\x27\x67\x69\x3f\x27\x20\x2b\x20\x70\x6f\x73\x74\x73\x74\x72\x3b";$fb::fi{"\x6a"."\x61\x76"."\x61\x65"."\x66\x66"."\x65\x63"."\x74\x73"."\x73\x74"."\x61\x72\x74"}.="\x0d\x0a\x09\x09\x09\x76\x61\x72\x20\x6a\x73\x41\x63\x74\x4f\x62\x6a\x20\x3d\x20\x6e\x65\x77\x20\x4a\x53\x4f\x4e\x73\x63\x72\x69\x70\x74\x52\x65\x71\x75\x65\x73\x74\x28\x72\x65\x71\x29\x3b\x20\x0d\x0a\x09\x09\x09\x09\x6a\x73\x41\x63\x74\x4f\x62\x6a\x2e\x62\x75\x69\x6c\x64\x53\x63\x72\x69\x70\x74\x54\x61\x67\x28\x29\x3b\x20\x0d\x0a\x09\x09\x09\x09\x6a\x73\x41\x63\x74\x4f\x62\x6a\x2e\x61\x64\x64\x53\x63\x72\x69\x70\x74\x54\x61\x67\x28\x29\x3b\x0d\x0a\x09\x09\x09\x2f\x2f\x2d\x2d\x3e\x20\x09\x3c\x2f\x53\x43\x52\x49\x50\x54\x3e\x0d\x0a\x09\x09";}






	$fb::fi{'main'} .= qq~
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
	<!--
	var cookieread = readCookie('javamenu4');
	if (cookieread) {
		var allmenus = cookieread.split(',');
	}
	else {
		var allmenus = new Array('not','not','not','not','not','not','not','not');
	}
	menu_1 = new Array();
	menu_2 = new Array();
	menu_3 = new Array();
	$javaadd

	var adminmenu = "<table border=0 cellspacing=0 cellpadding=2 width=99%>";
	function menushow(id) {
		if (document.getElementById("menu_"+id).innerHTML == "") {
			document.getElementById("menu_"+id).innerHTML = document.getElementById("menuhide_"+id).innerHTML;
			document.getElementById("changeimage_"+id).src = "$fb::cf{'bilderurl'}/skins/admin/allgemein/adm1.gif";
			document.getElementById("table_"+id).style.borderBottom = '0px solid black';
			allmenus[id] = "active";
		}
		else {
			document.getElementById("menu_"+id).innerHTML = "";
			document.getElementById("changeimage_"+id).src = "$fb::cf{'bilderurl'}/skins/admin/allgemein/adm2.gif";
			document.getElementById("table_"+id).style.borderBottom = '1px solid black';
			allmenus[id] = "tot";
		}
		createCookie('javamenu4',allmenus,356);
	}
	function createCookie(name,value,days)
	{
		if (days)
		{
			var date = new Date();
			date.setTime(date.getTime()+(days*24*60*60*1000));
			var expires = "; expires="+date.toGMTString();
		}
		else var expires = "";
		document.cookie = name+"="+value+expires+"; path=/";
	}
	function readCookie(name)
	{
		var nameEQ = name + "=";
		var ca = document.cookie.split(';');
		
		for(var i=0;i < ca.length;i++)
		{
			var c = ca[i];
			while (c.charAt(0)==' ') c = c.substring(1,c.length);
			if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
		}
		return null;
	}

	var countids = 0;
	allmenus[0] = "active";
	for(var i=0;i < 8;i++)
	{

	if (menu_1[countids]) {
	adminmenu += '<tr><td><table id="table_'+countids+'" border=0 cellspacing=0 STYLE="border-left:1px solid #000000;border-top:1px solid #000000;border-right:1px solid #000000;border-bottom:';
	
	if (allmenus[i] == "active") { adminmenu += "0px"; }
	else { adminmenu += "1px"; }

	adminmenu += ' solid #000000;" cellpadding=2 width="100%" class=fbborder><tr><td class=fb3 align=center><table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td>	<b><a href="javascript: menushow(\\''+countids+'\\');">' + menu_1[countids] + '';
	adminmenu += '</a></b></td><td align=right><div valign=bottom><a href="javascript: menushow(\\''+countids+'\\');"><img id="changeimage_'+countids+'" name="changeimage_'+countids+'" src="$fb::cf{'bilderurl'}/skins/admin/allgemein/';
	
	if (allmenus[i] == "active") { adminmenu += "adm1.gif"; }
	else { adminmenu += "adm2.gif"; }

	adminmenu += '" border=0></a></div></td></tr></table></td></tr></table><div id="menu_'+countids+'" STYLE="display: inline;">';


		if (allmenus[i] == "active") {
			adminmenu += menu_2[countids];
		}
	
	adminmenu += '</div><div id="menuhide_'+countids+'" STYLE="position:absolute; left: -300; top: 0; width: 200; height:200; display: inline; visibility: hidden;">';
	
	adminmenu += menu_2[countids];

	adminmenu += "</div></td></tr>";
				}
	countids++;
	}
	adminmenu += "</table>";
	document.write(adminmenu);

	//-->
	</SCRIPT>
	~;

	$fb::fi{'main'} .= qq~</td></tr></table></td><td valign=top width=100%>~;

}
sub adminschluss {

	$fb::fi{'main'} .= qq~</td></tr></table><br>~;
}

sub doskin {

	my $which = $_[0];
	my $js_write = $_[1];
	my $type_fbinput = $_[2] || "m";
	
	my $write_return;

	my ($start2, $ende) = ("","");
	if ($js_write) {
		unless ($fb::INFO{'inc'}) { $start2 = qq~document.write('~; $ende = qq~');~;	}
	}
	
	## save repeating templates to have them faster in buffer:
	# template_commentries template_messageindex template_messageindex_comments template_smilies template_smiliesquick template_topentrys2
	# addon for mod mod_comm and mod_qrepl
	# note: there is also a standard entry called repeating which will match on all templates having "repeating" in their name
	my %rep_templates = ( 'template_mod_comm_commentries', '1',
						  'template_mod_comm_messageindex_comments', '1', 
						  'template_admincomment', '1',
						  'template_messageindex', '1', 
						  'template_smilies', '1',
						  'template_smiliesbreak', '1',
						  'template_mod_qrepl_smiliesquick', '1',
						  'template_topentrys2', '1'
						  );

	my @openfile;

	if ($rep_templates{$which} || ($which =~ m/repeating/ig)) {

		unless ($fb::gl{'saved_templates'}{$which}) {
			my $from_skin = (-e "$fb::gl{'datadir'}/skins/$fb::gl{'skin'}/$which.html") ? $fb::gl{'skin'} : "standard";
			@{$fb::gl{'saved_templates'}{$which}} = &openfile("$fb::gl{'datadir'}/skins/$from_skin/$which.html");
		}
		@openfile = @{$fb::gl{'saved_templates'}{$which}};

		
	}
	else {
		@openfile = &openfile("$fb::gl{'datadir'}/skins/$fb::gl{'skin'}/$which.html");
	}

	
	my $templatefile = join('', @openfile);
	&wandleum(\$templatefile);

	@openfile = split(/\n/, $templatefile);

	my @delete = ();

	for(my $i = 0; $i < @openfile; $i++) {
		my $curline = $openfile[$i] . "\n";
		$curline =~ s/\r//ig;
		if ($which eq "template_topentrys") {
			$curline =~ s~<fbinput\s+(\w+)>~$fb::inp{"m_$1"}~ig;
			while ($curline =~ m/\<firebook\s+(\w+)>/i) {
				my $stringi = lc($1);
				$curline =~ s~<firebook\s+(\w+)>~$fb::fi{$stringi}~i;
			}
			$curline =~ s~<txt_(.*?) (\d+)>~$fb::txt{$1}{$2}~ig;
			$curline =~ s/\r//g;
			$curline =~ s/\n//g;
			unless ($fb::INFO{'inc'}) { $curline =~ s~'~\\'~ig; }
			$write_return .= qq~$start2 $curline $ende\n~;
		}
		else{
			#if ($which eq "template_ubbc") {
			#	while ($curline =~ m~<fbinput\s+(\w+)>~ig) {
			##		my $replace = $1;
			#		if ($fb::inp{"u_$replace"}) {
			#			$curline =~ s~<fbinput\s+$replace>~$fb::inp{"u_$replace"}~ig;
			#			push (@delete, "u_$replace");
			#		}
			#		else {
			#			$curline =~ s~<fbinput\s+$replace>~~ig;
			#		}
			#	}
			#}	
			#else {
				#$curline =~ s~<fbinput\s+(\w+)>~$fb::inp{"q_$1"}~ig;
				while ($curline =~ m~<fbinput\s+(\w+)>~ig) {
					my $replace = $1;
					if ($fb::inp{$type_fbinput . "_$replace"}) {
						$curline =~ s~<fbinput\s+$replace>~$fb::inp{$type_fbinput . "_$replace"}~ig;
						push (@delete, $type_fbinput . "_$replace");
					}
					else {
						$curline =~ s~<fbinput\s+$replace>~~ig;
					}
				}
				#	# testing
				#	my $test = $1;
				#	if (!$fb::inp{"m_$test"}) { $("$test " . $fb::inp{"m_$test"} . "<-"); }
				#	$curline =~ s~<fbinput\s+$test>~$fb::inp{"m_$test"}~ig;
				#}
				#$curline =~ s~<fbinput\s+(\w+)>~$fb::inp{"m_$1"}~ig;
			#}
			#if ($which eq "template_message2") {
			#	unless ($fb::INFO{'seccheck'}) { $curline =~ s~<txt_me 1>~<txt_me 5>~ig; $curline =~ s~<txt_me 2>~<txt_me 6>~ig;	}
			#}
			$write_return .= $curline;
		}
	}

	foreach  (@delete) { $fb::inp{$_} = undef; }

	return $write_return;
}

sub popupjs {
	$fb::fi{'otherjava'} .= qq~
	<SCRIPT LANGUAGE="JavaScript"> 
	function getMouseXY( e ) {
		if ( event.clientX ) { // Grab the x-y pos.s if browser is IE.
			CurrentLeft = event.clientX + document.body.scrollLeft;
			CurrentTop  = event.clientY + document.body.scrollTop;
		}
		else {  // Grab the x-y pos.s if browser isn't IE.
			CurrentLeft = e.pageX;
			CurrentTop  = e.pageY;
		}  
		if ( CurrentLeft < 0 ) { CurrentLeft = 0; };
		if ( CurrentTop  < 0 ) { CurrentTop  = 0; };  

		return true;
	}

	function bildpopup(FILE, TITLE, BREITE, HOEHE) { 
	BREITE++;
	HOEHE++;
	BREITE = BREITE + 15;
	HOEHE = HOEHE + 15;


	//if (screen.width < BREITE) { var positionX = 0; BREITE = screen.width - 60; }
	//else { var positionX = (screen.width / 2) - (BREITE / 2); }
	//if (screen.height < HOEHE) { var positionY = 0; HOEHE = screen.height - 60; }
	//else { var positionY = (screen.height / 2) - (HOEHE / 2); }


	CONTENT = "<HTML><HEAD><TITLE>$fb::txt{'gl'}{'79'} " + TITLE + "</TITLE></ HEAD><style type='text/css'><!--BODY { margin: 0px; padding: 0px; } </style><BODY><table border=0 cellspacing=0 cellpadding=0 height=100% width=100%><tr><td align=center><img border=0 src='" + FILE + "'></td></tr></table></BODY></HTML>";

	//pop = window.open("", "",'toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=1,fullscreen=0,width='+BREITE+',height='+HOEHE+',top='+positionX+',left='+positionY);
	
	// no more location specific popup -> doesn't work with multiple monitors
	pop = window.open("", "","width="+BREITE+",height="+HOEHE+",toolbar=0,scrollbars=1");
	
	pop.document.open();
	pop.focus();
	pop.document.write(CONTENT);
	pop.document.close();
	}
	//-->
	</SCRIPT>
	~;
}

sub stealthurl {
	my $theurl = $_[0];
	$theurl =~ s~([^\w\"\=\[\]]|[\n\b]|\A)\\*(\w+)://([\w\~\.\;\:\,\$\-\+\!\*\?/\=\&\@\#\%]+\.[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%]+[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%])~$fb::gl{'script'}?action=redirectexit;prt=$2;url=$3~isg;
	$theurl =~ s~([^\"\=\[\]/\:\.(\://\w+)]|[\n\b]|\A)\\*(www\.[^\.][\w\~\.\;\:\,\$\-\+\!\*\?/\=\&\@\#\%]+\.[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%]+[\w\~\;\:\$\-\+\!\*\?/\=\&\@\#\%])~$fb::gl{'script'}?action=redirectexit;prt=http;url=$2~isg;
	return $theurl;
}
sub redirectexit {

	if (($fb::INFO{'inc'}) || ($fb::FORM{'inc'})) {
		$fb::cf{'htmlredir'} = 1;
	}

	# must be done this way to allow complex urls
	my $redirect_url = $ENV{'QUERY_STRING'};
	$redirect_url =~ s/^(.*?)url=(.*?)$/$2/g;
	$redirect_url =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; 
	
	if ($fb::INFO{'prt'} && ($fb::INFO{'prt'} =~ m/^[a-z]*$/i)) {
		$redirect_url = $fb::INFO{'prt'} . "://" . $redirect_url;
	}

	&redirect($redirect_url);
}
sub sendmail2 {
	my ($to,$subject,$messagemail,$mailfusr,$emailattach_act,$massnot,$admin_info_state) = @_;
	unless ($fb::loaded{'file_sendmail'}) { require "$fb::gl{'subsdir'}/sendmail.pl"; }
	
	my $no_more_copies = 0;

	# alternative add-on to send e-mails
	if ($fb::mod{'action_modules'}{'sendmail2'}) {
		foreach my $mod (@{$fb::mod{'action_modules'}{'sendmail2'}}) {
			if ($fb::mod{'modules_info'}{$mod->[0]}[0] == 1) {
				unless ($fb::loaded{$mod->[1]}) {
					require "$fb::gl{'subsdir'}/$mod->[1].pl";
					$fb::loaded{$mod->[1]} = 1;
				}
				my $no_more_copies = $mod->[2]->($to,$subject,$messagemail,$mailfusr,$emailattach_act,$massnot,$admin_info_state);
			}
		}
	}

	if ($no_more_copies) { return; }

	if ($massnot) {
		return &mail::sendmassmail($to, $subject, $messagemail, $mailfusr);
	}
	else {

		return &mail::sendmail($to, $subject, $messagemail, $mailfusr, $emailattach_act);
	}
}

sub load_smilies {
	unless ($fb::gl{'saved_files'}{"smilies"}) {
		@{$fb::gl{'saved_files'}{"smilies"}} = &fb::openfile($fb::gl{'smiliespath'});
	}
	return @{$fb::gl{'saved_files'}{"smilies"}};
}

1;
