####################### [Firebook] - guestbook ################################
# editall.pl  		                                                          #
###############################################################################

package fb;

use strict;
use warnings;
#use diagnostics;

# file was hacked to also accomodate comments mod_comm module

sub editall {

	&isadmin;
	&adminmenu;

	my $start = $fb::INFO{'startb'};
	

	
	my $sel = $fb::INFO{'sel'} || "";

	my $implement_file = "";
	my $print_title = "";

	if ($sel eq "comm") {
		
		$print_title = $fb::txt{'mod_comm_gl'}{'7'};
		$implement_file = "datacomm";

	}
	else {

		$print_title = $fb::txt{'ea'}{'1'};
		$implement_file = "datainc";

	}

		$fb::fi{'main'} .= qq~	<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder><tr>
		<td colspan=2 width="100%" class=fbcatbg>$print_title</td></tr>~;

	my $searchstring    = $fb::INFO{'suche'} || "";
	my $sort            = $fb::INFO{'sort'} || "";
	my $pr_searchstring = convert_to_hex($searchstring);
	
	my $addhere         = ";sort=$sort;suche=$pr_searchstring";

	my $add_sql_search = "";

	if ($searchstring) {
		
		$searchstring = lc($searchstring);
		my $quoted = $fb::dbh->quote("%" . $searchstring . "%");

		$add_sql_search .=
		    " AND (LOWER(name) LIKE " . $quoted
		  . " OR LOWER(email) LIKE "
		  . $quoted
		  . " OR LOWER(message) LIKE "
		  . $quoted
		  . " OR LOWER(ip) LIKE "
		  . $quoted . ")";
	}
	
	my $add_sort = "";
	if    ($sort eq "name")  { $add_sort = " ORDER BY name ASC"; }
	elsif ($sort eq "email") { $add_sort = " ORDER BY email ASC"; }
	elsif ($sort eq "ip")    { $add_sort = " ORDER BY ip ASC"; }
	elsif ($sort eq "datum") { $add_sort = " ORDER BY datum DESC"; }
	else { $add_sort = " ORDER BY id DESC"; }

	unless ($start) { $start = 0; }

	my $countf = $fb::dbh->selectrow_array("SELECT COUNT(*) FROM $fb::cf{'db_prefix'}" . "$implement_file WHERE (1)$add_sql_search$add_sort", undef);

	if    ($start > $countf) { $start = int($countf % $fb::cf{'maxindex'}) * $fb::cf{'maxindex'}; }
	elsif ($start < 0)       { $start = 0; }
	
	my $indexdisplaynum = 5;
	my $tmpa            = 1;
	my $tmpx            = int($countf / $fb::cf{'maxindex'});

	my ($startpage, $endpage) = (0,0);

	if ($start >= (($indexdisplaynum - 1) * $fb::cf{'maxindex'})) {
		$startpage = $start - (($indexdisplaynum - 1) * $fb::cf{'maxindex'});
		$tmpa = int($startpage / $fb::cf{'maxindex'}) + 1;
	}
	if ($countf >= $start + ($indexdisplaynum * $fb::cf{'maxindex'})) { $endpage = $start + ($indexdisplaynum * $fb::cf{'maxindex'}); }
	else { $endpage = $countf }
	
	my ($pagesa) = "";

	if ($startpage > 0) { $pagesa = qq~<a href="$fb::gl{'scriptac'}=editall;sel=$sel;startb=0$addhere">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $fb::cf{'maxindex'}) { $pagesa = qq~<a href="$fb::gl{'scriptac'}=editall;sel=$sel;startb=0$addhere">1</a>&nbsp;~; }
	for (my $counter = $startpage ; $counter < $endpage ; $counter += $fb::cf{'maxindex'}) {
		$pagesa .= ($start == $counter) ? qq~<B><U>$tmpa</U></B>&nbsp;~ : qq~<a href="$fb::gl{'scriptac'}=editall;sel=$sel;startb=$counter$addhere">$tmpa</a>&nbsp;~;
		++$tmpa;
	}
	
	$tmpx      = $countf - 1 - $fb::cf{'maxindex'};
	my $outerpn   = int($tmpx / $fb::cf{'maxindex'});
	my $pagecount = int(($countf - 1) / $fb::cf{'maxindex'}) + 1;
	my $lastptn   = ($pagecount - 1) * $fb::cf{'maxindex'};
	
	my $pagesaadd = "";

	if ($endpage < $countf - $fb::cf{'maxindex'}) { $pagesaadd = qq~&nbsp;...&nbsp;~; }
	if ($endpage != $countf) {
		$pagesaadd .= qq~&nbsp;<a href="$fb::gl{'scriptac'}=editall;sel=$sel;startb=$lastptn$addhere">$pagecount</a>~;
	}
	$pagesa .= $pagesaadd;
	if ($pagesa eq "") { $pagesa = "1"; }

	my $sorturl = "$fb::gl{'scriptac'}=editall;sel=$sel;suche=$pr_searchstring&sort";

	$fb::fi{'main'} .= qq~<tr><td class=fb1 colspan=2 align=center>
		[ <b>$countf</b> $fb::txt{'ea'}{'3'} ] &nbsp; [ $fb::txt{'gl'}{'4'}: $pagesa ]</td></tr>
	<tr><td class=fb2 colspan=2 align=center>
			
			<table border=0 cellspacing=0 cellpadding=3><form action="$fb::gl{'script'}" method="get" name="fiform">	
				<input type=hidden name=lang value=$fb::gl{'sprache2'}>$fb::gl{'hiddenscro2'} <input type=hidden name=action value="editall"><input type=hidden name=sel value="$sel"><input type=hidden name=skin value="admin">
			<tr><td align=right>
	<b>$fb::txt{'ea'}{'11'}:</b></td>

	<td>
		<input type="text" name="suche" value="$searchstring" size=10> <input type="submit" name="post" value="$fb::txt{'gl'}{'65'}">
	</td></tr></form></table>

	</td></tr>
	</table><br>~;
	
	my ($sort_idlink, $sort_namelink, $sort_emaillink, $sort_datumlink, $sort_iplink);

	if (($sort eq "id") || ($sort eq "")) { $sort_idlink = qq~<font color=blue>$fb::txt{'gl'}{'48'}</font>~; }
	else { $sort_idlink = qq~<a href="$sorturl=id">$fb::txt{'gl'}{'48'}</a>~; }
	
	if ($sort eq "name") { $sort_namelink = qq~<font color=blue>$fb::txt{'gl'}{'28'}</font>~; }
	else { $sort_namelink = qq~<a href="$sorturl=name">$fb::txt{'gl'}{'28'}</a>~; }
	
	if ($sort eq "email") { $sort_emaillink = qq~<font color=blue>$fb::txt{'gl'}{'29'}</font>~; }
	else { $sort_emaillink = qq~<a href="$sorturl=email">$fb::txt{'gl'}{'29'}</a>~; }
	
	if ($sort eq "datum") { $sort_datumlink = qq~<font color=blue>$fb::txt{'ea'}{'6'}</font>~; }
	else { $sort_datumlink = qq~<a href="$sorturl=datum">$fb::txt{'ea'}{'6'}</a>~; }
	
	if ($sort eq "ip") { $sort_iplink = qq~<font color=blue>$fb::txt{'gl'}{'27'}</font>~; }
	else { $sort_iplink = qq~<a href="$sorturl=ip">$fb::txt{'gl'}{'27'}</a>~; }

	$fb::fi{'main'} .= qq~
	<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>
	<form action="$fb::gl{'scriptac'}=editall2" method="post" name="fiform"><input type=hidden name=sel value="$sel">
	<input type=hidden name=start value="$start"><input type=hidden name=sort value="$sort">
	<tr><td class=fb1 align=center>&nbsp;</td><td class=fb1 align=center>&nbsp;</td>
	<td class=fb1 align=center><b>$sort_idlink</b></td>
	<td class=fb1><b>&raquo; $sort_namelink<br>&raquo; $sort_emaillink</b></td> 
	<td class=fb1><b>&raquo; $sort_datumlink<br>&raquo; $sort_iplink</b></td><td class=fb1 width=40%><b>&raquo; $fb::txt{'gl'}{'47'}</b></td>
	<td class=fb1 align=center><img src="$fb::fi{'bilderurlsk'}/allgemein/not_ok.gif" title="$fb::txt{'ea'}{'8'}" alt="$fb::txt{'ea'}{'8'}" border=0></td>	
	<td class=fb1 align=center><img src="$fb::fi{'bilderurlsk'}/allgemein/delete.gif" title="$fb::txt{'ea'}{'7'}" alt="$fb::txt{'ea'}{'7'}" border=0></td>
		</tr>
	~;

	my $sth;

	if ($sel eq "comm") {
		$sth = $fb::dbh->prepare("SELECT id, nr, datum, name, email, ip, message, frei FROM $fb::cf{'db_prefix'}" . "$implement_file WHERE (1)$add_sql_search$add_sort LIMIT ?,?");
	}
	else {
		$sth = $fb::dbh->prepare("SELECT id, datum, name, email, ip, message, frei FROM $fb::cf{'db_prefix'}" . "$implement_file WHERE (1)$add_sql_search$add_sort LIMIT ?,?");
	}

	$sth->bind_param(1, $start, DBI::SQL_INTEGER);
	$sth->bind_param(2, $fb::cf{'maxindex'}, DBI::SQL_INTEGER);

	$sth->execute($start, $fb::cf{'maxindex'}) or save_db_error(DBI->errstr);
	
	my $countem = 1;
	my $shownids = "";

	while (my @entry = $sth->fetchrow_array) {
		
		my ($idold, $id, $datum, $name, $email, $ip, $message, $frei);

		if ($sel eq "comm") {
			($idold, $id, $datum, $name, $email, $ip, $message, $frei) = @entry;
		}
		else {
			($id, $datum, $name, $email, $ip, $message, $frei) = @entry;
		}

		if ($idold) {
			if ($idold =~ m/\*/ig) { (my $unwicht, $idold) = split(/\*/, $idold); }
		}
		if ($id    =~ m/\*/ig) { (my $unwicht, $id)    = split(/\*/, $id); }

		$shownids .= qq~$id,~;
		$countem++;

		$datum = &formatdatum($datum);

		my ($thischecked, $thisclass);
		
		if ($frei == 1) { $thischecked = " checked"; $thisclass = "fb1"; }
		else { $thischecked = ""; $thisclass = "fb2"; }



		if ($sel eq "comm") {

		$fb::fi{'main'} .= qq~<tr><td class=$thisclass align=center><font size=1>
			<a href="javascript:popUp('$fb::gl{'scriptac'}=mod_comm_showcomment;show=$id',600,200)">
			<img src="$fb::fi{'bilderurlsk'}/allgemein/preview.gif" title="$fb::txt{'ea'}{'9'} $id" alt="$fb::txt{'ea'}{'9'} $id" border="0">
			</a></font></td><td class=$thisclass align=center><font size=1>~;
			
			my $actionstring = &fb::convert_argument("mod_comm_commentsedit;id=$idold;nr=$id");
			$fb::fi{'main'} .= qq~<a target=_blank href="$fb::gl{'scriptac'}=customlogin;action_follow=$actionstring;freetemp=1">
				<img src="$fb::fi{'bilderurlsk'}/allgemein/edit_mini.gif" title="$fb::txt{'ea'}{'10'} $id" alt="$fb::txt{'ea'}{'10'} $id" border="0">
				</a>~;

		}
		else {

		$fb::fi{'main'} .= qq~<tr><td class=$thisclass align=center><font size=1>
			<a href="javascript:popUp('$fb::gl{'scriptac'}=showmessage;show=$id',600,200)">
			<img src="$fb::fi{'bilderurlsk'}/allgemein/preview.gif" title="$fb::txt{'ea'}{'9'} $id" alt="$fb::txt{'ea'}{'9'} $id" border="0">
			</a></font></td><td class=$thisclass align=center><font size=1>~;
		
			my $actionstring = &fb::convert_argument("edit;id=$id");
			$fb::fi{'main'} .= qq~<a target=_blank href="$fb::gl{'scriptac'}=customlogin;action_follow=$actionstring">
				<img src="$fb::fi{'bilderurlsk'}/allgemein/edit_mini.gif" title="$fb::txt{'ea'}{'10'} $id" alt="$fb::txt{'ea'}{'10'} $id" border="0">
				</a>~;

		}

		$fb::fi{'main'} .= qq~</font></td><td class=$thisclass align=center><b>~;

		if ($idold) { $fb::fi{'main'} .= qq~$idold - $id~; }
		else { $fb::fi{'main'} .= qq~$id~; }

		$fb::fi{'main'} .= qq~</b></td><td class=$thisclass><font size=1><u>$name</u><br><a href="mailto:$email">$email</a>
			</font></td><td class=$thisclass><font size=1>$datum<br><i><font color=red>$ip</font></i></font></td>
			<td class=$thisclass><font size=1><b>$message</b><input type=hidden id="change_ids" name="change_ids" value="$id"></font></td>
			<td class=$thisclass align=center><input type=hidden id="c$id" name="c$id" value=1>
			<input type=checkbox id="a$id" name="a$id" value="1"$thischecked>	</td><td align=center class=$thisclass>
			<input type=checkbox id="b$id" name="b$id" value="1"></td></tr>
			~;

	}

	if ($countem != 1) {
		# we have entries

		my @shownids = split(/\,/, $shownids);
		my ($checkit, $uncheckit) = ("","");
		foreach (@shownids) {
			$checkit   .= qq~document.getElementById(was+ "$_").checked=true;\n~;
			$uncheckit .= qq~document.getElementById(was+ "$_").checked=false;\n~;
		}

		$fb::fi{'main'} .= qq~
		<tr><td class=fb2 colspan=6>
		<script language="javascript">
		function check_it(was){
		$checkit
		}
		function uncheck_it(was){
		$uncheckit
		}	
		</script></td><td class=fb1 align=center><INPUT TYPE="checkbox" ONCLICK="if (this.checked) check_it('a'); else uncheck_it('a');">
			</td><td class=fb1 align=center><INPUT TYPE="checkbox" ONCLICK="if (this.checked) check_it('b'); else uncheck_it('b');"></td></tr>~;

	}

	$fb::fi{'main'} .= qq~<tr><td colspan=8 align=center class=fb4>~;

	if ($countem != 1) { 
		$fb::fi{'main'} .= qq~<input type="submit" name="post" value="$fb::txt{'gl'}{'117'}">~; 
	}
	else {
		if ($sel eq "comm") { $fb::fi{'main'} .= qq~<b>$fb::txt{'ea'}{'5'}</b>~; }
		else { $fb::fi{'main'} .= qq~<b>$fb::txt{'ea'}{'4'}</b>~; }
	}
	$fb::fi{'main'} .= qq~</td>
      </tr></form>
	</table>~;

	&adminschluss;
	&template;
}

sub editall2 {
	
	&isadmin;

	my @change_ids = split(/\, /, $fb::FORM{'change_ids'});

	my $sel = $fb::FORM{'sel'};
	
	my $messages_processed = 0;
	
	if ($sel eq "comm") {

		foreach my $id (@change_ids) {
			
			my $frei = $fb::FORM{"a$id"} || "0";
			my $del = $fb::FORM{"b$id"} || "0";
			my $washere = $fb::FORM{"c$id"};

			if ($washere == 1) {
				
				my $printfrei = ($frei == 1) ? "1" : "0";

				unless ($del == 1) {
					$fb::dbh->do("UPDATE $fb::cf{'db_prefix'}" . "datacomm SET frei = ? WHERE nr = ?", undef, $printfrei, $id);
				}
				else {
					$fb::dbh->do("DELETE FROM $fb::cf{'db_prefix'}" . "datacomm WHERE nr = ?", undef, $id);
					$messages_processed++;
				}
			}

		}

	}
	else {

		foreach my $id (@change_ids) {
			
			my $frei = $fb::FORM{"a$id"} || "0";
			my $del = $fb::FORM{"b$id"} || "0";
			my $washere = $fb::FORM{"c$id"};

			if ($washere == 1) {
				
				my $printfrei = ($frei == 1) ? "1" : "0";

				unless ($del == 1) {
					$fb::dbh->do("UPDATE $fb::cf{'db_prefix'}" . "datainc SET frei = ? WHERE id = ?", undef, $printfrei, $id);
				}
				else {
					$fb::dbh->do("DELETE FROM $fb::cf{'db_prefix'}" . "datainc WHERE id = ?", undef, $id);

					## possibility to add extra modules .-> delete comments

					if ($fb::mod{'action_modules'}{'deletemsg'}) {
						foreach my $mod (@{$fb::mod{'action_modules'}{'deletemsg'}}) {
							if ($fb::mod{'modules_info'}{$mod->[0]}[0] == 1) {
								unless ($fb::loaded{$mod->[1]}) {
									require "$fb::gl{'subsdir'}/$mod->[1].pl";
									$fb::loaded{$mod->[1]} = 1;
								}
								my $check = $mod->[2]->($id);
							}
						}
					}

					$messages_processed++;
				}
			}
		}

	}

	my $start = $fb::FORM{'start'} - $messages_processed;
	if ($start < 0) { $start = 0; }

	my $set_location = "$fb::gl{'scriptac'}=editall;sel=$sel;startb=$start;sort=$fb::FORM{'sort'}";
	&redirect($set_location);
}
1;
