####################### [Firebook] - guestbook ################################
# login.pl   		                                                          #
###############################################################################

package fb;

use strict;
use warnings;
#use diagnostics;

sub login {

	$fb::INFO{'skin'} = "admin";
	$fb::gl{'skin'} = "admin";

	&isadmin2;

	if ($fb::INFO{'inc'}) {
		$fb::cf{'htmlredir'} = 1;
		my $set_location = qq~$fb::gl{'scriptac'}=login~;
		$fb::gl{'noRedirectReplace'} = 1;
		&redirect($set_location);
	}
	unless ($fb::gl{'logged_in'}) {

		$fb::fi{'title'} = "$fb::txt{'lg'}{'1'}";
		$fb::fi{'main'} .= qq~<br>
			<form action="$fb::gl{'scriptac'}=admin" method="post" name="fiform">	
			<table border=0 width="300" cellspacing=1 class=fbborder cellpadding="2" align=center><tr>
				<td class=fbcatbg><b>$fb::txt{'lg'}{'2'}</b></td></tr>
			<tr><td class=fb2>
			<table border=0 width="100%" cellspacing=0 cellpadding="2"><tr>
				<tr> <td align="right"><b>$fb::txt{'lg'}{'3'}:&nbsp;</b></td>
					<td><input type=text name="usr" size=26></td></tr>
				<tr><td align="right"><b>$fb::txt{'lg'}{'4'}:&nbsp;</b></td>
					<td><input type=password name="usrpass" size=26></td>
				  </tr>
				<tr><td align="right"></td>
					<td><input type="checkbox" name="remember"> $fb::txt{'lg'}{'6'} </td>
				  </tr>
			</table></td>
			
		<tr><td class=fb4 align=center><input type="submit" name="post" value="$fb::txt{'lg'}{'5'}"></td></tr>
			</table>
			</form><br>~;
		&template;

	}
	else {
		my $set_location = qq~$fb::gl{'scriptac'}=admin~;
		&redirect($set_location);
	}
}

sub customlogin {

	my $value = $fb::INFO{'id'};

	&isadmin2;

	my $forward_action_string = $fb::INFO{'action_follow'} || &fatal_error("action string missing");
	$forward_action_string = &fb::deconvert_argument($forward_action_string);

	my $return_action_string = $fb::INFO{'action_return'} || "";
	# to be deconverted later in the action
	#$return_action_string = &fb::deconvert_argument($return_action_string);

	unless ($fb::gl{'logged_in'}) {
		# not logged in

		$fb::fi{'title'} = $fb::txt{'lg'}{'5'};

		$fb::fi{'main'} .= qq~<br>
		<form action="$fb::gl{'scriptac'}=$forward_action_string;action_return=$return_action_string" method="post" name="fiform">	

<table border=0 width="300" cellspacing=1 class=fbborder cellpadding="2" align=center><tr>
				<td class=fbcatbg><b>$fb::fi{'title'}</b></td></tr>
			<tr><td class=fb2>
			<table border=0 width="100%" cellspacing=0 cellpadding="2"><tr>
				<tr> <td align="right"><b>$fb::txt{'lg'}{'3'}:&nbsp;</b></td>
					<td><input type=text name="usr" size=26></td></tr>
				<tr><td align="right"><b>$fb::txt{'lg'}{'4'}:&nbsp;</b></td>
					<td><input type=password name="usrpass" size=26></td>
				  </tr>
				<tr><td align="right"></td>
					<td><input type="checkbox" name="remember"> $fb::txt{'lg'}{'6'} </td>
				  </tr>
			</table></td>
			
		<tr><td class=fb4 align=center><input type="submit" name="post" value="$fb::txt{'lg'}{'5'}"></td></tr>
			</table>
			</form>


		</form><br>~;
		
		# extension for modules using popups
		if ($fb::INFO{'freetemp'}) {
			if ($fb::cf{'popup_act'} == 1) { &freetemp; }
			else { &template; }
			exit;
		}
		else {
			&template;
			exit;
		}
	}
	else {

		my $popuptemplate = 0;

		my $set_location = "$fb::gl{'scriptac'}=$forward_action_string;action_return=$return_action_string";

		if ($fb::INFO{'inc'}) { $fb::cf{'htmlredir'} = 1; }
		
		&redirect($set_location, $popuptemplate);
	
	}
}

sub cook {
	
	&isadmin;
	
	my $deletecookies = $fb::INFO{'deletecookies'} || "";
	
	# only if there are cookies we can delete them
	my ($cookie_username,$cookie_password) = split(/\|/,&cookie_laden('fbcookiepwgb'));

	if (($deletecookies eq "") && $cookie_username) {

		$fb::fi{'main'} .= qq~
		<br><table border=0 width="300" cellspacing=1 align="center" class=fbborder cellpadding="4">
		<tr><td class=fb2>
		  <table border=0 cellspacing=1 cellpadding=2 width=100%><tr><td align=center>
		  </td><td align=center><b>$fb::txt{'lg'}{'8'}</b></td></tr><tr><td></td>
		  <td class=quote>
			<table border=0 cellspacing=0 cellpadding=3 width=100%><tr><td align=right>
		<a href="$fb::gl{'scriptac'}=cook;deletecookies=yes"><img src="$fb::cf{'bilderurl'}/skins/standard/allgemein/raquo.gif" title="$fb::txt{'lg'}{'9'}" alt="$fb::txt{'lg'}{'9'}" border=0></a></td><td> 
			<a href="$fb::gl{'scriptac'}=cook;deletecookies=yes"><b>$fb::txt{'lg'}{'9'}</b></a></td><td align=right>
			<a href="$fb::gl{'scriptac'}=cook;deletecookies=no"><img src="$fb::cf{'bilderurl'}/skins/standard/allgemein/raquo.gif" title="$fb::txt{'lg'}{'10'}" alt="$fb::txt{'lg'}{'10'}" border=0></a></td><td>
			<a href="$fb::gl{'scriptac'}=cook;deletecookies=no"><b>$fb::txt{'lg'}{'10'}</b></a></td></tr></table>
			</td>
		  </tr></table></td></tr>
		</table><br>
			~;
		&template;
	}
	elsif ($deletecookies eq "yes") {
		
		my $fbcookiepwgb = "|";
		my $expired_time=gmtime(time()-30*24*3600)." GMT";	# we set a past date
		push(@{$fb::gl{'cookies'}},"fbcookiepwgb=$fbcookiepwgb; expires=$expired_time;");
		&delete_sessions("", $fb::gl{'fisession'});
		
		my $set_location = "$fb::fi{'script'}";
		&redirect($set_location);

	}
	else {
		
		&delete_sessions("", $fb::gl{'fisession'});
		my $set_location = "$fb::fi{'script'}";
		&redirect($set_location);
	
	}
}

sub newadmin {
	# admin password change

	&isadmin;
	require "$fb::gl{'datadir'}/admdat/admin.pl";

	package fb;

	&adminmenu;

	$fb::fi{'main'} .= qq~<form action="$fb::gl{'scriptac'}=newadmin2" method="post" name="fiform">
	<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder><tr><td width="100%" class=fbcatbg><b>$fb::txt{'gl'}{'82'}</b>
	</td></tr>
	<tr><td align=center class=fb2>

	<table border=0 cellspacing=0 cellpadding=0><tr>
				<td align="right"><font size=2><b>$fb::txt{'lg'}{'11'}:&nbsp;</b></font></td>
			<td><font size=2><input type=text name="usernameneu" value="$fb::cf{'user'}" size=20></font></td></tr><tr>
			<td align="right"><font size=2>$fb::txt{'lg'}{'12'}:&nbsp;</font></td>
			<td><font size=2><input type=password name="passwrdneu" value="$fb::cf{'pass'}" size=20></font></td>
	</tr><tr>
			<td align="right"><font size=2>$fb::txt{'lg'}{'13'}:&nbsp;</font></td>
			<td><font size=2><input type=password name="passwrdneu2" value="$fb::cf{'pass'}" size=20></font></td>
	</tr></table></td></tr>
		<tr><td class=fb4 align=center><input type="submit" name="post" value="$fb::txt{'gl'}{'117'}"></td></tr>
	</table></form>
	~;

	&adminschluss;
	&template;
}

sub newadmin2 {
	
	&isadmin;
	
	my $adm2   = $fb::FORM{'usernameneu'};
	my $passs2 = $fb::FORM{'passwrdneu'};
	my $passs3 = $fb::FORM{'passwrdneu2'};
	
	&fatal_error($fb::txt{'lg'}{'14'}) unless ($adm2);
	&fatal_error($fb::txt{'lg'}{'14'}) unless ($passs2);
	&fatal_error($fb::txt{'lg'}{'14'}) unless ($passs3);

	my $cryptpass = $fb::cf{'pass'};
		
	my $weiterlpass = "";
	
	if ($passs2 ne "$passs3")         { &fatal_error("$fb::txt{'lg'}{'15'}"); }
	if ($passs2 ne "$fb::cf{'pass'}") {
		$cryptpass = crypt("$passs2", $fb::gl{'pwseed'});
	}

	my $newadmin = << "EOF";
\$fb::cf{'user'} = "$adm2";	# whle deinen Admin Benutzernamen
\$fb::cf{'pass'} = "$cryptpass"; # whle dein Admin Passwort
1;
EOF

	&writefile("$fb::gl{'datadir'}/admdat/admin.pl", $newadmin);

	my $set_location = "$fb::gl{'scriptac'}=admin";
	&redirect($set_location);

}
1;
