####################### [Firebook] - guestbook ################################
# mailer.pl		                                                              #
###############################################################################

package fb;

use strict;
use warnings;
#use diagnostics;

sub mail {
	
	# language
	my $sprachesel = $fb::INFO{'sprachesel'} || $fb::cf{'sprache'};
	
	# load mail files
	my @contents = &opendirectory("$fb::gl{'datadir'}/language/$sprachesel");
	
	# current language file
	my $mailakt = $fb::INFO{'mailakt'} || "mail";
	my @mailfile = &openfile("$fb::gl{'datadir'}/language/$sprachesel/$mailakt.txt");

	# email file instructions
	my %etxt;

	$etxt{'normal'} = qq~<table border=0 cellspacing=3 cellpadding=3><tr><td valign=top width=33%>
<table border=0 cellspacing=0 cellpadding=0 width=100%>
<tr><td align=right><font size=1 color=red><i>+fbname+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'32'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+homepage+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'44'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+admmail+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'33'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+admmail2+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'34'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+id+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'36'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+datum+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'37'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+name+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'38'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+icon+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'39'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+admincomment+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'18'}</font></td></tr>
</table>
</td><td valign=top width=33%>
<table border=0 cellspacing=0 cellpadding=0 width=100%>
<tr><td align=right><font size=1 color=red><i>+email+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'29'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+url+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'31'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+ip+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'40'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+icq+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'18'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+aim+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'19'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+msn+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'20'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+yim+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'21'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+idurl+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'59'}</font></td></tr>
</table>
</td><td valign=top width=33%>

<table border=0 cellspacing=0 cellpadding=0 width=100%>
<tr><td align=right><font size=1 color=red><i>+message+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'36'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+bewertung+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'34'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+ort+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'32'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+inputinX+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'41'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+skype+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'146'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+jabber+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'22'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+betreff+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'30'}</font></td></tr>
<tr><td align=right><font size=1 color=red><i>+script+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'42'}</font></td></tr>
</table>
</td></tr></table>~;


	$etxt{'conf_code'} = qq~<table border=0 cellspacing=3 cellpadding=3><tr><td valign=top width=33%>
<table border=0 cellspacing=0 cellpadding=0 width=100%>
 <tr><td align=right><font size=1 color=red><i>+fbname+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'32'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+admmail+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'33'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+admmail2+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'34'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+confirmationcode+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'56'}</font></td></tr>
</table>
</td><td valign=top width=33%>
<table border=0 cellspacing=0 cellpadding=0 width=100%>
 <tr><td align=right><font size=1 color=red><i>+email+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'29'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+ip+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'40'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+datum+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'37'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+confirmationurl+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'57'}</font></td></tr>
</table>
</td><td valign=top width=33%>

<table border=0 cellspacing=0 cellpadding=0 width=100%>
 <tr><td align=right><font size=1 color=red><i>+homepage+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'44'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+script+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'42'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+aktion+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'58'}</font></td></tr>
	</table>
</td></tr></table>~;


# mod_comm addition


	$etxt{'mod_comm_mail_adminnotify'} = $etxt{'mod_comm_mail_authorcomm'} = $etxt{'mod_comm_mail_authorgbmsg'} = qq~<table border=0 cellspacing=3 cellpadding=3><tr><td valign=top width=33%>
<table border=0 cellspacing=0 cellpadding=0 width=100%>
 <tr><td align=right><font size=1 color=red><i>+fbname+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'32'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+admmail+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'33'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+admmail2+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'34'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+id+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'36'}</font></td></tr>
</table>
</td><td valign=top width=33%>
<table border=0 cellspacing=0 cellpadding=0 width=100%>
 <tr><td align=right><font size=1 color=red><i>+email+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'29'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+ip+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'40'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+datum+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'37'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+idurl+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'59'}</font></td></tr>
</table>
</td><td valign=top width=33%>

<table border=0 cellspacing=0 cellpadding=0 width=100%>
 <tr><td align=right><font size=1 color=red><i>+homepage+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'44'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+message+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'36'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+script+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'42'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+name+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'38'}</font></td></tr></table>
</td></tr></table>~;



# mod_users additon

	$etxt{'mod_users_mail_registeradminnotify'} = $etxt{'mod_users_mail_registerconfirmation'} = qq~<table border=0 cellspacing=3 cellpadding=3><tr><td valign=top width=33%>
<table border=0 cellspacing=0 cellpadding=0 width=100%>
 <tr><td align=right><font size=1 color=red><i>+fbname+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'32'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+homepage+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'44'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+admmail+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'33'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+admmail2+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'34'}</font></td></tr>
</table>
</td><td valign=top width=33%>
<table border=0 cellspacing=0 cellpadding=0 width=100%>
 <tr><td align=right><font size=1 color=red><i>+email+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'29'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+ip+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'40'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+datum+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'37'}</font></td></tr>
</table>
</td><td valign=top width=33%>

<table border=0 cellspacing=0 cellpadding=0 width=100%>
 <tr><td align=right><font size=1 color=red><i>+name+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'38'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+password+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'43'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+script+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'42'}</font></td></tr>
	</table>
</td></tr></table>~;

## mod_users end

# mod_fmail addon
	$etxt{'mod_fmail_mail_formailer'} = qq~<table border=0 cellspacing=3 cellpadding=3><tr><td valign=top width=33%>
<table border=0 cellspacing=0 cellpadding=0 width=100%>
 <tr><td align=right><font size=1 color=red><i>+fbname+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'32'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+admmail+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'33'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+admmail2+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'34'}</font></td></tr>
</table>
</td><td valign=top width=33%>
<table border=0 cellspacing=0 cellpadding=0 width=100%>
 <tr><td align=right><font size=1 color=red><i>+name+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'38'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+email+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'29'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+nachricht+</i></font></td><td><font size=1> = $fb::txt{'gl'}{'36'}</font></td></tr>
</table>
</td><td valign=top width=33%>

<table border=0 cellspacing=0 cellpadding=0 width=100%>
<tr><td align=right><font size=1 color=red><i>+homepage+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'44'}</font></td></tr> 
<tr><td align=right><font size=1 color=red><i>+betreff+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'47'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+script+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'42'}</font></td></tr>
	</table>
</td></tr></table>~;

# mod_fmail addon end

## mod backup addon

	$etxt{'mod_bak_mail_backupnotify'} = qq~<table border=0 cellspacing=3 cellpadding=3><tr><td valign=top width=33%>
<table border=0 cellspacing=0 cellpadding=0 width=100%>
 <tr><td align=right><font size=1 color=red><i>+filename+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'48'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+filesize+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'49'}</font></td></tr>
</table>
</td><td valign=top width=33%>
<table border=0 cellspacing=0 cellpadding=0 width=100%>
 <tr><td align=right><font size=1 color=red><i>+homepage+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'44'}</font></td></tr>
 <tr><td align=right><font size=1 color=red><i>+fbname+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'32'}</font></td></tr>
</table>
</td><td valign=top width=33%>

<table border=0 cellspacing=0 cellpadding=0 width=100%>
  <tr><td align=right><font size=1 color=red><i>+script+</i></font></td><td><font size=1> = $fb::txt{'ma'}{'42'}</font></td></tr>
	</table>
</td></tr></table>~;

## mod backup end

	my $beschr;

	if    ($mailakt eq "mail")   { $beschr = qq~<font size=1>[ $fb::txt{'ma'}{'10'} ]</font><br>$etxt{'normal'}~; }
	elsif ($mailakt eq "mail2")  { $beschr = qq~<font size=1>[ $fb::txt{'ma'}{'11'} ]</font><br>$etxt{'normal'}~; }
	elsif ($mailakt eq "mail10") { $beschr = qq~<font size=1>[ $fb::txt{'ma'}{'46'} ]</font><br>$etxt{'normal'}~; }
	elsif ($mailakt eq "mail11") { $beschr = qq~<font size=1>[ $fb::txt{'ma'}{'52'} ]</font><br>$etxt{'normal'}~; }
	elsif ($mailakt eq "mail12") { $beschr = qq~<font size=1>[ $fb::txt{'ma'}{'53'} ]</font><br>$etxt{'normal'}~; }
	elsif ($mailakt eq "mail13") { $beschr = qq~<font size=1>[ $fb::txt{'ma'}{'55'} ]</font><br>$etxt{'conf_code'}~; }
	
	if ($mailakt =~ m/mod\_/) {
		my ($mod_foo, $mod_code, $mail_foo, $mod_where) = split(/\_/, $mailakt);
		my $showtxt = "$fb::txt{'ma'}{'20'} $mod_where $fb::txt{'ma'}{'29'} mod_$mod_code$fb::txt{'ma'}{'31'}";		
		$beschr = qq~<font size=1>[ $showtxt ]</font><br>~;
		 
		if ($etxt{$mailakt}) {
			$beschr .= $etxt{$mailakt};
		}
		else {
			$beschr .= "<div style='padding:10px;'><font size=1>" . $fb::txt{'ma'}{'35'} . "</font></div>";
		}
	}
	

	my $options = qq~<select name=mailakt>~;
	
	# saves mail files
	my @options;

	my $countthis = 0;
	foreach (@contents) {
		my ($name, $extension) = split(/\./, $_);
		
		if ($extension && ($extension eq "txt") && ($name =~ m/mail/ig)) {
			my $showtxt;
			if    ($name    eq "mail")   { $showtxt  = "$fb::txt{'ma'}{'21'}"; }
			elsif ($name    eq "mail2")  { $showtxt  = "$fb::txt{'ma'}{'22'}"; }
			elsif ($name    eq "mail10") { $showtxt  = "$fb::txt{'ma'}{'45'}"; }
			elsif ($name    eq "mail11") { $showtxt  = "$fb::txt{'ma'}{'50'}"; }
			elsif ($name    eq "mail12") { $showtxt  = "$fb::txt{'ma'}{'51'}"; }
			elsif ($name    eq "mail13") { $showtxt  = "$fb::txt{'ma'}{'54'}"; }

			if ($name =~ /mod\_/) {
				my ($mod_foo, $mod_code, $mail_foo, $mod_where) = split(/\_/, $_);
				($mod_where, my $ext_foo) = split(/\./, $mod_where);
				$showtxt = "$fb::txt{'ma'}{'19'} mod_$mod_code: $mod_where";
			}			
			
			my $selected = ($mailakt eq "$name") ? " selected" : "";

			$options[$countthis] = qq~$showtxt|<option value="$name"$selected>$showtxt</option>\n~;
			$countthis++;
		}
	}

	@options = sort { uc($a) cmp uc($b) } (@options);
	
	foreach (@options) {
		my ($name, $thisopt) = split(/\|/, $_);
		$options .= $thisopt;
	}
	$options .= qq~</select>~;

	
	# load active languages
	my @contents2 = &opendirectory("$fb::gl{'datadir'}/language");
	my $sprache_select = "";

	@contents2 = sort { uc($a) cmp uc($b) } (@contents2);
	foreach my $line (@contents2) {
		if ((-d "$fb::gl{'datadir'}/language/$line") && (($line ne ".") && ($line ne ".."))) {
			my $selected = ($line eq $sprachesel) ? " selected" : "";
			$sprache_select .= qq~<option value=\"$line\"$selected>$line\n~;
		}
	}

	&isadmin;
	&adminmenu;
	$fb::fi{'main'} .= qq~

	<table border=0 width="100%" align=center cellspacing=1 class=fbborder cellpadding=2>
	  <tr>
		<td class=fbcatbg><b>$fb::txt{'gl'}{'87'}</b></td>
	  </tr>
		<tr>
		<td class=fb1>
		<table border=0 cellspacing=0 cellpadding=0 align=center>
	<form NAME="theForm" action="$fb::gl{'script'}" method="get">	
	<tr><td>
	<b>$fb::txt{'ma'}{'30'}</b>&nbsp;</td><td>$options</td><td> <select name="sprachesel">$sprache_select</select>$fb::gl{'hiddenscro'} <input type=hidden name=action value=mail> </td><td>&nbsp;<input type="submit" value="$fb::txt{'gl'}{'65'}"></td></tr>
	</form>	
	</table></td></tr>
	<tr><td class=fb2 align=center><font size=1>$fb::txt{'ma'}{'15'}</font></td></tr>	
	</table>
	<bR>
	<table border="0" class=fbborder cellspacing="1" cellpadding="2" align="center" width="100%">
	<form action="$fb::gl{'scriptac'}=mail2" method="POST"><tr>
		<td class=fb1 align=center>$beschr
		</td></tr><tr><td class=fb2 align="center">
		<input type=hidden name=saveas value="$mailakt">
		<input type=hidden name=sprachesel value="$sprachesel">
	<textarea rows=14 cols=60 wrap=virtual name="$mailakt" style="width:98%">~;
	
	foreach (@mailfile) {
		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
		$fb::fi{'main'} .= $_;
	}

	$fb::fi{'main'} .= qq~</textarea></td></tr><tr><td class=fb4 align="center">
		<input type=submit value="$fb::txt{'gl'}{'117'}">
		</font></td>
	  </tr></form>
	</table>
	~;

	&adminschluss;
	&template;

}

sub mail2 {
	
	&isadmin;
	my $save       = $fb::FORM{'saveas'};
	my $sprachesel = $fb::FORM{'sprachesel'} || $fb::cf{'sprache'};

	my $mail = $fb::FORM{$save};
	$mail =~ s/\r//g;
	&writefile("$fb::gl{'datadir'}/language/$sprachesel/$save.txt", $mail);

	my $set_location = "$fb::gl{'scriptac'}=mail;mailakt=$save;sprachesel=$sprachesel";
	&redirect($set_location);
}


1;
