####################### [Firebook] - guestbook ################################
# messageothers.pl                                                            #
###############################################################################

use strict;
use warnings;
#use diagnostics;

sub showmessage {

	&isadmin;
	
	my $showid             = $fb::INFO{'show'};
	my $hasshown           = 0;
	my $type			   = $fb::INFO{'type'} || "inc";
	$fb::gl{'vorschau'} = 1;

	my %le;
		
	my $table = "data" . quotemeta($type);

	(
		$le{'id'},        $le{'datum'},  $le{'name'},    $le{'icon'},   $le{'email'}, $le{'url'},     $le{'ip'},
		$le{'icq'},       $le{'aim'},    $le{'msn'},     $le{'skype'},  $le{'yim'},   $le{'message'}, $le{'feedback'},
		$le{'bewertung'}, $le{'ort'},    $le{'nosmile'}, $le{'frei'},   $le{'msf'},   $le{'hideown'}, $le{'savedinput'},
		$le{'privatn'},   $le{'pinned'}, $le{'betreff'}, $le{'jabber'}, $le{'state'}, $le{'sprchosen'}
	  )
	  = $fb::dbh->selectrow_array("SELECT * FROM $fb::cf{'db_prefix'}" . "$table WHERE id = ?", undef, $showid);

	if ($le{'id'} == $showid) {

		$hasshown = 1;

		unless ($fb::loaded{'file_loadentry'}) { require "$fb::gl{'subsdir'}/loadentry.pl"; }

		my $actionstring = "$fb::txt{'le'}{'30'}: $le{'id'}";

		$fb::fi{'main'} .= &return_header($actionstring);
		$fb::fi{'main'} .= &showit("0", \%le);
	}

	if ($hasshown != 1) {
		$fb::gl{'popup_force'} = 1;
		&fatal_error("message not found");
	}
	&freetemp;
}
sub return_header {

	my $actionshow = $_[0];

	my $return_message = qq~<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>~;
	$return_message .= qq~<tr><td class=fbtitle align=center>$actionshow~;
	$return_message .= qq~</td></tr></table><br>~;

	return $return_message;

}

1;
