####################### [Firebook] - guestbook ################################
# messageothers.pl                                                            #
###############################################################################

use strict;
use warnings;
#use diagnostics;

sub privatn {

	&isadmin;
	
	$fb::fi{'title'} = "$fb::txt{'gl'}{'45'}";
	
	my $start = $fb::INFO{'startb'} || 0;

	my $order_richt = ($fb::cf{'verkehrt'} == 1) ? "ASC" : "DESC";

	my $countf = $fb::dbh->selectrow_array("SELECT COUNT(*) FROM $fb::cf{'db_prefix'}" . "datainc WHERE privatn = ?", undef, "1");
	
	if    ($start > $countf) { $start = int($countf % $fb::cf{'maxindex'}) * $fb::cf{'maxindex'}; }
	elsif ($start < 0)       { $start = 0; }
	my $indexdisplaynum = 5;
	my $tmpa            = 1;
	my $tmpx            = int($countf / $fb::cf{'maxindex'});
	
	my ($startpage, $endpage) = (0,0);
	
	if ($start >= (($indexdisplaynum - 1) * $fb::cf{'maxindex'})) {
		$startpage = $start - (($indexdisplaynum - 1) * $fb::cf{'maxindex'});
		$tmpa = int($startpage / $fb::cf{'maxindex'}) + 1;
	}

	if ($countf >= $start + ($indexdisplaynum * $fb::cf{'maxindex'})) { $endpage = $start + ($indexdisplaynum * $fb::cf{'maxindex'}); }
	else { $endpage = $countf }
	
	my $pagesa = "";
	
	if ($startpage > 0) { $pagesa = qq~<a href="$fb::gl{'scriptac'}=privatn;startb=0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $fb::cf{'maxindex'}) { $pagesa = qq~<a href="$fb::gl{'scriptac'}=privatn;startb=0">1</a>&nbsp;~; }
	for (my $counter = $startpage ; $counter < $endpage ; $counter += $fb::cf{'maxindex'}) {
		$pagesa .= ($start == $counter) ? qq~<B><U>$tmpa</U></B>&nbsp;~ : qq~<a href="$fb::gl{'scriptac'}=privatn;startb=$counter">$tmpa</a>&nbsp;~;
		++$tmpa;
	}
	$tmpx      = $countf - 1 - $fb::cf{'maxindex'};
	my $outerpn   = int($tmpx / $fb::cf{'maxindex'});
	my $pagecount = int(($countf - 1) / $fb::cf{'maxindex'}) + 1;
	my $lastptn   = ($pagecount - 1) * $fb::cf{'maxindex'};

	my $pagesaadd = "";
	
	if ($endpage < $countf - $fb::cf{'maxindex'}) { $pagesaadd = qq~&nbsp;...&nbsp;~; }
	if ($endpage != $countf) { $pagesaadd .= qq~&nbsp;<a href="$fb::gl{'scriptac'}=privatn;startb=$lastptn">$pagecount</a>~; }
	$pagesa .= $pagesaadd;
	if ($pagesa eq "") { $pagesa = "1"; }

	if ($countf == 0) { 
		$fb::fi{'main'} .= &return_header($fb::txt{'pm'}{'1'});
	}

	&adminmenu;
	

	my $sth_e = $fb::dbh->prepare("SELECT * FROM $fb::cf{'db_prefix'}" . "datainc WHERE privatn = ? ORDER BY pinned DESC, datum $order_richt LIMIT ?,?");

	$sth_e->bind_param(1, "1");
	$sth_e->bind_param(2, $start, DBI::SQL_INTEGER);
	$sth_e->bind_param(3, $fb::cf{'maxindex'}, DBI::SQL_INTEGER);

	$sth_e->execute() or save_db_error(DBI->errstr);

	my $hasshown = 0;

	my $return_message = "";

	while (my @entry = $sth_e->fetchrow_array) {

		my %le;
		(
			$le{'id'},        $le{'datum'},  $le{'name'},    $le{'icon'},   $le{'email'}, $le{'url'},     $le{'ip'},
			$le{'icq'},       $le{'aim'},    $le{'msn'},     $le{'skype'},  $le{'yim'},   $le{'message'}, $le{'feedback'},
			$le{'bewertung'}, $le{'ort'},    $le{'nosmile'}, $le{'frei'},   $le{'msf'},   $le{'hideown'}, $le{'savedinput'},
			$le{'privatn'},   $le{'pinned'}, $le{'betreff'}, $le{'jabber'}, $le{'state'}, $le{'sprchosen'}
		  )
		  = @entry;

		unless ($fb::loaded{'file_loadentry'}) { require "$fb::gl{'subsdir'}/loadentry.pl"; }
		
		$return_message .= &showit($start, \%le);

		$hasshown++;
	}

	if ($hasshown) {
		$fb::fi{'main'} .= &return_header("$countf $fb::txt{'gl'}{'45'} | $fb::txt{'gl'}{'4'}: $pagesa");
	}

	$fb::fi{'main'} .= $return_message;
	
	&adminschluss;
	&template;
	exit;

}

sub return_header {

	my $actionshow = $_[0];
	my $frei = $_[1];

	my $current_title = $fb::txt{'gl'}{'45'};

	my $return_message = qq~<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>~;

	if ($current_title) {
		$return_message .= qq~<tr><td class=fbcatbg>$current_title</td></tr>~;
	}

	$return_message .= qq~<tr><td class=fb1 align=center>$actionshow~;
	
	$return_message .= qq~</td></tr></table><br>~;

	return $return_message;

}

1;
