####################### [Firebook] - guestbook ################################
# topentrys.pl  	                                                          #
###############################################################################

package fb;

use strict;
use warnings;
#use diagnostics;

sub topentrys {

	&load_language("loadentry");

	$fb::inp{"m_fbtitle"} = $fb::cf{'fbname'};
	if ($fb::cf{'url_ssi'}) { $fb::gl{'scriptac'} = qq~$fb::cf{'url_ssi'}?ssi=yes;lang=$fb::gl{'sprache2'};skin=$fb::INFO{'skin'};fisession=$fb::gl{'fisession'}&action~; $fb::gl{'script'} = qq~$fb::cf{'url_ssi'}?ssi=yes;fisession=$fb::gl{'fisession'};lang=$fb::INFO{'lang'}~; }
	$fb::inp{"m_scripturl"} = $fb::gl{'script'};

	my	$cut = $fb::INFO{'cut'};
	my	$anzahl = $fb::INFO{'anzahl'} || "5";
	my $jswrite = ($fb::INFO{'ssi'}) ? "0" : "1"; # 1 = jswrite

	my $order_richt = ($fb::cf{'verkehrt'} == 1) ? "ASC" : "DESC";


	my $sth_e = $fb::dbh->prepare("SELECT * FROM $fb::cf{'db_prefix'}" . "datainc WHERE privatn <> ? AND frei <> ? ORDER BY datum $order_richt LIMIT ?,?");

	$sth_e->bind_param(1, "1");
	$sth_e->bind_param(2, "1");
	$sth_e->bind_param(3, "0", DBI::SQL_INTEGER); 
	$sth_e->bind_param(4, $anzahl, DBI::SQL_INTEGER);

	$sth_e->execute() or save_db_error(DBI->errstr);

	my ($id, $datum, $name, $icon, $email, $url, $ip, $icq, $aim, $msn, $skype, $yim, $message, $feedback, $bewertung, $ort, $nosmile, $frei, $msf, $hideown, $savedinput, $privatn, $pinned, $betreff, $jabber, $state, $sprchosen);

	$sth_e->bind_columns(\$id, \$datum, \$name, \$icon, \$email, \$url, \$ip, \$icq, \$aim, \$msn, \$skype, \$yim, \$message, \$feedback, \$bewertung, \$ort, \$nosmile, \$frei, \$msf, \$hideown, \$savedinput, \$privatn, \$pinned, \$betreff, \$jabber, \$state, \$sprchosen);

	my $i = 0;

	while($sth_e->fetchrow_arrayref) {

		if (($frei != 1) && ($message ne "") && ($privatn != 1)) {

			
			
			$datum = &formatdatum($datum);



			if ($cut) { 

				$message = substr($message, 0, $cut);
				
				
				&UBBC($nosmile, "1", \$message,\$feedback);

				if( $message =~ m~\<table~i ) {
					$$message =~ s/([\<]*[\/A-Za-z]*?)$//ig;
					unless ($message =~ m~\</table>~i ) { $message .= qq~...</table>~;	}
				}
				else { $message .= qq~...~; }
			}
			else {
				&UBBC($nosmile, "1", \$message,\$feedback);
			}

			$message = &ubbc::dobadwords($message);
			$fb::inp{"m_message"} = $message;

			$name = &ubbc::dobadwords($name);
			$ort = &ubbc::dobadwords($ort);
			$savedinput = &ubbc::dobadwords($savedinput);

			$fb::inp{"m_name"} = qq~$name~;

			if ($icon) { $fb::inp{"m_msgicon"} = qq~<img src=$fb::fi{'bilderurlsk_noadmin'}/headsmilies/$icon border=0>~; }
			else { $fb::inp{"m_msgicon"} = ""; }
			$fb::inp{"m_id"} = $id;
			
			$fb::inp{"m_email"} = qq~$email~;
			$fb::inp{"m_ort"} = qq~$ort~;
			$fb::inp{"m_datum"} = $datum;
			$fb::inp{"m_betreff"} = qq~$betreff~;
			$fb::inp{"m_starturl"} = qq~$fb::gl{'scriptac'}=;start=$i~;
			if ($feedback) {
				$fb::inp{"m_feedback"} = qq~<font class=fbkomm>$fb::txt{'mod_comm_gl'}{'3'}:</b> $feedback</font>~;
			}
			
			unless ($fb::loaded{'file_loadentry'}) { require "$fb::gl{'subsdir'}/loadentry.pl"; }
			
			&inputinshow("data",$savedinput,$bewertung,$id,undef,$name);
			&iamy2($email, $url, $icq, $aim, $msn, $yim, $skype, $jabber, $state, $name, $hideown,$id);
			
			$fb::inp{"m_messages"} .= &doskin("template_topentrys2",$jswrite);

			$i++;
		}
	}

	# 1 = jswrite
	$fb::fi{'main'} .= &doskin("template_topentrys",$jswrite);

	print "Content-type: text/html\n\n";
	print $fb::fi{'main'};
	&database_disconnect();
	exit;
}
1;