#!/usr/bin/perl -w
################################ FIREBOOK #####################################
# setup.cgi	     															  #
###############################################################################
# [Firebook] - guestbook                                                      #
# - see licence at http://www.firebook.de/licence  -                          #
#                                                                             #
# =========================================================================== #
#                                                                             #
# Version:                              6.0                                   #
# Release:                              01.06.2009                            #
# Author:                               Karl Tschetschonig                    #
# URL:                                  http://www.firebook.de                #
# E-Mail:                               support\@firebook.de                  #
#                                                                             #
###############################################################################

use strict;

#use CGI::Carp qw(fatalsToBrowser);
use Time::Local;
use DBI;
use warnings;
#use diagnostics;
alarm(10);

package fb;

$fb::gl{'charset'} = "ISO-8859-1";
$fb::cf{'use_flock'}      = qq~1~;
$fb::cf{'usetempfile'}    = qq~~;
$fb::cf{'faketruncation'} = qq~~;
$fb::gl{'postsize'} = 1000;
$fb::gl{'pwseed'} ||= 'fb';

my $cgi_dir;

if ($0 =~ m#^(.*)\\#) {
	$cgi_dir = "$1";
}
elsif ($0 =~ m#^(.*)/#) {
	$cgi_dir = "$1";
}
else {
	`pwd` =~ /(.*)/;
	$cgi_dir = "$1";
}

if (($ENV{REQUEST_URI} =~ m/\.pl$/ig) || ($ENV{SCRIPT_NAME} =~ m/\.pl$/ig)) { $fb::gl{'ext'} = "pl"; }
else { $fb::gl{'ext'} = "cgi"; }

sub fatal_error {
	
	my $sprache = $fb::FORM{'sprache'} || $fb::INFO{'sprache'} || "english";

	my %txte;

	if ($sprache eq "deutsch") {
		$txte{'1'}  = "Ein Fehler ist aufgetreten";
		$txte{'2'}  = "Fehlermeldung";
		$txte{'3'}  = "Systeminformationen";
		$txte{'4'}  = "Perl Version";
		$txte{'5'}  = "Scriptpfad";
		$txte{'6'}  = "ScriptURL";
		$txte{'7'}  = "HTTP Verweisseite";
		$txte{'8'}  = "User";
		$txte{'9'}  = "QUERYSTRING";
		$txte{'10'} = "Du kannst die Programmierer von firebook.de um Hilfe bitten";
		$txte{'11'} = "Firebook Support Foren";
		$txte{'12'} = "ZURCK";
	}
	else {
		$txte{'1'}  = "An Error Occured!";
		$txte{'2'}  = "Error Message";
		$txte{'3'}  = "running system";
		$txte{'4'}  = "perl version";
		$txte{'5'}  = "script path";
		$txte{'6'}  = "script url";
		$txte{'7'}  = "http referer";
		$txte{'8'}  = "remote user";
		$txte{'9'}  = "query string";
		$txte{'10'} = "You may contact the programmers on firebook.de for help";
		$txte{'11'} = "Firebook support forums";
		$txte{'12'} = "BACK";
	}

	my $error = $_[0];
	$error =~ s/\n/<BR>\n/gs;    # return \n as html

	my $servername     = $ENV{SERVER_NAME}     || 'not found';
	my $referer        = $ENV{HTTP_REFERER}    || 'none';
	my $remote_user    = $ENV{REMOTE_USER}     || 'not found';
	my $query_string   = $ENV{QUERY_STRING}    || 'none';
	my $cookies        = $ENV{HTTP_COOKIE}     || 'none';
	my $formular       = $ENV{REQUEST_METHOD}  || 'none';
	my $serversoftware = $ENV{SERVER_SOFTWARE} || 'not found';
	
	$fb::fi{'title'}       = $txte{'1'};
	
	$fb::fi{'main'} .= qq~
	<table width="100%" height="100%" border=0 cellspacing=0 cellpadding=0 align=center><tr><td colspan=2>
	<table width="600" border=0 cellspacing=1 cellpadding=1 class=fbborder align=center><tr><td class=fb1 align=center>
	<b>$txte{'1'}</b></td></tr><tr><td class=fb2 align=center>
	<table border=0 cellspacing=0 cellpadding=2 align=center><tr><td width=110 align=center><b>$txte{'2'}</b></td><td>
	<b>$error</b></td></tr></table>
	</td></tr>
	<tr><td class=fb2 align=center><a href="javascript:history.back()"><B>[ &nbsp; $txte{'12'} &nbsp; ]</b></a></td></tr>	</table>
	<br><br>
		<table width="400" border=0 cellspacing=1 cellpadding=1 class=fbborder align=center>
	<tr><td class=fb2>
	<table border=0 cellspacing=0 cellpadding=2 align=center><tr><td colspan=2><i><font size=1>helpful information:</font></i></td></tr>
	<tr><td valign=top><font size=1>$txte{'3'}</td><td><font size=1>$serversoftware </td></tr>
	<tr><td valign=top><font size=1>$txte{'4'}</td><td><font size=1>$]</td></tr>
	<tr><td width=110 valign=top><font size=1>$txte{'5'}</td><td><font size=1>$cgi_dir/setup.$fb::gl{'ext'}</td></tr>
	<tr><td valign=top><font size=1>$txte{'6'}</td><td><font size=1>$fb::gl{'foundurl'}</td></tr>
	<tr><td valign=top><font size=1>$txte{'7'}</td><td><font size=1>$referer</td></tr>
	<tr><td valign=top><font size=1>$txte{'8'}</td><td><font size=1>$remote_user</td></tr>
	<tr><td valign=top><font size=1>$txte{'9'}</td><td><font size=1>$query_string</td></tr>
	</table>

	</td></tr><tr><td class=fb2 align=center>$txte{'10'}<br>
		<b>&raquo; <a target=_blank href="http://www.firebook.de/forums">$txte{'11'}</a></b>
		
	</td></tr>
		
	</table></td></tR></table>
	~;

	&output;
	exit 0;
}

$SIG{"__DIE__"} = sub {
	
	my $error = shift;
	chomp $error;

	print $error, return unless defined $ENV{GATEWAY_INTERFACE};
	$error =~ s/</&lt;/g;
	$error =~ s/>/&gt;/g;
	$error =~ s/\n/<BR>\n/gs;
	&fatal_error($error);
};


sub header {
	my %params = @_;
	my $ret = "";
	my $IIS;

	if( $ENV{'SERVER_SOFTWARE'} =~ /IIS/ ) {
		$IIS = 1;
		$0 =~ m~(.*)(\\|/)~;
		my $mod_path = $1;
		$mod_path =~ s~\\~/~g;
		chdir($mod_path);
		push(@INC,$mod_path);
	}
	if ($params{'-status'}) {
		if ($IIS) { $ret .= "HTTP/1.0 $params{'-status'}\n"; } 
		else { $ret .= "Status: $params{'-status'}\n";	}
	}


	$ret .= qq~Cache-Control: no-cache, must-revalidate\n~;
	$ret .= qq~Pragma: no-cache\n~;

	if ($params{'-cookies'}) {
		my(@cookie) = @{$params{'-cookies'}};
		
		foreach (@cookie) {
			if ($_) { $ret .= "Set-Cookie: $_\n";	}
		}
	}
	if ($params{'-location'}) {
		$ret .= "Location: $params{'-location'}\n";
	}
	unless ($params{'-contenttype'}) {
		$params{'-contenttype'} = "text/html";
	}
	$params{'-charset'} = ($params{'-charset'}) ? "; charset=$params{'-charset'}" : "";
	$params{'Content-Encoding'} = ($params{'Content-Encoding'}) ? "Content-Encoding: $params{'Content-Encoding'}\n" : "";
	$ret .= "$params{'Content-Encoding'}Content-Type: $params{'-contenttype'}$params{'-charset'}\r\n\r\n";
	return $ret;
}

my $LOCK_EX = 2;
my $LOCK_UN = 8;
my $LOCK_SH = 1;

use Fcntl qw/:DEFAULT/;
unless (defined $LOCK_SH) { $LOCK_SH = 1; }
{
	my %OpenMode = (
		'+>>' => 5,
		'+>'  => 4,
		'+<'  => 3,
		'>>'  => 2,
		'>'   => 1,
		'<'   => 0,
		''    => 0
	);

	my %tmpfile;

	sub fopen ($$;$) {
		my( $filehandle, $filename, $usetmp ) = @_;
		unless ($filename) { die "error";	}
		
		# for test purposes
		#$fb::fi{'openedfiles'} .= qq~$filehandle -> $filename<br>~;
		
		my( $flockCorrected, $cmdResult, $openMode, $openSig, $serveros );

		$serveros ="$^O";
		if ($serveros =~ m/Win/ && substr($filename,1,1) eq ":"){
			$filename =~ s~\\~\\\\~g;
			$filename =~ s~/~\\\\~g;
		} else {
			$filename =~ tr~\\~/~;
		}

		$filename =~ m~\A([<>+]*)(.+)~;
		$openSig = $1 || '';
		$filename = $2 || $filename;
		$openMode = $OpenMode{$openSig} || 0;

		$filename =~ s~[^/\\0-9A-Za-z#%+\,\-\ \.\:@^_]~~g;
		
		my $testfile = $filename;
		
		my (%LckFile);

		if($fb::cf{'use_flock'} == 2 && $openMode) {
			my $count;
			while( $count < 15 ) {
				if( -e $filehandle ) { sleep 2; }
				else { last; }
				++$count;
			}
			unlink($filehandle) if ($count == 15);
			local *LFH;
			CORE::open(LFH, ">$filehandle");
			$LckFile{$filehandle} = *LFH;
		}
		if($fb::cf{'use_flock'} && $openMode == 1 && $usetmp && $fb::cf{'usetempfile'} && -e $filename) {
			$tmpfile{$filehandle} = $filename;
			$filename .= '.tmp';
		}

		if($openMode > 2) {
			if($openMode == 5) { $cmdResult = CORE::open($filehandle, "+>>$filename"); }
			elsif( $fb::cf{'use_flock'} == 1 ) {
				if( $openMode == 4 ) {
					if( -e $filename ) {
						$flockCorrected = 1;
						$cmdResult = CORE::open($filehandle, "+<$filename");
					}
					else { $cmdResult = CORE::open($filehandle, "+>$filename"); }
				}
				else { $cmdResult = CORE::open($filehandle, "+<$filename"); }
			}
			elsif( $openMode == 4 ) { $cmdResult = CORE::open($filehandle, "+>$filename"); }
			else { $cmdResult = CORE::open($filehandle, "+<$filename"); }
		}
		elsif ($openMode == 1 && $fb::cf{'use_flock'} == 1) {
			if(-e $filename) {
				$flockCorrected = 1;
				$cmdResult = CORE::open($filehandle, "+<$filename");
			}
			else { $cmdResult = CORE::open($filehandle, ">$filename"); }
		}
		elsif ( $openMode == 1 ) {
			$cmdResult = CORE::open($filehandle, ">$filename");
		}
		elsif ( $openMode == 2 ) {
			$cmdResult = CORE::open($filehandle, ">>$filename");
		}
		elsif ( $openMode == 0 ) {
			$cmdResult = CORE::open($filehandle, $filename);
		}
		unless ($cmdResult) { return 0; }
		if ($flockCorrected) {
			flock($filehandle, $LOCK_EX);
			if( $fb::cf{'faketruncation'} ) {
				CORE::open(OFH, ">$filename");
				unless ($cmdResult) { return 0; }
				print OFH '';
				CORE::close(OFH);
			}
			else { truncate(*$filehandle, 0) || die "$fb::txt{'gl'}{'124'}: $filename"; }
			seek($filehandle, 0, 0);
		}
		elsif ($fb::cf{'use_flock'} == 1) {
			if( $openMode ) { flock($filehandle, $LOCK_EX); }
			else { flock($filehandle, $LOCK_SH); }
		}
		return 1;
	}
	sub fclose ($) {
		my $filehandle = $_[0];

		my (%LckFile);

		CORE::close($filehandle);
		if( $fb::cf{'use_flock'} == 2 ) {
			if( exists $LckFile{$filehandle} && -e $filehandle ) {
				CORE::close( $LckFile{$filehandle} );
				unlink( $filehandle );
				delete $LckFile{$filehandle};
			}
		}

		if($tmpfile{$filehandle}) {

			my $bakfile = $tmpfile{$filehandle};
			if( $fb::cf{'use_flock'} == 1 ) {
				local *FH;
				CORE::open(FH, $bakfile);
				flock(FH, $LOCK_EX);
				CORE::close(FH);
			}
			unlink("$bakfile.bak") if( -e "$bakfile.bak" );
			rename($bakfile,"$bakfile.bak");
			rename("$bakfile.tmp",$bakfile);
			delete $tmpfile{$filehandle};
			if(-e $bakfile) {
				unlink("$bakfile.bak");
			}
		}
		return 1;
	}
}

sub openfile {

	my $filename = $_[0];
	my $binmode = $_[1] || "0";

	unless ($filename) { die "no data available for opening file"; }

	my @tempsaveinarray;
	my ($AnzahlBytes,$tSpeicher,$geleseneBytes);

	my $FILE = *FILEHANDLE;

	fopen($FILE, "$filename");

	if ($binmode == 1) {
		$AnzahlBytes = -s "$filename";
		$tSpeicher = "";
		$geleseneBytes = "";
		binmode $FILE;
		binmode(STDOUT);
		$geleseneBytes = read($FILE, $tSpeicher, $AnzahlBytes);
	}
	else {
		@tempsaveinarray = <$FILE>;
	}
	fclose($FILE);
	if ($binmode == 1) {
		@tempsaveinarray = "";
		$tempsaveinarray[0] = $tSpeicher;
	}
	return (@tempsaveinarray);

}
sub writefile {

	my $filename = $_[0];
	my $writetofile = $_[1];
	my $mode = $_[2] || "";
	my $writearray_ref = $_[3];
	my $binmode = $_[4] || "0";

	if ($writearray_ref) {
		foreach (@{$writearray_ref}) { $writetofile .= $_; }
	}
	
	if ($mode eq "add") { $filename = qq~>>$filename~; }
	else { $filename = qq~>$filename~; }

	my $FILE = *FILEHANDLE;

	fopen($FILE, "$filename") || die "$fb::txt{'gl'}{'119'}: $filename! - $!";

	if ($binmode == 1) {
		binmode $FILE;
		binmode(STDOUT);
		print $FILE $writetofile;
	}
	else{
		print $FILE $writetofile;
	}
		
	fclose($FILE);

}

sub opendirectory {

	my $directoryname = $_[0];

	my @savedirectory;

	opendir(DIR, "$directoryname") || die "directory not available $directoryname";
	@savedirectory = readdir(DIR);
	closedir(DIR);
	return @savedirectory;

}


sub split_string 
{ 
	my ($string, $hash, $altdelim) = @_; 

	my @pairs;
	my ($name, $value) = "";

	if($altdelim && $$string =~ m~;~) { @pairs = split(/;/, $$string); } 
	else { @pairs = split(/&/, $$string); }

	foreach $_ (@pairs) {

			($name,$value) = split(/=/, $_); 

			if ($name) {
				### values come seperated by + --> need to be replaced by blanks
				$value =~ tr/+/ /d; 
				$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; 
				$name =~ tr/+/ /d; 
				$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; 
				if (exists($hash->{$name})) { 
					$hash->{$name} .= ", $value"; 
				} else { 
					$hash->{$name} = $value; 
				} 

			}

	}

} 
sub readform {
	 
	my $testenv = $ENV{QUERY_STRING} || ""; 
	$testenv =~ s/\&/\;/g; 

	## correct false email links
	my @test_url = split(/\%3B/, $testenv);
	$testenv = "";
		
	my $i = 0;
	foreach (@test_url) {
		my ($test1,$test2) = split(/\;/, $_);
		if ($i == 0) {
			$testenv .= $_;
		}
		elsif ($test1 =~ m/\=/) {
			$testenv .= ";" . $_;
		}
		else {
			$testenv .= "%3B" . $_;
		}
		$i++;
	}

    split_string(\$testenv, \%fb::INFO, 1);

	if ($ENV{REQUEST_METHOD} eq 'POST') {
		my $input;
		read(STDIN, $input, $ENV{CONTENT_LENGTH});
		split_string(\$input, \%fb::FORM);
	}
      
    $fb::gl{'action'} = $fb::INFO{'action'} || $fb::FORM{'action'} || "";
	$fb::gl{'action'} =~ /^(\w+)$/;
    $fb::gl{'action'} = $1 || "";

} 

sub output {
	print header(
		-status  => '200 OK',
		-charset => $fb::gl{'charset'}
	);
	print qq~<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
	<html>
	<head>
	<title>$fb::fi{'title'}</title>
	<style type="text/css">
	<!--
	A:link { background-color: transparent; color: #660000; text-decoration: none; }
	A:visited { background-color: transparent; color: #660000; text-decoration: none; }
	A:hover { background-color: transparent; color: #000000; text-decoration: none; }
	BODY { background-color: #ffffff; color: #000000; font-family: Arial, Verdana, Helvetica; font-size: 12px; margin: 0px; padding: 0px; }
	.fb1 { background-color: #f2f1f1; color: #000000; }
	.fb2 { background-color: #f8f8f8; color: #000000; }
	.fb3 { background-color: #d7d7d7; color: #000000; font-weight: bold; }
	.fb4 { background-color: #fffff1; color: #000000; }
	.fbtitle { background-color: #993333; color: #FFFFFF; }
	.fbcatbg { background-color: #990000; color: #FFFFFF; font-size: 12px; font-weight: bold; }
	.fbborder { background-color: #000000; color: #FFFFFF; font-size: 12px; }
	td { color: #000000; font-family: Arial, Verdana, Helvetica; font-size: 12px; }
	hr { color: #000000; }
	input { background-color: transparent; color: #000000; border: 1px solid #660000; font-family: Arial, Verdana, Helvetica; font-size: 11px; margin: 1px; }
	textarea { background-color: #f8f8f8; color: #000000; border: 1px solid #660000; font-family: Arial, Verdana, Helvetica; font-size: 11px; margin: 1px; }
	select { background-color: #f8f8f8; color: #000000; border: 1px solid #660000; font-family: Arial, Verdana, Helvetica; font-size: 11px; margin: 1px; }
	.pinned { background-color: #000099; }
	.marked { background-color: #990000; }
	.fbkomm { color: #333333; font-family: Verdana, Lucida, Sans-Serif; }
	.quote { color: #000000; border: 1px dotted #333333; font-family: Arial, Verdana, Helvetica; font-size: 12px; }
	.ubbcbutton A:link { background-color: #FFFFFF; border: 1px solid #660000; text-decoration: none; margin: 1px; padding: 2px; display: block; }
	.ubbcbutton A:visited { background-color: #FFFFFF; border: 1px solid #660000; text-decoration: none; margin: 1px; padding: 2px; display: block; }
	.ubbcbutton A:hover { background-color: #d8d8d8; border: 1px solid #cc3333; text-decoration: none; margin: 1px; padding: 2px; display: block; }
	form { padding: 0px; margin: 0px; }
	/* own CSS tags */
	ownTag { padding: 0px; }
	/* own CSS tags */
	a span {display: none; }
	a { position: relative; }
	a:hover span {
	  position: absolute;
	  top: 5px;
	  left: 5px;
	  display: block;
	  background: #FFFFFF;
	  padding: 3px;
	  border: 1px solid #660000;
	  width: 200px;
	  font-size: 10px;
	}
	-->
	</style>
	</head>
	<body>
	<table border=0 cellspacing=0 cellpadding=2 width=100% height=100%><tr><td align=center>
	$fb::fi{'main'}
	</td></tr></table>
	</body>
	</html>~;
	exit;
}

&readform;

my $tempurl = "";

if ($ENV{HTTP_REFERER}){ $tempurl = $ENV{HTTP_REFERER}; } 
elsif($ENV{HTTP_HOST} && $ENV{REQUEST_URI}){	$tempurl = qq~http://$ENV{HTTP_HOST}$ENV{REQUEST_URI}~; }
elsif($ENV{HTTP_HOST} && $ENV{SCRIPT_NAME}){	$tempurl = qq~http://$ENV{HTTP_HOST}$ENV{SCRIPT_NAME}~; }

my $lastslash = rindex($tempurl,"/");
$fb::gl{'foundurl'} = substr($tempurl,0,$lastslash);

my $searchroot = "";
if ($ENV{'SERVER_SOFTWARE'} =~ /IIS/) {
	my $this_script = "$ENV{'SCRIPT_NAME'}";
	$_           = $0;
	s#\\#/#g;
	s#$this_script##;
	$searchroot = $_ . '/';
}
else { $searchroot = $ENV{'DOCUMENT_ROOT'}; }

my $firstslash = index($tempurl, "/", 8);
my $html_baseurl = substr($tempurl, 0, $firstslash);

# looking for subdirectory fbimages

my $lastdirectory = "";

if (-d "$searchroot/fbimages") {

	opendir(HTMLDIR, "$searchroot/fbimages");
	my @tcontents = readdir(HTMLDIR);
	closedir(HTML);

	my ($ishtmldir, $ishtmldir2, $ishtmldir3) = (0,0,0);

	foreach my $tname (@tcontents) {
		chomp $tname;
		if ($tname eq "skins")     { $ishtmldir  = 1; }
		if ($tname eq "allgemein") { $ishtmldir2 = 1; }
		if ($tname eq "upload")    { $ishtmldir3 = 1; }
	}
	if (($ishtmldir == 1) && ($ishtmldir2 == 1) && ($ishtmldir3 == 1)) {
		$lastdirectory = "$searchroot/fbimages";
	}
	else { $lastdirectory = ""; }

}
unless ($lastdirectory) {
	
	my $fnd_html_root = "$html_baseurl/fbimages";
	my $fnd_htmldir = "";

	opendir(HTMLDIR, "$searchroot");
	my @contents = readdir(HTMLDIR);
	closedir(HTML);
	foreach my $name (@contents) {
		chomp $name;
		if (-d "$searchroot/$name") {
			opendir(HTMLDIR, "$searchroot/$name");
			my @subcontents = readdir(HTMLDIR);
			closedir(HTML);
			foreach my $subname (@subcontents) {
				chomp $subname;
				if (lc($subname) eq "fbimages" && (-d "$searchroot/$name/$subname")) {
					$fnd_htmldir = "$searchroot/$name/$subname";
					$fnd_htmldir =~ s~//~/~g;
				}
			}
		}
	}

	opendir(HTMLDIR, "$fnd_htmldir");
	my @tcontents = readdir(HTMLDIR);
	closedir(HTML);

	my ($ishtmldir, $ishtmldir2, $ishtmldir3) = (0,0,0);
	
	foreach my $tname (@tcontents) {
		chomp $tname;
		if ($tname eq "skins")     { $ishtmldir  = 1; }
		if ($tname eq "allgemein") { $ishtmldir2 = 1; }
		if ($tname eq "upload")    { $ishtmldir3 = 1; }
	}
	if (($ishtmldir == 1) && ($ishtmldir2 == 1) && ($ishtmldir3 == 1)) {
		$lastdirectory = $fnd_htmldir;
	}
	else { $lastdirectory = ""; }
}

sub chooselang {
	
	$fb::fi{'title'} = "choose your language, whle deine Sprache";

	$fb::fi{'main'} .= qq~
	<form action="setup.$fb::gl{'ext'}" method="get" name="fiform">
		<input type=hidden name=action value="setup">
	<table align=center width="200" border=0 cellspacing=1 cellpadding=2 class=fbborder>
				<tr>  
		<td class=fbcatbg colspan=2 align=center>choose your language</td></tr>
			<td class=fb2 align=center><font size=2>
		<select name="sprache">
	<option value="deutsch">deutsch</option>
	<option value="english" selected>english</option>
	</select>
		<input type="submit" name="post" value="Submit">
	</font></td>
		  </tr>
		<tr>  
		<td class=fbcatbg colspan=2 align=center>whle deine Sprache</td></tr>
	</table></td></tr></table></form>
	~;
	&output;

}

my $sprache = $fb::FORM{'sprache'} || $fb::INFO{'sprache'} || "english";

my (%txtb, %txtc);

if ($sprache eq "deutsch") {
	$txtb{'1'}   = "Sprache";
	$txtb{'3'}   = "Achtung: die Script URL konnte nicht ermittelt werden";
	$txtb{'4'}   = "Scripturl";
	$txtb{'5'}   = "URL zum Ordner firebook, ohne abschlieenden Backslash, z.B.: http://www.firebook.de/cgi-bin/firebook";
	$txtb{'6'}   = "Bilderurl";
	$txtb{'7'}   = "URL zum Ordner der Bilder und Scripte (fbimages), ohne abschlieenden Backslash, z.B.: http://www.firebook.de/fbimages";
	$txtb{'10'}  = "DEUTSCH";
	$txtb{'11'}  = "SETUP STARTEN!";
	$txtb{'11b'} = "OK!";
	$txtb{'12'}  = "Bilderpfad (absoluter Pfad)";
	$txtb{'13'}  = "absoluter Pfad zum Ordner der Bilder (fbimages), ohne abschlieenden Backslash. Dieser Pfad gibt den Ort des Bilderverzeichnisses in der Dateistruktur des Servers an (vom Verzeichnisbaum bis zum Verzeichnis 'fbimages'), z.B.: /srv/www/vhosts/firebook.de/httpdocs/fbimages oder /home/www/web0/html/fbimages";
	$txtb{'16'}  = "Scriptpfad (absoluter Pfad)";
	$txtb{'17'}  = "absoluter Pfad zum Ordner firebook, ohne abschlieenden Backslash.  Dieser Pfad gibt den Ort des Scriptes in der Dateistruktur des Servers an (vom Verzeichnisbaum bis zum firebook Verzeichnis), z.B.: /srv/www/vhosts/firebook.de/cgi-bin/firebook oder /home/www/web0/html/cgi-bin/firebook";
	$txtb{'18'}  = "Firebook Gstebuch Setup";
	$txtb{'19'}  =
"Falls du sicher bist, dass <b>alle Dateien vollstndig in die richtigen Ordner</b> und <b>im richtigen Modus</b> (<i>ASCII oder BINR</i>) hochgeladen hast und dass du keine Dateinamen oder Inhalte verndert hast, kannst du die Installation starten.<br><br>Dieses Setup wird die Rechte vergeben und deine Einstellungen speichern. Danach im Admincenter knnen noch weitere Einstellungen gettigt werden, Diese hier sind nur die Wichtigsten.";
	$txtb{'20'} = "Bitte berprfe ob die Pfade und URL stimmen. Das Script kann die richtigen Pfade nicht mit 100% erkennen.";
	$txtb{'21'} = "Achtung: die Bilder URL konnte nicht ermittelt werden";
	$txtb{'22'} = "Achtung: der Bilder Pfad konnte nicht ermittelt werden";
	$txtb{'23'} = "Achtung: der Script Pfad konnte nicht ermittelt werden";
	$txtb{'24'} = "Neuinstallation";
	$txtb{'25'} = "Importiere Daten von i-dreams.net GB 5.4";	
	$txtb{'26'} = "Importiere Daten von i-dreams.net GB 5.3 und frher";	
	$txtb{'27'} = "Installationstypus";
	$txtb{'28'} = "Hier kannst du festlegen ob es sich um eine Neuinstallation oder ein Update handelt.";
	$txtb{'29'} = "Pfad zur vorherigen Installation";
	$txtb{'30'} = "Falls du ein Update durchfhrst, musst du hier den Pfad zum Ordner der vorherigen Scriptversion angeben, ohne abschlieenden Backslash";
	$txtb{'31'} = "Installationstypus";
	$txtb{'32'} = "E-Mail Adresse";
	$txtb{'33'} = "Gib hier die Administrations E-Mail Adresse fr Benachrichtigungen an";
	$txtb{'34'} = "Homepage";
	$txtb{'35'} = "Gib hier die Webseite an wofr du Firebook installierst";

	$txtc{'24'} = "Datenbanktreiber";
	$txtc{'25'} = "Mithilfe des Datenbanktreibers kannst du mehrere verschiedene Datenbanken ansprechen. DBI:mysql wird normalerweise fr MySQL Datenbanken verwendet, DBI:Oracle fr Oracle Datenbanken. Achtung: Nur MySQL Datenbanken wurden genau getestet.";
	$txtc{'26'} = "Datenbankhost";
	$txtc{'27'} = "Gib hier den Datenbankhost an - meistens 'localhost'";
	$txtc{'28'} = "Datenbankname";
	$txtc{'29'} = "Gib hier den Namen der Datenbank an - z.B.: firebook";
	$txtc{'30'} = "Datenbank Username";
	$txtc{'31'} = "Gib hier den Usernamen fr die Datenbankverbindung zur angegebenen Datenbank an. Diesen kannst du beim Anlegen von Datenbanken festlegen, oder er wird vom System vorgegeben.";
	$txtc{'32'} = "Datenbank Passwort";
	$txtc{'33'} = "Gib hier das Passwort fr die Datenbankverbindung zur angegebenen Datenbank an. Dieses kannst du beim Anlegen von Datenbanken festlegen, oder es wird vom System vorgegeben.";
	$txtc{'34'} = "Tabellen Prefix";
	$txtc{'35'} = "Falls mehrere Scripte mit der gleichen Datenbank nutzt, kannst du hier einen Prefix definieren um Konflikte zu vermeiden. z.B.: fb_";
	$txtc{'36'} = "Datenbank Einstellungen";
	$txtc{'37'} = "Datenbank Port";
	$txtc{'38'} = "Gib hier den Port zu deiner Datenbank an, womit das Datenbank-Programm angesprochen werden kann, MySQL Standard: 3306";
	$txtc{'39'} = "Tabellen erstellen";
	$txtc{'40'} = "Aktiviere diese Option falls du mchtest, dass das Script die fr das Script notwendigen Tabellen erstellt (empfohlen!) - alte Tabellen werden gelscht. Alternativ musst du die Tabellen selbst ber ein externes Tool (z.B. PhpMyAdmin) einpflegen";
	$txtc{'41'} = "Datenbank anlegen";
	$txtc{'42'} = "Hier kannst du die Datenbank vom Script anlegen lassen - funktioniert nur wenn der angegebene DB-Benutzer gengend Rechte hat um neue Datenbanken anzulegen.";

}
else {
	$txtb{'1'}   = "language";
	$txtb{'3'}   = "attention: the script url couldn't be found";
	$txtb{'4'}   = "URL to script";
	$txtb{'5'}   = "URL to the firebook directory without last backslash, e.g. http://www.firebook.de/cgi-bin/firebook";
	$txtb{'6'}   = "URL to images";
	$txtb{'7'}   = "URL to the directory containing Firebook images (fbimages) without last backslash, , e.g. http://www.firebook.de/fbimages";
	$txtb{'10'}  = "ENGLISH";
	$txtb{'11'}  = "START SETUP!";
	$txtb{'11b'} = "OK!";
	$txtb{'12'}  = "absolute path to images";
	$txtb{'13'}  = "absolute path to the directory containing images (fbimages) without last backslash. The absolute path contains the root directory and all other sub directories required to get to the directory fbimages. E.g.: /srv/www/vhosts/firebook.de/httpdocs/fbimages or /home/www/web0/html/fbimages";
	$txtb{'16'}  = "absolute path to script";
	$txtb{'17'}  = "absolute path to the firebook directory without last backslash. The absolute path contains the root directory and all other sub directories required to get to the directory firebook. E.g.: /srv/www/vhosts/firebook.de/cgi-bin/firebook or /home/www/web0/html/cgi-bin/firebook";
	$txtb{'18'}  = "Firebook guestbook setup.";
	$txtb{'19'}  =
"If you are sure, that all <b>files were fully uploaded</b> in the <b>correct directories</b> and with the <b>correct mode</b> (<i>ASCII or BINARY</i>) and that you have not changed a file name or content you can start the installation.<br><br>This setup will set rights on the files and it will save the paths and settings. Other settings can be made after the installation, these are just the most important ones.";
	$txtb{'20'} = "Please check if the paths and urls are correct. The script can not always detect the correct paths.";
	$txtb{'21'} = "attention: the graphics url couldn't be found";
	$txtb{'22'} = "attention: the graphics path couldn't be found";
	$txtb{'23'} = "attention: the script path couldn't be found";
	$txtb{'24'} = "fresh installation";
	$txtb{'25'} = "import data from i-dreams.net GB 5.4";	
	$txtb{'26'} = "import data from i-dreams.net GB 5.3 and older";	
	$txtb{'27'} = "Installation type";
	$txtb{'28'} = "If you are updating from a previous version, change this setting accordingly.";
	$txtb{'29'}  = "path to previous installation";
	$txtb{'30'}  = "If you are updating from a previous version, please enter the path to the installation of the old version.";
	$txtb{'31'} = "Installation Type";
	$txtb{'32'} = "E-Mail address";
	$txtb{'33'} = "Please enter the administration e-mail address for notifications";
	$txtb{'34'} = "Homepage";
	$txtb{'35'} = "Please enter the website for which you are installing the firebook guestbook";

	$txtc{'24'} = "database driver";
	$txtc{'25'} = "The database driver allows you to connect to various types of databases. DBI:mysql is normally used for MySQL databases, DBI:Oracle for Oracle ones... Attention: only MySQL Databases were thoroughly tested!";
	$txtc{'26'} = "database host";
	$txtc{'27'} = "Enter here the host adress for your database - in most cases: 'localhost'";
	$txtc{'28'} = "database name";
	$txtc{'29'} = "Enter here the name of your database - e.g.: firebook";
	$txtc{'30'} = "database username";
	$txtc{'31'} = "Enter here the username for the database connection to the database defined above. You can either choose a username with the tool you are creating your databases, or it is predefined by your system.";
	$txtc{'32'} = "database password";
	$txtc{'33'} = "Enter here the password for the database connection to the database defined above. You can either choose a password with the tool you are creating your databases, or it is predefined by your system.";
	$txtc{'34'} = "table prefix";
	$txtc{'35'} = "If there are other programs using this database too, you may define a prefix here to avoid conflicts. e.g.: fb_";
	$txtc{'36'} = "database settings";
	$txtc{'37'} = "database port";
	$txtc{'38'} = "Enter here the port for the database connection to access the database program, MySQL Standard: 3306";
	$txtc{'39'} = "create tables";
	$txtc{'40'} = "Activate this option if you want the script to create the gb service tables (recommended) - old tables will be deleted. If you do not create the tables through this script you will have to create them manually in a program of your choice (e.g. PhpMyAdmin).";
	$txtc{'41'} = "create database";
	$txtc{'42'} = "Activate this option if you want the script to create the database - only works if DB user has sufficient permissions to create databases.";
}

$cgi_dir       =~ s/\\/\//ig;
$cgi_dir       =~ s/\/\//\//ig;
$cgi_dir       =~ s/^.:(.+?)/$1/ig;
$lastdirectory =~ s/^.:(.+?)/$1/ig;
$lastdirectory =~ s/\\/\//ig;
$lastdirectory =~ s/\/\//\//ig;

sub setup {
	
	$fb::fi{'title'} = qq~$txtb{'18'}~;

	$fb::fi{'main'} .= qq~
	<script type="text/javascript" language="javascript">
		
	<!--

	function inst_types() {
				
				var inst_type = document.getElementById('installation_type').value;
				
				if ((inst_type == "update_5.4") || (inst_type == "update_5.3")) {
					document.getElementById("now_update_fields").innerHTML = document.getElementById("update_fields").innerHTML;
				}
				else {
					document.getElementById("now_update_fields").innerHTML = "";
				}

	}

	//-->
	</script>

	<div id="update_fields" style="position: absolute; width: 400px; visibility: hidden;">
		<table border="0" cellspacing="1" cellpadding=2 width="100%"><tr>
		<td align="right" width=50%><font size=2><b>$txtb{'29'}:</b></font><br><font size=1>$txtb{'30'}</font></td>
		<td><font size=2><input type=text name="old_ordnerdir" size=50 value=""></font></td></tr></table>
	</div>
<form action="setup.$fb::gl{'ext'}?action=setup2" method="post" name="fiform">
<table align=center width="90%" border=0 cellspacing=1 cellpadding=2 class=fbborder>
<tr><td class=fb1 align=center width=10%><b>$txtb{'10'}</b></td><td class=fbcatbg align=center width=80%>
<b>$txtb{'18'}</b></td><td class=fb1 align=center width=10%><b>$txtb{'10'}</b></td></tr><tr><td class=fb2 colspan=3><div align=justify>$txtb{'19'}</div>
</td></tr>

<tr><td colspan=3 class=fb1 width=100% align=center><b>$txtb{'31'}</b></td></tr>
<tr><td colspan=3 class=fb2 width="100%"><table width="100%" border=0 cellspacing="0" cellpadding="3">

<tr>  
<td align="right" width=50%><font size=2><b>$txtb{'27'}:</b></font><br><font size=1>$txtb{'28'}</font></td>
<td><font size=2><select name="installation_type" id="installation_type" onchange="inst_types();">
	<option value="fresh">$txtb{'24'}</option>
	<option value="update_5.4">$txtb{'25'}</option>
	<option value="update_5.3">$txtb{'26'}</option>
	</font></td>
</tr>
<tr><td colspan=2 width="100%">
	<div id="now_update_fields"></div>
</td>
</tr>
</table>
	</td></tr>
<tr><td colspan=3 class=fb1 width=100% align=center><b>$txtb{'20'}</b></td></tr>
<tr><td colspan=3 class=fb2 width="100%"><table width="100%" border=0 cellspacing="0" cellpadding="3">

<tr>  
<td align="right" width=50%><font size=2><b>$txtb{'4'}:</b></font>~;
unless ($fb::gl{'foundurl'}) { $fb::fi{'main'} .= qq~<br><font size=1 color=red><b>$txtb{'3'}</b></font>~; }
$fb::fi{'main'} .= qq~</td>
<td><font size=2><input type=text name="ordnerurl" size=50 value="$fb::gl{'foundurl'}"> 
	<a class="tooltip" href="#"><b><u>?</u></b><span>$txtb{'5'}</span></a></font></td>
</tr>
<tr>  
<td align="right"><font size=2><b>$txtb{'16'}:</b></font>~;
unless ($cgi_dir) { $fb::fi{'main'} .= qq~<br><font size=1 color=red><b>$txtb{'23'}</b></font>~; }
$fb::fi{'main'} .= qq~</td>
<td><font size=2><input type=text name="ordnerdir" size=50 value="$cgi_dir"> <a class="tooltip" href="#"><b><u>?</u></b><span>$txtb{'17'}</span></a></font></td>
</tr>
<tr>  
<td align="right"><font size=2><b>$txtb{'6'}:</b></font>~;
unless ($html_baseurl) { $fb::fi{'main'} .= qq~<br><font size=1 color=red><b>$txtb{'21'}</b></font>~; }
$fb::fi{'main'} .= qq~</td>
<td><font size=2><input type=text name="bilderurl" size=50 value="$html_baseurl/fbimages">
	<a class="tooltip" href="#"><b><u>?</u></b><span>$txtb{'7'}</span></a></font></td>
</tr>
<tr>  
<td align="right"><font size=2><b>$txtb{'12'}:</b></font>~;
unless ($lastdirectory) { $fb::fi{'main'} .= qq~<br><font size=1 color=red><b>$txtb{'22'}</b></font>~; }
$fb::fi{'main'} .= qq~</td>
<td><font size=2><input type=text name="bilderdir" size=50 value="$lastdirectory">
	<a class="tooltip" href="#"><b><u>?</u></b><span>$txtb{'13'}</span></a></font></font></td>
</tr>
<tr>  
<td align="right" width=50%><font size=2><b>$txtb{'32'}:</b></font></td>
<td><font size=2><input type=text name="admmail" size=50 value="dummy\@firebook.de">
	<a class="tooltip" href="#"><b><u>?</u></b><span>$txtb{'33'}</span></a></font></td>
</tr>	
	<tr>  
<td align="right" width=50%><font size=2><b>$txtb{'34'}:</b></font></td>
<td><font size=2><input type=text name="homepage" size=50 value="http://www.test.com">
	<a class="tooltip" href="#"><b><u>?</u></b><span>$txtb{'35'}</span></a></font></td>
</tr>	
</table>
	</td></tr>
<tr><td colspan=3 class=fb1 width=100% align=center><b>$txtc{'36'}</b></td></tr>
<tr><td colspan=3 class=fb2 width="100%"><table width="100%" border=0 cellspacing="0" cellpadding="3">
<tr>  
<td align="right" width=50%><font size=2><b>$txtc{'41'}:</b></font></td>
<td><font size=2><input type=checkbox name="db_createdatabase" value="1">
	<a class="tooltip" href="#"><b><u>?</u></b><span>$txtc{'42'}</span></a></font></td>
</tr>
<tr>  
<td align="right" width=50%><font size=2><b>$txtc{'39'}:</b></font></td>
<td><font size=2><input type=checkbox name="db_createtables" value="1" checked>
	<a class="tooltip" href="#"><b><u>?</u></b><span>$txtc{'40'}</span></a></font></td>
</tr>
<tr>  
<td align="right" width=50%><font size=2><b>$txtc{'24'}:</b></font></td>
<td><font size=2><input type=text name="db_driver" size=50 value="DBI:mysql">
	<a class="tooltip" href="#"><b><u>?</u></b><span>$txtc{'25'}</span></a></font></td>
</tr>
<tr>  
<td align="right" width=50%><font size=2><b>$txtc{'26'}:</b></font></td>
<td><font size=2><input type=text name="db_host" size=50 value="localhost">
	<a class="tooltip" href="#"><b><u>?</u></b><span>$txtc{'27'}</span></a></font></td>
</tr>
<tr>  
<td align="right" width=50%><font size=2><b>$txtc{'37'}:</b></font></td>
<td><font size=2><input type=text name="db_port" size=50 value="3306">
	<a class="tooltip" href="#"><b><u>?</u></b><span>$txtc{'38'}</span></a></font></td>
</tr>
<tr>  
<td align="right" width=50%><font size=2><b>$txtc{'28'}:</b></font></td>
<td><font size=2><input type=text name="db_name" size=50 value="firebook">
	<a class="tooltip" href="#"><b><u>?</u></b><span>$txtc{'29'}</span></a></font></td>
</tr>
<tr>  
<td align="right" width=50%><font size=2><b>$txtc{'30'}:</b></font></td>
<td><font size=2><input type=text name="db_user" size=50 value="admin">
	<a class="tooltip" href="#"><b><u>?</u></b><span>$txtc{'31'}</span></a></font></td>
</tr>
<tr>  
<td align="right" width=50%><font size=2><b>$txtc{'32'}:</b></font></td>
<td><font size=2><input type=password name="db_password" size=50 value="">
	<a class="tooltip" href="#"><b><u>?</u></b><span>$txtc{'33'}</span></a></font></td>
</tr>
<tr>  
<td align="right" width=50%><font size=2><b>$txtc{'34'}:</b></font></td>
<td><font size=2><input type=text name="db_prefix" size=50 value="fb_">
	<a class="tooltip" href="#"><b><u>?</u></b><span>$txtc{'35'}</span></a></font></td>
</tr>

</table>
	</td></tr>

<tr><td colspan=3 class=fb3 width="100%"><table width="100%" border=0 cellspacing="0" cellpadding="3">
        <tr><td align=center><input type=hidden name=sprache value="$sprache">
	<input type="submit" name="post" value="$txtb{'11'}">	
</td>
      </tr></table></td></tr></table></form>
~;

	&output;

}

my (%txtb, %txtg);

if ($sprache eq "deutsch") {
	$txtb{'24'}  = "Der angegebene Pfad zum Script:";
	$txtb{'24b'} =
	  "ist nicht korrekt!\nBitte berprfe deine Eingaben.\nVersuche die Installation mit dem absoluten und relativen Pfad\n";
	$txtb{'25'}  = "Der angegebene Bilderpfad:";
	$txtb{'25b'} =
	  "ist nicht korrekt!\nBitte berprfe deine Eingaben.\nVersuche die Installation mit dem absoluten und relativen Pfad.\n";
	$txtb{'26'} = "Der Ordner &quot;data&quot; existiert nicht im Script Verzeichnis!";
	$txtb{'27'} = "Der Ordner &quot;";
	$txtb{'28'} = "&quot; konnte nicht unter &quot;data&quot; gefunden werden";
	$txtb{'29'} = "&quot; konnte nicht unter &quot;skins&quot; gefunden werden";
	$txtb{'30'} = "Die Datei";
	$txtb{'31'} = "existiert nicht im Script Verzeichnis!";
	$txtb{'32'} = "Der Ordner";
	$txtb{'33'} = "existiert nicht im gewhlten Graphiken Verzeichnis!";
	$txtb{'34'} = "konnte Datei firebook.$fb::gl{'ext'} nicht bearbeiten";
	$txtb{'35'} = "konnte Datei config.pl nicht bearbeiten";
	$txtb{'36'} = "Setup wurde beendet";
	$txtb{'37'} = "Es wurden soeben die Rechte der Dateien gesetzt und die Pfade gespeichert.";
	$txtb{'38'} = "Falls das Script noch nicht funktionsfhig ist, folge bitte den Anweisungen fr die manuelle Installation.";
	$txtb{'39'} = "Firebook Support Foren";
	$txtb{'40'} = "Link zum Gstebuch";
	$txtb{'41'} = "Link zum Gstebuch Admincenter";
	$txtb{'42'} = "Login Daten";
	$txtb{'43'} = "Username";
	$txtb{'44'} = "Passwort";
	$txtb{'45'} = "keines";
	$txtb{'46'} = "Die Datei setup.$fb::gl{'ext'} wurde automatisch gelscht.";
	$txtb{'47'} = "Die Dateien der vorherigen Version wurden upgedated.";
	$txtb{'48'} = "Es wurde keine Vorgngerversion upgedatet";
	$txtb{'49'} =
	  "Das Script konnte keine Dateirechte setzen. Bitte setze die Dateirechte manuell wie beschrieben in der Hilfedatei Teil4, Schritt3.";
	$txtb{'50'} = "Die Datei setup.$fb::gl{'ext'} konnte nicht gelscht werden. Bitte manuell lschen!";
	$txtb{'51'} = "Du hast Update als Installationstyp angegeben - hierzu musst du auch den Pfad der vorherigen Installation angeben!";
	$txtb{'52'} = "Die angegebene E-Mail Adresse ist nicht korrekt!";
	$txtb{'53'} = "Du musst die Homepage deiner Webseite angeben!";

	$txtc{'1'} = "Die angegebenen SQL Daten sind inkorrekt! Bitte berprfe deine Eingaben!\nError: ";
	$txtc{'2'} = "Der Pfad zur vorherigen Installation ist nicht korrekt! Bitte berprfen Sie Ihre Daten.";
}
else {
	$txtb{'24'}  = "The path to the script entered:";
	$txtb{'24b'} = "is not correct!\nPlease check this field\nTry to install with the absolute and the relative path.\n";
	$txtb{'25'}  = "The path to the images entered:";
	$txtb{'25b'} = "is not correct!\nPlease check this field\n.Try to install with the absolute and the relative path.\n";
	$txtb{'26'}  = "the directory &quot;data&quot; does not exist in the script directory";
	$txtb{'27'}  = "the directory &quot;";
	$txtb{'28'}  = "&quot; could not be found in &quot;data&quot;";
	$txtb{'29'}  = "&quot; could not be found in &quot;skins&quot;";
	$txtb{'30'}  = "the file";
	$txtb{'31'}  = "does not exist in the script directory";
	$txtb{'32'}  = "The directory";
	$txtb{'33'}  = "does not exist in the graphics directory";
	$txtb{'34'}  = "couldn't edit file firebook.$fb::gl{'ext'}";
	$txtb{'35'}  = "couldn't edit file config.pl";
	$txtb{'36'}  = "Setup is finished";
	$txtb{'37'}  = "The rights have been changed and the paths have been saved.";
	$txtb{'38'}  =
	  "If the script is not working yet, please follow the instructions for a manual installation. Starte dann das Setup erneut.";
	$txtb{'39'} = "Firebook support forums";
	$txtb{'40'} = "link to your guestbook";
	$txtb{'41'} = "link to your guestbook admincenter";
	$txtb{'42'} = "login data:";
	$txtb{'43'} = "username";
	$txtb{'44'} = "password";
	$txtb{'45'} = "none";
	$txtb{'46'} = "The file setup.$fb::gl{'ext'} has been deleted automatically.";
	$txtb{'47'} = "The data from a previous version has been updated.";
	$txtb{'48'} = "No previous version has been updated.";
	$txtb{'49'} =
"The script couldn't set file permissions. Please set permissions manually like describe in the manual stage4 step 3. Afterwards start the setup.";
	$txtb{'50'} = "The file setup.$fb::gl{'ext'} couldn't be deleted. Please delete that file manually!";
	$txtb{'51'} = "You chose to make an update - please enter the path to the previous script version!";
	$txtb{'52'} = "Your e-mail address is not correct!";
	$txtb{'53'} = "You have to enter the homepage of your website!";
	
	$txtc{'1'} = "Your Mysql Data is incorrect, please check the data!\nError received: ";
	$txtc{'2'} = "The path to your previous installation is not correct! Please check again.";
}

sub setup2 {
	
	
	$fb::FORM{'ordnerdir'}    =~ s/~/\\~/g;
	$fb::FORM{'bilderdir'}    =~ s/~/\\~/g;
	$fb::FORM{'bilderurl'} =~ s/~/\\~/g;
	$fb::FORM{'ordnerurl'}    =~ s/~/\\~/g;
	$fb::FORM{'admmail'}    =~ s/~/\\~/g;
	$fb::FORM{'homepage'}    =~ s/~/\\~/g;

	# check folders
	unless (-d $fb::FORM{'ordnerdir'}) { &fatal_error("$txtb{'24'} &quot;$fb::FORM{'ordnerdir'}&quot; $txtb{'24b'}"); }
	unless (-d $fb::FORM{'bilderdir'}) { &fatal_error("$txtb{'25'} &quot;$fb::FORM{'bilderdir'}&quot; $txtb{'25b'}"); }
	else { chmod(0777, "$fb::FORM{'bilderdir'}"); }

	unless (-e "$fb::FORM{'ordnerdir'}/firebook.$fb::gl{'ext'}") { &fatal_error("$txtb{'30'} firebook.$fb::gl{'ext'} $txtb{'31'}"); }
	unless (-e "$fb::FORM{'ordnerdir'}/config.pl")        { &fatal_error("$txtb{'30'} config.pl $txtb{'31'}"); }
	
	unless ( $fb::FORM{'admmail'} =~ /^[a-zA-Z0-9]{1}[a-zA-Z0-9\._-]*\@[a-zA-Z0-9_\.-]*[a-zA-Z0-9-aaaccccddeeeee?gggghhiiiiijk?llllnnnooorrrssstttuuuuuuwyzz]{2,}\.[a-z]{2,4}$/) { &fatal_error($txtb{'52'}); }
	&fatal_error($txtb{'52'}) unless($fb::FORM{'admmail'});
	if ($fb::FORM{'admmail'} eq "dummy\@firebook.de") {
		&fatal_error($txtb{'52'});
	}
	
	unless ($fb::FORM{'homepage'}) { &fatal_error($txtb{'53'}); }
	
	$fb::FORM{'admmail'} =~ s/@/\\@/g;

	# change paths in firebook.cgi file
	my @firebookcgi = &openfile("$fb::FORM{'ordnerdir'}/firebook.$fb::gl{'ext'}");
	
	unless (@firebookcgi) {
		&fatal_error("$txtb{'34'}")
	}

	my $printback = "";
	foreach my $line (@firebookcgi) {
		if ($line =~ m/^my \$configpath \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~my \$configpath \= qq\~$fb::FORM{'ordnerdir'}/config.pl\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::gl\{\'datadirpath\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::gl{'datadirpath'} \= qq\~$fb::FORM{'ordnerdir'}/data\~\;\n~;
		}
		else { $printback .= $line; }
	}
	
	&writefile("$fb::FORM{'ordnerdir'}/firebook.$fb::gl{'ext'}",$printback);
	
	# change settings in config file
	my @infospl = &openfile("$fb::FORM{'ordnerdir'}/config.pl");
	
	unless (@infospl) {
		&fatal_error("$txtb{'35'}");
	}


	my $found_db_settings = 0;

	my $printback = "";
	foreach my $line (@infospl) {
		if ($line =~ m/^\$fb::cf\{\'bilderdir\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::cf{'bilderdir'} \= qq\~$fb::FORM{'bilderdir'}\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::cf\{\'ordnerdir\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::cf{'ordnerdir'} \= qq\~$fb::FORM{'ordnerdir'}\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::cf\{\'ordnerurl\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::cf{'ordnerurl'} \= qq\~$fb::FORM{'ordnerurl'}\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::cf\{\'bilderurl\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::cf{'bilderurl'} \= qq\~$fb::FORM{'bilderurl'}\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::cf\{\'sprache\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::cf{'sprache'} \= qq\~$fb::FORM{'sprache'}\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::cf\{\'db_driver\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::cf{'db_driver'} \= qq\~$fb::FORM{'db_driver'}\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::cf\{\'db_host\'\} \= qq\~(.*?)\~\;/ig) {
			$found_db_settings = 1;
			$printback .= qq~\$fb::cf{'db_host'} \= qq\~$fb::FORM{'db_host'}\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::cf\{\'db_name\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::cf{'db_name'} \= qq\~$fb::FORM{'db_name'}\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::cf\{\'db_user\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::cf{'db_user'} \= qq\~$fb::FORM{'db_user'}\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::cf\{\'db_password\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::cf{'db_password'} \= qq\~$fb::FORM{'db_password'}\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::cf\{\'db_prefix\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::cf{'db_prefix'} \= qq\~$fb::FORM{'db_prefix'}\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::cf\{\'db_port\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::cf{'db_port'} \= qq\~$fb::FORM{'db_port'}\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::cf\{\'admmail\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::cf{'admmail'} \= qq\~$fb::FORM{'admmail'}\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::cf\{\'admmail2\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::cf{'admmail2'} \= qq\~$fb::FORM{'admmail'}\~\;\n~;
		}
		elsif ($line =~ m/^\$fb::cf\{\'homepage\'\} \= qq\~(.*?)\~\;/ig) {
			$printback .= qq~\$fb::cf{'homepage'} \= qq\~$fb::FORM{'homepage'}\~\;\n~;
		}
		else { $printback .= $line; }
	}

	unless ($found_db_settings) {

	my $printnew_back = qq~\$fb::cf{'db_driver'} \= qq\~$fb::FORM{'db_driver'}\~\;
	\$fb::cf{'db_host'} \= qq\~$fb::FORM{'db_host'}\~\;
	\$fb::cf{'db_name'} \= qq\~$fb::FORM{'db_name'}\~\;
	\$fb::cf{'db_user'} \= qq\~$fb::FORM{'db_user'}\~\;
	\$fb::cf{'db_password'} \= qq\~$fb::FORM{'db_password'}\~\;
	\$fb::cf{'db_prefix'} \= qq\~$fb::FORM{'db_prefix'}\~\;
	\$fb::cf{'db_port'} \= qq\~$fb::FORM{'db_port'}\~\;\n~;

	$printback = $printnew_back . $printback;

	}

	
	&writefile("$fb::FORM{'ordnerdir'}/config.pl",$printback);

	chmod(0755, "$fb::FORM{'ordnerdir'}/firebook.$fb::gl{'ext'}");
	chmod(0666, "$fb::FORM{'ordnerdir'}/config.pl");
	
	# permission setting does not work
	my $rechte = substr(sprintf("%o", (stat("$fb::FORM{'ordnerdir'}/config.pl"))[2]), 3, 6);

	if (($rechte ne "666") && ($rechte ne "")) {
		&fatal_error("$txtb{'49'}");
	}

	if (-d "$fb::FORM{'ordnerdir'}/data") {
		chmod(0777, "$fb::FORM{'ordnerdir'}/data");
		opendir(DIR, "$fb::FORM{'ordnerdir'}/data");
		my @files = readdir(DIR);
		closedir(DIR);
		foreach my $line (@files) {
			if (($line ne ".") && ($line ne "..") && ($line ne "")) {
				unless (-d "$fb::FORM{'ordnerdir'}/data/$line") {
					chmod(0666, "$fb::FORM{'ordnerdir'}/data/$line");
				}
			}
		}
	}
	else {
		# data directory not found
		&fatal_error("$txtb{'26'}");
	}

	# set permissions
	my @testthese = ("admdat", "errors", "language", "modules", "skins", "styles", "subs");
	foreach my $testthem (@testthese) {
		if (-d "$fb::FORM{'ordnerdir'}/data/$testthem") {
			
			chmod(0777, "$fb::FORM{'ordnerdir'}/data/$testthem");
			
			opendir(DIR, "$fb::FORM{'ordnerdir'}/data/$testthem");
			my @files = readdir(DIR);
			closedir(DIR);

			foreach my $line (@files) {
				if (($line ne ".") && ($line ne "..") && ($line ne "")) {
					unless (-d "$fb::FORM{'ordnerdir'}/data/$testthem/$line") {
						chmod(0666, "$fb::FORM{'ordnerdir'}/data/$testthem/$line");
					}
					else {
						chmod(0777, "$fb::FORM{'ordnerdir'}/data/$testthem/$line");
						opendir(DIR, "$fb::FORM{'ordnerdir'}/data/$testthem/$line");
						my @langfiles = readdir(DIR);
						closedir(DIR);
						foreach my $langline (@langfiles) {
							if (($langline ne ".") && ($langline ne "..") && ($langline ne "")) {
								unless (-d "$fb::FORM{'ordnerdir'}/data/$testthem/$line/$langline") {
									chmod(0666, "$fb::FORM{'ordnerdir'}/data/$testthem/$line/$langline");
								}
							}
						}
					}
				}
			}
		}
		else {
			&fatal_error("$txtb{'27'} $testthem $txtb{'28'}");
		}
	}

	# set permissions for graphic files

	my @testthese = ("allgemein", "maps", "upload", "temp");
	foreach my $testthem (@testthese) {
		if (-d "$fb::FORM{'bilderdir'}/$testthem") {
			chmod(0777, "$fb::FORM{'bilderdir'}/$testthem");
			opendir(DIR, "$fb::FORM{'bilderdir'}/$testthem");
			my @files = readdir(DIR);
			closedir(DIR);
			foreach my $line (@files) {
				if (($line ne ".") && ($line ne "..") && ($line ne "")) {
					unless (-d "$fb::FORM{'bilderdir'}/$testthem/$line") {
						if ($line eq "Thumbs.db") {
							unlink "$fb::FORM{'bilderdir'}/$testthem/$line";
						}
						else {
							chmod(0666, "$fb::FORM{'bilderdir'}/$testthem/$line");
						}
					}
				}
			}
		}
		else {
			&fatal_error("$txtb{'32'} $testthem $txtb{'33'}");
		}
	}

	# set permissions for sub folders in skins

	unless (-d "$fb::FORM{'bilderdir'}/skins") { &fatal_error("$txtb{'32'} &quot;skins&quot; $txtb{'33'}"); }
	else { chmod(0777, "$fb::FORM{'bilderdir'}/skins"); }

	opendir(DIR, "$fb::FORM{'bilderdir'}/skins");
	my @directories = readdir(DIR);
	closedir(DIR);
	foreach my $testthem (@directories) {
		if (($testthem ne ".") && ($testthem ne "..") && ($testthem ne "")) {
			if (-d "$fb::FORM{'bilderdir'}/skins/$testthem") {
				chmod(0777, "$fb::FORM{'bilderdir'}/skins/$testthem");
				opendir(DIR, "$fb::FORM{'bilderdir'}/skins/$testthem");
				my @files = readdir(DIR);
				closedir(DIR);
				foreach my $line (@files) {
					if (($line ne ".") && ($line ne "..") && ($line ne "")) {
						chmod(0777, "$fb::FORM{'bilderdir'}/skins/$testthem/$line");
						opendir(DIR, "$fb::FORM{'bilderdir'}/skins/$testthem/$line");
						my @files2 = readdir(DIR);
						closedir(DIR);
						foreach my $lin2 (@files2) {
							if (($lin2 ne ".") && ($lin2 ne "..") && ($lin2 ne "")) {
								unless (-d "$fb::FORM{'bilderdir'}/skins/$testthem/$line/$lin2") {
									if ($lin2 eq "Thumbs.db") {
										unlink "$fb::FORM{'bilderdir'}/skins/$testthem/$line/$lin2";
									}
									else {
										chmod(0666, "$fb::FORM{'bilderdir'}/skins/$testthem/$line/$lin2");
									}
								}
							}
						}
					}
				}
			}
			else {
				&fatal_error("$txtb{'32'} $testthem $txtb{'33'}");
			}
		}
	}

	# test DB settings
	

	# create database
	my $create_database = $fb::FORM{'db_createdatabase'} || "0";

	if ($create_database) {
		&create_database;
	}

	# raises an error if DB data is not correct
	my $dbh2;
	$dbh2 = DBI->connect( "$fb::FORM{'db_driver'}:$fb::FORM{'db_name'}:$fb::FORM{'db_host'}:$fb::FORM{'db_port'}",$fb::FORM{'db_user'},$fb::FORM{'db_password'}, {"PrintError" => 0, "AutoCommit" => 0, "RaiseError" => 0});

	if(!$dbh2) {
		&fatal_error("$txtc{'1'}" . DBI::errstr);
	}
	$dbh2->disconnect();
	



	# create tables
	my $create_tables = $fb::FORM{'db_createtables'} || "0";
	
	if ($create_tables) {
		&create_tables;
	}

	$fb::fi{'title'} = "$txtb{'36'}";

	if ($fb::FORM{'installation_type'} =~ m/update/) {
		
		unless ($fb::FORM{'old_ordnerdir'}) {
			&fatal_error("$txtb{'51'}");
		}
		
		# update from previous version
		my %read_data;
		if ($fb::FORM{'installation_type'} eq "update_5.4") {
			my $read_data_ref = &getdata_54($fb::FORM{'old_ordnerdir'});
			%read_data = %{$read_data_ref};
		}
		elsif ($fb::FORM{'installation_type'} eq "update_5.3") {
			my $read_data_ref = &getdata_53($fb::FORM{'old_ordnerdir'});
			%read_data = %{$read_data_ref};
		}

		## TEST

#	print "<table border=1 width=1024><tr><th colspan=2>read_data</th></tr>";
#	
#	my @contents = sort { uc($a) cmp uc($b) } (keys %read_data);
#	foreach my $key (@contents) {
#		
#		my $value = $read_data{$key} || "";
#		
#		my $pr_value = "";
#		my @val_arr = @{$value};
#		foreach my $item (@val_arr) {
#			$pr_value .= qq~$item<br>~;
#		}
#
#		print "<tr><td>$key</td><td>$pr_value</td></tr>";		
#		
#	}
#	print "</table><br><br>";
#	die();

	### TEST

		if (%read_data) {
			&import_data(\%read_data);
		}
		
	}

	
	unlink "$fb::FORM{'ordnerdir'}/setup.$fb::gl{'ext'}";
	
	my $notdeleted = 0;
	if (-e "$fb::FORM{'ordnerdir'}/setup.$fb::gl{'ext'}") { $notdeleted = 1; }

	$fb::fi{'main'} .= qq~
<table border=0 width="500" cellspacing=1 class=fbborder align="center" cellpadding="2">
  <tr>
    <td class=fbcatbg><font size=2><b>$txtb{'36'}</b></font></td>
  </tr>
	<tr><td class=fb1>&raquo; &nbsp;$txtb{'37'}<br>~;
	if ($notdeleted == 1) { $fb::fi{'main'} .= qq~<font color=red><b>&raquo; &nbsp;$txtb{'50'}</b><br></font>~; }
	else { $fb::fi{'main'} .= qq~&raquo; &nbsp;$txtb{'46'}<br>~; }
	if ($fb::FORM{'installation_type'} =~ m/update/) { $fb::fi{'main'} .= qq~<b>&raquo; &nbsp;$txtb{'47'}</b>~; }
	else { $fb::fi{'main'} .= qq~&raquo; &nbsp;$txtb{'48'}~; }
	$fb::fi{'main'} .= qq~</td>
</tr>	
<tr>
    <td class=fb2 align=center>
<table border=0 cellspacing=0 cellpadding=4 width=100%><tr>
<td width=20><a href="$fb::FORM{'ordnerurl'}/firebook.$fb::gl{'ext'}"><img src="$fb::FORM{'bilderurl'}/skins/standard/allgemein/raquo.gif" alt="$txtb{'40'}" border=0></a></td><td>

<table border=0 cellspacing=0 cellpadding=3 width=100%><tr><td class=quote width=100%>
<b><a href="$fb::FORM{'ordnerurl'}/firebook.$fb::gl{'ext'}">$txtb{'40'}</a></b>
</td></tr></table>

</td></tr>
</table></td></tr>
<tr>
    <td class=fb2 align=center>
<table border=0 cellspacing=0 cellpadding=4 width=100%><tr>

<td width=20><a href="$fb::FORM{'ordnerurl'}/firebook.$fb::gl{'ext'}?action=login"><img src="$fb::FORM{'bilderurl'}/skins/standard/allgemein/raquo.gif" alt="$txtb{'41'}" border=0></a></td><td>

<table border=0 cellspacing=0 cellpadding=3 width=100%><tr><td class=quote width=100%>
<b><a href="$fb::FORM{'ordnerurl'}/firebook.$fb::gl{'ext'}?action=login">$txtb{'41'}</a></b><br>
<font size=1>$txtb{'42'} &raquo; $txtb{'43'}: <b>admin</b> &middot;
	$txtb{'44'}: <i>($txtb{'45'})</i> </font>
</td></tr></table>

</td></tr>
</table></td></tr>
<tr>    <td class=fb2 align=center>
<table border=0 cellspacing=0 cellpadding=4 width=100%><tr>
<td width=20><a href="http://www.firebook.de/forums"><img src="$fb::FORM{'bilderurl'}/skins/standard/allgemein/raquo.gif" alt="$txtb{'39'}" border=0></a></td><td>

<table border=0 cellspacing=0 cellpadding=3 width=100%><tr><td class=quote width=100%>
<b><a href="http://www.firebook.de/forums">$txtb{'39'}</a></b><br>

</td></tr></table>

</td></tr>
</table>
</td>
  </tr>
  <tr>
    <td class=fb2 align=center><font size=1><b>$txtb{'38'}</b></font></td>
  </tr>
</table>
~;
	&output;
}

sub create_database {

	my $dbh = DBI->connect( "$fb::FORM{'db_driver'}:host=$fb::FORM{'db_host'};port=$fb::FORM{'db_port'}",$fb::FORM{'db_user'},$fb::FORM{'db_password'}, {"PrintError" => 1, "AutoCommit" => 1, "RaiseError" => 1});

	my $sql_import = &get_sql_import_database();

	$sql_import =~ s/FIREBOOK_/$fb::FORM{'db_prefix'}/ig;
	$sql_import =~ s/FB_DATABASE/$fb::FORM{'db_name'}/ig;

	my @sql_statements = split('\;\n', $sql_import);

	foreach my $statement (@sql_statements) {
		$statement =~ s/\/\*(.+?)\*\///ig;
		$statement =~ s/\n//ig;
		if ($statement && (($statement =~ m/USE/ig) || ($statement =~ m/DROP/ig) || ($statement =~ m/CREATE/ig) || ($statement =~ m/INSERT/ig) || ($statement =~ m/SET/ig) || ($statement =~ m/ALTER/ig))) {
			$dbh->do($statement);
		}
	}

	$dbh->disconnect();


}

sub create_tables {
	
	my %txt_db;

	if ($sprache eq "deutsch") {
		$txt_db{'1'} = "Die Datenbank konnte nicht geffnet werden:";
		$txt_db{'2'} = "Konnte SQL Schema nicht ffnen";
	}
	else {
		$txt_db{'1'} = "The database could not be opened:";
		$txt_db{'2'} = "Could not open SQL Scheme";
	}

	my $dbh = DBI->connect( "$fb::FORM{'db_driver'}:$fb::FORM{'db_name'}:$fb::FORM{'db_host'}:$fb::FORM{'db_port'}",$fb::FORM{'db_user'},$fb::FORM{'db_password'}, {"PrintError" => 1, "AutoCommit" => 1, "RaiseError" => 1});


	my $sql_import = &get_sql_import();

	$sql_import =~ s/FIREBOOK_/$fb::FORM{'db_prefix'}/ig;
	$sql_import =~ s/FB_DATABASE/$fb::FORM{'db_name'}/ig;

	my @sql_statements = split('\;\n', $sql_import);

	foreach my $statement (@sql_statements) {
		$statement =~ s/\/\*(.+?)\*\///ig;
		$statement =~ s/\n//ig;
		if ($statement && (($statement =~ m/USE/ig) || ($statement =~ m/DROP/ig) || ($statement =~ m/CREATE/ig) || ($statement =~ m/INSERT/ig) || ($statement =~ m/SET/ig) || ($statement =~ m/ALTER/ig))) {
			$dbh->do($statement);
		}
	}

	$dbh->disconnect();

}
sub getdata_54 {
	
	my $update_path = $_[0];

	my %return_data;

	unless (-e $update_path . "/data/impdat/data.inc") {
		&fatal_error($txtc{'2'});
	}
	
	@{$return_data{'badwords'}} = &openfile($update_path . "/data/admdat/badwords.dat");
	@{$return_data{'bannip'}} = &openfile($update_path . "/data/admdat/bannip.dat");
	@{$return_data{'bannmail'}} = &openfile($update_path . "/data/admdat/bannmail.dat");
	@{$return_data{'ownfields'}} = &openfile($update_path . "/data/admdat/ownfields.dat");
	@{$return_data{'spamwords'}} = &openfile($update_path . "/data/admdat/spamwords.dat");

	@{$return_data{'databak'}} = &openfile($update_path . "/data/impdat/data.bak");
	@{$return_data{'datainc'}} = &openfile($update_path . "/data/impdat/data.inc");
	@{$return_data{'datakomm'}} = &openfile($update_path . "/data/impdat/data.komm");
	@{$return_data{'dataspam'}} = &openfile($update_path . "/data/impdat/data.spam");
	@{$return_data{'map'}} = &openfile($update_path . "/data/impdat/map.dat");
	@{$return_data{'users'}} = &openfile($update_path . "/data/impdat/users.dat");

	return \%return_data;

}
sub getdata_53 {

	my $update_path = $_[0];
	
	my %return_data;

	unless (-e $update_path . "/data/data.inc") {
		&fatal_error($txtc{'2'});
	}

	my @contents_data = &opendirectory($update_path . "/data");

	# data for GB version < 5.4
	my (@save_bannmail, @save_bannip, @save_badwords);

	foreach my $line (@contents_data){
		unless (($line eq ".") || ($line eq "..")) {
				if ($line eq "bannip.pl") {
					@{$return_data{'bannip'}} = &openfile($update_path . "/data/$line");
				}
				elsif ($line eq "bannmail.pl") {
					@{$return_data{'bannmail'}} = &openfile($update_path . "/data/$line");
				}
				elsif ($line eq "badwords.pl") {
					@{$return_data{'badwords'}} = &openfile($update_path . "/data/$line");
				}
				elsif (($line eq "data.bak") || ($line eq "data.inc")) {

					my @data = &openfile($update_path . "/data/$line");
					
					my $getback = "";
					my @return_arr = ();

					foreach my $entra (@data) {
						chomp $entra;
						my ($count, $date, @rest) = split(/\|/, $entra);
						
						if ($rest[17] =~ m/\d\&(.*?)/i) {	}
						elsif ($rest[17] ne "") {
							$rest[17] = qq~1<$rest[17]~;
							if ($rest[18]) {
							$rest[17] .= qq~2<$rest[18]~;
							$rest[18] = "";
							}
						}
						
						if ($date =~ m/\./) {
							my ($rdatum,$uhrzeit) = split(/ um /, $date);
							my ($oldday,$oldmonth,$oldyear) = split(/\./, $rdatum);
							my ($oldhour,$oldminute) = split(/\:/, $uhrzeit);
							$date = Time::Local::timelocal(0,$oldminute,$oldhour,$oldday,$oldmonth,$oldyear);
						}
						$getback .= qq~$count|$date~;
						
						foreach my $print (@rest) {
							$getback .= qq~|$print~;
						}

						$getback .= qq~\n~;

						push(@return_arr, $getback);

					}
					$line =~ s/\.//ig;
					@{$return_data{"$line"}} = @return_arr;

				}
				elsif ($line eq "input.cat") {
					@{$return_data{"ownfields"}} = &openfile($update_path . "/data/$line");
				}
				elsif ($line eq "komm.inc") {

					my @data = &openfile($update_path . "/data/$line");
					
					my $getbacka = "";
					my @return_arr = ();

					foreach my $entra (@data) {
						
						chomp $entra;
						
						my ($count, $count2, $date, @rest) = split(/\|/, $entra);

						if ($date =~ m/\./) {
							my ($rdatum,$uhrzeit) = split(/ um /, $date);
							my ($oldday,$oldmonth,$oldyear) = split(/\./, $rdatum);
							my ($oldhour,$oldminute) = split(/\:/, $uhrzeit);
							$date = Time::Local::timelocal(0,$oldminute,$oldhour,$oldday,$oldmonth,$oldyear);
						}
						
						$getbacka .= qq~$count|$count2|$date~;
						
						foreach my $print (@rest) {
							$getbacka .= qq~|$print~;
						}
						$getbacka .= qq~||\n~;

						push(@return_arr, $getbacka);
					}

					@{$return_data{'datakomm'}} = @return_arr;

				}
				elsif ($line eq "map.dat") {
					@{$return_data{'map'}} = &openfile($update_path . "/data/$line");
				}
				elsif ($line eq "users.dat") {


					my @data = &openfile($update_path . "/data/$line");
					
					my $writeback = "";
					my @return_arr = ();


					foreach my $users (@data) {
						chomp($users);
						my @veraend = split(/\|/, $users);
						my $newpass = "";
						if ($veraend[1] !~ m/^fb/i) { $newpass = crypt($veraend[1],$fb::gl{'pwseed'}); }
						else { $newpass = $veraend[1]; }
						$writeback .= qq~$veraend[0]|$newpass|$veraend[2]|$veraend[3]|$veraend[4]|$veraend[5]|$veraend[6]\n~;

						push(@return_arr, $writeback);
					}

					@{$return_data{'users'}} = @return_arr;

				}

		}
	}

	return \%return_data;

}

sub import_data {

	# imports data from previous version to mysql database
	
	# Attention: there is no error check at the moment
	$fb::dbh = DBI->connect( "$fb::FORM{'db_driver'}:$fb::FORM{'db_name'}:$fb::FORM{'db_host'}:$fb::FORM{'db_port'}",$fb::FORM{'db_user'},$fb::FORM{'db_password'}, {"PrintError" => 0, "AutoCommit" => 0, "RaiseError" => 0});


	my %return_data = %{$_[0]};

	if ($return_data{'badwords'}) {
		&update_file_mysqltable_user_tostring(\@{$return_data{'badwords'}},"extsettings","badwords");
	}
	
	if ($return_data{'bannip'}) {
		&update_file_mysqltable_user_tostring(\@{$return_data{'bannip'}},"extsettings","bannip");
	}
	
	if ($return_data{'bannmail'}) {
		&update_file_mysqltable_user_tostring(\@{$return_data{'bannmail'}},"extsettings","bannmail");
	}

	if ($return_data{'ownfields'}) {
		&update_file_mysqltable_user(\@{$return_data{'ownfields'}},"ownfields","10");
	}

	if ($return_data{'spamwords'}) {
		&update_file_mysqltable_user_tostring(\@{$return_data{'spamwords'}},"extsettings","spamwords");
	}

	if ($return_data{'databak'}) {
		&update_file_mysqltable_user_entries(\@{$return_data{'databak'}},"databak","27");
	}

	if ($return_data{'datainc'}) {
		&update_file_mysqltable_user_entries(\@{$return_data{'datainc'}},"datainc","27");
	}

	if ($return_data{'datakomm'}) {
		&update_file_mysqltable_user(\@{$return_data{'datakomm'}},"datacomm","11");
	}

	if ($return_data{'dataspam'}) {
		&update_file_mysqltable_user_entries(\@{$return_data{'dataspam'}},"dataspam","27");
	}

	if ($return_data{'map'}) {
		&update_file_mysqltable_user(\@{$return_data{'map'}},"map","6");
	}

	if ($return_data{'users'}) {
		&update_file_mysqltable_user(\@{$return_data{'users'}},"users","6");
	}
	
	$fb::dbh->disconnect();

}

sub update_file_mysqltable_user_tostring {

	my @entries = @{$_[0]};
	my $insert_table = $_[1];
	my $type = $_[2];

	my $data = "";

	foreach my $line (@entries) {
		$line =~ tr/\n//d;
		$line =~ tr/\r//d;
		$data .= qq~$line\n~;
	}

	if (length($data) > 0) {
		$fb::dbh->do("INSERT INTO $fb::FORM{'db_prefix'}" . "$insert_table (type, data) VALUES(?,?) ON DUPLICATE KEY UPDATE data = ?", undef, $type, $data, $data);
	}


}
sub update_file_mysqltable_user {

	my @entries = @{$_[0]};
	my $insert_table = $_[1];
	my $values_count = $_[2];
		
	foreach my $entry (@entries) {
		
		chomp $entry;
		my @entry = split(/\|/, $entry);

		if ($insert_table eq "map") {
			my ($co1,$co2) = split(/\,/, $entry[3]);
			splice(@entry, 3, 1,$co1,$co2);
		}
		if ($insert_table eq "ownfields") {
			if ($entry[9] eq "") { $entry[9] = "0"; }
		}
		if ($insert_table eq "datacomm") {
			if ($entry[10] eq "") { $entry[10] = "0"; }
		}

		if (@entry) {
			$fb::dbh->do("INSERT INTO $fb::FORM{'db_prefix'}" . "$insert_table VALUES(" . fragezeich($values_count) . ")", undef, reduziere_array($values_count,@entry));
		}
	}


}
sub update_file_mysqltable_user_entries {

	my @entries = @{$_[0]};
	my $insert_table = $_[1];
	my $values_count = $_[2];

	foreach my $entry (@entries) {
		chomp $entry;
		my @entry = split(/\|/, $entry);
		
		## insert skype on correct position
		my $ch_skype = $entry[20];
		splice(@entry, 20, 1);
		splice(@entry,10,0,$ch_skype);

		## remove .gif from Bewertung
		my ($new_bewertung, $unused) = split(/\./, $entry[14]);
		$entry[14] = ($new_bewertung =~ m/\D/g) ? "0" : $new_bewertung;
		unless ($entry[21]) {
			# set privatn
			$entry[21] = "0";
		}
		unless ($entry[22]) {
			# set pinned
			$entry[22] = "0";
		}

		if (@entry) {
			$fb::dbh->do("INSERT INTO $fb::FORM{'db_prefix'}" . "$insert_table VALUES(" . fragezeich($values_count) . ")", undef, reduziere_array($values_count,@entry));
		}
	}

}


sub reduziere_array {

	my $number_reduz = $_[0] - 1;
	my $number_test = $number_reduz + 2;

	my @get_array = @_;
	shift(@get_array);


	for (my $i = 0; $i <= $number_test; $i++) {
		if ($i > $number_reduz) { undef $get_array[$i]; }
		else {
			if ($get_array[$i] eq "0") {	}
			else { 	unless ($get_array[$i]) { $get_array[$i] = "";	} }
		}
	}

	@get_array = turn_to_null(@get_array);

	return @get_array;

}
sub fragezeich {

	my $print_frag = "";
	for (my $i = 1; $i <= $_[0]; $i++) {
		$print_frag .= "?,";
	}
	chop($print_frag);

	return $print_frag;

}
sub turn_to_null {
	my @convert = @_;
	foreach  (@convert) { 
		 if ($_ eq "") { $_ = undef; }
		 $_ =~ s/\\@/@/ig;
		 $_ =~ s/\\"/"/ig;
	}
	return @convert;
}
sub get_sql_import_database {

	my $sql_import;

	$sql_import .= q~

	/* 
		FIREBOOK_ is used as db prefix here
		you may want to replace FIREBOOK_ with your desired name as table prefix
		FB_DATABASE is the name of the database used here - you may change this name.

		FIREBOOK_ wird hier als Datenbank Prefix verwendet
		Du kannst FIREBOOK_ gerne in deinen Wunschprefix ndern
		FB_DATABASE ist der Datenbank Name hier - du kannst diesen Namen gerne anpassen.
	*/

	SET NAMES 'latin1';

	CREATE DATABASE if not exists FB_DATABASE;

	ALTER DATABASE `FB_DATABASE` DEFAULT CHARACTER SET latin1 COLLATE latin1_general_ci;
	~;

	return $sql_import;

}
sub get_sql_import {

	my $sql_import;

	$sql_import .= q~

	/*Table structure for table `FIREBOOK_admin_log` */

	DROP TABLE IF EXISTS `FIREBOOK_admin_log`;

	CREATE TABLE `FIREBOOK_admin_log` (
	  `access_admin_ip` varchar(250) default NULL,
	  `access_admin_host` varchar(255) default NULL,
	  `access_admin_date` int(10) default NULL,
	  `access_admin_agent` varchar(255) default NULL,
	  `access_admin_referer` varchar(255) default NULL
	) ENGINE=MyISAM;


	/*Table structure for table `FIREBOOK_checkdat` */

	DROP TABLE IF EXISTS `FIREBOOK_checkdat`;

	CREATE TABLE `FIREBOOK_checkdat` (
	  `time` int(10) NOT NULL,
	  `confcode` varchar(50) NOT NULL,
	  `checkname` varchar(80) NOT NULL,
	  `checkmail` varchar(50) NOT NULL,
	  `checkpw` varchar(30) default NULL,
	  `code` varchar(30) NOT NULL,
	  PRIMARY KEY  (`time`)
	) ENGINE=MyISAM COMMENT='stores pre-registration informations from gb accounts';


	/*Table structure for table `FIREBOOK_clicklog` */

	DROP TABLE IF EXISTS `FIREBOOK_clicklog`;

	CREATE TABLE `FIREBOOK_clicklog` (
	  `user_ip` varchar(250) NOT NULL default '',
	  `currtime` int(10) NOT NULL default '0',
	  `referer` varchar(255) default NULL,
	  `agent` varchar(255) default NULL
	) ENGINE=MyISAM;


	/*Table structure for table `FIREBOOK_databak` */

	DROP TABLE IF EXISTS `FIREBOOK_databak`;

	CREATE TABLE `FIREBOOK_databak` (
	  `id` int(11) NOT NULL,
	  `datum` int(10) default NULL COMMENT 'date',
	  `name` varchar(80) default NULL,
	  `icon` varchar(20) default NULL,
	  `email` varchar(50) default NULL,
	  `url` varchar(255) default NULL,
	  `ip` varchar(250) default NULL,
	  `icq` varchar(20) default NULL,
	  `aim` varchar(20) default NULL,
	  `msn` varchar(40) default NULL,
	  `skype` varchar(50) default NULL,
	  `yim` varchar(20) default NULL,
	  `message` text NOT NULL,
	  `feedback` text,
	  `bewertung` varchar(10) default NULL COMMENT 'rating',
	  `ort` varchar(40) default NULL COMMENT 'location',
	  `nosmile` tinyint(1) default NULL,
	  `frei` tinyint(1) NOT NULL COMMENT 'revision',
	  `msf` varchar(200) default NULL COMMENT 'attachment',
	  `hideown` tinyint(1) NOT NULL,
	  `savedinput` varchar(255) default NULL COMMENT 'own fields',
	  `privatn` tinyint(1) NOT NULL COMMENT 'private message',
	  `pinned` tinyint(1) NOT NULL,
	  `betreff` varchar(100) default NULL COMMENT 'topic',
	  `jabber` varchar(20) default NULL,
	  `state` varchar(40) default NULL,
	  `sprchosen` varchar(20) default NULL COMMENT 'language',
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM COMMENT='stores all the gb entries of the archive';


	/*Table structure for table `FIREBOOK_datacomm` */

	DROP TABLE IF EXISTS `FIREBOOK_datacomm`;

	CREATE TABLE `FIREBOOK_datacomm` (
	  `id` int(11) NOT NULL,
	  `nr` int(11) NOT NULL COMMENT 'identifies a comment',
	  `datum` int(10) default NULL COMMENT 'date',
	  `name` varchar(80) default NULL,
	  `email` varchar(50) default NULL,
	  `ip` varchar(250) default NULL,
	  `message` text NOT NULL,
	  `nosmile` tinyint(1) default NULL,
	  `hideown` tinyint(1) NOT NULL COMMENT 'revision',
	  `savedinput` varchar(255) default NULL,
	  `frei` tinyint(1) default NULL COMMENT 'own fields',
	  PRIMARY KEY  (`id`,`nr`)
	) ENGINE=MyISAM COMMENT='stores all the gb comments on entries';


	/*Table structure for table `FIREBOOK_datainc` */

	DROP TABLE IF EXISTS `FIREBOOK_datainc`;

	CREATE TABLE `FIREBOOK_datainc` (
	  `id` int(11) NOT NULL,
	  `datum` int(10) default NULL COMMENT 'date',
	  `name` varchar(80) default NULL,
	  `icon` varchar(20) default NULL,
	  `email` varchar(50) default NULL,
	  `url` varchar(255) default NULL,
	  `ip` varchar(250) default NULL,
	  `icq` varchar(20) default NULL,
	  `aim` varchar(20) default NULL,
	  `msn` varchar(40) default NULL,
	  `skype` varchar(50) default NULL,
	  `yim` varchar(20) default NULL,
	  `message` text NOT NULL,
	  `feedback` text,
	  `bewertung` tinyint(4) default NULL COMMENT 'rating',
	  `ort` varchar(40) default NULL COMMENT 'location',
	  `nosmile` tinyint(1) default NULL,
	  `frei` tinyint(1) NOT NULL COMMENT 'revision',
	  `msf` varchar(200) default NULL COMMENT 'attachment',
	  `hideown` tinyint(1) NOT NULL,
	  `savedinput` varchar(255) default NULL COMMENT 'own fields',
	  `privatn` tinyint(1) NOT NULL COMMENT 'private message',
	  `pinned` tinyint(1) NOT NULL,
	  `betreff` varchar(100) default NULL COMMENT 'topic',
	  `jabber` varchar(20) default NULL,
	  `state` varchar(40) default NULL,
	  `sprchosen` varchar(20) default NULL COMMENT 'language',
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM COMMENT='stores all the gb entries';

	/*Table structure for table `FIREBOOK_dataspam` */

	DROP TABLE IF EXISTS `FIREBOOK_dataspam`;

	CREATE TABLE `FIREBOOK_dataspam` (
	  `id` int(11) NOT NULL,
	  `datum` int(11) default NULL COMMENT 'date',
	  `name` varchar(80) default NULL,
	  `icon` varchar(20) default NULL,
	  `email` varchar(50) default NULL,
	  `url` varchar(255) default NULL,
	  `ip` varchar(250) default NULL,
	  `icq` varchar(20) default NULL,
	  `aim` varchar(20) default NULL,
	  `msn` varchar(40) default NULL,
	  `skype` varchar(50) default NULL,
	  `yim` varchar(20) default NULL,
	  `message` text NOT NULL,
	  `feedback` text,
	  `bewertung` varchar(10) default NULL COMMENT 'rating',
	  `ort` varchar(40) default NULL COMMENT 'location',
	  `nosmile` tinyint(1) default NULL,
	  `frei` tinyint(1) NOT NULL COMMENT 'revision',
	  `msf` varchar(200) default NULL COMMENT 'attachment',
	  `hideown` tinyint(1) NOT NULL,
	  `savedinput` varchar(255) default NULL COMMENT 'own fields',
	  `privatn` tinyint(1) NOT NULL COMMENT 'private message',
	  `pinned` tinyint(1) NOT NULL,
	  `betreff` varchar(100) default NULL COMMENT 'topic',
	  `jabber` varchar(20) default NULL,
	  `state` varchar(40) default NULL,
	  `sprchosen` varchar(20) default NULL COMMENT 'language',
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM COMMENT='stores all the gb entries identified as spam';

	/*Table structure for table `FIREBOOK_extsettings` */

	DROP TABLE IF EXISTS `FIREBOOK_extsettings`;

	CREATE TABLE `FIREBOOK_extsettings` (
	  `type` varchar(20) NOT NULL COMMENT 'id of setting',
	  `data` text COMMENT 'data of setting',
	  PRIMARY KEY  (`type`)
	) ENGINE=MyISAM COMMENT='used to store settings which can contain more dat';


	/*Table structure for table `FIREBOOK_map` */

	DROP TABLE IF EXISTS `FIREBOOK_map`;

	CREATE TABLE `FIREBOOK_map` (
	  `name` varchar(80) NOT NULL,
	  `country` varchar(50) default NULL,
	  `state` varchar(50) default NULL,
	  `coordinate1` smallint(6) NOT NULL,
	  `coordinate2` smallint(6) NOT NULL,
	  `user_ip` varchar(250) default NULL,
	  PRIMARY KEY  (`name`,`coordinate1`,`coordinate2`)
	) ENGINE=MyISAM COMMENT='this table stores the user map pin locations';

	/*Table structure for table `FIREBOOK_ownfields` */

	DROP TABLE IF EXISTS `FIREBOOK_ownfields`;

	CREATE TABLE `FIREBOOK_ownfields` (
	  `id` smallint(6) NOT NULL,
	  `name` varchar(30) NOT NULL COMMENT 'field description',
	  `form` tinyint(4) NOT NULL COMMENT 'representation for input',
	  `ishowform` tinyint(4) NOT NULL COMMENT 'representation form',
	  `ipredefined` text COMMENT 'pre defined variables',
	  `igraphurl` varchar(50) NOT NULL COMMENT 'url to graphics',
	  `iactive` tinyint(1) NOT NULL COMMENT 'required field?',
	  `iqactive` tinyint(1) NOT NULL COMMENT 'is activated?',
	  `ireqfield` tinyint(1) NOT NULL COMMENT 'active in quick entries',
	  `kommf` tinyint(1) NOT NULL COMMENT 'active in comments',
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM;


	/*Table structure for table `FIREBOOK_sessions` */

	DROP TABLE IF EXISTS `FIREBOOK_sessions`;

	CREATE TABLE `FIREBOOK_sessions` (
	  `time_old` int(10) NOT NULL COMMENT 'session time',
	  `created_id` varchar(40) NOT NULL COMMENT 'session id',
	  `sess_user_ip` varchar(250) default NULL,
	  `username` varchar(30) default NULL,
	  `password` varchar(30) default NULL,
	  `userag` varchar(255) default NULL COMMENT 'user browser',
	  `writtenids` int(11) default NULL,
	  `message_codes` varchar(200) default NULL COMMENT 'for spam protection',
	  `fact_sent` varchar(10) default NULL COMMENT 'needed for spam time protection',
	  `saved_proove_code` varchar(50) default NULL COMMENT 'captcha code',
	  PRIMARY KEY  (`created_id`)
	) ENGINE=MyISAM COMMENT='stores session informations';

	/*Table structure for table `FIREBOOK_stats` */

	DROP TABLE IF EXISTS `FIREBOOK_stats`;

	CREATE TABLE `FIREBOOK_stats` (
	  `insg_zugriffe` bigint(20) default NULL,
	  `letzter_zugriff` int(10) default NULL
	) ENGINE=MyISAM COMMENT='stores simple statistics for gb accounts';

	/*Table structure for table `FIREBOOK_stats_detail` */

	DROP TABLE IF EXISTS `FIREBOOK_stats_detail`;

	CREATE TABLE `FIREBOOK_stats_detail` (
	  `ip` varchar(250) NOT NULL,
	  `time` int(10) NOT NULL default '0',
	  `admin` tinyint(1) default NULL
	) ENGINE=MyISAM COMMENT='stores simple access stats for admin statistics';

	/*Table structure for table `FIREBOOK_ubbc` */

	DROP TABLE IF EXISTS `FIREBOOK_ubbc`;

	CREATE TABLE `FIREBOOK_ubbc` (
	  `code` varchar(20) NOT NULL,
	  `id` smallint(6) NOT NULL,
	  `beschr` varchar(200) default NULL,
	  `syntax` varchar(255) default NULL,
	  `umwandlung` text,
	  `javaeinf1` text,
	  `javaeinf2` text,
	  `javaeinf1wied` tinyint(1) default NULL,
	  `javaeinf2wied` tinyint(1) default NULL,
	  `dimensions` varchar(10) default NULL,
	  `list_ersetz` varchar(100) default NULL,
	  `kuerze_feld` varchar(100) default NULL,
	  `aktionen_nein` varchar(200) default NULL,
	  `effekt_einzeln` tinyint(1) default NULL,
	  `effekt_gewaehlt` varchar(10) default NULL,
	  `gbhilfe_akt` tinyint(1) default NULL,
	  `active` tinyint(1) default NULL,
	  `active_comments` tinyint(1) default NULL,
	  `delete_pipe` tinyint(1) default NULL,
	  `delete_bracket` tinyint(1) default NULL,
	  `delete_nl` tinyint(1) default NULL,
	  `allowed_values` text,
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM;

	/*Data for the table `FIREBOOK_ubbc` */

	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbbold',1,'<txt_ub 1>: <b><txt_ub 4></b>','[b]%text%[/b]','<b>%text%</b>','','',0,0,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbitalic',2,'<txt_ub 1>: <b><txt_ub 5></b>','[i]%text%[/i]','<i>%text%</i>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbunderline',3,'<txt_ub 1>: <b><txt_ub 6></b>','[u]%text%[/u]','<u>%text%</u>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbstrike',4,'<txt_ub 1>: <b><txt_ub 7></b>','[s]%text%[/s]','<s>%text%</s>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figboverline',5,'<txt_ub 1>: <b><txt_ub 8></b>','[o]%text%[/o]','<font STYLE=\"text-decoration: overline;\">%text%</font>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbleft',6,'<txt_ub 2>: <b><txt_ub 9></b>','[left]%text%[/left]','<div align=left>%text%</div>',NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbcenter',7,'<txt_ub 2>: <b><txt_ub 10></b>','[center]%text%[/center]','<div align=center>%text%</div>','','',0,0,',','','*','',0,'',1,1,1,0,0,0,'');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbright',8,'<txt_ub 2>: <b><txt_ub 11></b>','[right]%text%[/right]','<div align=right>%text%</div>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbjustify',9,'<txt_ub 2>: <b><txt_ub 12></b>','[justify]%text%[/justify]','<div align=justify>%text%</div>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbpre',10,'<txt_ub 2>: <b><txt_ub 13></b>','[pre]%text%[/pre]','<pre>%text%</pre>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbsup',11,'<txt_ub 1>: <b><txt_ub 14></b>','[sup]%text%[/sup]','<sup>%text%</sup>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbsub',12,'<txt_ub 1>: <b><txt_ub 15></b>','[sub]%text%[/sub]','<sub>%text%</sub>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbhr',13,'<txt_ub 3>: <b><txt_ub 16></b>','[hr=%opt1%,%opt2%]','<hr size=1 STYLE=\"border : 1px %opt2% %opt1%;\" width=\"60%\">',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,'black*red*orangered*darkred*coral*yellow*deeppink*green*limegreen*seagreen*orange*purple*indigo*skyblue*blue*navy*beige*sandybrown*chocolate*brown*teal*maroon*silver$solid*dotted');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbhr',14,'<txt_ub 3>: <txt_ub 16>','[hr]','<hr size=1 width=\"60%\">',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figblink',15,'<txt_ub 17>','[link=%opt1%]%text%[/link]','<a href=\"%stealthlink1%\" target=_blank>%text%</a>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figblink',19,'<txt_ub 17>','[link]%opt1%[/link]','<a href=\"%stealthlink1%\" target=_blank>%opt1%</a>',NULL,NULL,NULL,NULL,NULL,NULL,'opt1*55',NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbftp',23,'<txt_ub 17>','[ftp=ftp://%opt1%]%text%[/ftp]','<a href=\"<FIREBOOK SCRIPTACNOSKIN>=redirectexit;prt=ftp;url=%opt1%\" target=_blank>%text%</a>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbftp',24,'<txt_ub 17>','[ftp=ftp.%lopt1%]%text%[/ftp]','<a href=\"<FIREBOOK SCRIPTACNOSKIN>=redirectexit;prt=ftp;url=ftp.%opt1%\" target=_blank>%text%</a>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbftp',25,'<txt_ub 17>','[ftp=%opt1%]%text%[/ftp]','<a href=\"<FIREBOOK SCRIPTACNOSKIN>=redirectexit;prt=ftp;url=%opt1%\" target=_blank>%text%</a>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbftp',26,'<txt_ub 17>','[ftp]ftp://%opt1%[/ftp]','<a href=\"<FIREBOOK SCRIPTACNOSKIN>=redirectexit;prt=ftp;url=%opt1%\" target=_blank>%opt1%</a>',NULL,NULL,NULL,NULL,NULL,NULL,'opt1*55',NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbftp',27,'<txt_ub 17>','[ftp]ftp.%lopt1%[/ftp]','<a href=\"<FIREBOOK SCRIPTACNOSKIN>=redirectexit;prt=ftp;url=ftp.%opt1%\" target=_blank>ftp.%opt1%</a>',NULL,NULL,NULL,NULL,NULL,NULL,'opt1*55',NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbftp',28,'<txt_ub 17>','[ftp]%opt1%[/ftp]','<a href=\"<FIREBOOK SCRIPTACNOSKIN>=redirectexit;prt=ftp;url=%opt1%\" target=_blank>ftp://%opt1%</a>',NULL,NULL,NULL,NULL,NULL,NULL,'opt1*55',NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figburl',29,'<txt_ub 3>: <b><txt_ub 17></b>','[url=%opt1%]%text%[/url]','<a href=\"%stealthlink1%\" target=_blank>%text%</a>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figburl',33,'<txt_ub 17>','[url]%opt1%[/url]','<a href=\"%stealthlink1%\" target=_blank>%opt1%</a>',NULL,NULL,NULL,NULL,NULL,NULL,'opt1*55',NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbimg',37,'<txt_ub 3>: <b><txt_ub 18></b>','[img]%imgopt1%[/img]','<img src=\"http://%opt1%\" alt=\"<txt_gl 79>\" border=0>',NULL,NULL,NULL,NULL,'400,400',NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbemail',38,'<txt_ub 3>: <b><txt_ub 19></b>','[email=%emailopt1%]%text%[/email]','<a href=\"mailto:%opt1%\">%text%</a>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbemail',39,'<txt_ub 19>','[email]%emailopt1%[/email]','<a href=\"mailto:%opt1%\">%opt1%</a>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbflash',40,'<txt_ub 3>: <b><txt_ub 20></b>','[flash=%digopt1%,%digopt2%]%linkopt3%[/flash]',' <b>[ <txt_ub 40> %opt1% x %opt2%: <a href=\"javascript:popUp(\'%stealthlink3%\',%opt1%,%opt2%)\">%opt3%</a> ]</b> ',NULL,NULL,NULL,NULL,'500,500',NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbquote',41,'<txt_ub 3>: <b><txt_ub 21></b>','[quote]%text%[/quote]','<table border=0 cellspacing=0 cellpadding=2><tr><td width=10>&nbsp;</td><td valign=top width=10 align=right><img src=\"<FIREBOOK BILDERURLSK>/allgemein/quotebox.gif\" alt=\"<txt_ub 21>\"></td><td width=100%><table cellspacing=1 width=95% class=quote cellpadding=8><tr><td class=fb1 width=100%><div STYLE=\"font-size: 11px;\">%text%</div></td></tr></table></td></tr></table>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figblist',42,'<txt_ub 3>: <b><txt_ub 22></b>','[list=%opt1%]%optrow%[/list]','<%opt1%l>%optrow%</%opt1%l>',NULL,NULL,NULL,NULL,NULL,'[&#42;]<li>',NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,'o*u');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbfont',43,'<txt_ub 2>: <b><txt_ub 23></b>','[font=%opt1%]%text%[/font]','<font face=\"%opt1%\">%text%</font>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,'arial*arial black*comic sans ms*courier*courier new*impact*tahoma*times new roman*verdana');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbcolor',44,'<txt_ub 2>: <b><txt_ub 24></b>','[color=%opt1%]%text%[/color]','<font color=\"%opt1%\">%text%</font>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,'black*red*orangered*darkred*coral*yellow*deeppink*green*limegreen*seagreen*orange*purple*indigo*skyblue*blue*navy*beige*sandybrown*chocolate*brown*teal*maroon*silver*#330000*#333300*#336600*#339900*#33CC00*#33FF00*#66FF00*#66CC00*#669900*#666600*#663300*#660000*#FF0000*#FF3300*#FF6600*#FF9900*#FFCC00*#FFFF00*#330033*#333333*#336633*#339933*#33CC33*#33FF33*#66FF33*#66CC33*#669933*#666633*#663333*#660033*#FF0033*#FF3333*#FF6633*#FF9933*#FFCC33*#FFFF33*#330066*#333366*#336666*#339966*#33CC66*#33FF66*#66FF66*#66CC66*#669966*#666666*#663366*#660066*#FF0066*#FF3366*#FF6666*#FF9966*#FFCC66*#FFFF66*#330099*#333399*#336699*#339999*#33CC99*#33FF99*#66FF99*#66CC99*#669999*#666699*#663399*#660099*#FF0099*#FF3399*#FF6699*#FF9999*#FFCC99*#FFFF99*#3300CC*#3333CC*#3366CC*#3399CC*#33CCCC*#33FFCC*#66FFCC*#66CCCC*#6699CC*#6666CC*#6633CC*#6600CC*#FF00CC*#FF33CC*#FF66CC*#FF99CC*#FFCCCC*#FFFFCC*#3300FF*#3333FF*#3366FF*#3399FF*#33CCFF*#33FFFF*#66FFFF*#66CCFF*#6699FF*#6666FF*#6633FF*#6600FF*#FF00FF*#FF33FF*#FF66FF*#FF99FF*#FFCCFF*#FFFFFF*#0000FF*#0033FF*#0066FF*#0099FF*#00CCFF*#00FFFF*#99FFFF*#99CCFF*#9999FF*#9966FF*#9933FF*#9900FF*#CC00FF*#CC33FF*#CC66FF*#CC99FF*#CCCCFF*#CCFFFF*#0000CC*#0033CC*#0066CC*#0099CC*#00CCCC*#00FFCC*#99FFCC*#99CCCC*#9999CC*#9966CC*#9933CC*#9900CC*#CC00CC*#CC33CC*#CC66CC*#CC99CC*#CCCCCC*#CCFFCC*#000099*#003399*#006699*#009999*#00CC99*#00FF99*#99FF99*#99CC99*#999999*#996699*#993399*#990099*#CC0099*#CC3399*#CC6699*#CC9999*#CCCC99*#CCFF99*#000066*#003366*#006666*#009966*#00CC66*#00FF66*#99FF66*#99CC66*#999966*#996666*#993366*#990066*#CC0066*#CC3366*#CC6666*#CC9966*#CCCC66*#CCFF66*#000033*#003333*#006633*#009933*#00CC33*#00FF33*#99FF33*#99CC33*#999933*#996633*#993333*#990033*#CC0033*#CC3333*#CC6633*#CC9933*#CCCC33*#CCFF33*#000000*#003300*#006600*#009900*#00CC00*#00FF00*#99FF00*#99CC00*#999900*#996600*#993300*#990000*#CC0000*#CC3300*#CC6600*#CC9900*#CCCC00*#CCFF00*#000000*#111111*#222222*#333333*#444444*#555555*#666666*#777777*#888888*#999999*#9A9A9A*#AAAAAA*#BBBBBB*#CCCCCC*#DDDDDD*#EEEEEE*#EFEFEF*#FFFFFF');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbsize',45,'<txt_ub 2>: <b><txt_ub 25></b>','[size=%digopt1%]%text%[/size]','<font size=\"%opt1%\">%text%</font>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,'1*2*3*4*5*6');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbaim',46,'<txt_ub 41>: <b><txt_gl 19></b>','[aim]%opt1%[/aim]','%aimgif%',NULL,NULL,NULL,NULL,',','','*','',0,'',1,1,1,0,0,0,'');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbicq',47,'<txt_ub 41>: <b><txt_gl 18></b>','[icq]%digopt1%[/icq]','%icqgif%',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbimg',48,'<txt_ub 41>: <b><txt_ub 18></b>','[img=%digopt1%,%digopt2%]%imgopt3%[/img]','<img alt=\"<txt_gl 79>\" src=\"http://%opt3%\" border=0 width=%opt1% height=%opt2%>',NULL,NULL,NULL,NULL,'400,400',NULL,NULL,NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbjabber',49,'<txt_ub 41>: <b><txt_gl 22></b>','[jabber]%opt1%[/jabber]','%jabbergif%',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbmsn',50,'<txt_ub 41>: <b><txt_gl 21></b>','[msn]%opt1%[/msn]','%msngif%',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbskype',51,'<txt_ub 41>: <b><txt_gl 146></b>','[skype]%opt1%[/skype]','%skypegif%',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbyim',52,'<txt_ub 41>: <b><txt_gl 20></b>','[yim]%opt1%[/yim]','%yimgif%',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbeffect-updown',53,'<txt_ub 42>: <b><txt_ub 26></b>','[updown]%text%[/updown]','%text%',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'updown',1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbeffect-blur',54,'<txt_ub 42>: <b><txt_ub 27></b>','[blur=%digopt1%]%text%[/blur]','<span style=\"filter:blur(add=true, direction=10, strength=%opt1%); width: 100%; display: block;\">%text%</span>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbeffect-chcolor',55,'<txt_ub 42>: <b><txt_ub 28></b>','[chcolor]%text%[/chcolor]','<div STYLE=\"display:inline;\" id=\"c%count%\">%text%</div>&nbsp;','<SCRIPT LANGUAGE=\"JavaScript1.2\">%br%<!--%br%var wechsel=new Array()%br%var initwerte=new Array()%br%%br%var xcount = 0;%br%var chcolor = new Array(\"black\",\"red\",\"orangered\",\"darkred\",\"coral\",\"yellow\",\"deeppink\",\"green\",\"limegreen\",\"seagreen\",\"orange\",\"purple\",\"indigo\",\"skyblue\",\"blue\",\"navy\",\"beige\",\"sandybrown\",\"chocolate\",\"brown\",\"teal\",\"maroon\",\"silver\");%br%%br%function ch2color(){%br%lenw = wechsel.length;%br%for (i = 1; i <= lenw-1; i++) {%br%if (!initwerte[i]) { initwerte[i] = document.getElementById(\"c\"+i).innerHTML; }%br%document.getElementById(\"c\"+i).innerHTML =\'<font color=\"\' +chcolor[xcount]+ \'\">\'+initwerte[i]+\'</font>\';%br%}%br%(xcount < chcolor.length-1) ? xcount++ : xcount = 0;%br%}%br%//-->%br%</script>','<script language=\"JavaScript\">%br%<!--%br%wechsel[%allcount%] = 1;%br%setInterval(\"ch2color()\",500);%br%//-->%br%</script>',0,0,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbeffect-glow',56,'<txt_ub 42>: <b><txt_ub 29></b>','[glow=%opt1%,%digopt2%]%text%[/glow]','%text%','','',0,0,',','','*',NULL,0,'glow',1,1,1,0,0,0,'black*red*orangered*darkred*coral*yellow*deeppink*green*limegreen*seagreen*orange*purple*indigo*skyblue*blue*navy*beige*sandybrown*chocolate*brown*teal*maroon*silver$1*2*3*4*5*6*7$');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbeffect-shadow',57,'<txt_ub 42>: <b><txt_ub 30></b>','[shadow=%opt1%,%opt2%]%text%[/shadow]','%text%',NULL,NULL,0,0,',','','*',NULL,1,'shadow',1,1,1,0,0,0,'black*red*orangered*darkred*coral*yellow*deeppink*green*limegreen*seagreen*orange*purple*indigo*skyblue*blue*navy*beige*sandybrown*chocolate*brown*teal*maroon*silver$left*right*top*bottom*topright*bottomright*bottomleft*topleft$');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbeffect-shake',58,'<txt_ub 42>: <b><txt_ub 31></b>','[shake]%text%[/shake]','<div STYLE=\"display:inline;\" id=\"shaketick%count%\" STYLE=\"position: relative;\">%text%</div>&nbsp;','<SCRIPT LANGUAGE=\"JavaScript1.1\">%br%<!-- %br%var shakewechsel=new Array()%br%var y=0%br%var x=0%br%var count_shakes= 0%br%var count_mezzos= 0%br%var countsrand = \"\";%br%var shakerand = \"\";%br%var shaketicker=new Array()%br%%br%function initObjects() {%br%lenshake = shakewechsel.length;%br%%br%	for (i = 1; i <= lenshake-1; i++) {%br%		shaketicker[i] = document.getElementById(\"shaketick\"+i).style%br%	}%br%	shake()%br%}%br%%br%function getrandom() {%br%		var dif= Math.floor(Math.random()*2)%br%		return dif%br%}%br%function intermezzo() {%br%		count_shakes=0%br%		count_mezzos++;%br%		if (count_mezzos < 20) { %br%		shakerand = randInt(2000,10000);%br%		setTimeout(\'shake()\',shakerand) }%br%}%br%function randInt(min,max)%br%{%br%        var div = (max - min) + 1%br%        var randNum = Math.random()%br%        for (var i = 0; i <= div - 1; i++)%br%        {%br%                if (randNum >= i / div && randNum < (i+1) / div)%br%                        {return i + min}%br%        }%br%}%br%function shake() {%br%if (count_shakes == 0) {%br%countsrand = randInt(5,40);%br%}%br%%br%	if (count_shakes < countsrand) {%br%		%br%		for (i = 1; i <= lenshake-1; i++) {%br%			shaketicker[i].top=y+getrandom(); shaketicker[i].left=x+getrandom();%br%		}%br%		var timer = setTimeout(\'shake()\',20)%br%		count_shakes++;%br%	}		%br%	else {%br%	for (i = 1; i <= lenshake-1; i++) {%br%		shaketicker[i].top=y; shaketicker[i].left=x;%br%		}%br%		intermezzo()%br%		clearTimeout(timer)%br%	}%br%%br%}%br%-->%br%</SCRIPT>','<script language=\"JavaScript\">%br%<!--%br%shakewechsel[%allcount%] = 1;%br%initObjects();%br%//-->%br%</script>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbeffect-wave',59,'<txt_ub 42>: <b><txt_ub 32></b>','[wave=%digopt1%,%digopt2%]%text%[/wave]','<span style=\"filter:wave(Add=0, Freq=%opt1%, LightStrength=0, Phase=0, Strength=%opt2%); width: 100%; display: block;\">%text%</span>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbeffect-rainbow',60,'<txt_ub 42>: <b><txt_ub 33></b>','[rainbow=%digopt1%]%text%[/rainbow]','<script language=javascript>%br%<!--%br%function farbschrift%count%()%br%{%br%        for(var i=0 ; i<Buchstabe%count%.length; i++) { document.all[\"a%count%\"+i].style.color=farben%count%[i]; }%br%        for(var i=0 ; i<farben%count%.length; i++) { farben%count%[i-1]=farben%count%[i]; }%br%        farben%count%[farben%count%.length-1]=farben%count%[-1];%br%		setTimeout(\"farbschrift%count%()\",50);%br%}%br%function string2array%count%(text)%br%{%br%   Buchstabe%count% = new Array();%br%   while(farben%count%.length<text%count%.length) { farben%count% = farben%count%.concat(farben%count%);	}%br%   k=0;%br%   while(k<=text%count%.length) {	Buchstabe%count%[k] = text%count%.charAt(k); k++; } %br%   for(var i=0 ; i<Buchstabe%count%.length; i++)%br%   { document.write(\"<span id=\'a%count%\"+i+\"\' class=\'a%count%\"+i+\"\'>\"+Buchstabe%count%[i] + \"</span>\"); }%br%   farbschrift%count%();%br% } %br% text%count%= \"%text%\"; %br% farben%count% = farbbibliothek[%opt1%]; %br% string2array%count%(text%count%);%br%-->%br%</script>','<script language=javascript>%br%<!--%br%farbbibliothek = new Array();%br%farbbibliothek[1] = new Array(\"#FF0000\",\"#FF1100\",\"#FF2200\",\"#FF3300\",\"#FF4400\",\"#FF5500\",\"#FF6600\",\"#FF7700\",\"#FF8800\",\"#FF9900\",\"#FFaa00\",\"#FFbb00\",\"#FFcc00\",\"#FFdd00\",\"#FFee00\",\"#FFff00\",\"#FFee00\",\"#FFdd00\",\"#FFcc00\",\"#FFbb00\",\"#FFaa00\",\"#FF9900\",\"#FF8800\",\"#FF7700\",\"#FF6600\",\"#FF5500\",\"#FF4400\",\"#FF3300\",\"#FF2200\",\"#FF1100\");%br%farbbibliothek[2] = new Array(\"#00FF00\",\"#000000\",\"#00FF00\",\"#00FF00\");%br%farbbibliothek[3] = new Array(\"#00FF00\",\"#FF0000\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\",\"#00FF00\");%br%farbbibliothek[4] = new Array(\"#FF0000\",\"#FF4000\",\"#FF8000\",\"#FFC000\",\"#FFFF00\",\"#C0FF00\",\"#80FF00\",\"#40FF00\",\"#00FF00\",\"#00FF40\",\"#00FF80\",\"#00FFC0\",\"#00FFFF\",\"#00C0FF\",\"#0080FF\",\"#0040FF\",\"#0000FF\",\"#4000FF\",\"#8000FF\",\"#C000FF\",\"#FF00FF\",\"#FF00C0\",\"#FF0080\",\"#FF0040\");%br%farbbibliothek[5] = new Array(\"#FF0000\",\"#EE0000\",\"#DD0000\",\"#CC0000\",\"#BB0000\",\"#AA0000\",\"#990000\",\"#880000\",\"#770000\",\"#660000\",\"#550000\",\"#440000\",\"#330000\",\"#220000\",\"#110000\",\"#000000\",\"#110000\",\"#220000\",\"#330000\",\"#440000\",\"#550000\",\"#660000\",\"#770000\",\"#880000\",\"#990000\",\"#AA0000\",\"#BB0000\",\"#CC0000\",\"#DD0000\",\"#EE0000\");%br%farbbibliothek[6] = new Array(\"#000000\",\"#000000\",\"#000000\",\"#FFFFFF\",\"#FFFFFF\",\"#FFFFFF\");%br%farbbibliothek[7] = new Array(\"#0000FF\",\"#FFFF00\");%br%-->%br%</script>',NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,1,1,1,'1*2*3*4*5*6*7');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbeffect-waveani',61,'<txt_ub 42>: <b><txt_ub 34></b>','[waveani]%text%[/waveani]','<div STYLE=\"display:inline;\" ID=\"theKlaus%count%\"></div>%br%<script language=\"JavaScript\">%br%<!--%br%function sizeCycle%count%(text%count%,method,dis)%br%{%br%	output%count% =  \"\";%br%	for (i = 0; i < text%count%.length; i++)%br%	{%br%		size = parseInt(nextSize(i +dis,method,text%count%.length));%br%		output%count% += \"<font style=\'font-size: \"+ size +\"pt\'>\" +text%count%.substring(i,i+1)+ \"</font>\";%br%	}%br%	theKlaus%count%.innerHTML = output%count%;%br%}%br%%br%function doWave%count%(n) %br%{   %br%	theText%count% = \'%texta%\';%br%	sizeCycle%count%(theText%count%,1,n);%br%	if (n > theText%count%.length) {n=0}%br%	setTimeout(\"doWave%count%(\" + (n+1) + \")\", 150);%br%}%br%doWave%count%(0);%br%-->%br%</script>','<script language=\"JavaScript\">%br%<!--%br%function nextSize(i,incMethod,textLength)%br%{%br%if (incMethod == 1) return (72*Math.abs( Math.sin(i/(textLength/3.14))) );%br%if (incMethod == 2) return (255*Math.abs( Math.cos(i/(textLength/3.14))));%br%}%br%-->%br%</script>',NULL,NULL,NULL,',','','texta*20',NULL,0,NULL,0,0,0,1,1,1,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbeffect-terminal',62,'<txt_ub 42>: <b><txt_ub 35></b>','[terminal]%text%[/terminal]','<div STYLE=\"display:inline;\" id=\"dis%count%\"></div>%br%<script language=javascript>%br%<!--%br%var symarray%count%=new Array();%br%function newstart%count%() {%br%for (var i=0; i<text[%count%].length; i++){%br%symarray%count%[i]=\" \";%br%}%br%scroll%count%();%br%}%br%function scroll%count%(){%br%for (var i=0; i<text[%count%].length; i++){%br%if (symarray%count%[i]!=text[%count%].substring(i,i+1)) {%br%for (var x=0; x<70; x++) if (symarray%count%[i]==symtype[x]) {symarray%count%[i]=symtype[x+1]; break}%br%}%br%}%br%outsym%count%=\"\";%br%for (var i=0; i<text[%count%].length; i++) outsym%count%+=symarray%count%[i];%br%dis%count%.innerHTML=outsym%count%;%br%if (outsym%count% != text[%count%]) {%br%setTimeout(\'scroll%count%()\',50);%br%}%br%}%br%text[%count%]=\"%text%\";%br%newstart%count%();%br%-->%br%</script>','<script language=javascript>%br%<!--%br%var text=new Array();%br%var symtype=new Array(\" \",\"A\",\"a\",\"B\",\"b\",\"C\",\"c\",\"D\",\"d\",\"E\",\"e\",\"F\",\"f\",\"G\",\"g\",\"H\",\"h\",\"I\",\"i\",\"J\",\"j\",\"K\",\"k\",\"L\",\"l\",\"M\",\"m\",\"N\",\"n\",\"O\",\"o\",\"P\",\"p\",\"Q\",\"q\",\"R\",\"r\",\"S\",\"s\",\"T\",\"t\",\"U\",\"u\",\"V\",\"v\",\"W\",\"w\",\"X\",\"x\",\"Y\",\"y\",\"Z\",\"z\",\"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\".\",\",\",\"&\",\"!\",\"?\",\"-\",\"_\",\"\",\"\",\"\");%br%-->%br%</script>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,1,1,1,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbeffect-move',63,'<txt_ub 42>: <b><txt_ub 36></b>','[move=%opt1%,%opt2%]%text%[/move]','<marquee bgcolor=\"%opt1%\" width=\"50%\" scrolldelay=\"20\"><font color=\"%opt2%\">%text%</font></marquee>','','',0,0,',','','*','',0,'',0,1,1,0,1,0,'$$');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbeffect-move',67,'<txt_ub 42>: <b><txt_ub 36></b>','[move]%text[/move]','<marquee>%text%</marquee>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbpopupsmilies',68,'mod_popsm addon','[smiley=%text%]','<img border=0 src=\"<FIREBOOK BILDERURLSK_NOADMIN>/popsmilies/%text%\">','','',0,0,NULL,NULL,NULL,NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbeffect-blink',64,'<txt_ub 42>: <b><txt_ub 37></b>','[blink]%text%[/blink]','<blink><div STYLE=\"display:inline;\" id=\"blink%count%\">%text%</div>&nbsp;</blink>','<script language=\"JavaScript\">%br%<!--%br%var blink;%br%var blinkies=new Array()%br%%br%function blink1 () {%br%if (blinky1 == \"blink\") { blinky1 = \"noblink\"%br%	for (i = 0; i < len-1; i++) {%br%	i2 = i +1;%br%	document.getElementById(\"blink\"+i2).style.visibility = \"hidden\";%br%	}%br%%br%}%br%else { %br%	for (i = 0; i < len-1; i++) {%br%	i2 = i +1;%br%	document.getElementById(\"blink\"+i2).style.visibility = \"visible\";%br%	}%br%blinky1 = \"blink\" %br%}%br% setTimeout(\"blink1()\",500);%br%}%br%%br%function startblink1 () {%br%len = blinkies.length;%br%blinky1 = \"blink\";%br%blink1();%br%}%br%//-->%br%</script>','<script language=\"JavaScript\">%br%<!--%br%blinkies[%allcount%] = 1;%br%startblink1();%br%//-->%br%</script>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,1,1,1,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('figbeditnote',65,'<txt_ub 38>','[edit %opt1%]%digopt2%[/edit]','<br><font size=1><div align=right> <txt_ub 43> %datopt2% <txt_ub 44> %nameopt1% </div></font>',NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('videosyoutube',66,'<txt_ub 108>','[youtube]%optrow%[/youtube]','<object width=\"425\" height=\"344\"><param name=\"movie\" value=\"%optrow%\"></param><param name=\"allowFullScreen\" value=\"true\"></param><param name=\"allowscriptaccess\" value=\"always\"></param><embed src=\"%optrow%\" type=\"application/x-shockwave-flash\" allowscriptaccess=\"always\" allowfullscreen=\"true\" width=\"425\" height=\"344\"></embed></object>','','',0,0,',','watch?v=v/','*','',0,'',0,1,1,0,0,0,'');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('videosmyvideo',69,'<txt_ub 111>','[myvideo]%optrow%[/myvideo]','<object style=\'width:425px;height:367px;\' width=\'425\' height=\'367\'><param name=\'movie\' value=\'%optrow%\'></param><param name=\'AllowFullscreen\' value=\'true\'></param><param name=\'AllowScriptAccess\' value=\'always\'></param><embed src=\'%optrow%\' width=\'425\' height=\'367\' type=\'application/x-shockwave-flash\' allowscriptaccess=\'always\' allowfullscreen=\'true\'></embed></object>','','',0,0,',','watchmovie','*','',0,'',0,1,1,0,0,0,'');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('videosdailymotion',70,'<txt_ub 118>','[dailymotion]%optrow%[/dailymotion]','<object width=\"425\" height=\"344\"><param name=\"movie\" value=\"http://www.dailymotion.com/swf/x9osih_thriller-music-video_shortfilms&related=0\"></param><param name=\"allowFullScreen\" value=\"true\"></param><param name=\"allowScriptAccess\" value=\"always\"></param><embed src=\"http://www.dailymotion.com/swf/x9osih_thriller-music-video_shortfilms&related=0\" type=\"application/x-shockwave-flash\" width=\"425\" height=\"344\" allowFullScreen=\"true\" allowScriptAccess=\"always\"></embed></object>','','',0,0,',','videoswf','*','',0,'',0,1,1,0,0,0,'');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('videosclipfish',71,'<txt_ub 113>','[clipfish]http://www.clipfish.de/video/%opt1%/%opt2%/[/clipfish]','<object classid=\'clsid:d27cdb6e-ae6d-11cf-96b8-444553540000\' codebase=\'http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=8,0,0,0\' width=\'425\' height=\'344\' id=\'player\' align=\'middle\'><param name=\'allowScriptAccess\' value=\'always\' /><param name=\'movie\' value=\'http://www.clipfish.de/videoplayer.swf?as=0&vid=14452&r=1\' /><param name=\'quality\' value=\'high\' /><param name=\'bgcolor\' value=\'#FFFFFF\' /><param name=\'allowFullScreen\' value=\'true\' /><embed src=\'http://www.clipfish.de/videoplayer.swf?as=0&vid=14452&r=1\' quality=\'high\' bgcolor=\'#FFFFFF\' width=\'425\' height=\'344\' name=\'player\' align=\'middle\' allowFullScreen=\'true\' allowScriptAccess=\'always\' type=\'application/x-shockwave-flash\' pluginspage=\'http://www.macromedia.com/go/getflashplayer\'></embed></object>','','',0,0,NULL,NULL,NULL,NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('videosbreakcom',72,'<txt_ub 119>','[breakcom]%text%[/breakcom] ','<object width=\"425\" height=\"344\"><param name=\"movie\" value=\"http://embed.break.com/%text%\"></param><param name=\"allowScriptAccess\" value=\"always\"></param><embed src=\"http://embed.break.com/%text%\" type=\"application/x-shockwave-flash\" allowScriptAccess=\"always\" width=\"425\" height=\"344\"></embed></object>','','',0,0,NULL,NULL,NULL,NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('videosveohcom',73,'<txt_ub 115>','[veohcom]%text%[/veohcom]','<object width=\"425\" height=\"344\" id=\"veohFlashPlayer\" name=\"veohFlashPlayer\"><param name=\"movie\" value=\"http://www.veoh.com/static/swf/webplayer/WebPlayer.swf?version=AFrontend.5.4.2.20.1002&permalinkId=%text%&player=videodetailsembedded&videoAutoPlay=0&id=anonymous\"></param><param name=\"allowFullScreen\" value=\"true\"></param><param name=\"allowscriptaccess\" value=\"always\"></param><embed src=\"http://www.veoh.com/static/swf/webplayer/WebPlayer.swf?version=AFrontend.5.4.2.20.1002&permalinkId=%text%&player=videodetailsembedded&videoAutoPlay=0&id=anonymous\" type=\"application/x-shockwave-flash\" allowscriptaccess=\"always\" allowfullscreen=\"true\" width=\"425\" height=\"344\" id=\"veohFlashPlayerEmbed\" name=\"veohFlashPlayerEmbed\"></embed></object>','','',0,0,NULL,NULL,NULL,NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('videosgoogle',74,'<txt_ub 114>','[googlevideos]%optrow%[/googlevideos] ','<embed id=\"VideoPlayback\" src=\"%optrow%\" style=\"width:425px;height:344px\" allowFullScreen=\"true\" allowScriptAccess=\"always\" type=\"application/x-shockwave-flash\"> </embed>','','',0,0,',','videoplaygoogleplayer.swf','*','',0,'',0,1,1,0,0,0,'');
	insert  into `FIREBOOK_ubbc`(`code`,`id`,`beschr`,`syntax`,`umwandlung`,`javaeinf1`,`javaeinf2`,`javaeinf1wied`,`javaeinf2wied`,`dimensions`,`list_ersetz`,`kuerze_feld`,`aktionen_nein`,`effekt_einzeln`,`effekt_gewaehlt`,`gbhilfe_akt`,`active`,`active_comments`,`delete_pipe`,`delete_bracket`,`delete_nl`,`allowed_values`) values ('videosmetacafe',75,'<txt_ub 116>','[metacafe]http://www.metacafe.com/watch/%opt1%/%opt2%/[/metacafe] ','<embed src=\"http://www.metacafe.com/fplayer/%opt1%/%opt2%.swf\" width=\"425\" height=\"344\" wmode=\"transparent\" allowFullScreen=\"true\" allowScriptAccess=\"always\" name=\"Metacafe_7203\" pluginspage=\"http://www.macromedia.com/go/getflashplayer\" type=\"application/x-shockwave-flash\"> </embed>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,1,1,NULL,NULL,NULL,NULL);

	/*Table structure for table `FIREBOOK_ubbcinput` */

	DROP TABLE IF EXISTS `FIREBOOK_ubbcinput`;

	CREATE TABLE `FIREBOOK_ubbcinput` (
	  `code` varchar(20) default NULL,
	  `id` smallint(6) NOT NULL,
	  `beschr` varchar(255) default NULL,
	  `syntax` varchar(255) default NULL,
	  `type` varchar(50) default NULL,
	  `graphic` varchar(50) default NULL,
	  `modus` varchar(10) default NULL,
	  `styles` text,
	  `options` text,
	  `questions` text,
	  `optrow_char` varchar(30) default NULL,
	  `active` tinyint(1) default NULL,
	  `active_comments` tinyint(1) default NULL,
	  `questions_sub` text,
	  `options_sub` text,
	  `syntaxes_sub` text,
	  `actives_sub` text,
	  `show_link` tinyint(1) default NULL,
	  `proove_url` tinyint(1) default NULL,
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM;

	/*Data for the table `FIREBOOK_ubbcinput` */

	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbbold',1,'<txt_ub 4>','[b]%text%[/b]','button','bold.gif','seltext',NULL,NULL,NULL,'',1,1,NULL,NULL,NULL,'0',0,0);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbitalic',2,'<txt_ub 5>','[i]%text%[/i]','button','italicize.gif','seltext',NULL,NULL,NULL,NULL,1,1,NULL,NULL,NULL,'0',NULL,NULL);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbunderline',3,'<txt_ub 6>','[u]%text%[/u]','button','underline.gif','seltext',NULL,NULL,NULL,NULL,1,1,NULL,NULL,NULL,'0',NULL,NULL);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figboverline',4,'<txt_ub 8>','[o]%text%[/o]','button','overline.gif','seltext',NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,'0',NULL,NULL);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbstrike',5,'<txt_ub 7>','[s]%text%[/s]','button','strike.gif','seltext',NULL,NULL,NULL,NULL,1,1,NULL,NULL,NULL,'0',NULL,NULL);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbleft',6,'<txt_ub 9>','[left]%text%[/left]','button','left.gif','seltext',NULL,NULL,NULL,NULL,1,1,NULL,NULL,NULL,'0',NULL,NULL);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbcenter',7,'<txt_ub 10>','[center]%text%[/center]','button','center.gif','seltext',NULL,NULL,NULL,NULL,1,1,NULL,NULL,NULL,'0',NULL,NULL);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbright',8,'<txt_ub 11>','[right]%text%[/right]','button','right.gif','seltext',NULL,NULL,NULL,NULL,1,1,NULL,NULL,NULL,'0',NULL,NULL);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbjustify',9,'<txt_ub 12>','[justify]%text%[/justify]','button','justify.gif','seltext',NULL,NULL,NULL,NULL,1,1,NULL,NULL,NULL,'0',NULL,NULL);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbpre',10,'<txt_ub 13>','[pre]%text%[/pre]','button','pre.gif','seltext',NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,'0',NULL,NULL);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbsup',11,'<txt_ub 14>','[sup]%text%[/sup]','button','sup.gif','seltext',NULL,NULL,NULL,NULL,1,1,NULL,NULL,NULL,'0',NULL,NULL);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbsub',12,'<txt_ub 15>','[sub]%text%[/sub]','button','sub.gif','seltext',NULL,NULL,NULL,NULL,1,1,NULL,NULL,NULL,'0',NULL,NULL);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbhr',13,'<txt_ub 16>','[hr=%opt1%,%opt2%]','button','hr.gif','popup',NULL,'red<txt_ub 45>*blue<txt_ub 46>*green<txt_ub 47>*black<txt_ub 48>$dotted<txt_ub 49>*solid<txt_ub 50>','<b><txt_ub 72></b>*opt1$<b><txt_ub 52></b>*opt2','',1,1,NULL,NULL,NULL,'0',0,0);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figburl',14,'<txt_ub 17>','[url=%text%]%opt1%[/url]','button','url.gif','popup',NULL,NULL,'<b><txt_ub 53></b>*<txt_ub 54>',NULL,1,1,NULL,NULL,NULL,'0',NULL,1);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbemail',15,'<txt_ub 19>','[email=%text%]%opt1%[/email]','button','email2.gif','popup','','','<b><txt_ub 55></b>*<txt_ub 54>$','',1,1,NULL,NULL,NULL,'0',0,0);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbimg',16,'<txt_ub 18>','[img]%text%[/img]','button','img.gif','seltext',NULL,NULL,NULL,NULL,1,1,NULL,NULL,NULL,'0',NULL,1);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbvideos',17,'<txt_ub 110>','','buttondropdown','video.gif','popup','font-weight: bold; background-image: url(<FIREBOOK BILDERURLSK>/allgemein/youtube.gif); background-repeat: no-repeat; padding-left: 19px; margin-left: 1px; margin: 1px; display: block;*font-weight: bold; background-image: url(<FIREBOOK BILDERURLSK>/allgemein/metacafe.gif); background-repeat: no-repeat; padding-left: 19px; margin-left: 1px; margin: 1px; display: block;*font-weight: bold; margin: 1px; background-image: url(<FIREBOOK BILDERURLSK>/allgemein/dailymotion.gif); background-repeat: no-repeat; padding-left: 19px; display: block;*font-weight: bold; margin: 1px; background-image: url(<FIREBOOK BILDERURLSK>/allgemein/myvideo.gif); background-repeat: no-repeat; padding-left: 19px; display: block;*font-weight: bold; margin: 1px; background-image: url(<FIREBOOK BILDERURLSK>/allgemein/clipfish.gif); background-repeat: no-repeat; padding-left: 19px; display: block;*font-weight: bold; margin: 1px; background-image: url(<FIREBOOK BILDERURLSK>/allgemein/breakcom.gif); background-repeat: no-repeat; padding-left: 19px; display: block;*font-weight: bold; margin: 1px; background-image: url(<FIREBOOK BILDERURLSK>/allgemein/veoh.gif); background-repeat: no-repeat; padding-left: 19px; display: block;*font-weight: bold; margin: 1px; background-image: url(<FIREBOOK BILDERURLSK>/allgemein/googlevideos.gif); background-repeat: no-repeat; padding-left: 19px; display: block;*font-weight: bold; margin: 1px; background-image: url(<FIREBOOK BILDERURLSK>/allgemein/flash.gif); background-repeat: no-repeat; padding-left: 19px; display: block;','youtube<txt_ub 108>*metacafe<txt_ub 116>*dailymotion<txt_ub 118>*myvideo<txt_ub 111>*clipfish<txt_ub 113>*breakcom<txt_ub 119>*veoh<txt_ub 115>*googlevideos<txt_ub 114>*flash<txt_ub 20>','*$','',1,1,'<txt_ub 109>http://*$<txt_ub 123>http://*$<txt_ub 117>http://*$<txt_ub 112>http://*$<txt_ub 120>http://*$<txt_ub 124>507504*$<txt_ub 122>e41615*$<txt_ub 121>http://*$<b><txt_ub 56></b>200*<b><txt_ub 57></b>200*','$','[youtube]%opt1%[/youtube][metacafe]%opt1%[/metacafe][dailymotion]%opt1%[/dailymotion][myvideo]%opt1%[/myvideo][clipfish]%opt1%[/clipfish][breakcom]%opt1%[/breakcom][veohcom]%opt1%[/veohcom][googlevideos]%opt1%[/googlevideos][flash=%opt1%,%opt2%]%text%[/flash]','1*1*1*1*1*1*1*1*1',0,0);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbquote',18,'<txt_ub 21>','[quote]%text%[/quote]','button','quote2.gif','seltext',NULL,NULL,NULL,NULL,1,1,NULL,NULL,NULL,'0',NULL,NULL);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figblist',19,'<txt_ub 22>','[list=u]%optrow%[/list]','button','list.gif','optrow',NULL,NULL,'<txt_ub 58> %optrowcount%.<txt_ub 59>','[*]',1,1,NULL,NULL,NULL,'0',NULL,NULL);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbfont',20,'<txt_ub 23>','[font=%opt1%]%text%[/font]','buttondropdown','downm.gif','seltext','display: inline; padding: 0px; margin: 0px 0px 0px 2px; font-family:arial;*display: inline; padding: 0px; margin: 0px 0px 0px 2px; font-family:arial black;*display: inline; padding: 0px; margin: 0px 0px 0px 2px; font-family:comic sans ms;*display: inline; padding: 0px; margin: 0px 0px 0px 2px; font-family:courier;*display: inline; padding: 0px; margin: 0px 0px 0px 2px; font-family:courier new;*display: inline; padding: 0px; margin: 0px 0px 0px 2px; font-family:impact;*display: inline; padding: 0px; margin: 0px 0px 0px 2px; font-family:tahoma;*display: inline; padding: 0px; margin: 0px 0px 0px 2px; font-family:times new roman;*display: inline; padding: 0px; margin: 0px 0px 0px 2px; font-family:verdana;','arialArial*arial blackArial Black*comic sans msComic Sans*courierCourier*courier newCourier New*impactImpact*tahomaTahoma*times new romanTimes New Roman*verdanaVerdana','*$',NULL,1,1,NULL,NULL,NULL,'0',1,0);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbcolor',21,'<txt_ub 24>','[color=%opt1%]%text%[/color]','buttondropdown','downm.gif','colorbox','','','*$','',1,1,NULL,NULL,NULL,'0',1,0);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbsize',22,'<txt_ub 25>','[size=%opt1%]%text%[/size]','buttondropdown','downm.gif','seltext','display: inline; padding: 0px; margin: 0px 0px 0px 2px; font-size:10px;*display: inline; padding: 0px; margin: 0px 0px 0px 2px; font-size:13px;*display: inline; padding: 0px; margin: 0px 0px 0px 2px; font-size:16px;*display: inline; padding: 0px; margin: 0px 0px 0px 2px; font-size:22px;*display: inline; padding: 0px; margin: 0px 0px 0px 2px; font-size:30px;','1<txt_ub 60>*2<txt_ub 61>*3<txt_ub 62>*5<txt_ub 63>*6<txt_ub 64>','*$',NULL,1,1,NULL,NULL,NULL,'0',1,0);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbeffect',23,'<txt_ub 39>','','buttondropdown','downm.gif','popup','display: inline; padding: 0px; margin: 0px; *display: inline; padding: 0px; margin: 0px; *display: inline; padding: 0px; margin: 0px; *display: inline; padding: 0px; margin: 0px; filter:blur(add=true, direction=10, strength=2); width: 100;*display: inline; padding: 0px; margin: 0px; filter:wave(Add=0, Freq=1, LightStrength=0, Phase=0, Strength=2); width: 100;','move<marquee><txt_ub 36></marquee>*glow<txt_ub 65>*shadow<txt_ub 66>*blur<txt_ub 27>*wave<txt_ub 32>*updown<txt_ub 67>*blink<blink><txt_ub 37></blink> (<txt_ub 68>)*chcolor<txt_ub 69>*terminal<txt_ub 35> (<txt_ub 68>)*rainbow<txt_ub 70>*shake<txt_ub 31> (<txt_ub 68>)*waveani<txt_ub 71>','*$','',1,1,'<b><txt_ub 76></b>opt1*<b><txt_ub 77></b>opt2*$<b><txt_ub 72></b>opt1*<b><txt_ub 51></b>opt2*$<b><txt_ub 51></b>opt1*<b><txt_ub 73></b>opt2*$<b><txt_ub 51></b>opt1*$<b><txt_ub 74></b>opt1*<b><txt_ub 51></b>opt2*$$$$$<b><txt_ub 75></b>opt1*$$','#FFFFFF<txt_ub 91>*#FF0000<txt_ub 45>*#FF6633<txt_ub 78>*#990000<txt_ub 79>*#FF00FF<txt_ub 80>*#66CC00<txt_ub 47>*#99FF00<txt_ub 81>*#66CC66<txt_ub 82>*#990099<txt_ub 83>*#99FFFF<txt_ub 84>*#66CC99<txt_ub 85>*#3300FF<txt_ub 46>*#000066<txt_ub 86>*#FFFF00<txt_ub 87>*#CC9933<txt_ub 88>*#663300<txt_ub 89>*#CCCCFF<txt_ub 90>*#000000<txt_ub 48>$#000000<txt_ub 48>*#FF0000<txt_ub 45>*#FF6633<txt_ub 78>*#990000<txt_ub 79>*#FF00FF<txt_ub 80>*#66CC00<txt_ub 47>*#99FF00<txt_ub 81>*#66CC66<txt_ub 82>*#990099<txt_ub 83>*#99FFFF<txt_ub 84>*#66CC99<txt_ub 85>*#3300FF<txt_ub 46>*#000066<txt_ub 86>*#FFFF00<txt_ub 87>*#CC9933<txt_ub 88>*#663300<txt_ub 89>*#CCCCFF<txt_ub 90>*#FFFFFF<txt_ub 91>#FFFF00<txt_ub 87>*#FF0000<txt_ub 45>*#FF6633<txt_ub 78>*#990000<txt_ub 79>*#FF00FF<txt_ub 80>*#66CC00<txt_ub 47>*#99FF00<txt_ub 81>*#66CC66<txt_ub 82>*#990099<txt_ub 83>*#99FFFF<txt_ub 84>*#66CC99<txt_ub 85>*#3300FF<txt_ub 46>*#000066<txt_ub 86>*#000000<txt_ub 48>*#CC9933<txt_ub 88>*#663300<txt_ub 89>*#CCCCFF<txt_ub 90>*#FFFFFF<txt_ub 91>$22*33*44*55*66*77#FF0000<txt_ub 45>*#3300FF<txt_ub 46>*#FF6633<txt_ub 78>*#990000<txt_ub 79>*#FF00FF<txt_ub 80>*#66CC00<txt_ub 47>*#99FF00<txt_ub 81>*#66CC66<txt_ub 82>*#990099<txt_ub 83>*#99FFFF<txt_ub 84>*#66CC99<txt_ub 85>*#000000<txt_ub 48>*#000066<txt_ub 86>*#FFFF00<txt_ub 87>*#CC9933<txt_ub 88>*#663300<txt_ub 89>*#CCCCFF<txt_ub 90>*#FFFFFF<txt_ub 91>$left<txt_ub 92>*right<txt_ub 93>*top<txt_ub 94>*bottom<txt_ub 95>*topright<txt_ub 96>*bottomright<txt_ub 97>*bottomleft<txt_ub 98>*topleft8 11*22*33*44*55*66*7711*22*33*44*55*66*77$11*22*33*44*55*66*771<txt_ub 100>*2<txt_ub 101>*3<txt_ub 102>*4<txt_ub 103>*5<txt_ub 104>*6<txt_ub 105>*7<txt_ub 106>','[move=%opt1%,%opt2%]%text%[/move][glow=%opt1%,%opt2%]%text%[/glow][shadow=%opt1%,%opt2%]%text%[/shadow][blur=%opt1%]%text%[/blur][wave=%opt1%,%opt2%]%text%[/wave][updown]%text%[/updown][blink]%text%[/blink][chcolor]%text%[/chcolor][terminal]%text%[/terminal][rainbow=%opt1%]%text%[/rainbow][shake]%text%[/shake][waveani]%text%[/waveani]','1*1*1*1*1*1*1*1*1*0*1*0',1,0);
	insert  into `FIREBOOK_ubbcinput`(`code`,`id`,`beschr`,`syntax`,`type`,`graphic`,`modus`,`styles`,`options`,`questions`,`optrow_char`,`active`,`active_comments`,`questions_sub`,`options_sub`,`syntaxes_sub`,`actives_sub`,`show_link`,`proove_url`) values ('figbhelp',24,'<txt_ub 107>',NULL,'buttondropdown','help.gif','help',NULL,NULL,NULL,NULL,1,1,NULL,NULL,NULL,'0',1,NULL);

	/*Table structure for table `FIREBOOK_users` */

	DROP TABLE IF EXISTS `FIREBOOK_users`;

	CREATE TABLE `FIREBOOK_users` (
	  `relname` varchar(80) NOT NULL COMMENT 'user name',
	  `relpass` varchar(30) NOT NULL COMMENT 'password',
	  `relmail` varchar(50) default NULL COMMENT 'mail adress',
	  `reladminr` tinyint(1) NOT NULL COMMENT 'admin rights',
	  `relactivation` tinyint(1) NOT NULL COMMENT 'is activated',
	  `reladmmailr` tinyint(1) NOT NULL COMMENT 'admin mail receiver',
	  PRIMARY KEY  (`relname`)
	) ENGINE=MyISAM COMMENT='stores the registered users for all gbs';



	~;

	return $sql_import;


}



if ($fb::gl{'action'} eq "setup")  { &setup; }
elsif ($fb::gl{'action'} eq "setup2") { &setup2; }
else {
	&chooselang;
}





1;
