####################### [Firebook] - guestbook ################################
# admin.pl       	                                                          #
###############################################################################

use strict;
use warnings;
#use diagnostics;

sub admin {
	
	my @smilies = &load_smilies;
	my @contents = &opendirectory("$fb::cf{'bilderdir'}/upload");
	

	my @adminlog = $fb::dbh->selectrow_array("SELECT access_admin_ip, access_admin_host, access_admin_date, access_admin_agent, access_admin_referer FROM $fb::cf{'db_prefix'}" . "admin_log", undef);

	unless ($adminlog[4]) { $adminlog[4] = ""; }

	my $datum = time;
		
	$fb::dbh->do("INSERT INTO $fb::cf{'db_prefix'}" . "admin_log (access_admin_ip, access_admin_host, access_admin_date, access_admin_agent, access_admin_referer) VALUES(?,?,?,?,?) ON DUPLICATE KEY UPDATE access_admin_ip = ?, access_admin_host = ?, access_admin_date = ?, access_admin_agent = ?, access_admin_referer = ?", undef, $fb::gl{'user_ip'}, $ENV{'REMOTE_HOST'}, $datum, $ENV{'HTTP_USER_AGENT'}, $ENV{'HTTP_REFERER'}, $fb::gl{'user_ip'}, $ENV{'REMOTE_HOST'}, $datum, $ENV{'HTTP_USER_AGENT'}, $ENV{'HTTP_REFERER'});

	@smilies = &load_smilies;

	# addon for mod_comm
	my $countcomm = 0;
	if ($fb::mod{'modules_info'}{'mod_comm'}[0]) {
		$countcomm = $fb::dbh->selectrow_array("SELECT COUNT(*) FROM $fb::cf{'db_prefix'}" . "datacomm", undef);
	}
	
	# addon for users mod
	my $countusers = 0;
	if ($fb::mod{'modules_info'}{'mod_users'}[0]) {
		$countusers = $fb::dbh->selectrow_array("SELECT COUNT(*) FROM $fb::cf{'db_prefix'}" . "users", undef);
	}
	
	my $countsmilies = @smilies;
	
	# addon for arch mod
	my $archiveentr = 0;
	if ($fb::mod{'modules_info'}{'mod_arch'}[0]) {
		$archiveentr = $fb::dbh->selectrow_array("SELECT COUNT(*) FROM $fb::cf{'db_prefix'}" . "databak", undef);
	}

	# addon for map mod
	my $mapentr = 0;
	if ($fb::mod{'modules_info'}{'mod_mmap'}[0]) {
		$mapentr = $fb::dbh->selectrow_array("SELECT COUNT(*) FROM $fb::cf{'db_prefix'}" . "map", undef);
	}

	# addon for spam mod
	my $spamdata = "";
	if ($fb::mod{'modules_info'}{'mod_spam'}[0]) {
		my $spamdata = $fb::dbh->selectrow_array("SELECT COUNT(*) FROM $fb::cf{'db_prefix'}" . "dataspam", undef);
	}	

	my $letzte_id = $fb::dbh->selectrow_array("SELECT MAX(id) FROM $fb::cf{'db_prefix'}" . "datainc", undef);

	my $attachentr = $fb::dbh->selectrow_array("SELECT COUNT(*) FROM $fb::cf{'db_prefix'}" . "datainc WHERE msf IS NOT NULL AND msf <> ''", undef);
	
	my $firstdate = "";
	my $firstfrei = "";
	($firstdate, $firstfrei) = $fb::dbh->selectrow_array("SELECT datum, frei FROM $fb::cf{'db_prefix'}" . "datainc WHERE id = ?", undef, $letzte_id);

	my $freientr = $fb::dbh->selectrow_array("SELECT COUNT(*) FROM $fb::cf{'db_prefix'}" . "datainc WHERE frei = ?", undef, "1");

	my $count = $fb::dbh->selectrow_array("SELECT COUNT(*) FROM $fb::cf{'db_prefix'}" . "datainc", undef);

	if ($firstfrei) { $fb::gl{'actionfirstdate'} = qq~<a href="$fb::gl{'scriptac'}=activation">~; }
	else { $fb::gl{'actionfirstdate'} = qq~<a href="$fb::fi{'scriptacnoskin'}" target="_blank">~; }


	$firstdate = &formatdatum($firstdate);

	unless ($archiveentr) { $archiveentr = "0"; }
	unless ($mapentr) { $mapentr = "0"; }
	unless ($countusers) { $countusers = "0"; }
	unless ($spamdata) { $spamdata = "0"; }
	unless ($countsmilies) { $countsmilies = "0"; }
	unless ($countcomm) { $countcomm = "0"; }
	

	chomp(@adminlog);

	my $allfiles = 0;
	foreach (@contents) {
		my ($name, $extension) = split (/\./, $_);
		if (($extension) && (($extension eq "gif") || ($extension eq "jpg") || ($extension eq "png"))){
			$allfiles++;
		}
	}

	my $datum_log = &formatdatum($adminlog[2]);
	
	my $print_verw;

	if (length($adminlog[4]) > 70) {
		$print_verw = substr($adminlog[4],0,70) . "...";
	}
	else {
		$print_verw = $adminlog[4];
	}


	&isadmin;
	$fb::fi{'title'} = "$fb::txt{'gl'}{'2'}";
	&adminmenu;
	$fb::fi{'main'} .= qq~<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>
		<tr><td class=fbcatbg colspan=2><b>$fb::txt{'gl'}{'113'}</b></td></tr>
	<tr>
		<td class=fb2 width="50%"><div style="padding: 5px"><br><b>$fb::txt{'ad'}{'1'}</b><br>$fb::txt{'ad'}{'2'}<br>&nbsp;</div></td>
		<td class=fb1>
				<table width="100%" border=0 cellspacing=1 cellpadding=2>
					<tr><td width=35><a href="$fb::gl{'scriptac'}=licencemanagement">
						<img src="$fb::fi{'bilderurlsk'}/allgemein/activation_state.gif" border="0"></a></td>
						<td><a href="$fb::gl{'scriptac'}=licencemanagement"><b>$fb::txt{'ad'}{'33'}</b></a></td></tr>
					<tr><td><a href="$fb::gl{'scriptac'}=modules">
						<img src="$fb::fi{'bilderurlsk'}/allgemein/module_update.gif" border="0"></a></td>
						<td><a href="$fb::gl{'scriptac'}=modules"><b>$fb::txt{'ad'}{'32'}</b></a></td></tr>
				</table>
	</td>
	</tr>


		
		
		<tr>
		<td class=fb1 colspan=2>
		<table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td>
	<b>$fb::txt{'ad'}{'5'}:</b></td><td align=right>$datum_log</td></tr></table>
		
	</td>
		</tr>
	<tr><td class=fb2 valign=top>
		<table border=0 cellspacing=0 cellpadding=3><tr><td valign=top>
		<i>$fb::txt{'ad'}{'6'}:</i></td><td><font size=1>$adminlog[3]</font></td></tr><tr><td valign=top>
		<i>$fb::txt{'ad'}{'7'}:</i></td><td><font size=1><a href="$adminlog[4]" target=_blank>$print_verw</a></font>
		</td></tr></table>


		
	</td><td class=fb2 valign=top>
	<table border=0 cellspacing=0 cellpadding=3><tr><td valign=top><i>$fb::txt{'ad'}{'8'}:</i></td><td valign=top>
		$adminlog[0]</td></tr><tr><td valign=top><i>$fb::txt{'ad'}{'9'}:</i></td><td valign=top> $adminlog[1]</td>
		</tr>
		</table>
		
	</td></tr>

		
		
		<tr>	<td class=fb1 colspan=2>
		<b>$fb::txt{'ad'}{'10'}:</b>
	</td></tr>

	<tr><td class=fb2 valign=top>
		<table border=0 cellspacing=0 cellpadding=3 width=99%>
		<tr><td valign=top><i><a href="$fb::gl{'scriptac'}=editall">$fb::txt{'ad'}{'12'}</a>:</i></td><td align=right><b>$count</b>~;
	
	# addon for mod arch and mod spam
	if ($fb::mod{'modules_info'}{'mod_spam'}[0] || $fb::mod{'modules_info'}{'mod_arch'}[0]) {
		
		$fb::fi{'main'} .= qq~(~;
		
		my $add_print = "";

		if ($fb::mod{'modules_info'}{'mod_arch'}[0]) {
			$add_print .= qq~$fb::txt{'ad'}{'14'} $archiveentr <a href="$fb::gl{'scriptac'}=archiv">$fb::txt{'ad'}{'13'}</a>~;
		}
		if ($fb::mod{'modules_info'}{'mod_spam'}[0]) {
			if ($add_print) { $add_print .= ", "; }
			$add_print .= qq~, $spamdata <a href="$fb::gl{'scriptac'}=spamfilter">$fb::txt{'mod_spam_gl'}{'1'}</a>~;
		}

		$fb::fi{'main'} .= qq~$add_print)~;
	}

		
	$fb::fi{'main'} .= qq~)</td></tr>
		<tr><td valign=top><i>$fb::gl{'actionfirstdate'}$fb::txt{'ad'}{'16'}</a>:</i></td><td align=right><b>$firstdate</b></td></tr>



	</table>
		
	</td><td class=fb2 valign=top><table border=0 cellspacing=0 cellpadding=3 width=99%>
		<tr><td valign=top><i><a href="$fb::gl{'scriptac'}=activation">$fb::txt{'ad'}{'17'}</a>:</i></td><td align=right> <b>$freientr</b></td></tr>~;
	
	if ($fb::mod{'modules_info'}{'mod_comm'}[0]) {
		$fb::fi{'main'} .= qq~<tr><td valign=top><i><a href="$fb::gl{'scriptac'}=editall;sel=comm">$fb::txt{'ad'}{'18'}</a>:</i></td><td align=right> <b>$countcomm</b></td></tr>~;
	}

	$fb::fi{'main'} .= qq~</table></td></tr>

	<tr><td class=fb2 valign=top>
		<table border=0 cellspacing=0 cellpadding=3 width=99%>

		<tr><td valign=top><i><a href="$fb::gl{'scriptac'}=fileexplorer;go2=upload">$fb::txt{'ad'}{'31'}</a>:</i></td><td align=right><b>$allfiles</b> ($fb::txt{'ad'}{'20'} $attachentr $fb::txt{'ad'}{'21'})</td></tr>~;

		if ($fb::mod{'modules_info'}{'mod_mmap'}[0]) {
			$fb::fi{'main'} .= qq~<tr><td valign=top><i><a href="$fb::gl{'scriptac'}=mod_mmap_mmadmin;show=members">$fb::txt{'mod_mmap_gl'}{'6'}</a>:</i></td><td align=right> <b>$mapentr</b></td></tr>	~;
		}

		$fb::fi{'main'} .= qq~</table>
		
	</td><td class=fb2 valign=top><table border=0 cellspacing=0 cellpadding=3 width=99%>
		<tr><td valign=top><i><a href="$fb::gl{'scriptac'}=smilies">$fb::txt{'ad'}{'22'}</a>:</i></td><td align=right><b>$countsmilies</b></td></tr>~;

	if ($fb::mod{'modules_info'}{'mod_users'}[0]) {
		$fb::fi{'main'} .= qq~<tr><td valign=top><i><a href="$fb::gl{'scriptac'}=admreg">$fb::txt{'mod_users_gl'}{'9'}</a>:</i></td><td align=right><b>$countusers</b></td></tr>	~;
	}
	
$fb::fi{'main'} .= qq~
	</table></td></tr>
		<tr>	<td class=fb1 colspan=2>

	<b>$fb::txt{'ad'}{'25'}</b> ($fb::txt{'ad'}{'26'})</td></tr>

	<tr><td class=fb2 valign=top>
		<table border=0 cellspacing=0 cellpadding=3 width=99%>
	<tr><td valign=top><i>$fb::txt{'ad'}{'27'}:</i></td><td align=right><b>$fb::fi{'countheute'}</b> ($fb::fi{'countheuteadmin'} $fb::txt{'ad'}{'30'})</td></tr>
	<tr><td valign=top><i>$fb::txt{'ad'}{'19'}:</i></td><td align=right><b>$fb::fi{'countgestern'}</b> ($fb::fi{'countgesternadmin'} $fb::txt{'ad'}{'30'})</td></tr>

	</table>
		
	</td><td class=fb2 valign=top><table border=0 cellspacing=0 cellpadding=3 width=99%>
	<tr><td valign=top><i>$fb::txt{'ad'}{'28'}:</i></td><td align=right><b>$fb::fi{'allezugriffe'}</b></td></tr>
	<tr><td valign=top><i>$fb::txt{'ad'}{'29'}:</i></td><td align=right><b>$fb::fi{'countjetzt'}</b> ($fb::fi{'countjetztadmin'} $fb::txt{'ad'}{'30'})</td></tr>

	</table></td></tr>

		<tr>	<td class=fb1 colspan=2>
		
	<b>$fb::txt{'ad'}{'3'}:</b>
	</td></tr>
	<tr><td class=fb2 colspan=2 align=center>

		<table border=0 cellspacing=0 cellpadding=3><form action="$fb::gl{'scriptac'}=such2" method="post" name="fiform">			
			<tr><td align=right>
	<b>$fb::txt{'ad'}{'4'}:</b></td>

		<td>
			<input type="text" name="alles" value="" size=10> <input type="submit" name="post" value="$fb::txt{'gl'}{'65'}">
		</td></tr></form></table>
	</td></tr>






		</table>

	~;

	&adminschluss;
	&template;
}
sub idreams {
	my $was = $fb::INFO{'was'};

	# TBD change support URLs accordingly
	
	my ($language, $helpfile, $language2, $set_location);

	if ($fb::gl{'sprache2'} eq "deutsch") { $language = "deutsch"; $helpfile = "Hilfe"; $language2 = "de";	}
	else { $language = "english";  $helpfile = "Help"; $language2 = "en"; }
	if ($was eq "support") {
		$set_location = "http://www.firebook.de";
		#$set_location = "http://scripts.i-dreams.net/forums/?langid=$language2&dolangchange=1";
	}
	elsif ($was eq "download") {
		$set_location = "http://www.firebook.de";
		#$set_location = "http://scripts.i-dreams.net/?$language:script:$fb::gl{'thisscriptcode'}:download";
	}
	elsif ($was eq "information") {
		$set_location = "http://www.firebook.de";
		#$set_location = "http://scripts.i-dreams.net/?$language:script:$fb::gl{'thisscriptcode'}";
	}
	elsif ($was eq "other") {
		$set_location = "http://www.firebook.de";
	}
	elsif ($was eq "help") {
		$set_location = "http://www.firebook.de";
	#	$set_location = "http://scripts.i-dreams.net/inc/$fb::gl{'thisscriptcode'}/$helpfile.pdf";
	}
	&redirect($set_location);
}
1;