####################### [Firebook] - guestbook ################################
# astats.pl      	                                                          #
###############################################################################

package fb;

use strict;
use warnings;
#use diagnostics;

sub astats {
	
	my $statsdate = time;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	$year = $year + 1900;

	my $today1 = Time::Local::timelocal("0","0","0",$mday,$mon,$year);
	my $today2 = Time::Local::timelocal("59","59","23",$mday,$mon,$year);

	my $stats1date = $statsdate - 300;
	my $stats2date = $statsdate + 300;
	
	my $yestoday1 = $today1 - 86400;
	my $yestoday2 = $today2 - 86400;

	

	$fb::dbh->do("DELETE FROM $fb::cf{'db_prefix'}" . "stats_detail WHERE time < ?", undef, $yestoday1);

	my $insg_zugriffe = $fb::dbh->selectrow_array("SELECT insg_zugriffe FROM $fb::cf{'db_prefix'}" . "stats", undef) || "0";
	my $sth = $fb::dbh->prepare("SELECT ip, time, admin FROM $fb::cf{'db_prefix'}" . "stats_detail");
	$sth->execute() or save_db_error(DBI->errstr);
	
	my ($count_todayclicks, %countjetzt, $countjetzt, %countjetztadmin, $countjetztadmin, %countheute, $countheute, $grenze1, $grenze2, %countheuteadmin, $countheuteadmin, %countgestern, $countgestern, %countgesternadmin, $countgesternadmin, %countrest, $countrest);
	
	$countjetzt = 0;
	$countjetztadmin = 0;
	$countheute = 0;
	$countheuteadmin = 0;

	while(my @stats = $sth->fetchrow_array) {
		
		unless($stats[2]) { $stats[2] = 0; }


		if (($stats[1] >= $today1) && ($stats[1] <= $today2)) {
			$count_todayclicks++;
		}

		if (($stats[1] >= $stats1date) && ($stats[1] <= $stats2date)) {
			
			unless	($countjetzt{$stats[0]}) { 
				$countjetzt{$stats[0]} = $stats[1]; $countjetzt++; 
			}
			if ($stats[2] == 1) { 
					unless ($countjetztadmin{$stats[0]}) {  $countjetztadmin++; $countjetztadmin{$stats[0]}++; 	}
			}
		
		}
		elsif (($stats[1] >= $today1) && ($stats[1] <= $today2)) {
			
			if ($countheute{$stats[0]}) { 
				$grenze1 = $countheute{$stats[0]} + 5400;
				$grenze2 = $today2;
				if (($stats[1] >= $grenze1) && ($stats[1] <= $grenze2)) {
					$countheute++;
					$countheute{$stats[0]} = $stats[1];
				}
			}
			else { $countheute{$stats[0]} = $stats[1]; $countheute++;	}
			
			if (($countheuteadmin{$stats[0]}) && ($stats[2] == 1)) {
				$grenze1 = $countheuteadmin{$stats[0]} + 5400;
				$grenze2 = $today2;
				if (($stats[1] >= $grenze1) && ($stats[1] <= $grenze2)) {
					$countheuteadmin++;
					$countheuteadmin{$stats[0]} = $stats[1];
				}
			}
			elsif ($stats[2] == 1) { $countheuteadmin{$stats[0]} = $stats[1]; $countheuteadmin++; }
		  
		}
		elsif (($stats[1] >= $yestoday1) && ($stats[1] <= $yestoday2)) {
			if ($countgestern{$stats[0]}) { 
				$grenze1 = $countgestern{$stats[0]} + 5400;
				$grenze2 = $yestoday2;
				if (($stats[1] >= $grenze1) && ($stats[1] <= $grenze2)) {
					$countgestern++;
					$countgestern{$stats[0]} = $stats[1];
				}
			}
			else { $countgestern{$stats[0]} = $stats[1]; $countgestern++; 	}
				if (($countgesternadmin{$stats[0]}) && ($stats[2] == 1)) { 
				$grenze1 = $countgesternadmin{$stats[0]} + 5400;
				$grenze2 = $yestoday2;
				if (($stats[1] >= $grenze1) && ($stats[1] <= $grenze2)) {
					$countgesternadmin++;
					$countgesternadmin{$stats[0]} = $stats[1];
				}
			}
					elsif ($stats[2] == 1) { $countgesternadmin{$stats[0]} = $stats[1]; $countgesternadmin++; }
		}
		else {
			if ($countrest{$stats[0]}) { 
				$grenze1 = $countrest{$stats[0]} + 5400;
				if ($stats[1] >= $grenze1) {
					$countrest++;
					$countrest{$stats[0]} = $stats[1];
				}
			}
			else { $countrest{$stats[0]} = 0; $countrest++; }
			$countrest{$stats[0]} = $stats[1];
		}
	}
	unless ($countrest) { $countrest = 0; }	

	my $statallcount = $countrest + $insg_zugriffe;

	$countheute = $countheute + $countjetzt;
	$countheuteadmin = $countheuteadmin + $countjetztadmin;
	
	unless ($countjetzt) { $countjetzt = "0"; }
	unless ($countheute) { $countheute = "0"; }
	unless ($countgestern) { $countgestern = "0"; }
	unless ($countrest) { $countrest = "0"; }
	unless ($countgesternadmin) { $countgesternadmin = "0"; }
	unless ($countheuteadmin) { $countheuteadmin = "0"; }
	unless ($countjetztadmin) { $countjetztadmin = "0"; }


	$fb::fi{'allezugriffe'} = $statallcount + $countgestern + $countheute + $countjetzt;
	$fb::fi{'countgestern'} = $countgestern;
	$fb::fi{'countheute'} = $countheute;
	$fb::fi{'countjetzt'} = $countjetzt;
	$fb::fi{'countgesternadmin'} = $countgesternadmin;
	$fb::fi{'countheuteadmin'} = $countheuteadmin;
	$fb::fi{'countjetztadmin'} = $countjetztadmin;
	$fb::fi{'countrest'} = $countrest;
	
	$fb::dbh->do("DELETE FROM $fb::cf{'db_prefix'}" . "stats");
	$fb::dbh->do("INSERT INTO $fb::cf{'db_prefix'}" . "stats (insg_zugriffe, letzter_zugriff) VALUES(?,?)", undef, $statallcount, time);



}

1;