####################### [Firebook] - guestbook ################################
# edit.pl                                                                     #
###############################################################################

package fb;

use strict;
use warnings;
#use diagnostics;

sub edit {
	
	# change skin back to standard skin
	if ($fb::gl{'skin'} eq "admin") {
		$fb::gl{'skin'} = $fb::cf{'skinchosen'}; 
		$fb::INFO{'skin'} = $fb::cf{'skinchosen'}; 
		$fb::gl{'byadmin'} = 1; 
	}
	$fb::gl{'noadmin_skchange'} = 1;  # avoid automatic skin change

	my $id = $fb::INFO{'id'} || $fb::FORM{'id'};
	&isadmin;

	# values for the fields to be loaded are stored in here
	my %loadf;

	unless ($fb::cf{'attachzusatz'}) {
		$fb::cf{'attachzusatz'} = 1;
		$loadf{'attachzusatz_onlyselected'} = 1;
	}

	$fb::fi{'title'} = "$fb::txt{'ed'}{'2'}";

	my ($datum, $ip, $frei, $pinned, $sprchosen);
	
	($loadf{'id'}, $datum, $loadf{'name'}, $loadf{'icon'}, $loadf{'email'}, $loadf{'url'}, $ip, $loadf{'icq'}, $loadf{'aim'},
	$loadf{'msn'},  $loadf{'skype'}, $loadf{'yim'}, $loadf{'message'}, $loadf{'feedback'}, $loadf{'savedbewertung'}, $loadf{'ort'},    
	$loadf{'nosmile'}, $frei, $loadf{'file'}, $loadf{'hideown'}, $loadf{'savedinput'}, $loadf{'privatn'}, $pinned, $loadf{'betreff'},   
	$loadf{'jabber'}, $loadf{'state'}, $sprchosen)
	  = $fb::dbh->selectrow_array("SELECT * FROM $fb::cf{'db_prefix'}" . "datainc WHERE id = ?", undef, $id);

	unless ($loadf{'id'}) { &fatal_error($fb::txt{'ed'}{'4'}) }
	unless ($loadf{'feedback'}) { $loadf{'feedback'} = ""; }
	
	if ($frei == 1) {
		unless ($fb::gl{'aeditown'}) { &fatal_error($fb::txt{'ed'}{'4'}) }
	}

	$loadf{'message'}  =~ s~<br>~\n~g;
	$loadf{'feedback'} =~ s~<br>~\n~g;
	$loadf{'message'}  =~ s/\[edit (.+?)](.+?)\[\/edit\]//ig;

	unless ($fb::loaded{'file_ubbcjs'}) { require "$fb::gl{'subsdir'}/ubbcjs.pl"; }
	$fb::fi{'otherjava'} .= &ubbcjs("1");
	&popupjs;

	unless ($fb::loaded{'file_loadfields'}) { require "$fb::gl{'subsdir'}/loadfields.pl"; }

	&loadfields(\%loadf);


	# mod for mod_mmaps
	if ($fb::mod{'modules_info'}{'mod_mmap'}[0]) {
		&fb::load_language("mod_mmap_global");
		$fb::inp{"m_maplink"} = qq~<a href="$fb::gl{'scriptac'}=mod_mmap_writemm;id=$id">$fb::txt{'mod_mmap_gl'}{'1'}</a>~;
	}


	if ($fb::gl{'byadmin'}) { $fb::inp{"m_formopen"} .= qq~<input type=hidden name="byadmin" value="1">~; }

	$fb::inp{"m_formopen"} .= qq~<input type=hidden name=sprchosen value="$sprchosen"><input type="hidden" name="id" value="$loadf{'id'}"><input type=hidden name="olddatum" value="$datum"><input type=hidden name=oldname value="$loadf{'name'}">~;

	my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($datum);
	$mon++;
	$year += 1900;
	if ($mon < 10)          { $mon       = "0$mon" }
	if ($mday < 10)         { $mday      = "0$mday" }
	if ($hour < 10)         { $hour      = "0$hour" }
	if ($min < 10)          { $min       = "0$min" }
	if ($sec < 10)          { $sec       = "0$sec" }

	my $showdatum;
	if ($fb::FORM{'datum'}) { $showdatum = "$fb::FORM{'datum'}"; }
	else { $showdatum = "$mday.$mon.$year"; }

	my $showzeit;
	if ($fb::FORM{'zeit'}) { $showzeit = "$fb::FORM{'zeit'}"; }
	else { $showzeit = "$hour:$min:$sec"; }

	$fb::inp{"m_datum"}    = qq~<input type=text name="datum" size=7 maxlength=10 value="$showdatum">~;
	$fb::inp{"m_zeit"}     = qq~<input type=text name="zeit" size=5 maxlength=8 value="$showzeit">~;
	$fb::inp{"m_ip"}       = $ip;
	$fb::inp{"m_feedback"} = qq~<textarea name=feedback rows=14 cols=63 wrap="virtual" ONSELECT="javascript:storeCaret(this);" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);" STYLE="width: 100%;" id="feedback">~;
	
	if ($fb::FORM{'feedback'}) { $fb::inp{"m_feedback"} .= qq~$fb::FORM{'feedback'}~; }
	elsif (($loadf{'feedback'}) && (!$fb::gl{'vorschau'})) { $fb::inp{"m_feedback"} .= qq~$loadf{'feedback'}~; }
	
	$fb::inp{"m_feedback"} .= qq~</textarea>~;
	
	my $freic = (($fb::FORM{'frei'}) || ($frei == 1)) ? " checked" : "";
	my $pinnedc = (($fb::FORM{'pinned'}) || ($pinned == 1)) ? " checked" : "";

	$fb::inp{"m_activation"} = qq~<input type=checkbox name="frei" value="1"$freic>~;
	$fb::inp{"m_pinned"}     = qq~<input type=checkbox name="pinned" value="1"$pinnedc>~;
	
	my $b1checked = ($fb::FORM{'bl'}) ? " checked" : "";
	my $blallchecked = ($fb::FORM{'blall'}) ? " checked" : "";
	my $entfattchecked = ($fb::FORM{'entfatt'}) ? " checked" : "";

	$fb::inp{"m_delete"}     = qq~<input type=checkbox name="bl" value="1"$b1checked>~;
	$fb::inp{"m_deleteall"}  = qq~<input type=checkbox name="blall" value="1"$blallchecked>~;
	$fb::inp{"m_attachdele"} = qq~<input type=checkbox name="entfatt" value="1"$entfattchecked>~;
	$fb::inp{"m_editmessage"} .= &doskin("template_editmessage");

	unless ($fb::gl{'aeditown'}) {
		&docodebuttons('1', 'feedback', 'm');
		&smiliebox('feedback');
		$fb::inp{"m_editadmin"} .= &doskin("template_edit");
	}
	else {
		$fb::inp{"m_editadmin"} .= qq~<input type=hidden name="aeditown" value="1">~;
	}
	$fb::fi{'main'} .= &doskin("template_edittemplate");

	&template;
}

sub edit2 {

	$fb::gl{'noadmin_skchange'} = 1;
	
	$fb::gl{'byadmin'} = $fb::FORM{'byadmin'};
	
	my $id = $fb::FORM{'id'} || &fatal_error("$fb::txt{'ch'}{'34'}");
	&isadmin;

	unless ($fb::loaded{'file_checkmessage'}) { require "$fb::gl{'subsdir'}/checkmessage.pl"; }

	my ($fields_ref) = &checkmessage_standard();
	my %fields = %{$fields_ref};

	# do also save the id in the fields hash
	$fields{'id'} = $id;
	
	my ($entfatt, $loeschen, $blall);

	if (($fb::FORM{'aeditown'}) || ($fb::gl{'aeditown'})) {
		$fb::gl{'aeditown'} = 1;
		$entfatt            = 0;
		$fields{'frei'}     = 0;
		$fields{'pinned'}   = 0;
		$loeschen           = 0;
		$blall              = 0;
	}
	else {
		$entfatt             = $fb::FORM{'entfatt'}   || "0";
		$fields{'frei'}      = $fb::FORM{'frei'}      || "0";
		$fields{'pinned'}    = $fb::FORM{'pinned'}    || "0";
		$loeschen            = $fb::FORM{'bl'}        || "0";
		$blall               = $fb::FORM{'blall'}     || "0";
	}

	if ($fb::gl{'aeditown'}) {
		# user is editing his own guestbook message
		
		$fields{'datum'} = $fb::FORM{'olddatum'}; 
		$fields{'name'} = $fb::FORM{'oldname'}; 

	}
	else { 

		my $spcher = $fb::FORM{'datum'} || "";
		my $zeit   = $fb::FORM{'zeit'}  || "00:00:00";
		my ($retag, $remonat, $rejahr) = split(/\./, $spcher);
		if (($retag > 31)   || ($retag < 1))   { &fatal_error("$fb::txt{'ch'}{'30'} $fb::txt{'ch'}{'31'}"); }
		if (($remonat > 12) || ($remonat < 1)) { &fatal_error("$fb::txt{'ch'}{'30'} $fb::txt{'ch'}{'32'}"); }
		my ($rehour, $reminute, $resecond) = split(/\:/, $zeit);
		if ($rehour > 23)   { $rehour   = 23; }
		if ($reminute > 59) { $reminute = 59; }
		if ($resecond > 59) { $resecond = 59; }

		$remonat--;

		my ($sec, $min, $h, $mtag, $monat, $jahr) = localtime();
		if ($mtag < 10)  { $mtag  = "0" . "$mtag"; }
		if ($monat < 10) { $monat = "0" . "$monat"; }
		if ($sec < 10)   { $sec   = "0" . "$sec"; }
		if ($min < 10)   { $min   = "0" . "$min"; }
		$jahr    = $jahr + 1900;
		my $number1 = ($jahr * 365) + ($monat * 30) + $mtag;
		my $number2 = ($rejahr * 365) + ($remonat * 30) + $retag;
		my $result  = $number1 - $number2;
		if ($result < 0) { &fatal_error("$fb::txt{'ch'}{'33'}"); }
		$fields{'datum'} = Time::Local::timelocal($resecond, $reminute, $rehour, $retag, $remonat, $rejahr);	
	
	}

	$fields{'sprchosen'} = $fb::FORM{'sprchosen'} || "";

	if ($fb::gl{'vorschau'}) {

		if ($fb::FORM{'inc'}) { &fatal_error($fb::txt{'ch'}{'27'}); }
		$fb::fi{'title'} = "$fb::txt{'ch'}{'35'}";

		unless ($fb::loaded{'file_loadentry'}) { require "$fb::gl{'subsdir'}/loadentry.pl"; }

		&loadentry(\%fields);
		$fb::inp{"m_messages"} .= &doskin("template_messageindex");
		$fb::inp{"m_preview"}  .= &doskin("template_ouindex");
		&wandleum(\$fb::inp{"m_preview"});
		&edit;
		&template;
		exit;
	}


	my $sth = $fb::dbh->prepare("SELECT msf, COUNT(msf) FROM $fb::cf{'db_prefix'}" . "datainc WHERE msf <> '' AND msf IS NOT NULL GROUP BY msf");
	$sth->execute() or save_db_error(DBI->errstr);
	
	my %attachs;

	while (my ($this_msf, $msf_c) = $sth->fetchrow_array) {
		
		$attachs{$this_msf} = $msf_c;

		if ($blall == 1) {
			&dounlink("$fb::cf{'bilderdir'}/upload/$this_msf");
		}
	}

	my ($old_datum, $old_name, $old_feedback, $old_msf) =
	  $fb::dbh->selectrow_array("SELECT datum, name, feedback, msf FROM $fb::cf{'db_prefix'}" . "datainc WHERE id = ?", undef, $id);

	if ($blall == 1) {
		$fb::dbh->do("DELETE FROM $fb::cf{'db_prefix'}" . "datainc",  undef);


		## possibility to add extra modules .-> delete comments

		if ($fb::mod{'action_modules'}{'deletemsg'}) {
			foreach my $mod (@{$fb::mod{'action_modules'}{'deletemsg'}}) {
				if ($fb::mod{'modules_info'}{$mod->[0]}[0] == 1) {
					unless ($fb::loaded{$mod->[1]}) {
						require "$fb::gl{'subsdir'}/$mod->[1].pl";
						$fb::loaded{$mod->[1]} = 1;
					}
					my $check = $mod->[2]->("all");
				}
			}
		}

	}
	elsif ($loeschen == 1) {

		$fb::dbh->do("DELETE FROM $fb::cf{'db_prefix'}" . "datainc WHERE id = ?",  undef, $id);

		## possibility to add extra modules .-> delete comments

		if ($fb::mod{'action_modules'}{'deletemsg'}) {
			foreach my $mod (@{$fb::mod{'action_modules'}{'deletemsg'}}) {
				if ($fb::mod{'modules_info'}{$mod->[0]}[0] == 1) {
					unless ($fb::loaded{$mod->[1]}) {
						require "$fb::gl{'subsdir'}/$mod->[1].pl";
						$fb::loaded{$mod->[1]} = 1;
					}
					my $check = $mod->[2]->($id);
				}
			}
		}

		### only delete attachment if there belong no more messages to it
		if ($attachs{$old_msf} < 2) {
			&dounlink("$fb::cf{'bilderdir'}/upload/$old_msf");
		}

	}
	else {
		# we are not deleting the entry -> so we gonna save it!

		
		# add edit stamp
		if ((($fb::gl{'aeditown'}) && ($fb::cf{'addeditadm'})) || (($fb::cf{'addedit'}) && (!$fb::gl{'aeditown'}))) {
			
			my $timestamp = time;
			my $useradd = ($fb::gl{'aeditown'}) ? "user" : "admin";
			$fields{'message'} .= qq~\[edit $useradd\]$timestamp\[\/edit\]~;
		
		}

		if ($entfatt == 1) {
			if (($old_msf ne "") && (-e "$fb::cf{'bilderdir'}/upload/$old_msf")) {
				&dounlink("$fb::cf{'bilderdir'}/upload/$old_msf");
				$fields{'fixfile'} = "";
			}
		}

		if ($fb::gl{'aeditown'}) { 
			# some values user are not allowed to change
			$fields{'datum'} = $old_datum; 
			$fields{'feedback'} = $old_feedback; 
			$fields{'name'} = $old_name; 
		}

		if (($fields{'feedback'} ne "") && ($fields{'feedback'} ne $old_feedback) && ($fb::cf{'emailact10'} == 1)) {

			$fields{'chdatum'} = &formatdatum($fields{'datum'}, "1");
			
			my $mail10path = "";

			unless (-e "$fb::gl{'datadir'}/language/$fields{'sprchosen'}/mail10.txt") {
				$mail10path = "$fb::gl{'datadir'}/language/$fb::cf{'sprache'}/mail10.txt";
			}
			else { $mail10path = "$fb::gl{'datadir'}/language/$fields{'sprchosen'}/mail10.txt"; }

			my @mailzuthx2 = &openfile("$mail10path");
			my $mail10 = "";
			foreach my $curmail (@mailzuthx2) {
				$curmail = &mailroutine($curmail, \%fields);
				$mail10 .= qq~$curmail\n~;
			}

			&sendmail2($fields{'email'}, "$fb::cf{'fbname'}: $fb::txt{'ed'}{'5'}", "$mail10", $fields{'mailfusr'});

		}

		$fb::dbh->do(
			"UPDATE $fb::cf{'db_prefix'}"
			  . "datainc SET datum = ?, name = ?, icon = ?, email = ?, url = ?, icq = ?, aim = ?, msn = ?, skype = ?, yim = ?, message = ?, feedback = ?, bewertung = ?, ort = ?, nosmile = ?, frei = ?, msf = ?, hideown = ?, savedinput = ?, privatn = ?, pinned = ?, betreff = ?, jabber = ?, state = ?, sprchosen = ? WHERE id = ?",
			undef,
			turn_to_null(
				$fields{'datum'},   $fields{'name'},     $fields{'icon'},      $fields{'email'},      $fields{'url'},
				$fields{'icq'},     $fields{'aim'},      $fields{'msn'},       $fields{'skype'},      $fields{'yim'},
				$fields{'message'}, $fields{'feedback'}, $fields{'bewertung'}, $fields{'ort'},        $fields{'nosmile'},
				$fields{'frei'},    $fields{'fixfile'},  $fields{'hideown'},   $fields{'savedinput'}, $fields{'privatn'},
				$fields{'pinned'},  $fields{'betreff'},  $fields{'jabber'},    $fields{'state'},      $fields{'sprchosen'},
				$id
			)
		);

	}



	my $gotoid = $id;
	
	# for page view purposes
	
	
	my $changeid = 0;

	if ($fb::cf{'verkehrt'} == 1) {
		my $nextid = $fb::dbh->selectrow_array("SELECT MIN(id) FROM $fb::cf{'db_prefix'}" . "datainc WHERE id > ?", undef, $id);
		my $lastid = $fb::dbh->selectrow_array("SELECT MAX(id) FROM $fb::cf{'db_prefix'}" . "datainc WHERE id <> ?", undef, $id);

		$changeid = $nextid || $lastid;
	}
	else {
		my $beforeid = $fb::dbh->selectrow_array("SELECT MAX(id) FROM $fb::cf{'db_prefix'}" . "datainc WHERE id < ?", undef, $id);
		my $firstid = $fb::dbh->selectrow_array("SELECT MIN(id) FROM $fb::cf{'db_prefix'}" . "datainc WHERE id <> ?", undef, $id);
		
		$changeid = $beforeid || $firstid;
	}


	if ($loeschen == 1)         { $gotoid = $changeid; }
	if ($blall == 1)            { $gotoid = 0; }
	
	if ($fields{'pinned'} == 1) { $gotoid = 0; }

	$fb::fi{'title'} = "$fb::txt{'ed'}{'1'}";

	if ($fb::gl{'byadmin'}) {
		$fb::fi{'javaeffects'} .= qq~<SCRIPT LANGUAGE="JAVASCRIPT" TYPE="TEXT/JAVASCRIPT">
	<!--
	var StayAlive = 1;
	function KillMe(){
	setTimeout("self.close()",StayAlive * 1000);
	}
	-->
	</SCRIPT>~;
		$fb::fi{'main'} .= qq~
	<br><table align=center width="300" border=0 cellspacing=1 cellpadding=2 class=fbborder>
		<tr><td class=fbcatbg align=center><b>$fb::txt{'ed'}{'6'}</b></td></tr>
		<tr><td class=fb2 align=center>$fb::txt{'ed'}{'7'}</td></tr>
		</table>
	<SCRIPT LANGUAGE="JAVASCRIPT" TYPE="TEXT/JAVASCRIPT">
	<!--
	opener.location.reload(); 
	KillMe();
	-->
	</SCRIPT><br>
	~;
		&template;
	}
	else {
		my $set_location = "$fb::gl{'scriptac'}=;showid=$gotoid";
		&redirect($set_location);
	}
}

sub deleteit {

	my $id    = $fb::INFO{'id'};
	my $start = $fb::INFO{'start'} || "0";
	my $action_return = $fb::INFO{'return'} || "";

	&isadmin;

	# deleting guestbook entries
	
	my $gotid = $fb::dbh->do("DELETE FROM $fb::cf{'db_prefix'}" . "datainc WHERE id = ?", undef, $id);
	unless ($gotid) { &fatal_error($fb::txt{'ed'}{'8'}); }

	## possibility to add extra modules .-> delete comments

	if ($fb::mod{'action_modules'}{'deletemsg'}) {
		foreach my $mod (@{$fb::mod{'action_modules'}{'deletemsg'}}) {
			if ($fb::mod{'modules_info'}{$mod->[0]}[0] == 1) {
				unless ($fb::loaded{$mod->[1]}) {
					require "$fb::gl{'subsdir'}/$mod->[1].pl";
					$fb::loaded{$mod->[1]} = 1;
				}
				my $check = $mod->[2]->($id);
			}
		}
	}
	
	# page redirection to correct entry
	my $changeid = 0;

	if ($fb::cf{'verkehrt'} == 1) {
		my $nextid = $fb::dbh->selectrow_array("SELECT MIN(id) FROM $fb::cf{'db_prefix'}" . "datainc WHERE id > ?", undef, $id);
		my $lastid = $fb::dbh->selectrow_array("SELECT MAX(id) FROM $fb::cf{'db_prefix'}" . "datainc WHERE id <> ?", undef, $id);

		$changeid = $nextid || $lastid;
	}
	else {
		my $beforeid = $fb::dbh->selectrow_array("SELECT MAX(id) FROM $fb::cf{'db_prefix'}" . "datainc WHERE id < ?", undef, $id);
		my $firstid = $fb::dbh->selectrow_array("SELECT MIN(id) FROM $fb::cf{'db_prefix'}" . "datainc WHERE id <> ?", undef, $id);
		
		$changeid = $beforeid || $firstid;
	}


	my $realstart = $start - 1;
	if ($realstart < 0) { $realstart = 0; }
	
	my $set_location;

	if ($action_return eq "such2") {
		my $such_was     = convert_to_hex($fb::INFO{'was'});
		$set_location = "$fb::gl{'scriptac'}=such2;startb=$realstart;wo=$fb::INFO{'wo'};type=$fb::INFO{'type'};was=$such_was;datum=$fb::INFO{'datum'}";
	}
	elsif ($action_return eq "privatn") {
		$set_location = "$fb::gl{'scriptac'}=privatn;startb=$start";

	}
	else {
		$set_location = "$fb::gl{'scriptac'}=$action_return;showid=$changeid";
	}

	# 1 = popup template
	&redirect($set_location, "1");


}
1;
