####################### [Firebook] - guestbook ################################
# fileexplorer.pl                                                             #
###############################################################################

package fb;

use strict;
use warnings;
#use diagnostics;

sub fileexplorer {

	&isadmin;
	&adminmenu;

	if ($fb::INFO{'requskin'}) {
		$fb::INFO{'go2'} = "skinopen_" . $fb::INFO{'requskin'};
	}
	
	my $go2 = $fb::INFO{'go2'} || "";
	my $doinf = $fb::INFO{'do'} || "";
	
	# something needs to be deleted, renamed,...
	if ($doinf eq "fileact") {

		my $pathwork = $fb::INFO{'path'};
		my ($path1, $path2, $path3) = split(/\//, $pathwork);
		unless ($path3) { $path3 = "";	}
		unless ($path2) { $path2 = "";	}
		unless ($path1) { $path1 = "";	}
		if ($path2) { $path1 = qq~skinopen_$path2~; }

		my $savedloc;
		
		if ($fb::INFO{'delete'}) {
			
			if (-e "$fb::cf{'bilderdir'}/$pathwork/$fb::INFO{'delete'}") { &dounlink("$fb::cf{'bilderdir'}/$pathwork/$fb::INFO{'delete'}"); }
			$savedloc = qq~$fb::gl{'scriptac'}=fileexplorer;go2=$path1;sub=$path3~;
		}
		elsif ($fb::INFO{'rename'}) {
			if (-e "$fb::cf{'bilderdir'}/$pathwork/$fb::INFO{'rename'}") { 
				use File::Copy;
				move("$fb::cf{'bilderdir'}/$pathwork/$fb::INFO{'rename'}", "$fb::cf{'bilderdir'}/$pathwork/$fb::INFO{'toname'}");
				$savedloc = qq~$fb::gl{'scriptac'}=fileexplorer;go2=$path1;sub=$path3~;
			}
		}
		elsif ($fb::INFO{'kopiere'}) {
			if (-e "$fb::cf{'bilderdir'}/$pathwork/$fb::INFO{'kopiere'}") { 
				use File::Copy;
				copy("$fb::cf{'bilderdir'}/$pathwork/$fb::INFO{'kopiere'}", "$fb::INFO{'todir'}/$fb::INFO{'toname'}");
				
				$savedloc = qq~$fb::gl{'scriptac'}=fileexplorer;go2=$path1;sub=$path3~;
			}
		}
		elsif ($fb::INFO{'move'}) {
			if (-e "$fb::cf{'bilderdir'}/$pathwork/$fb::INFO{'move'}") { 
				use File::Copy;
				move("$fb::cf{'bilderdir'}/$pathwork/$fb::INFO{'move'}", "$fb::INFO{'moveto'}/$fb::INFO{'move'}");
				$savedloc = qq~$fb::gl{'scriptac'}=fileexplorer;go2=$path1;sub=$path3~;
			}
		}
		if ($savedloc) {
			my $set_location = qq~$savedloc~;
			&redirect($set_location);
		}
	}
	
	my $skselected;
	my $skino = "";

	my ($split1, $split2) = split(/\_/, $go2);
	$skselected = $split2;


	$fb::fi{'main'} .= qq~<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>~;


	my $choosebox = qq~
	<table border=0 cellspacing=0 cellpadding=2>
	<form action="$fb::gl{'script'}" method="GET" name="Formular">
	 $fb::gl{'hiddenscro'}<input type=hidden name=action value=fileexplorer><input type=hidden name=go value=fileexplorer>
	<tr><td align=right><b>$fb::txt{'fe'}{'29'}:</b></td>
	<td><select name=go2>~;

	my @files2 = &opendirectory("$fb::cf{'bilderdir'}/skins");
	
	my ($tick1, $tick2, $tick3, $tick4, $opentxt, $openwhat1, $openwhat2);

	$tick1=$tick2=$tick3=$tick4="";

	

	if ($go2 eq "allgemein") { 
		$tick1 = " selected";
		$opentxt = qq~$fb::txt{'fe'}{'31'} $fb::txt{'fe'}{'32'}~;
		$openwhat1 = "allgemein";
	}
	elsif ($go2 eq "maps") { 
		# addon for mod_mmaps
		$tick2 = " selected";
		$opentxt = qq~$fb::txt{'fe'}{'31'} $fb::txt{'fe'}{'33'}~;
		$openwhat1 = "maps";
	}
	
	my $skinausw = "";
	my $options2 = "";

	foreach (@files2){
		if (($_ ne ".") && ($_ ne "..") && ($_ ne "")) {
			if ((-d "$fb::cf{'bilderdir'}/skins/$_") && ($_ ne "admin")) {
			
				my $sel;
				if ($go2 =~ m/skinopen_$_/) { $sel = " selected"; }
				else { $sel = ""; }
				$skinausw .= qq~<option value="skinopen_$_"$sel>----- $fb::txt{'fe'}{'37'} $_</option>~;
				$options2 .= qq~<option value="$_"$sel>$_</option>~;
			}
		}
	}

	if ($go2 eq "upload") { 
		$tick4 = " selected";
		$opentxt = qq~$fb::txt{'fe'}{'31'} $fb::txt{'fe'}{'35'}~;
		$openwhat1 = "upload";
	}
	if ($go2 =~ m/skinopen/) {
		my $unw;
		($unw, $skino) = split (/\_/, $go2);
		if ($skino) { $opentxt = qq~$fb::txt{'fe'}{'31'} $fb::txt{'fe'}{'38'} <font color=red>$skino</font>~; }
		$tick3 = " selected";
		$openwhat1 = "skins";
		$openwhat2 = "$skino";
	}

	
	
	$choosebox .= qq~
	<option value="">$fb::txt{'fe'}{'57'}</option>
	<option value="">------------------------------------</option>
	<option value="allgemein"$tick1>=&gt; $fb::txt{'fe'}{'32'}</option>~;

	# addon for mod_mmap
	if ($fb::mod{'modules_info'}{'mod_mmap'}[0]) {
		$choosebox .= qq~
		<option value="maps"$tick2>=&gt; $fb::txt{'fe'}{'33'}</option>
		~;
	}

	$choosebox .= qq~
	<option value="skinopen"$tick3>=&gt; $fb::txt{'fe'}{'58'}</option>
	$skinausw
	~;

	$choosebox .= qq~
	<option value="upload"$tick4>=&gt; $fb::txt{'fe'}{'35'}</option>
	~;

	$choosebox .= qq~
	</select></td><td>
	<input type=submit value="$fb::txt{'gl'}{'65'}">
	</td></tr></form></table>~;

	if ($go2) {

		$fb::fi{'otherjava'} .= qq~<script language="javascript">
		<!--
		function actions(subiname, name, actiondo) {
		
		if (actiondo == "loesche") {
				if (confirm("$fb::txt{'fe'}{'59'} "+ name +" $fb::txt{'fe'}{'60'}")) {
					window.location.href='$fb::gl{'scriptac'}=fileexplorer;do=fileact;path=' + subiname + ';delete=' + name;
				}
		}
		else if (actiondo == "umben") {
			txt=window.prompt ("$fb::txt{'fe'}{'61'} "+ name +" $fb::txt{'fe'}{'62'}",name);
			if (txt != "" && txt != null) {
			window.location.href='$fb::gl{'scriptac'}=fileexplorer;do=fileact;path=' + subiname + ';rename=' + name + ';toname=' + txt;
			}
		}
		else if (actiondo == "verschieben") {
			txt=window.prompt ("$fb::txt{'fe'}{'65'}","$fb::cf{'bilderdir'}");
			if (txt != "" && txt != null) {
			window.location.href='$fb::gl{'scriptac'}=fileexplorer;do=fileact;path=' + subiname + ';move=' + name + ';moveto=' + txt;
			}
		}
		else if (actiondo == "kopieren") {
			txt=window.prompt ("$fb::txt{'fe'}{'63'} "+ name +" $fb::txt{'fe'}{'62'}","copy_" + name);
			if (txt != "" && txt != null) {
				txt2=window.prompt ("$fb::txt{'fe'}{'64'}","$fb::cf{'bilderdir'}");
				 if (txt2 != "" && txt2 != null) {
					window.location.href='$fb::gl{'scriptac'}=fileexplorer;do=fileact;path=' + subiname + ';kopiere=' + name + ';toname=' + txt + ';todir=' + txt2;
				 }
			}
		}
		document.getElementById(name).action.options[0].selected = true;
		}
		-->
		</script>~;

		unless ($opentxt) { $opentxt = ""; 	}

	
		$fb::fi{'main'} .= qq~<tr><td class=fbcatbg colspan=3><b>$fb::txt{'fe'}{'72'} &raquo; $fb::txt{'gl'}{'94'}</b></td></tr>~;

		$fb::fi{'main'} .= qq~
		<tr><td colspan=3 class=fb1 align=center>

			<table border=0 cellspacing=0 cellpadding=0 width=100%><tr><td align=center>
		<b>$opentxt</b></td></td><td align=right>$choosebox</td></tr></table>
		</td></tr>~;

		if ($skselected) {

			$fb::fi{'main'} .= qq~
			<tr>
			<td class=fb1 align=center width=120><b>[ <a href="$fb::gl{'scriptac'}=skinsystem">$fb::txt{'fe'}{'81'}</a> ]</b></td>	
			<td align=center class=fb2>
			<table border=0 cellspacing=0 cellpadding=3><form action="$fb::gl{'scriptac'}" method="GET">
			<tr>
				<td align=right><b>$fb::txt{'fe'}{'73'}:</b></td><td><select name="action">
			<option value="skineinst">$fb::txt{'gl'}{'149'}</option>
			<option value="skincss">$fb::txt{'gl'}{'96'}</option>
			<option value="skintemplates">$fb::txt{'gl'}{'148'}</option>~;
			
			# mod for skin editor
			if ($fb::mod{'modules_info'}{'mod_skine'}[0]) {
				$fb::fi{'main'} .= qq~<option value="mod_skine_skineditor">$fb::txt{'gl'}{'101'}</option>~;
			}
			$fb::fi{'main'} .= qq~<option value="smilies">$fb::txt{'gl'}{'93'}</option>~;
			
			# mod for popup smilies
			if ($fb::mod{'modules_info'}{'mod_popsm'}[0]) {
				$fb::fi{'main'} .= qq~<option value="mod_popsm_adminsett">$fb::txt{'gl'}{'131'}</option>~;
			}
			$fb::fi{'main'} .= qq~
			<option value="fileexplorer" selected>$fb::txt{'gl'}{'94'}</option>
			</select>
			</td>
				<td align=right><b>$fb::txt{'fe'}{'79'}:</b></td>
				<td><select name="requskin">$options2</select></td><td><input type="submit" name="post" value="$fb::txt{'gl'}{'65'}"></td></tr></form></table></td>
			<td class=fb1 align=center width=120><b>[ <a target="_blank" href="$fb::gl{'scriptac2'}=message;lang=$fb::gl{'sprache2'};skin=$skselected">$fb::txt{'fe'}{'80'}</a> ]</b></td>	
			</tr></table><br><table border="0" class=fbborder cellspacing="1" cellpadding="2" align="center" width="100%">~;
		}

		$fb::fi{'main'} .= qq~	
			<tr><td colspan=2 class=fb2>
		<table border=0 cellspacing=0 cellpadding=2 width=100%><tr class=fb1>
		<td>&nbsp;</td><td><i>$fb::txt{'fe'}{'66'}</i></td><td><i>$fb::txt{'fe'}{'67'}</i></td><td><i>$fb::txt{'fe'}{'68'}</i></td><td><i>$fb::txt{'fe'}{'69'}</i></td><td><i>$fb::txt{'fe'}{'42'}</i></td></tr>~;

		my $dirback = "";
		my $wasoeffnen = $openwhat1 || "";
		if ($openwhat1) { $dirback = qq~~; }
		if ($openwhat2) { $wasoeffnen .= qq~/$openwhat2~; $dirback = qq~~; }
		if ($fb::INFO{'sub'}) { $wasoeffnen .= qq~/$fb::INFO{'sub'}~; $dirback = qq~$openwhat2~; }
		
		# link to previous directory
		my $dirbacklink;
	
		$dirbacklink = qq~<a href="$fb::gl{'scriptac'}=fileexplorer">~;

		if ($skino) { $dirbacklink = qq~<a href="$fb::gl{'scriptac'}=fileexplorer;go2=skinopen_$dirback">~; }
		elsif ($dirback) { $dirbacklink = qq~<a href="$fb::gl{'scriptac'}=fileexplorer;go2=$dirback">~; }

		if ($dirbacklink) {
			$fb::fi{'main'} .= qq~<tr class=fb2><td align=center>$dirbacklink<img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/ordnerback.gif" alt="$fb::txt{'fe'}{'70'}" title="$fb::txt{'fe'}{'70'}" border=0></a></td><td colspan=5><b>$dirbacklink [ $fb::txt{'fe'}{'70'} ]</a></b></td></tr>~;
		}
		

		# index file from directory
		my @filesbearb = &opendirectory("$fb::cf{'bilderdir'}/$wasoeffnen");

		@filesbearb = sort{uc($a) cmp uc($b)} (@filesbearb);
		
		my $countab = 0;
		my $countac = 0;

		my (@filesbearb2, @filesbearb3);

		foreach (@filesbearb) {
			if (-d "$fb::cf{'bilderdir'}/$wasoeffnen/$_") {
				# it is a folder
				$filesbearb3[$countab] = qq~$_~;
				$countab++;
			}
			else {
				# it is a file
				$filesbearb2[$countac] = qq~$_~;
				$countac++;
			}
		}
		
		
		# first do folders
		foreach my $lines (@filesbearb3){
			if ($lines eq "Thumbs.db") { &dounlink("$fb::cf{'bilderdir'}/$wasoeffnen/$lines"); next; }
			
			if (($lines ne ".") && ($lines ne "..") && ($lines ne "")) {
				if ($lines eq "admin") { next; }
				
				#links
				my $ahr1 = qq~<a href="$fb::gl{'scriptac'}=fileexplorer;go2=$go2;sub=$lines">~;
				my $ahr2 = qq~</a>~;

				$fb::fi{'main'} .= qq~<tr><td align=center>$ahr1<img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/folder.gif" border=0 alt="$fb::txt{'fe'}{'71'}" title="$fb::txt{'fe'}{'71'}">$ahr2</td>
					<td><b>$ahr1~;
				
				if (($openwhat2) && (-d "$fb::cf{'bilderdir'}/$wasoeffnen/$lines")) {
					if ($lines eq "allgemein") { $fb::fi{'main'} .= qq~$fb::txt{'fe'}{'30'} $openwhat2: &nbsp;&nbsp; $fb::txt{'fe'}{'50'}~; }
					elsif ($lines eq "bewertung") { $fb::fi{'main'} .= qq~$fb::txt{'fe'}{'30'} $openwhat2: &nbsp;&nbsp; $fb::txt{'fe'}{'51'}~; }
					elsif ($lines eq "flags") { $fb::fi{'main'} .= qq~$fb::txt{'fe'}{'30'} $openwhat2: &nbsp;&nbsp; $fb::txt{'fe'}{'52'}~; }
					elsif ($lines eq "headsmilies") { $fb::fi{'main'} .= qq~$fb::txt{'fe'}{'30'} $openwhat2: &nbsp;&nbsp; $fb::txt{'fe'}{'53'}~; }
					elsif ($lines eq "lang") { $fb::fi{'main'} .= qq~$fb::txt{'fe'}{'30'} $openwhat2: &nbsp;&nbsp; $fb::txt{'fe'}{'54'}~; }
					elsif ($lines eq "popsmilies") { 
						# mod_popsm hack
						$fb::fi{'main'} .= qq~$fb::txt{'fe'}{'30'} $openwhat2: &nbsp;&nbsp; $fb::txt{'fe'}{'55'}~; 
					}
					elsif ($lines eq "postsmilies") { $fb::fi{'main'} .= qq~$fb::txt{'fe'}{'30'} $openwhat2: &nbsp;&nbsp; $fb::txt{'fe'}{'56'}~; }
				}
				else { $fb::fi{'main'} .= qq~$fb::txt{'fe'}{'38'} $lines~; }
				$fb::fi{'main'} .= qq~$ahr2</td><td></td><td>$fb::txt{'fe'}{'39'}</td><td></td><td></td></tr>~;
			}
		}

		foreach my $lines (@filesbearb2){

			if ($lines eq "Thumbs.db") { &dounlink("$fb::cf{'bilderdir'}/$wasoeffnen/$lines"); next; }
			
			if (($lines ne ".") && ($lines ne "..") && ($lines ne "")) {
				
				my $size = -s "$fb::cf{'bilderdir'}/$wasoeffnen/$lines";
				$size = int($size/1024);
				
				my $chdate = int(-M "$fb::cf{'bilderdir'}/$wasoeffnen/$lines");
				
				my $type;

				my @allsplit = split (/\./, $lines);
				if (($allsplit[$#allsplit] =~ m/gif/i) || ($allsplit[$#allsplit] =~ m/jpg/i) || ($allsplit[$#allsplit] =~ m/jpeg/i) || ($allsplit[$#allsplit] =~ m/png/i) || ($allsplit[$#allsplit] =~ m/bmp/i)) {
					$type = "type_img";
				}
				elsif (($allsplit[$#allsplit] =~ m/htm/ig)|| ($allsplit[$#allsplit] =~ m/js/i)) {
					$type = "type_html";
				}
				else { $type = "file"; }
				
				my ($alttype, $altt);

				unless ($altt) { $altt = $fb::txt{'fe'}{'40'}; }

				my $ahr1 = qq~<a href="$fb::cf{'bilderurl'}/$wasoeffnen/$lines" target=_blank>~; 
				my $ahr2 = qq~</a>~;

				unless ($alttype) { $alttype = uc($allsplit[$#allsplit]) . " - $fb::txt{'fe'}{'41'}"; }
				$fb::fi{'main'} .= qq~<tr><td align=center>$ahr1<img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/$type.gif" border=0 alt="$altt" title="$altt">$ahr2</td>
					<td><b>$ahr1~;
				$fb::fi{'main'} .= qq~$lines~;
				my $options = qq~<select name="action" id="action" onChange="actions('$wasoeffnen','$lines',this.options[this.selectedIndex].value)">
				<option value="">$fb::txt{'fe'}{'42'}</option>
				<option value="loesche">$fb::txt{'gl'}{'115'}</option>
				<option value="umben">$fb::txt{'fe'}{'43'}</option>
				<option value="kopieren">$fb::txt{'fe'}{'44'}</option>
				<option value="verschieben">$fb::txt{'fe'}{'45'}</option>
				</select>
				~;
				$fb::fi{'main'} .= qq~$ahr2</td><td>$size KB</td><td>$alttype</td><td>$chdate</td><form method="post" action="$fb::gl{'scriptac'}=" name=$lines><td>$options</td></form></tr>~;
			}
		}


		my $uploadlink = qq~<a href="javascript:popUp('$fb::gl{'scriptac'}=uploadmanager;thisskin=$skino;wasoeff=$wasoeffnen',$fb::cf{'uplpop1'},$fb::cf{'uplpop2'})">~;
		
		$fb::fi{'main'} .= qq~<tr class=fb2><td align=center>$uploadlink<img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/filenew.gif" alt="$fb::txt{'fe'}{'46'}" title="$fb::txt{'fe'}{'46'}" border=0></a></td><td colspan=5><b>$uploadlink [ $fb::txt{'fe'}{'46'} ]</a></b></td></tr>
		</table>
		</td></tr>~;

	}
	else {

		my %found;

		if ($fb::FORM{'searchfor'}) {

			my @testthese = ("allgemein", "upload");

			# mod_mmaps addon
			if ($fb::mod{'modules_info'}{'mod_mmap'}[0]) {
				push (@testthese, "maps");
			}


			foreach my $folder (@testthese) {
				if (-e "$fb::cf{'bilderdir'}/$folder/$fb::FORM{'searchfor'}") {
					$found{$folder} = $fb::txt{'fe'}{'47'};
				}
				else {
					$found{$folder} = "";
				}
			}

			if (-e "$fb::cf{'bilderdir'}/skins/$fb::FORM{'searchfor'}") {
				$found{"skins"} = $fb::txt{'fe'}{'47'};
			}
			else {
				$found{"skins"} = "";
			}

			my @directories = &opendirectory("$fb::cf{'bilderdir'}/skins");

			foreach my $testthem (@directories) {

					if (-e "$fb::cf{'bilderdir'}/skins/$testthem/$fb::FORM{'searchfor'}") {
						$found{"skins_sub_$testthem"} = $fb::txt{'fe'}{'47'};
					}
					else {
						$found{"skins_sub_$testthem"} = "";
					}

				my @files = &opendirectory("$fb::cf{'bilderdir'}/skins/$testthem");

				foreach my $line (@files){
					if (-e "$fb::cf{'bilderdir'}/skins/$testthem/$line/$fb::FORM{'searchfor'}") {
						$found{"skins_sub2_$line"} = $fb::txt{'fe'}{'47'};
					}
					else {
						$found{"skins_sub2_$line"} = "";
					}
				}
			}

		}
		else {
			$fb::FORM{'searchfor'} = "";
			$found{"allgemein"}=$found{'maps'}=$found{'upload'}=$found{'skins'}="";
			my @directories = &opendirectory("$fb::cf{'bilderdir'}/skins");

			foreach my $testthem (@directories) {
				$found{"skins_sub_$testthem"} = "";

				my @files = &opendirectory("$fb::cf{'bilderdir'}/skins/$testthem");

				foreach my $line (@files){
					$found{"skins_sub2_$line"} = "";
				}
			}

		}

		$fb::fi{'main'} .= qq~
		<tr><td class=fbcatbg colspan=3><b>$fb::txt{'fe'}{'48'}</b></td></tr>
		<tr><td colspan=3 class=fb2>
		<br>
		<table border=0 cellspacing=0 cellpadding=1 align=center>
		<tr><td colspan=7><b>[ &nbsp; <a href="$fb::cf{'bilderurl'}" target=_blank>$fb::cf{'bilderurl'}</a> &nbsp; ]</b></td></tr>
			<tr><td>
		<img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/plus.gif" alt="$fb::txt{'fe'}{'34'}" title="$fb::txt{'fe'}{'34'}" border=0></td><td>
		<a href="$fb::gl{'scriptac'}=fileexplorer;go2=allgemein"><img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/folder.gif" alt="$fb::txt{'fe'}{'32'}" title="$fb::txt{'fe'}{'32'}" border=0></a>
		</td><td colspan=5><a href="$fb::gl{'scriptac'}=fileexplorer;go2=allgemein"><b>$fb::txt{'fe'}{'32'}</b></a> $found{"allgemein"}
			</td></tr>~;

			# addon for mod_mmap
			if ($fb::mod{'modules_info'}{'mod_mmap'}[0]) {
				$fb::fi{'main'} .= qq~
					<tr><td>
				<img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/plus.gif" alt="$fb::txt{'fe'}{'34'}" title="$fb::txt{'fe'}{'34'}" border=0></td><td>	
				<a href="$fb::gl{'scriptac'}=fileexplorer;go2=maps"><img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/folder.gif" alt="$fb::txt{'fe'}{'33'}" title="$fb::txt{'fe'}{'33'}" border=0></a>
				</td><td colspan=5><a href="$fb::gl{'scriptac'}=fileexplorer;go2=maps"><b>$fb::txt{'fe'}{'33'}</b></a> $found{"maps"}
					</td></tr>~;

			}
			$fb::fi{'main'} .= qq~<tr><td>
			<img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/minus.gif" alt="$fb::txt{'fe'}{'34'}" title="$fb::txt{'fe'}{'34'}" border=0></td><td> <img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/red_folder.gif" alt="$fb::txt{'fe'}{'34'}" border=0>
		</td><td colspan=5><b>$fb::txt{'fe'}{'34'}</b> $found{"skins"}
			</td></tr>~;


		foreach my $lin2 (@files2){
			if (($lin2 ne ".") && ($lin2 ne "..") && ($lin2 ne "")) {

				if ((-d "$fb::cf{'bilderdir'}/skins/$lin2") && ($lin2 ne "admin")) {
									
					$fb::fi{'main'} .= qq~
					<tr><td>
						</td><td><a href="$fb::gl{'scriptac'}=fileexplorer;go2=skinopen_$lin2"></td><td><img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/minus.gif" alt="$fb::txt{'fe'}{'34'}" title="$fb::txt{'fe'}{'34'}" border=0></a> <a href="$fb::gl{'scriptac'}=fileexplorer;go2=skinopen;skin=$lin2"><img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/red_folder.gif" alt="$fb::txt{'fe'}{'35'}" title="$fb::txt{'fe'}{'35'}" border=0></a>
					</td><td colspan=3><a href="$fb::gl{'scriptac'}=fileexplorer;go2=skinopen_$lin2"><b>$fb::txt{'fe'}{'49'} $lin2</b></a> $found{"skins_sub_$lin2"}
						</td></tr>~;

						my @files3 = &opendirectory("$fb::cf{'bilderdir'}/skins/$lin2");
						
						foreach my $lin3 (@files3){
							if (($lin3 ne ".") && ($lin3 ne "..") && ($lin3 ne "")) {
								if (-d "$fb::cf{'bilderdir'}/skins/$lin2/$lin3") {
									
									my $lin3p = "";
									if ($lin3 eq "allgemein") { $lin3p .= qq~$fb::txt{'fe'}{'50'}~; }
									elsif ($lin3 eq "bewertung") { $lin3p .= qq~$fb::txt{'fe'}{'51'}~; }
									elsif ($lin3 eq "flags") { $lin3p .= qq~$fb::txt{'fe'}{'52'}~; }
									elsif ($lin3 eq "headsmilies") { $lin3p .= qq~$fb::txt{'fe'}{'53'}~; }
									elsif ($lin3 eq "lang") { $lin3p .= qq~$fb::txt{'fe'}{'54'}~; }
									elsif ($lin3 eq "popsmilies") { 
										# mod popsm hack
										$lin3p .= qq~$fb::txt{'fe'}{'55'}~; 
									}
									elsif ($lin3 eq "postsmilies") { $lin3p .= qq~$fb::txt{'fe'}{'56'}~; }
									$fb::fi{'main'} .= qq~
									<tr><td colspan=2>&nbsp;</td><td>
									</td><td><a href="$fb::gl{'scriptac'}=fileexplorer;go2=skinopen_$lin2;sub=$lin3"></td><td><img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/plus.gif" alt="$fb::txt{'fe'}{'34'}" title="$fb::txt{'fe'}{'34'}" border=0></a> <a href="$fb::gl{'scriptac'}=fileexplorer;go2=skinopen;skin=$lin2"><img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/folder.gif" alt="$fb::txt{'fe'}{'35'}" title="$fb::txt{'fe'}{'35'}" border=0></a>
									</td><td><a href="$fb::gl{'scriptac'}=fileexplorer;go2=skinopen_$lin2;sub=$lin3"><b>$lin3p</b></a> $found{"skins_sub2_$lin3"}
									</td></tr>~;

								}
							}
						}


				}
			}
		}

		$fb::fi{'main'} .= qq~
		<tr><td>
		<img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/plus.gif" alt="$fb::txt{'fe'}{'34'}" title="$fb::txt{'fe'}{'34'}" border=0></td><td>
		<a href="$fb::gl{'scriptac'}=fileexplorer;go2=upload"><img src="$fb::cf{'bilderurl'}/skins/admin/allgemein/folder.gif" alt="$fb::txt{'fe'}{'35'}" title="$fb::txt{'fe'}{'35'}" border=0></a>
		</td><td colspan=5><a href="$fb::gl{'scriptac'}=fileexplorer;go2=upload"><b>$fb::txt{'fe'}{'35'}</b></a> $found{"upload"}
			</td></tr>
			</table><br>
			</td></tr>
		<tr><td class=fb1 colspan=2 align=center>
		<table border=0 cellspacing=0 cellpadding=4><form action="$fb::gl{'scriptac'}=fileexplorer" method="post" name="search"><tr><td><b>$fb::txt{'fe'}{'36'}:</b></td><td><input type=text name=searchfor value="$fb::FORM{'searchfor'}"></td><td><input type="submit" value="$fb::txt{'gl'}{'65'}"></td></tr></form></table>	
		</td></tr>	
		~;
	}

	&adminschluss;
	&template;

}
sub uploadmanager {

	&isadmin;
	$fb::gl{'popup_force'} = 1;

	if ($fb::FORM{'file'}) {
		
		my $weiterl = $fb::FORM{'weiterl'};
		my $uploadskin = $fb::FORM{'uskin'} || "";
		my $wohin = $fb::FORM{'wohin'} || "";
		my $upload_dir = "$fb::cf{'bilderdir'}/skins/$uploadskin/$wohin";
		my $wasoeff = $fb::FORM{'wasoeff'} || "";
		
		my ($wasoeffadd, $andersadd2);

		if ($wasoeff) {
			
			$upload_dir = "$fb::cf{'bilderdir'}/$wasoeff/$wohin";
			$fb::FORM{'wohin'} = qq~$fb::cf{'bilderdir'}/$wasoeff~;
			$wasoeffadd = qq~;wasoeff=$wasoeff~;

			my ($path1, $path2, $path3) = split(/\//, $wasoeff);
			if ($path2) { $path1 = qq~skinopen_$path2~; }

			$fb::fi{'otherjava'} .= qq~<script language="JavaScript1.2" type="text/javascript">
			<!--
			function newurl() {
				opener.window.location='$fb::gl{'scriptac'}=fileexplorer;go2=$path1;sub=$path3;reset=1';
			}
			newurl();
			-->
			</script>
			~;
			$andersadd2 = "";
		}
		else {
			$andersadd2 = qq~$fb::txt{'fe'}{'17'}~;
		}

		require "$fb::gl{'subsdir'}/upload.pl";
		&upload::uploadcheck($upload_dir);

		&upload::doupload;

		$fb::fi{'main'} .= qq~
		<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>
		<tr><td class=fbcatbg colspan=2><b>$fb::txt{'fe'}{'18'}</b></td></tr>
		<tr><td class=fb1 align=center><img src="$fb::cf{'bilderurl'}/skins/standard/allgemein/raquo.gif" alt="$fb::txt{'fe'}{'18'}" title="$fb::txt{'fe'}{'18'}" border=0></td><td class=fb2>
		&raquo; $fb::txt{'fe'}{'19'} <b>$fb::FORM{'file'}</b><br>
		&raquo; $fb::txt{'fe'}{'20'} <b>$fb::FORM{'wohin'}</b> $andersadd2 <b>$uploadskin</b> $fb::txt{'fe'}{'21'}<br>
		&raquo; <b><a href="$fb::gl{'scriptac'}=uploadmanager;wohin=$wohin;uskin=$uploadskin$wasoeffadd">$fb::txt{'fe'}{'22'}</a></b>

		</td></tr></table>
		~;
			
		&freetemp;


	}
	else {

		my $weiterl = $fb::INFO{'weiterl'} || "";
		my $wohin = $fb::INFO{'wohin'} || "";
		my $skinwahl = $fb::cf{'skinchosen'};
		if ($fb::INFO{'thisskin'}) { $skinwahl = $fb::INFO{'thisskin'}; }
		
		$fb::fi{'main'} .= qq~
		<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>
		<form action="$fb::gl{'scriptac'}=uploadmanager" method="post" ENCTYPE="multipart/form-data">
		<input type=hidden name=weiterl value="$weiterl"><tr><td class=fbcatbg colspan=2><b>$fb::txt{'gl'}{'118'}</b></td></tr>~;
		
		my $filesize_info = "";

		unless ($fb::INFO{'wasoeff'}) {

			$filesize_info = qq~$fb::txt{'fe'}{'23'}~;

			$fb::fi{'main'} .= qq~
			<tr><td width=100% class=fb2><table border=0 cellspacing=0 cellpadding=0 width=100%>
			<tr>	<td valign="top" width="23%" align=right><font size=2><b>$fb::txt{'fe'}{'24'}:</b></font>&nbsp;</td>
			<td width=27%><select name=uskin>~;

			my @contents = &opendirectory("$fb::gl{'datadir'}/skins");
			@contents = sort{uc($a) cmp uc($b)} (@contents);
			foreach my $line (@contents){
				if (-d "$fb::gl{'datadir'}/skins/$line") {
					if (($line ne ".") && ($line ne "..")) {
						my $selected = "";
						if ($skinwahl eq $line) { $selected = " selected" }
						$fb::fi{'main'} .= qq~<option value=\"$line\"$selected>$line\n~; 
					}
				}
			}

			$fb::fi{'main'} .= qq~</select></td>
			<td valign="top" width="23%" align=right><font size=2><b>$fb::txt{'fe'}{'25'}:</b></font>&nbsp;</td>
			<td width=27%><select name=wohin>~;

			my @contents2 = &opendirectory("$fb::cf{'bilderdir'}/skins/standard");
			@contents2 = sort{uc($a) cmp uc($b)} (@contents2);

			foreach my $line (@contents2){
				if (-d "$fb::cf{'bilderdir'}/skins/standard/$line") {
					if (($line ne ".") && ($line ne "..")) {
						my $selected = "";
						if ($wohin eq $line) { $selected = " selected" }
						$fb::fi{'main'} .= qq~<option value=\"$line\"$selected>$line\n~; 
					}
				}
			}

			$fb::fi{'main'} .= qq~</select></td>
			</tr></table></td><td class=fb2>&nbsp;</td></tr>
			~;
		}
		else {
			my $ausmach = $fb::INFO{'wasoeff'};
			$fb::fi{'main'} .= qq~<tr><td width=100% align=center colspan=2 class=fb1><input type=hidden name=wasoeff value="$ausmach">$fb::txt{'fe'}{'26'}: $fb::cf{'bilderdir'}/<b>$ausmach</b></td></tr>~;
		}

		$fb::fi{'main'} .= qq~

		<tr><td width=100% class=fb2><table border=0 cellspacing=0 cellpadding=0 width=100%>

		<tr>
			<td valign="top" width="23%" align=right><font size=2><b>$fb::txt{'fe'}{'27'}:</b>&nbsp;</font></td>
			<td><input type="file" name="file" size="49"></td>
		</tr>
			

			<tr>
			<td align="right"></td>
			<td><font size="1">$filesize_info</font></td>

		</tr>

		</table></td>
			<td class=fb1><input type="submit" name="post" value="$fb::txt{'fe'}{'28'}"></td></tr></form>
		</table>~; 
		&freetemp;

	}
}

1;