####################### [Firebook] - guestbook ################################
# important.pl		                                                          #
###############################################################################

package fb;

use strict;
use warnings;
#use diagnostics;


# standard cookie expiration 1 year
my $fut_time=gmtime(time()+365*24*3600)." GMT";

$fb::gl{'expires'} = $fut_time;
$fb::gl{'pwseed'} ||= 'fb';

use subs 'exit';
$$fb::fi{'main'} = "";	# set body start to blank
$CGITempFile::TMPDIRECTORY = "$fb::cf{'bilderdir'}/temp";

sub exit {
	local $| = 1;
	local $\ = '';
	print '';
	CORE::exit( $_[0] || 0 );
}

sub opendirectory {

	my $directoryname = $_[0];
	my $testfname = $directoryname;

	# old Firebook 5.4 code
	#$testfname =~ s/\\//ig;
	#$testfname =~ s/\///ig;
	#$testfname =~ s~\.~\_~ig;

	# my $newsavearray = uc($testfname);

	#
	#if (@{"saved_$newsavearray"}) {
	#	return @{"saved_$newsavearray"};
	#	$printfile = 1;
	#}
	#else {
	#	opendir(DIR, "$directoryname") || die "$fb::txt{'gl'}{'74'} $directoryname";
	#	@{"saved_$newsavearray"} = readdir(DIR);
	#	closedir(DIR);
	#	return @{"saved_$newsavearray"};
	##}

	# new Firebook 6.0

	my @savedirectory;

	opendir(DIR, "$directoryname") || die "$fb::txt{'gl'}{'74'} $directoryname";
	@savedirectory = readdir(DIR);
	closedir(DIR);
	return @savedirectory;

}

sub openfile_value {

	my $filename = $_[0];

	unless ($filename) { die "no data available for opening file"; }

	#my $testfname = $filename;

	#$testfname =~ s/\\//ig;
	#$testfname =~ s/\///ig;
	#$testfname =~ s~\.~\_~ig;

	#my $newsavearray = uc($testfname);

	my $tempsaveinstring;

	my $FILE = *FILEHANDLE;

	fopen($FILE, "$filename") || die "$fb::txt{'gl'}{'119'}: $filename!";
	$tempsaveinstring = <$FILE>;
	fclose($FILE);
	
	return $tempsaveinstring;

}

sub openfile {

	my $filename = $_[0];
	my $binmode = $_[1] || "0";

	unless ($filename) { die "no data available for opening file"; }

	#my $testfname = $filename;

	#$testfname =~ s/\\//ig;
	#$testfname =~ s/\///ig;
	#$testfname =~ s~\.~\_~ig;

	#my $newsavearray = uc($testfname);


# old FB 5.4
#
### FLAT
#if ($notarray == 1) { 
#	if ($saved{$filename}) {
#		${"$saveinarray"} = $saved{$filename};
#		$printfile = 1;
#	} 
#}
#else {
#	if ($opened{$newsavearray}) {
#		@{"$saveinarray"} = @{"saved_$newsavearray"};
#		$printfile = 1;
#	}
#}
#unless ($printfile == 1) {
#	fopen($newsavearray, "$filename") || die "$fb::txt{'gl'}{'119'}: $filename!";
#  if ($binmode == 1) {
#		$AnzahlBytes = -s "$filename";
#		$tSpeicher = "";
#		$geleseneBytes = "";
#		binmode $newsavearray;
#		binmode(STDOUT);
#		$geleseneBytes = read($newsavearray, $tSpeicher, $AnzahlBytes);
#  }
#  else {
#	if ($notarray == 1) { ${"$saveinarray"} = <$newsavearray>; }
#	else {	@{"$saveinarray"} = <$newsavearray>; }
#  }
#	fclose($newsavearray);
#  if ($binmode == 1) {
#		@{"$saveinarray"} = "";
#		${"$saveinarray"}[0] = $tSpeicher;
 # }
#}
#$printfile = 0;

#if ($notarray == 1) { $saved{$filename} = ${"$saveinarray"}; $notarray = 0; }
#else { @{"saved_$newsavearray"} = @{"$saveinarray"}; $opened{$newsavearray} = 1; }

	# old FB 6.0

	my @tempsaveinarray;
	my ($AnzahlBytes,$tSpeicher,$geleseneBytes);

	my $FILE = *FILEHANDLE;

	fopen($FILE, "$filename") || die "$fb::txt{'gl'}{'119'}: $filename!";
	if ($binmode == 1) {
		$AnzahlBytes = -s "$filename";
		$tSpeicher = "";
		$geleseneBytes = "";
		binmode $FILE;
		binmode(STDOUT);
		$geleseneBytes = read($FILE, $tSpeicher, $AnzahlBytes);
	}
	else {
		@tempsaveinarray = <$FILE>;
	}
	fclose($FILE);
	if ($binmode == 1) {
		@tempsaveinarray = "";
		$tempsaveinarray[0] = $tSpeicher;
	}
	
	return @tempsaveinarray;

}
sub writefile {

	my $filename = $_[0];
	my $writetofile = $_[1];
	my $mode = $_[2] || "";
	my $writearray_ref = $_[3];
	my $binmode = $_[4] || "0";

	if ($writearray_ref) {
		foreach (@{$writearray_ref}) { $writetofile .= $_; }
	}
	
	# my @filenames = split(/\//, $filename);
	# my @filenames2 = split(/\\\\/, $filenames[$#filenames]);
	# unless ($filenames2[$#filenames]) { $filenames2[$#filenames] = $filenames[$#filenames]; }
	# $filenames2[$#filenames] =~ s~\.~\_~ig;
	
	# my $newsavearray = uc($filenames2[$#filenames]);



	if ($mode eq "add") { $filename = qq~>>$filename~; }
	else { $filename = qq~>$filename~; }

	my $FILE = *FILEHANDLE;

	fopen($FILE, "$filename") || die "$fb::txt{'gl'}{'119'}: $filename! - $!";

	if ($binmode == 1) {
		binmode $FILE;
		binmode(STDOUT);
		print $FILE $writetofile;
	}
	else{
		print $FILE $writetofile;
	}
		
	fclose($FILE);

}


my $LOCK_EX = 2;
my $LOCK_UN = 8;
my $LOCK_SH = 1;

use Fcntl qw/:DEFAULT/;
unless( defined $LOCK_SH ) { $LOCK_SH = 1; }
{
	my %OpenMode = (
	'+>>' => 5,
	'+>' => 4,
	'+<' => 3,
	'>>' => 2,
	'>' => 1,
	'<' => 0,
	'' => 0
	);

	my %tmpfile;

	sub fopen ($$;$) {
		my( $filehandle, $filename, $usetmp ) = @_;
		unless ($filename) { die "error";	}
		
		# for test purposes
		$fb::fi{'openedfiles'} .= qq~$filehandle -> $filename<br>~;
		
		my( $flockCorrected, $cmdResult, $openMode, $openSig, $serveros );

		$serveros ="$^O";
		if ($serveros =~ m/Win/ && substr($filename,1,1) eq ":"){
			$filename =~ s~\\~\\\\~g;
			$filename =~ s~/~\\\\~g;
		} else {
			$filename =~ tr~\\~/~;
		}

		$filename =~ m~\A([<>+]*)(.+)~;
		$openSig = $1 || '';
		$filename = $2 || $filename;
		$openMode = $OpenMode{$openSig} || 0;

		$filename =~ s~[^/\\0-9A-Za-z#%+\,\-\ \.\:@^_]~~g;
		
		my $testfile = $filename;
		
		my (%LckFile);

		if($fb::cf{'use_flock'} == 2 && $openMode) {
			my $count;
			while( $count < 15 ) {
				if( -e $filehandle ) { sleep 2; }
				else { last; }
				++$count;
			}
			unlink($filehandle) if ($count == 15);
			local *LFH;
			CORE::open(LFH, ">$filehandle");
			$LckFile{$filehandle} = *LFH;
		}
		if($fb::cf{'use_flock'} && $openMode == 1 && $usetmp && $fb::cf{'usetempfile'} && -e $filename) {
			$tmpfile{$filehandle} = $filename;
			$filename .= '.tmp';
		}

		if($openMode > 2) {
			if($openMode == 5) { $cmdResult = CORE::open($filehandle, "+>>$filename"); }
			elsif( $fb::cf{'use_flock'} == 1 ) {
				if( $openMode == 4 ) {
					if( -e $filename ) {
						$flockCorrected = 1;
						$cmdResult = CORE::open($filehandle, "+<$filename");
					}
					else { $cmdResult = CORE::open($filehandle, "+>$filename"); }
				}
				else { $cmdResult = CORE::open($filehandle, "+<$filename"); }
			}
			elsif( $openMode == 4 ) { $cmdResult = CORE::open($filehandle, "+>$filename"); }
			else { $cmdResult = CORE::open($filehandle, "+<$filename"); }
		}
		elsif ($openMode == 1 && $fb::cf{'use_flock'} == 1) {
			if(-e $filename) {
				$flockCorrected = 1;
				$cmdResult = CORE::open($filehandle, "+<$filename");
			}
			else { $cmdResult = CORE::open($filehandle, ">$filename"); }
		}
		elsif ( $openMode == 1 ) {
			$cmdResult = CORE::open($filehandle, ">$filename");
		}
		elsif ( $openMode == 2 ) {
			$cmdResult = CORE::open($filehandle, ">>$filename");
		}
		elsif ( $openMode == 0 ) {
			$cmdResult = CORE::open($filehandle, $filename);
		}
		unless ($cmdResult) { return 0; }
		if ($flockCorrected) {
			flock($filehandle, $LOCK_EX);
			if( $fb::cf{'faketruncation'} ) {
				CORE::open(OFH, ">$filename");
				unless ($cmdResult) { return 0; }
				print OFH '';
				CORE::close(OFH);
			}
			else { truncate(*$filehandle, 0) || die "$fb::txt{'gl'}{'124'}: $filename"; }
			seek($filehandle, 0, 0);
		}
		elsif ($fb::cf{'use_flock'} == 1) {
			if( $openMode ) { flock($filehandle, $LOCK_EX); }
			else { flock($filehandle, $LOCK_SH); }
		}
		return 1;
	}
	sub fclose ($) {
		my $filehandle = $_[0];

		my (%LckFile);

		CORE::close($filehandle);
		if( $fb::cf{'use_flock'} == 2 ) {
			if( exists $LckFile{$filehandle} && -e $filehandle ) {
				CORE::close( $LckFile{$filehandle} );
				unlink( $filehandle );
				delete $LckFile{$filehandle};
			}
		}

		if($tmpfile{$filehandle}) {

			my $bakfile = $tmpfile{$filehandle};
			if( $fb::cf{'use_flock'} == 1 ) {
				local *FH;
				CORE::open(FH, $bakfile);
				flock(FH, $LOCK_EX);
				CORE::close(FH);
			}
			unlink("$bakfile.bak") if( -e "$bakfile.bak" );
			rename($bakfile,"$bakfile.bak");
			rename("$bakfile.tmp",$bakfile);
			delete $tmpfile{$filehandle};
			if(-e $bakfile) {
				unlink("$bakfile.bak");
			}
		}
		return 1;
	}
}
sub header {
	my %params = @_;
	my $ret = "";
	my $IIS;

	if( $ENV{'SERVER_SOFTWARE'} =~ /IIS/ ) {
		$IIS = 1;
		$0 =~ m~(.*)(\\|/)~;
		my $mod_path = $1;
		$mod_path =~ s~\\~/~g;
		chdir($mod_path);
		push(@INC,$mod_path);
	}
	if ($params{'-status'}) {
		if ($IIS) { $ret .= "HTTP/1.0 $params{'-status'}\n"; } 
		else { $ret .= "Status: $params{'-status'}\n";	}
	}


	$ret .= qq~Cache-Control: no-cache, must-revalidate\n~;
	$ret .= qq~Pragma: no-cache\n~;

	if ($params{'-cookies'}) {
		my(@cookie) = @{$params{'-cookies'}};
		
		foreach (@cookie) {
			if ($_) { $ret .= "Set-Cookie: $_\n";	}
		}
	}
	if ($params{'-location'}) {
		$ret .= "Location: $params{'-location'}\n";
	}
	unless ($params{'-contenttype'}) {
		$params{'-contenttype'} = "text/html";
	}
	$params{'-charset'} = ($params{'-charset'}) ? "; charset=$params{'-charset'}" : "";
	$params{'Content-Encoding'} = ($params{'Content-Encoding'}) ? "Content-Encoding: $params{'Content-Encoding'}\n" : "";
	$ret .= "$params{'Content-Encoding'}Content-Type: $params{'-contenttype'}$params{'-charset'}\r\n\r\n";
	return $ret;
}

sub split_string 
{ 
	my ($string, $hash, $altdelim) = @_; 

	my @pairs;
	my ($name, $value) = "";

	if($altdelim && $$string =~ m~;~) { @pairs = split(/;/, $$string); } 
	else { @pairs = split(/&/, $$string); }

	foreach $_ (@pairs) {

			($name,$value) = split(/=/, $_); 

			if ($name) {
				### values come seperated by + --> need to be replaced by blanks
				$value =~ tr/+/ /d; 
				$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; 
				$name =~ tr/+/ /d; 
				$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; 
				if (exists($hash->{$name})) { 
					$hash->{$name} .= ", $value"; 
				} else { 
					$hash->{$name} = $value; 
				} 

			}

	}

} 




sub readform {
	 
	my $testenv = $ENV{QUERY_STRING} || ""; 
	$testenv =~ s/\&/\;/g; 

	## correct false email links
	my @test_url = split(/\%3B/, $testenv);
	$testenv = "";
		
	my $i = 0;
	foreach (@test_url) {
		my ($test1,$test2) = split(/\;/, $_);
		if ($i == 0) {
			$testenv .= $_;
		}
		elsif ($test1 =~ m/\=/) {
			$testenv .= ";" . $_;
		}
		else {
			$testenv .= "%3B" . $_;
		}
		$i++;
	}

    split_string(\$testenv, \%fb::INFO, 1);

	if ($ENV{REQUEST_METHOD} eq 'POST') {

		if ($ENV{CONTENT_TYPE} =~ /multipart\/form-data/){
			use upload::CGI; import upload::CGI qw(:standard);
			my $cgipost = 1;
			if ($fb::INFO{'action'} eq "message2") {
				my $limit2 = $fb::cf{'limit'} + 700;
				$CGI::POST_MAX=1024*$limit2;
			}
			my $query = new CGI;
			my (@keylist) = sort($query->param());
			my $allkeys = @keylist;
			
			foreach my $key (@keylist) {
				$fb::gl{'postsize'} += length($query->param($key));
				my $value = join(', ', $query->param($key));
				$fb::FORM{$key} = $value;

			}
			if ($query->param('file')) {
				$fb::gl{'fixfile2'} = $query->param('file');
				$fb::gl{'postsize'} -= length($query->param('file'));
				$fb::gl{'tmpfile'} = $query->tmpFileName($fb::gl{'fixfile2'});
			}
			if ($cgipost == 1) {
				unless ($allkeys) { $fb::gl{'error_maxsize'} = 1; }
			}
		} 
		else {
			my $input;
			read(STDIN, $input, $ENV{CONTENT_LENGTH});
			split_string(\$input, \%fb::FORM);
		}
	}
      
    $fb::gl{'action'} = $fb::INFO{'action'} || $fb::FORM{'action'} || "";
	$fb::gl{'action'} =~ /^(\w+)$/;
    $fb::gl{'action'} = $1 || "";

} 
sub clear_temp {
	if($fb::gl{'fixfile2'}) {
		close($fb::gl{'fixfile2'});
	}
	if (-e $fb::gl{'tmpfile'} && $fb::gl{'tmpfile'} ne '')  {
		close($fb::gl{'tmpfile'});
		&dounlink($fb::gl{'tmpfile'});
	}
}

sub get_date {
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,$mon_num,$savehour,$saveyear);

	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time + (3600*$fb::cf{'setofdatum'}));
	$mon_num = $mon+1;
	$savehour = $hour;
	$hour = "0$hour" if ($hour < 10);
	$min = "0$min" if ($min < 10);
	$sec = "0$sec" if ($sec < 10);
	$saveyear = ($year % 100);
	$year = 1900 + $year;

	$mon_num = "0$mon_num" if ($mon_num < 10);
	$mday = "0$mday" if ($mday < 10);
	$saveyear = "0$saveyear" if ($saveyear < 10);
	return "$mon_num/$mday/$saveyear um $hour\:$min\:$sec";
}
sub get_year {

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst);
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time + (3600*$fb::cf{'setofdatum'}));
	$year = 1900 + $year;
	return $year;

}
sub get_month {

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,$mon_num);
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time + (3600*$fb::cf{'setofdatum'}));
	$mon_num = $mon+1;
	$mon_num = "0$mon_num" if ($mon_num < 10);
	return $mon_num;

}
sub get_day {

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,$mon_num);
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time + (3600*$fb::cf{'setofdatum'}));
	$mday = "0$mday" if ($mday < 10);
	return $mday;

}
sub get_ip {
	my $client_ip = &get_client_ip;
	my $x_forwarded = &get_x_forwarded;
	my $x_ip_client = &get_x_ip_client;
	my $http_via = &get_http_via;
	my $remote_addr = &get_remote_addr;

	if ($client_ip && $client_ip !~ m/empty/ && $client_ip !~ m/unknown/) {
		return $client_ip;
	} elsif ($x_forwarded && $x_forwarded !~ m/empty/ && $x_forwarded !~ m/unknown/) {
		return $x_forwarded;
	} elsif ($x_ip_client && $x_ip_client !~ m/empty/ && $x_ip_client !~ m/unknown/) {
		return $x_ip_client;
	} elsif ($http_via && $http_via !~ m/empty/ && $http_via !~ m/unknown/) {
		return $http_via;
	} elsif ($remote_addr && $remote_addr !~ m/empty/ && $remote_addr !~ m/unknown/) {
		return $remote_addr;
	} else {
		return "empty";
	}
}
sub get_client_ip {
	if($ENV{'HTTP_CLIENT_IP'} && $ENV{'HTTP_CLIENT_IP'} ne "127.0.0.1") {
		return $ENV{'HTTP_CLIENT_IP'};
	} else {
		return "empty";
	}
}
sub get_x_forwarded {
	if($ENV{'HTTP_X_FORWARDED_FOR'}&& $ENV{'HTTP_X_FORWARDED_FOR'} ne "127.0.0.1") {
		return $ENV{'HTTP_X_FORWARDED_FOR'};
	} else {
		return "empty";
	}
}
sub get_x_ip_client {
	if($ENV{'X_CLIENT_IP'} && $ENV{'X_CLIENT_IP'} ne "127.0.0.1") {
		return $ENV{'X_CLIENT_IP'};
	} else {
		return "empty";
	}
}
sub get_http_via {
	if($ENV{'HTTP_VIA'} && $ENV{'HTTP_VIA'} ne "127.0.0.1") {
		return $ENV{'HTTP_VIA'};
	} else {
		return "empty";
	}
}
sub get_remote_addr {
	if($ENV{'REMOTE_ADDR'}) {
		return $ENV{'REMOTE_ADDR'};
	} else {
		return "empty";
	}
}
sub dounlink {
	my $unlinkfile = $_[0];
	
	# Test
	#$fb::dbh->do("INSERT INTO files_del VALUES(?)", undef, $unlinkfile);

	unlink ($unlinkfile);
	if (-e "$unlinkfile") { &fatal_error("$fb::txt{'gl'}{'133'} $unlinkfile $fb::txt{'gl'}{'134'}"); }
}
sub convert_to_hex
{
    my $text = $_[0] || "";
	my $savetext = "";
	foreach (split(//, $text)) {
			if ($_ !~ m/[a-zA-Z0-9]/) {
				$savetext .= "%" . unpack("H*", $_);
			}
			else { $savetext .= $_; }
	}
    return $savetext;
}

sub make_message_code {
	
	my $action = $_[0];
	my $checknum2 = int( rand(9776) );
	$checknum2 =~ tr/0123456789/hy9do3uiks/;
	$_ = int( rand(678874) );
	$_ =~ tr/0123456789/pqh2l0vgs7/;
	$checknum2 .= $_;
	$_ = int( rand(5457665) );
	$_ =~ tr/0123456789/mnmngher5c/;
	$checknum2 .= $_;
	$_ = int( rand(66754) );
	$_ =~ tr/0123456789/xd8hbfk7sg/;
	
	my $message_codes = $action . ":" . $checknum2;
	return $message_codes;

}
sub validation_code {
	
	srand();
	my $codemaxchars = 6;
	

	my $checknum = int( rand(1000) );
	$checknum =~ tr/0123456789/ulx62ms5aw/;
	$_ = int( rand(1000) );
	$_ =~ tr/0123456789/hjo07kzv8t/;
	$checknum .= $_;
	$_ = int( rand(1000) );
	$_ =~ tr/0123456789/bec31qrn4f/;
	$checknum .= $_;
	$_ = int( rand(1000) );
	$_ =~ tr/0123456789/9dyipgy7d2/;
	$checknum .= $_;
	$_ = int( rand(1000) );
	$_ =~ tr/0123456789/5e0bzpktqg/;
	$checknum .= $_;
	$_ = int( rand(1000) );
	$_ =~ tr/0123456789/hvrislw6ao/;
	$checknum .= $_;
	$_ = int( rand(1000) );
	$_ =~ tr/0123456789/jcxfn4189u/;
	$checknum .= $_;

	my @checknum = split(//,$checknum);
	my $pick = @checknum;
	$checknum = "";
	while ($pick--) { $checknum .= splice(@checknum, int(rand(@checknum)), 1); } 
	
	$checknum = substr($checknum,0,$codemaxchars);
	return $checknum;
}
sub get_validation_graphic {

	my $time = time;
	my $valcode = qq~<img src="$fb::gl{'script'}?action=validate;fisession=$fb::gl{'fisession'};time=$time;skin=$fb::gl{'skin'}" border="0" alt="">~;
	return $valcode;

}
sub get_validation_code {
	# returns the current validation code

	my $validation_codes = $fb::dbh->selectrow_array("SELECT saved_proove_code FROM $fb::cf{'db_prefix'}" . "sessions WHERE created_id = ?", undef, $fb::gl{'fisession'});

	my @testsplit = split(/\_/, $validation_codes);
	return $testsplit[$#testsplit];

}
sub create_codes {

	my $create_val_code = $_[0] || "0";	# create verification graphic
	my $create_msg_code = $_[1] || "0";	# create hidden codes
	
	my $validation_codes = $fb::gl{'session_validation_codes'};
	my $message_codes = $fb::gl{'session_message_codes'};


	my ($return_val_code, $return_msg_code);

	if ($create_val_code) {
		# graphic verification code

		unless ($validation_codes) {
			$validation_codes = &validation_code;
			$return_val_code = $validation_codes;
		}
		else {

			my @testsplit = split(/\_/, $validation_codes);
			my $checksplit = @testsplit;

			if (($checksplit < 2) && ($validation_codes =~ m/\:/i)) {
				$validation_codes .= "_" . &validation_code;
			}
			else {
				$validation_codes = $testsplit[--$checksplit] . "_" . &validation_code;
			}  
		
			# save new code
			$return_val_code = $testsplit[$#testsplit];
		}


	}

	if ($create_msg_code) {
		# hidden msg code
		
		
		unless ($message_codes) {
			$message_codes = &make_message_code($fb::gl{'action'});
			$return_msg_code = $message_codes;
		}
		else {

			my @testsplit = split(/\_/, $message_codes);
			my $checksplit = @testsplit;

			if (($checksplit < 2) && ($message_codes =~ m/\:/i)) {
				$message_codes .= "_" . &make_message_code($fb::gl{'action'});
			}
			else {
				$message_codes = $testsplit[--$checksplit] . "_" . &make_message_code($fb::gl{'action'});
			}  	

			$return_msg_code = $testsplit[$#testsplit];
		}

	}

	$fb::dbh->do("UPDATE $fb::cf{'db_prefix'}" . "sessions SET saved_proove_code = ?, message_codes = ? WHERE created_id = ?", undef, $validation_codes, $message_codes, $fb::gl{'fisession'});

	$fb::gl{'session_validation_codes'} = $return_val_code;
	$fb::gl{'session_message_codes'} = $return_msg_code;

}

sub verify_access {

	my $time_now = time();

	my $verify_val_code = $_[0] || "0";
	my $verify_msg_code = $_[1] || "0";
	my $check_fact_sent = $_[2] || "0";	# store time from last action and check for validity

	my ($update_sess1, $update_sess2, $update_sess3) = (0,0,0);

	if ($check_fact_sent) {
		# check IP timeout
		my $sth = $fb::dbh->prepare("SELECT fact_sent FROM $fb::cf{'db_prefix'}" . "sessions WHERE sess_user_ip = ? AND fact_sent IS NOT NULL AND fact_sent <> ''");
		$sth->execute($fb::gl{'user_ip'}) or save_db_error(DBI->errstr);
		
		my $print_error = 0;
		while(my $fact_sent = $sth->fetchrow_array) {
				if(($time_now - $fact_sent) <= $fb::cf{'timeout'} ) { 
					$print_error = 1;	
				}
		}
		if ($print_error) { &fatal_error("$fb::txt{'gl'}{'80'} $fb::cf{'timeout'} $fb::txt{'gl'}{'81'}"); }

		$update_sess1 = 1;
	}

	if ($verify_val_code) {
		# verify image code

		my $print_proove_error = 0;

		my $validation_codes = $fb::gl{'session_validation_codes'};

		my @testsplit = split(/\_/, $validation_codes);
		
		unless ($testsplit[0]) {
			$testsplit[0] = "";
		}
		unless ($testsplit[1]) {
			$testsplit[1] = "";
		}
			
		# check code verification

		if ($fb::FORM{'verification'} eq '') { $print_proove_error = 1; }
		if ($fb::FORM{'verification'} !~ /\A[0-9A-Za-z]+\Z/) { $print_proove_error = 1; }
		if ($validation_codes ne $fb::FORM{'verification'}) { 
			if (($fb::FORM{'verification'} ne $testsplit[0]) && ($fb::FORM{'verification'} ne $testsplit[1])) {
				$print_proove_error = 1;
			}
		}

		if ($print_proove_error) {
			&fatal_error("$fb::txt{'gl'}{'142'}: 1");
		}


		$update_sess2 = 1;

	}

	if ($verify_msg_code) {
		# check hidden codes

		my $message_codes = $fb::gl{'session_message_codes'};

		my @testsplit = split(/\_/, $message_codes);
		unless ($testsplit[0]) {
			$testsplit[0] = "";
		}
		unless ($testsplit[1]) {
			$testsplit[1] = "";
		}


		if (($fb::FORM{'sent_message_code'} ne $message_codes) && ($fb::FORM{'sent_message_code'} ne $testsplit[0]) && ($fb::FORM{'sent_message_code'} ne $testsplit[1])) {
			#&delete_sessions("$fb::gl{'user_ip'};$sess_user_ip","$fb::gl{'fisession'}");
			#my $set_location = qq~$fb::gl{'script'}~;
			&database_disconnect; 
			die("validation code wrong");
			#&redirect($set_location);
		}

		$update_sess3 = 1;

	}

	if ($update_sess1 || $update_sess2 || $update_sess3) {
		
		my $dosql = "";
		
		if ($update_sess1) {
			$dosql .= qq~ fact_sent = '$time_now',~;
		}
		if ($update_sess2) {
			my $remaining_code = $fb::gl{'session_validation_codes'};
			$remaining_code =~ s~([_]*)$fb::FORM{'verification'}([_]*)~~ig;
			my $quoted_return = $fb::dbh->quote($remaining_code);
			$dosql .= qq~ saved_proove_code = $quoted_return,~;
		}
		if ($update_sess3) {
			my $remaining_code = $fb::gl{'session_message_codes'};
			$remaining_code =~ s~([_]*)$fb::FORM{'sent_message_code'}([_]*)~~ig;
			my $quoted_return = $fb::dbh->quote($remaining_code);
			$dosql .= qq~ message_codes = $quoted_return,~;
		}
		chop($dosql);

		my $quoted_session = $fb::dbh->quote("$fb::gl{'fisession'}");

		$fb::dbh->do("UPDATE $fb::cf{'db_prefix'}" . "sessions SET $dosql WHERE created_id = " . $quoted_session);

	}

}

sub check_sessions {

	# now also checking for session cookies
	$fb::gl{'cookie_session'} = &cookie_laden('fisession');
	$fb::gl{'fisession'} = $fb::INFO{'fisession'} || $fb::FORM{'fisession'} || $fb::gl{'cookie_session'} || "";

	my $nonew_session = 0;
	my $test_browser;
	my @browser_accesses = split(/\|/, $fb::cf{'browser_access'});

	foreach (@browser_accesses) {
		$_ = quotemeta($_);
		if ($ENV{'HTTP_USER_AGENT'} =~ m/$_/i) {
				$nonew_session = 1;
				$fb::gl{'fisession'} = "";
		}
	}

	# there shall be no session handling for interface to server
	if ($fb::gl{'action'} eq "interf_modules") {
		$nonew_session = 1;
	}

	unless ($fb::gl{'fisession'}) {
		if (!(%fb::FORM) && ($fb::gl{'action'} ne "redirectexit") && ($fb::gl{'action'} ne "topentrys")) {
			unless ($nonew_session) { &new_session(); }
		}
	}

	if ($fb::gl{'fisession'} eq "invalid") { &fatal_error("$fb::txt{'gl'}{'140'}"); }

	if($fb::gl{'fisession'} ne "") { 
		if ($nonew_session) {
			if ($fb::gl{'action'} eq "interf_modules") {
				# interf_modules is allowed to be accessed without session
			}
			elsif ((%fb::FORM)) { &database_disconnect; die(); }
		}
		else {
			&proove_session($nonew_session); 
		}
		
	}
	elsif ((%fb::FORM) && ($fb::gl{'fisession'} eq "")) { 
		# every action expect for the interface to the module server can send out error
		if ($fb::gl{'action'} ne "interf_modules") {
			#&delete_sessions($fb::gl{'user_ip'},"");
			&database_disconnect; 
			die("$fb::txt{'gl'}{'140'}");
		}
 	}

}
sub proove_session {
	
	my $nonew_session = $_[0];

	my $time_now = time();

	my $session_isvalid = 0;

	#my ($print_fatal_ip_double, $print_proove_error);

	my %count_sessionips;

	my @row = $fb::dbh->selectrow_array("SELECT time_old, created_id, sess_user_ip, username, password, userag, saved_proove_code, message_codes, writtenids FROM $fb::cf{'db_prefix'}" . "sessions WHERE created_id = ?", undef, $fb::gl{'fisession'});

	my ($time_old, $created_id, $sess_user_ip, $username, $password, $userag, $validation_codes, $message_codes, $writtenids) = @row;
	
	if ($time_old && ($time_old < ($time_now-$fb::cf{'sessionidtime'}))) {
		@row = ();
	}

	if (@row) {


				# my $test_user_ip = substr($fb::gl{'user_ip'}, 0, 33);
					# my $test_sess_ip = substr($sess_user_ip, 0, 33);

					#if (($fb::gl{'action'} ne "validate") && ($test_user_ip ne $test_sess_ip) && (!$fb::FORM{'inc'}) && (!$fb::INFO{'inc'})) {
						#&delete_sessions("$fb::gl{'user_ip'};$sess_user_ip","$fb::gl{'fisession'}");
					#	&database_disconnect; 
					#	die("user ip wrong");
						#my $envstring;
						#unless (%fb::FORM) {
						##	$envstring = $ENV{'QUERY_STRING'};
						#	$envstring =~ s/fisession=/invsession=/g;
						#	$envstring =~ s/inc=(php|ssi)/cutcni=/g;
						#}
						#&redirect("$fb::gl{'script'}?$envstring");
					#}
					#elsif(($fb::gl{'action'} ne "validate") && ($userag ne $ENV{'HTTP_USER_AGENT'}) && (!$fb::FORM{'inc'}) && (!$fb::INFO{'inc'})) {
						#&delete_sessions("$sess_user_ip","$fb::gl{'fisession'}");
						#&database_disconnect; 
						#die("wrong browser");
						#my $envstring;
						#unless (%fb::FORM) {
						#	$envstring = $ENV{'QUERY_STRING'};
						#	$envstring =~ s/fisession=/invsession=/g;
						#	$envstring =~ s/inc=(php|ssi)/cutcni=/g;
						#}
						#
						#&redirect("$fb::gl{'script'}?$envstring");
					#}
					#else { 
						$session_isvalid = 1;

						if ($fb::INFO{'usr'}) {
							$username = $fb::INFO{'usr'};
							$password = crypt($fb::INFO{'usrpass'},$fb::gl{'pwseed'});
						}
						if ($fb::FORM{'usr'}) {
							$username = $fb::FORM{'usr'};
							$password = crypt($fb::FORM{'usrpass'},$fb::gl{'pwseed'});
						}
						if ($fb::FORM{'password'}) {
							$username = $fb::FORM{'name'};
							$password = crypt($fb::FORM{'password'},$fb::gl{'pwseed'});
						}

						$fb::dbh->do("UPDATE $fb::cf{'db_prefix'}" . "sessions SET time_old = ?, sess_user_ip = ?, username = ?, password = ?, userag = ? WHERE created_id = ?", undef, turn_to_null($time_now, $fb::gl{'user_ip'}, $username, $password, $userag, $fb::gl{'fisession'}));

						# for logging purposes
						#$fb::dbh->do("INSERT INTO $fb::cf{'db_prefix'}" . "sessions_log (time_old, created_id, sess_user_ip, username, password, userag, writtenids, message_codes, fact_sent, saved_proove_code, env) VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", undef, turn_to_null($time_now, $fb::gl{'fisession'}, $fb::gl{'user_ip'}, $username, $password, $userag, $writtenids, $message_codes, $fact_sent, $saved_proove_code, $ENV{'QUERY_STRING'}));

						$fb::gl{'session_id_username'} = $username;
						$fb::gl{'session_id_password'} = $password;
						$fb::gl{'session_id_messageid'} = $writtenids;
						$fb::gl{'session_validation_codes'} = $validation_codes;
						$fb::gl{'session_message_codes'} = $message_codes;

					#}
	}

	

	if ($session_isvalid != 1) {
		
		unless ($nonew_session) {
			new_session();
 		}

	#	my $envstring = "";
	#	unless (%fb::FORM) {
	#		$envstring = $ENV{'QUERY_STRING'};
	#		if ($envstring) {
	#			$envstring =~ s/fisession=/invsession=/g;
	#			$envstring =~ s/inc=(php|ssi)/cutcni=/g;
	#		}
	#	}
	#	my $expired_time=gmtime(time()-30*24*3600)." GMT";	# we set a past date
	#	push(@{$fb::gl{'cookies'}},"fisession=; expires=$expired_time;");
	#	&redirect("$fb::gl{'script'}?$envstring");
	}

}

sub new_session {

#	my $sth = $fb::dbh->prepare("SELECT created_id FROM $fb::cf{'db_prefix'}" . "sessions WHERE sess_user_ip = ? AND userag NOT LIKE \"i-dreams.net\" ORDER BY time_old desc");
#	$sth->execute($fb::gl{'user_ip'}) or save_db_error(DBI->errstr);

#	$sth->bind_columns(\$created_id);

#	my $count_ips = 0;
#	while($sth->fetchrow_arrayref) {
#		$count_ips++;
#
#		if ($count_ips > 2) {
#			$fb::dbh->do("DELETE FROM $fb::cf{'db_prefix'}" . "sessions WHERE created_id = ?", undef, $created_id);
#		}
#	}

	# delete old sessions

	my $created_id = &create_sess;

	my $zeit = time();
	my $passwod; 

	$fb::dbh->do("DELETE FROM $fb::cf{'db_prefix'}" . "sessions WHERE time_old < ? OR userag like \"%i-dreams%\"", undef, ($zeit-$fb::cf{'sessionidtime'}));

	if ($fb::FORM{'usrpass'}) {
		$passwod = crypt($fb::FORM{'usrpass'},$fb::gl{'pwseed'});
	}
	elsif($fb::INFO{'usrpass'}) {
		$passwod = crypt($fb::INFO{'usrpass'},$fb::gl{'pwseed'});
	}
	while ($fb::dbh->selectrow_array("SELECT COUNT(*) FROM $fb::cf{'db_prefix'}" . "sessions WHERE created_id = ?", undef, $created_id)) {
		$created_id = &create_sess;
	}
	$fb::gl{'fisession'} = $created_id;


	$fb::gl{'session_id_username'} = $fb::FORM{'usr'} || $fb::INFO{'usr'};
	$fb::gl{'session_id_password'} = $passwod;

	$fb::dbh->do("INSERT INTO $fb::cf{'db_prefix'}" . "sessions (time_old, created_id, sess_user_ip, username, password, userag) VALUES(?, ?, ?, ?, ?, ?)", undef, turn_to_null($zeit, $created_id, $fb::gl{'user_ip'}, $fb::gl{'session_id_username'}, $passwod, $ENV{'HTTP_USER_AGENT'}));
	
	my $envstring;
	unless (%fb::FORM) {
		$envstring = $ENV{'QUERY_STRING'} || "";
		$envstring =~ s/fisession=/invsession=/g;
	}


	# for the first run of a new session we delete cookies 

	# cookie expiration 1 day
	my $fut_time=gmtime(time()+1*24*3600)." GMT";
	push(@{$fb::gl{'cookies'}},"fisession=$created_id; expires=$fut_time;");
	$fb::gl{'cookie_session'} = "";

	#my $set_location = qq~$fb::gl{'script'}?$envstring;fisession=$created_id~;
	#&small_redirect($set_location);

}
sub create_sess {
	use password::MD5 qw(md5_base64);
    my $self = shift;
    my $md5 = new password::MD5();
    $md5->add( $$ , time() , rand(9999) );
    my $created_id = $md5->b64digest();
	$created_id =~ s/\|//ig;
	$created_id =~ s/\//y/g;
	$created_id =~ s/\+/x/g;
	$created_id =~ s/\-/Z/g;
	$created_id =~ s/\:/Q/g;
	my $checknum = int( rand(100) );
	$checknum =~ tr/0123456789/ymifxupbck/;
	$_ = int( rand(78) );
	$_ =~ tr/0123456789/q8dv7w4jm3x/;
	$checknum .= $_;
	$_ = int( rand(99) );
	$_ =~ tr/0123456789/7v4sq3dam3/;
	$checknum .= $_;
	$_ = int( rand(12) );
	$_ =~ tr/0123456789/7asdssdcay/;
	$created_id .= $checknum;
	return $created_id;

}
sub delete_sessions {
	if (($fb::INFO{'inc'}) || ($fb::FORM{'inc'})) {
		$fb::cf{'htmlredir'} = 1;
	}
	my $delete_ips = $_[0];
	my $delete_ids = $_[1];

	my @delete_sessips = split(/\;/, $delete_ips);
	my @delete_sessids = split(/\|/, $delete_ids);

	foreach (@delete_sessips) {
		$fb::dbh->do("DELETE FROM $fb::cf{'db_prefix'}" . "sessions WHERE sess_user_ip = ?", undef, $_);
	}
	foreach (@delete_sessids) {
		$fb::dbh->do("DELETE FROM $fb::cf{'db_prefix'}" . "sessions WHERE created_id = ?", undef, $_);
	}

}
sub load_language {
	
	my $loadlfile = $_[0];

	unless ($fb::loaded{"lang_" . $loadlfile}) {
		require "$fb::gl{'datadir'}/language/$fb::gl{'sprache2'}/$loadlfile.lng";
		$fb::loaded{"lang_" . $loadlfile} = 1;
	}

}
sub small_redirect {

	my $set_location = $_[0];
	my $inctype;

	if (($fb::INFO{'inc'}) || ($fb::FORM{'inc'})) {
		
		my $inctype = $fb::INFO{'inc'} || $fb::INFO{'inc'};

			if ($fb::cf{'url_ssi'} =~ m/\?/) {
				$set_location =~ s/$fb::gl{'script'}\?/$fb::cf{'url_ssi'}\;inc=$inctype\;/ig;
				$set_location =~ s/$fb::gl{'script'}/$fb::cf{'url_ssi'}\;inc=$inctype/ig;
			}
			else {
				$set_location =~ s/$fb::gl{'script'}\?/$fb::cf{'url_ssi'}\?inc=$inctype\;/ig;
				$set_location =~ s/$fb::gl{'script'}/$fb::cf{'url_ssi'}\?inc=$inctype/ig;
			}
	}

	if ($fb::cf{'htmlredir'} == 1) {
		print "Content-type: text/html\n\n";
		print "<br>\n<SCRIPT LANGUAGE=\"JavaScript\">\n<!--\nwindow.location = \"$set_location\"\//-->\n</SCRIPT>\n<table border=0 cellspacing=0 cellpadding=0 width=100% height=100%><tr><td align=center><font size=2><b><a href=\"$set_location\" target=\"_top\">$set_location</a></b><br></font></td></tr></table><br>";
		&database_disconnect;
		exit;
	}
	else {
			print header(
					-status=>'302 Moved Temporarily',
					-location=>$set_location
			);
	}
	&database_disconnect;
	exit;
}
sub save_db_error {
	$fb::error{'db_error'} .= $_[0] . "<br>";
}
sub database_connect {

	our $dbh = DBI->connect( "$fb::cf{'db_driver'}:$fb::cf{'db_name'}:$fb::cf{'db_host'}:$fb::cf{'db_port'}",$fb::cf{'db_user'},$fb::cf{'db_password'}, {"PrintError" => 1, "AutoCommit" => 1, "RaiseError" => 1}) or save_db_error($DBI::errstr);

}
sub database_disconnect {
	if (defined($fb::dbh)) {
		$fb::dbh->disconnect();
	}
}
sub turn_to_null {
 my @convert = @_;
 foreach (@convert) { 
	 if ($_) {
		 if ($_ eq "") { $_ = undef; }
		 $_ =~ s/\\@/@/ig;
		 $_ =~ s/\\"/"/ig;
	 }
 }
 return @convert;
}
sub fragezeich {

	my $print_frag = "";
	for (my $i = 1; $i <= $_[0]; $i++) {
		$print_frag .= "?,";
	}
	chop($print_frag);

	return $print_frag;

}

# for the conversion of simple url parameters to be passed on to the following function
sub convert_argument {

	my $argument = $_[0];
	$argument =~ s/\;/\(and\)/ig;
	$argument =~ s/\=/\(eq\)/ig;
	return $argument;

}
sub deconvert_argument {

	my $argument = $_[0];
	$argument =~ s/\(and\)/\;/ig;
	$argument =~ s/\(eq\)/\=/ig;
	return $argument;

}
sub cookie_laden {

	my ($cookie) = shift;

	unless ($ENV{'HTTP_COOKIE'}) { $ENV{'HTTP_COOKIE'} = ""; }

	my $letzter=substr($ENV{'HTTP_COOKIE'}, -1, 1);
	if ($letzter eq ";") {
		chop($ENV{'HTTP_COOKIE'});
	}
	$ENV{'HTTP_COOKIE'} =~ s/;fb/; fb/ig;

	my @key_value_pairs = split (/; /, $ENV{'HTTP_COOKIE'});
	foreach (@key_value_pairs) {
		my ($key,$value) = split (/=/, $_);
		if ($key eq $cookie) {
		  return $value;
		}
	}
	return 0;

}

$fb::gl{'user_ip'} = &get_ip;

1;
