####################### [Firebook] - guestbook ################################
# language.pl   	                                                          #
###############################################################################

package fb;

use strict;
use warnings;
#use diagnostics;

my $pushatlang  = qq~pushlang-ftqh2i3s4i9s0ajlqarn3g4uakgaescdofdej34qj934fjdfasdfj4k-idreamsexportaygh7e4kjn081mszwhjx643lhgsq~;
my $pushatlang2 = qq~pushlang2-fth9iis3iqs4arliannjgmuaadgfecjo2d0ejzdwcooajdsafun38asdf3asdf~;

sub sprach {

	&isadmin;
	&adminmenu;

	my $sel = $fb::INFO{'sel'} || "";

	if ($sel eq "menu") {
		# overview of language files
		
		$fb::fi{'main'} .= qq~
		<table border=0 width="100%" cellspacing=1 class=fbborder cellpadding="2" align=center>
	  <tr>
		<td class=fbcatbg colspan=3><b>$fb::txt{'gl'}{'86'}</b></td></tr><tr>
		<td class=fb2 align=center width=33%><b><a href="$fb::gl{'scriptac'}=sprach;sel=main">$fb::txt{'la'}{'91'}</a></b></td>
		<td class=fb1 width=33% align=center><b>$fb::txt{'la'}{'1'}</b></td><td class=fb2 align=center width=33%><b><a href="$fb::gl{'scriptac'}=sprach;sel=edit">$fb::txt{'la'}{'2'}</a></b></td>
	  </tr>
	  <tr>
		<td class=fb2 colspan=3>~;
		
		# get all language files
		my @contents = &opendirectory("$fb::gl{'datadir'}/language/$fb::cf{'sprache'}");
		
		# where we save the compilation of language files
		my @prline;

		my $start    = 0;
		foreach (@contents) {
			my ($langsel, $fileext) = split(/\./, $_);
			
			if ($fileext eq "lng") {
				
				my ($langtxt,$langdescr,$langcode);
				
				if ($langsel eq "admin") {
					$langtxt   = qq~$fb::txt{'la'}{'3'}~;
					$langdescr = qq~$fb::txt{'la'}{'44'}~;
					$langcode  = qq~ad~;
				}
				elsif ($langsel eq "activation") {
					$langtxt   = qq~$fb::txt{'la'}{'4'}~;
					$langdescr = qq~$fb::txt{'la'}{'45'}~;
					$langcode  = qq~ac~;
				}
				elsif ($langsel eq "attachcontrol") {
					$langtxt   = qq~$fb::txt{'la'}{'5'}~;
					$langdescr = qq~$fb::txt{'la'}{'46'}~;
					$langcode  = qq~at~;
				}
				elsif ($langsel eq "autosett") {
					$langtxt   = qq~$fb::txt{'la'}{'6'}~;
					$langdescr = qq~$fb::txt{'la'}{'47'}~;
					$langcode  = qq~au~;
				}
				elsif ($langsel eq "checkmessage") {
					$langtxt   = qq~$fb::txt{'la'}{'7'}~;
					$langdescr = qq~$fb::txt{'la'}{'48'}~;
					$langcode  = qq~ch~;
				}
				elsif ($langsel eq "edit") {
					$langtxt   = qq~$fb::txt{'la'}{'9'}~;
					$langdescr = qq~$fb::txt{'la'}{'50'}~;
					$langcode  = qq~ed~;
				}
				elsif ($langsel eq "editall") {
					$langtxt   = qq~$fb::txt{'la'}{'121'}~;
					$langdescr = qq~$fb::txt{'la'}{'122'}~;
					$langcode  = qq~ea~;
				}
				elsif ($langsel eq "editsum") {
					$langtxt   = qq~$fb::txt{'la'}{'10'}~;
					$langdescr = qq~$fb::txt{'la'}{'51'}~;
					$langcode  = qq~es~;
				}
				elsif ($langsel eq "help") {
					$langtxt   = qq~$fb::txt{'la'}{'11'}~;
					$langdescr = qq~$fb::txt{'la'}{'52'}~;
					$langcode  = qq~he~;
				}
				elsif ($langsel eq "language") {
					$langtxt   = qq~$fb::txt{'la'}{'15'}~;
					$langdescr = qq~$fb::txt{'la'}{'56'}~;
					$langcode  = qq~la~;
				}
				elsif ($langsel eq "loadentry") {
					$langtxt   = qq~$fb::txt{'la'}{'16'}~;
					$langdescr = qq~$fb::txt{'la'}{'57'}~;
					$langcode  = qq~le~;
				}
				elsif ($langsel eq "loadfields") {
					$langtxt   = qq~$fb::txt{'la'}{'17'}~;
					$langdescr = qq~$fb::txt{'la'}{'58'}~;
					$langcode  = qq~lo~;
				}
				elsif ($langsel eq "login") {
					$langtxt   = qq~$fb::txt{'la'}{'18'}~;
					$langdescr = qq~$fb::txt{'la'}{'59'}~;
					$langcode  = qq~lg~;
				}
				elsif ($langsel eq "mailer") {
					$langtxt   = qq~$fb::txt{'la'}{'19'}~;
					$langdescr = qq~$fb::txt{'la'}{'60'}~;
					$langcode  = qq~ma~;
				}
				elsif ($langsel eq "message") {
					$langtxt   = qq~$fb::txt{'la'}{'21'}~;
					$langdescr = qq~$fb::txt{'la'}{'62'}~;
					$langcode  = qq~me~;
				}
				elsif ($langsel eq "privatn") {
					$langtxt   = qq~$fb::txt{'la'}{'22'}~;
					$langdescr = qq~$fb::txt{'la'}{'63'}~;
					$langcode  = qq~pm~;
				}
				elsif ($langsel eq "protection") {
					$langtxt   = qq~$fb::txt{'la'}{'24'}~;
					$langdescr = qq~$fb::txt{'la'}{'65'}~;
					$langcode  = qq~pr~;
				}
				elsif ($langsel eq "search") {
					$langtxt   = qq~$fb::txt{'la'}{'26'}~;
					$langdescr = qq~$fb::txt{'la'}{'67'}~;
					$langcode  = qq~sr~;
				}
				elsif ($langsel eq "settings") {
					$langtxt   = qq~$fb::txt{'la'}{'27'}~;
					$langdescr = qq~$fb::txt{'la'}{'68'}~;
					$langcode  = qq~se~;
				}
				elsif ($langsel eq "settings2") {
					$langtxt   = qq~$fb::txt{'la'}{'28'}~;
					$langdescr = qq~$fb::txt{'la'}{'69'}~;
					$langcode  = qq~se2~;
				}
				elsif ($langsel eq "skinsystem") {
					$langtxt   = qq~$fb::txt{'la'}{'30'}~;
					$langdescr = qq~$fb::txt{'la'}{'71'}~;
					$langcode  = qq~sk~;
				}
				elsif ($langsel eq "smilies") {
					$langtxt   = qq~$fb::txt{'la'}{'31'}~;
					$langdescr = qq~$fb::txt{'la'}{'72'}~;
					$langcode  = qq~sm~;
				}
				elsif ($langsel eq "smtperror") {
					$langtxt   = qq~$fb::txt{'la'}{'32'}~;
					$langdescr = qq~$fb::txt{'la'}{'73'}~;
					$langcode  = qq~smtp~;
				}
				elsif ($langsel eq "topentrys") {
					$langtxt   = qq~$fb::txt{'la'}{'33'}~;
					$langdescr = qq~$fb::txt{'la'}{'74'}~;
					$langcode  = qq~tp~;
				}
				elsif ($langsel eq "ubbcfiles") {
					$langtxt   = qq~$fb::txt{'la'}{'36'}~;
					$langdescr = qq~$fb::txt{'la'}{'77'}~;
					$langcode  = qq~ub~;
				}
				elsif ($langsel eq "ubbcjs") {
					$langtxt   = qq~$fb::txt{'la'}{'37'}~;
					$langdescr = qq~$fb::txt{'la'}{'78'}~;
					$langcode  = qq~js~;
				}
				elsif ($langsel eq "upload") {
					$langtxt   = qq~$fb::txt{'la'}{'38'}~;
					$langdescr = qq~$fb::txt{'la'}{'79'}~;
					$langcode  = qq~up~;
				}
				else {
					$langtxt  = qq~$fb::txt{'la'}{'39'}~;
					$langcode = qq~gl~;
				}
				#my $newlngtxt = uc($langtxt);

				if ($langsel =~ /mod\_/) {
					my ($mod_foo, $mod_code, $mod_where) = split(/\_/, $_);
					my $sub_dest = "";
					my $code = "";
					if ($mod_where =~ m/admin/i) {
						$sub_dest = $fb::txt{'la'}{'117'};
						$code = "mod_$mod_code";
					}
					elsif ($mod_where =~ m/user/i) {
						$sub_dest = $fb::txt{'la'}{'118'};
						$code = "mod_$mod_code";
					}
					elsif ($mod_where =~ m/global/i) {
						$sub_dest = $fb::txt{'la'}{'131'};
						$code = "mod_" . $mod_code . "_gl";
					}
					else {
						$sub_dest = $fb::txt{'la'}{'127'};
						$code = "mod_$mod_code";
					}
					$langtxt  = qq~mod_$mod_code $sub_dest~;
					$langdescr = qq~$fb::txt{'la'}{'128'} $sub_dest $fb::txt{'la'}{'129'} mod_$mod_code$fb::txt{'la'}{'130'}~;
					$langcode = $code;
				}

				unless ($langcode eq "gl") {
					$prline[$start] = qq~$langtxt|$langcode|$langsel|$langdescr~;
					$start++;
				}
			}
		}

		@prline = sort { uc($a) cmp uc($b) } (@prline);
		
		$fb::fi{'main'} .= qq~
			<script language= "JavaScript"> 
			<!-- 
			function schreiben(text, element) 
			{ 
			var text = document.createTextNode(text); 
			document.getElementById(element).appendChild(text); 
			} 

			function loeschen(element) 
			{ 
			var text = document.getElementById(element).firstChild; 
			text = document.getElementById(element).removeChild(text); 
			} 


			//--> 
			</script> 	

			<table border=0 cellspacing=0 cellpadding=2 width=100%>
			<tr><td><b>[ <a href="$fb::gl{'scriptac'}=sprach;sel=edit;langsel=global">$fb::txt{'la'}{'39'}</a> ]</b></td><td align=right><font size=1><font color=red>$fb::txt{'la'}{'41'}: gl</font></font></td></tr>
						<tr><td colspan=2>$fb::txt{'la'}{'42'}</td></tr></table></td></tr>
			~;
		
		my $counter = 0;

		# print language files overview
		foreach (@prline) {
			my ($langtxt, $langcode, $langsel, $langdescr) = split(/\|/, $_);

			$fb::fi{'main'} .= qq~<tr><td class=fb2 colspan=3>	
				<table border=0 cellspacing=0 cellpadding=2 width=100%><tr><td>
				<b>[ <a href="$fb::gl{'scriptac'}=sprach;sel=edit;langsel=$langsel" alt="" ONMOUSEOVER="schreiben('$langdescr','menu_$langcode$counter')" ONMOUSEOUT="loeschen('menu_$langcode$counter')">$langtxt</a> ]</b></td><td align=right><font size=1 color=red>$fb::txt{'la'}{'41'}: $langcode</font></td></tr>
			<tr><td colspan=2><div id="menu_$langcode$counter"></div></td></tr>
			 </table></td></tr>~;

			$counter++;

		}

		$fb::fi{'main'} .= qq~
		<tr><td class=fb2 colspan=3><div align=justify>$fb::txt{'la'}{'43'}</div></td></tr>
		</table>~;
	}
	elsif ($sel eq "edit") {

		# edit a single language file

		my $langsel2   = $fb::INFO{'langsel'}    || "global";
		my $langchosen = $fb::INFO{'langchosen'} || $fb::cf{'sprache'};
		
		$langsel2 =~ /^(\w+)$/;
		$langsel2 = $1;

		$langchosen =~ /^(\w+)$/;
		$langchosen = $1;
	
		unless ($langsel2 eq "global") {
			require "$fb::gl{'datadir'}/language/$langchosen/$langsel2.lng";
		}
		elsif ($langchosen ne $fb::gl{'sprache2'}) {
			require "$fb::gl{'datadir'}/language/$langchosen/$langsel2.lng";
		}

		# that's where we store the currently selected language file
		my ($savetxt,$savedescr,$savecode);
		
		# saved array of options for selection box
		my @optionssave;

		my @contents = &opendirectory("$fb::gl{'datadir'}/language/$fb::cf{'sprache'}");
		
		# get language file info for selection box overview
		my $start    = 0;
		foreach (@contents) {
			my ($langsel, $fileext) = split(/\./, $_);
			
			if ($fileext eq "lng") {
			
				my ($langtxt,$langdescr,$langcode);

				if ($langsel eq "admin") {
					$langtxt   = qq~$fb::txt{'la'}{'3'}~;
					$langdescr = qq~$fb::txt{'la'}{'44'}~;
					$langcode  = qq~ad~;
				}
				elsif ($langsel eq "activation") {
					$langtxt   = qq~$fb::txt{'la'}{'4'}~;
					$langdescr = qq~$fb::txt{'la'}{'45'}~;
					$langcode  = qq~ac~;
				}
				elsif ($langsel eq "attachcontrol") {
					$langtxt   = qq~$fb::txt{'la'}{'5'}~;
					$langdescr = qq~$fb::txt{'la'}{'46'}~;
					$langcode  = qq~at~;
				}
				elsif ($langsel eq "autosett") {
					$langtxt   = qq~$fb::txt{'la'}{'6'}~;
					$langdescr = qq~$fb::txt{'la'}{'47'}~;
					$langcode  = qq~au~;
				}
				elsif ($langsel eq "checkmessage") {
					$langtxt   = qq~$fb::txt{'la'}{'7'}~;
					$langdescr = qq~$fb::txt{'la'}{'48'}~;
					$langcode  = qq~ch~;
				}
				elsif ($langsel eq "edit") {
					$langtxt   = qq~$fb::txt{'la'}{'9'}~;
					$langdescr = qq~$fb::txt{'la'}{'50'}~;
					$langcode  = qq~ed~;
				}
				elsif ($langsel eq "editall") {
					$langtxt   = qq~$fb::txt{'la'}{'121'}~;
					$langdescr = qq~$fb::txt{'la'}{'122'}~;
					$langcode  = qq~ea~;
				}
				elsif ($langsel eq "editsum") {
					$langtxt   = qq~$fb::txt{'la'}{'10'}~;
					$langdescr = qq~$fb::txt{'la'}{'51'}~;
					$langcode  = qq~es~;
				}
				elsif ($langsel eq "help") {
					$langtxt   = qq~$fb::txt{'la'}{'11'}~;
					$langdescr = qq~$fb::txt{'la'}{'52'}~;
					$langcode  = qq~he~;
				}
				elsif ($langsel eq "language") {
					$langtxt   = qq~$fb::txt{'la'}{'15'}~;
					$langdescr = qq~$fb::txt{'la'}{'56'}~;
					$langcode  = qq~la~;
				}
				elsif ($langsel eq "loadentry") {
					$langtxt   = qq~$fb::txt{'la'}{'16'}~;
					$langdescr = qq~$fb::txt{'la'}{'57'}~;
					$langcode  = qq~le~;
				}
				elsif ($langsel eq "loadfields") {
					$langtxt   = qq~$fb::txt{'la'}{'17'}~;
					$langdescr = qq~$fb::txt{'la'}{'58'}~;
					$langcode  = qq~lo~;
				}
				elsif ($langsel eq "login") {
					$langtxt   = qq~$fb::txt{'la'}{'18'}~;
					$langdescr = qq~$fb::txt{'la'}{'59'}~;
					$langcode  = qq~lg~;
				}
				elsif ($langsel eq "mailer") {
					$langtxt   = qq~$fb::txt{'la'}{'19'}~;
					$langdescr = qq~$fb::txt{'la'}{'60'}~;
					$langcode  = qq~ma~;
				}
				elsif ($langsel eq "message") {
					$langtxt   = qq~$fb::txt{'la'}{'21'}~;
					$langdescr = qq~$fb::txt{'la'}{'62'}~;
					$langcode  = qq~me~;
				}
				elsif ($langsel eq "privatn") {
					$langtxt   = qq~$fb::txt{'la'}{'22'}~;
					$langdescr = qq~$fb::txt{'la'}{'63'}~;
					$langcode  = qq~pm~;
				}
				elsif ($langsel eq "protection") {
					$langtxt   = qq~$fb::txt{'la'}{'24'}~;
					$langdescr = qq~$fb::txt{'la'}{'65'}~;
					$langcode  = qq~pr~;
				}
				elsif ($langsel eq "search") {
					$langtxt   = qq~$fb::txt{'la'}{'26'}~;
					$langdescr = qq~$fb::txt{'la'}{'67'}~;
					$langcode  = qq~sr~;
				}
				elsif ($langsel eq "settings") {
					$langtxt   = qq~$fb::txt{'la'}{'27'}~;
					$langdescr = qq~$fb::txt{'la'}{'68'}~;
					$langcode  = qq~se~;
				}
				elsif ($langsel eq "settings2") {
					$langtxt   = qq~$fb::txt{'la'}{'28'}~;
					$langdescr = qq~$fb::txt{'la'}{'69'}~;
					$langcode  = qq~se2~;
				}
				elsif ($langsel eq "skinsystem") {
					$langtxt   = qq~$fb::txt{'la'}{'30'}~;
					$langdescr = qq~$fb::txt{'la'}{'71'}~;
					$langcode  = qq~sk~;
				}
				elsif ($langsel eq "smilies") {
					$langtxt   = qq~$fb::txt{'la'}{'31'}~;
					$langdescr = qq~$fb::txt{'la'}{'72'}~;
					$langcode  = qq~sm~;
				}
				elsif ($langsel eq "smtperror") {
					$langtxt   = qq~$fb::txt{'la'}{'32'}~;
					$langdescr = qq~$fb::txt{'la'}{'73'}~;
					$langcode  = qq~smtp~;
				}
				elsif ($langsel eq "topentrys") {
					$langtxt   = qq~$fb::txt{'la'}{'33'}~;
					$langdescr = qq~$fb::txt{'la'}{'74'}~;
					$langcode  = qq~tp~;
				}
				elsif ($langsel eq "ubbcfiles") {
					$langtxt   = qq~$fb::txt{'la'}{'36'}~;
					$langdescr = qq~$fb::txt{'la'}{'77'}~;
					$langcode  = qq~ub~;
				}
				elsif ($langsel eq "ubbcjs") {
					$langtxt   = qq~$fb::txt{'la'}{'37'}~;
					$langdescr = qq~$fb::txt{'la'}{'78'}~;
					$langcode  = qq~js~;
				}
				elsif ($langsel eq "upload") {
					$langtxt   = qq~$fb::txt{'la'}{'38'}~;
					$langdescr = qq~$fb::txt{'la'}{'79'}~;
					$langcode  = qq~up~;
				}
				else {
					$langtxt   = qq~$fb::txt{'la'}{'39'}~;
					$langdescr = qq~$fb::txt{'la'}{'42'}~;
					$langcode  = qq~gl~;
				}


				if ($langsel =~ /mod\_/) {
					my ($mod_foo, $mod_code, $mod_where) = split(/\_/, $_);
					my $sub_dest = "";
					my $code = "";
					if ($mod_where =~ m/admin/i) {
						$sub_dest = $fb::txt{'la'}{'117'};
						$code = "mod_$mod_code";
					}
					elsif ($mod_where =~ m/user/i) {
						$sub_dest = $fb::txt{'la'}{'118'};
						$code = "mod_$mod_code";
					}
					elsif ($mod_where =~ m/global/i) {
						$sub_dest = $fb::txt{'la'}{'131'};
						$code = "mod_" . $mod_code . "_gl";
					}
					else {
						$sub_dest = $fb::txt{'la'}{'127'};
						$code = "mod_$mod_code";
					}
					$langtxt  = qq~mod_$mod_code $sub_dest~;
					$langdescr = qq~$fb::txt{'la'}{'128'} $sub_dest $fb::txt{'la'}{'129'} mod_$mod_code$fb::txt{'la'}{'130'}~;
					$langcode = $code;
				}

				my $donow = 0;
				if ($langsel2 eq $langsel) {
					# this is the currently selected file
					$savetxt   = $langtxt;
					$savedescr = $langdescr;
					$savecode  = $langcode;
					$donow     = 1;
				}
				$optionssave[$start] = qq~$langtxt|$langsel|$donow~;
				$start++;
			}
		}
	
		@optionssave = sort { uc($a) cmp uc($b) } (@optionssave);
		
		# options for print of selection box
		my $options;

		foreach (@optionssave) {
			my ($langtxtit, $langselit, $select) = split(/\|/, $_);
			
			my $printsel = ($select == 1) ? " selected" : "";

			$options .= qq~<option value="$langselit"$printsel>$langtxtit</option>\n~;
		}
		
		$fb::fi{'main'} .= qq~	<table border=0 width="100%" cellspacing=1 class=fbborder cellpadding="2" align=center>
		  <tr>
			<td class=fbcatbg colspan=3><b>$fb::txt{'gl'}{'86'}</b></td></tr><tr>
		 <td class=fb2 width=33% align=center><b><a href="$fb::gl{'scriptac'}=sprach;sel=main">$fb::txt{'la'}{'91'}</a></b></td>
			<td class=fb2 width=33% align=center><b><a href="$fb::gl{'scriptac'}=sprach;sel=menu">$fb::txt{'la'}{'1'}</a></b></td><td class=fb1 align=center><b>$fb::txt{'la'}{'2'}</b></td>
		  </tr><tr><td class=fb1 colspan=3 align=center><table border=0 cellspacing=0 cellpadding=2><form action="$fb::gl{'script'}" method="GET" name="Formular">
		$fb::gl{'hiddenscro'} <input type=hidden name=action value=sprach><input type=hidden name=sel value=edit><tr><td><b>$fb::txt{'la'}{'82'}</b></td><td><select name="langsel">$options</select></td><td><select name="langchosen">~;

		# load all other languages
		my @contents2 = &opendirectory("$fb::gl{'datadir'}/language");

		@contents2 = sort { uc($a) cmp uc($b) } (@contents2);
		
		foreach my $line (@contents2) {
			if ((-d "$fb::gl{'datadir'}/language/$line") && (($line ne ".") && ($line ne ".."))) {
				
				my $selected = "";

				if ($fb::INFO{'langchosen'}) {
					if ($line eq $fb::INFO{'langchosen'}) {
						$selected = " selected";
					}
				}
				elsif ($line eq $fb::cf{'sprache'}) {
					$selected = " selected";
				}

				$fb::fi{'main'} .= qq~<option value=\"$line\"$selected>$line\n~;
			}
		}
		$fb::fi{'main'} .=
		  qq~</select></td><td><input type=submit value="$fb::txt{'gl'}{'65'}"></td></tr></form></table></td></tr></table><br>
			<table border=0 width="100%" cellspacing=1 class=fbborder cellpadding="2" align=center>
			<tr><td class=fb1 colspan=2 align=center><b>$fb::txt{'la'}{'81'}: &quot;$savetxt&quot; ($fb::txt{'la'}{'41'}: $savecode) </b><br>$savedescr</td></tr>
			<form method="post" action="$fb::gl{'scriptac'}=sprach2" name="language">
			~;

		if ($langsel2 eq "global") {
			$fb::fi{'main'} .= qq~<tr><td class=fb2 colspan=2><br><table align=center width=560 border=0 cellspacing=0 cellpadding=3>
			<tr><td colspan=2><font size=1>$fb::txt{'la'}{'40'}</font><br><input type=text name=charset value="$fb::cf{'charset'}" style="width:100%;">	
			~;
		}
		else {
			$fb::fi{'main'} .= qq~<tr><td class=fb2 colspan=2><br><table align=center width=560 border=0 cellspacing=0 cellpadding=3>
			<tr><td colspan=2>
			~;
		}
		
		#counter running through
		my $i             = 1;
		
		#counters for formatting purposes
		my $countitin     = 0;
		my $counta        = 1;
		
		my @schluessel    = keys %{$fb::txt{$savecode}};
		my @schluesselneu = sort { $a <=> $b } (@schluessel);
		
		my $allcount      = @schluesselneu;

		foreach my $key (@schluesselneu) {
			
			my $txtfile = $fb::txt{$savecode}{$key};
			$txtfile =~ s/\&/\&amp;/g;
			$txtfile =~ s/</&lt;/g;
			$txtfile =~ s/>/&gt;/g;
			$txtfile =~ s/"/&quot;/g;

			if (length($txtfile) < 60) {
				if ($counta == 1) {
					$fb::fi{'main'} .= qq~<tr><td width="280">\n~;
				}
				elsif ($counta == 2) {
					$fb::fi{'main'} .= qq~<td width="280">\n~;
				}
				$fb::fi{'main'} .= qq~<font size=1><font color=red>&lt;txt_$savecode $key&gt;:</font> 
					<font color=blue>$txtfile </font></font><br><input type=text name=txt$key value="$txtfile" style="width:100%">\n~;
			}
			else {
				if ($counta == 1) {
					$fb::fi{'main'} .= qq~<tr><td colspan=2>~;
					$counta++;
				}
				elsif ($counta == 2) {
					$fb::fi{'main'} .= qq~<td width="280">&nbsp;</td></tr><tr><td colspan=2>\n~;
				}
				my $rows = 1;
				if    (length($txtfile) > 360) { $rows = 5; }
				elsif (length($txtfile) > 270) { $rows = 4; }
				elsif (length($txtfile) > 180) { $rows = 3; }
				elsif (length($txtfile) > 90)  { $rows = 2; }

				$fb::fi{'main'} .= qq~<font size=1><font color=red>&lt;txt_$savecode $key&gt;:</font>
					<font color=blue> $txtfile</font> </font><br>
					<textarea rows=$rows cols=70 style="width:100%" type=text name=txt$key>$txtfile</textarea>\n~;
			
			}

			$fb::fi{'main'} .= qq~</td>\n~;
			
			if ($counta == 2) { $fb::fi{'main'} .= qq~</tr>\n~; $counta = 0; }
			
			$countitin++;

			if ((($countitin > 10) && ($counta == 0)) && ($i < $allcount)) {
				$countitin = 0;
				my $printkey  = $key + 1;
				$fb::fi{'main'} .= qq~<tr><td colspan=2><br><b>$printkey</b><hr></td></tr>\n~;
			}
			$counta++;
			$i++;
		}

		# additional input fields for months with global language file
		if ($langsel2 eq "global") {
			$fb::fi{'main'} .= qq~<tr><td colspan=2><br><b>$fb::txt{'la'}{'90'}</b><hr></td></tr>\n~;
			
			my $i      = 1;
			my $counta = 1;
			foreach my $month (@{$fb::txt{'months'}}) {
				if ($counta == 1) {
					$fb::fi{'main'} .= qq~<tr><td width="280">\n~;
				}
				elsif ($counta == 2) {
					$fb::fi{'main'} .= qq~<td width="280">\n~;
				}
				$fb::fi{'main'} .= qq~<font size=1>$i: $month</font><br><input type=text name=month$i value="$month" style="width:100%">\n~;
				$fb::fi{'main'} .= qq~</td>\n~;
				if ($counta == 2) {
					$fb::fi{'main'} .= qq~</tr>\n~;
					$counta = 0;
				}
				$i++;
				$counta++;
			}
		}
		
		# count up till first free language code number for new entry
		while ($fb::txt{$savecode}{$allcount}) {
			$allcount++;
		}

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td colspan=2><br><b>$fb::txt{'la'}{'85'}</b><hr></td></tr>
		<tr><td colspan=2>
			<table border=0 cellspacing=0 cellpadding=2 width=100%><tr><td width=40><i>$fb::txt{'la'}{'86'}:</i></td>
			<td><input type=text name=idnew size=3 value="$allcount"></td></tr><tr>
			<td valign=top><I>$fb::txt{'la'}{'87'}:</i></td>
			<td><textarea rows=2 cols=70 style="width:100%" type=text name=txtnew></textarea>
		</td></tr></table>
			</td></tr>
		</table><br>&nbsp;
			</td></tr>
			<tr><td class=fb4 colspan=2 align=center><input type=hidden name=langsel value="$langsel2"><input type=hidden name=langcode value="$savecode"><input type=hidden name=langchosen value="$langchosen"><input type=submit value="$fb::txt{'gl'}{'117'}"></td>
		  </tr></form>
		</table>
		~;

	}
	else {
		# main overview page for language file modifcation

		# read all available languages
		my @contents = &opendirectory("$fb::gl{'datadir'}/language");
		
		# option input for language selection box
		my $options = "";

		@contents = sort { uc($a) cmp uc($b) } (@contents);
		foreach my $line (@contents) {
			if ((-d "$fb::gl{'datadir'}/language/$line") && (($line ne ".") && ($line ne ".."))) {
				
				my $selected = "";
				if ($fb::INFO{'langchosen'}) {
					if ($line eq $fb::INFO{'langchosen'}) {
						$selected = " selected";
					}
				}
				elsif ($line eq $fb::cf{'sprache'}) {
					$selected = " selected";
				}

				$options .= qq~<option value=\"$line\"$selected>$line\n~;
			}
		}

		$fb::fi{'main'} .= qq~
			<table border=0 width="100%" cellspacing=1 class=fbborder cellpadding="2" align=center>
		  <tr>
			<td class=fbcatbg colspan=3><b>$fb::txt{'gl'}{'86'}</b></td></tr><tr>
			<td class=fb1 align=center width=33%><b>$fb::txt{'la'}{'91'}</b></td>
			<td class=fb2 width=33% align=center><b><a href="$fb::gl{'scriptac'}=sprach;sel=menu">$fb::txt{'la'}{'1'}</a></b></td><td class=fb2 align=center width=33%><b><a href="$fb::gl{'scriptac'}=sprach;sel=edit">$fb::txt{'la'}{'2'}</a></b></td>
		  </tr>
		<tr><td colspan=3 align=center class=fb1><b>$fb::txt{'la'}{'109'}</b></td></tr>
		<td class=fb2 colspan=3 align=center><br>
			<table border=0 cellspacing=0 cellpadding=2>
			<form action="$fb::gl{'scriptac'}" method="GET">
		$fb::gl{'hiddenscro'} <input type=hidden name=action value="sprach3">	
		<tr><td align=right><b>$fb::txt{'la'}{'110'}:</b></td>
			<td><select name="download">$options</select></td>
		<td><select name="was"><option value="bearbeiten">$fb::txt{'la'}{'114'}</option><option value="herunter">$fb::txt{'la'}{'113'}</option><option value="loesch">$fb::txt{'gl'}{'115'}</option></select>	
		<td><input type="submit" name="post" value="$fb::txt{'gl'}{'65'}"></td></tr></form></table><br>
			</td>
		</tr>
		<tr><td colspan=3 align=center class=fb1><b>$fb::txt{'la'}{'94'}</b></td></tr>
			<tr>
		<td class=fb2 colspan=3><br>
			<table border=0 cellspacing=0 cellpadding=1>
			<tr><td align=right valign=top width=24>1.</td><td>$fb::txt{'la'}{'95'}</td></tr>
			<tr><td align=right valign=top>2.</td><td>$fb::txt{'la'}{'96'}</td></tr>
			<tr><td align=right valign=top>3.</td><td>$fb::txt{'la'}{'97'}</td></tr>
			<tr><td align=right valign=top>4.</td><td>$fb::txt{'la'}{'102'}</td></tr>
			<tr><td align=right valign=top>5.</td><td>$fb::txt{'la'}{'98'}</td></tr>
			<tr><td align=right valign=top>6.</td><td>$fb::txt{'la'}{'99'}</td></tr>
			<tr><td align=right valign=top>7.</td><td>$fb::txt{'la'}{'100'}</td></tr>
			<tr><td align=right valign=top>8.</td><td>$fb::txt{'la'}{'101'}</td></tr>
			<tr><td align=right valign=top>9.</td><td>$fb::txt{'la'}{'106'}</td></tr>
			<tr><td align=right valign=top>10.</td><td>$fb::txt{'la'}{'108'}</td></tr>
			</table><br>
			</td>
			</tr>
			<form action="$fb::gl{'scriptac'}=sprach3" method="POST" name="fiform" ENCTYPE="multipart/form-data">
			<tr><td colspan=3 align=center class=fb1><b>$fb::txt{'la'}{'111'}</b></td></tr>	<tr>
			<td class=fb2 colspan=3 align=center>
				<table border=0 cellspacing=0 cellpadding=2>
							<tr>
								<td valign="top" width="35%" align=right>
									<b>$fb::txt{'la'}{'110'}:</b>&nbsp;
								</td>
								<td><input type="file" name="file" size="49"></td>
							</tr>
							<tr>
								<td align="right"></td>
								<td><font size="1">$fb::txt{'la'}{'115'}</font></td>
							</tr>
									</table>
				</td></tr>
			<tr><td colspan=3 class=fb4 align=center><input type="submit" name="post" value="$fb::txt{'gl'}{'117'}"></td></tr></form>
			<tr><td colspan=3 class=fb2 height=5></td></tr>
			<form action="$fb::gl{'scriptac'}=sprach3" method="POST" name="fiform" ENCTYPE="multipart/form-data">
			<tr><td colspan=3 align=center class=fb1><b>$fb::txt{'la'}{'103'}</b></td></tr>	<tr>
			<td class=fb2 colspan=3 align=center>
				<table border=0 cellspacing=0 cellpadding=2>
				<tr><td align=right width=35%><b>$fb::txt{'la'}{'105'}:</b></td><td><input type=text name=neuspr value=""></td>
				</tr><tr><td align=right><b>$fb::txt{'la'}{'104'}:</b></td><td><select name="neulang">$options</select></td></tr>
				<tr><td align=right><b>$fb::txt{'la'}{'107'}:</b></td><td><input type="file" name="file" size="49"></td></tr></table>
				</td></tr>
			<tr><td colspan=3 class=fb4 align=center><input type="submit" name="post" value="$fb::txt{'gl'}{'117'}"></td></tr></form>



			</table>~;

	}
	&adminschluss;
	&template;
}

sub sprach2 {
	&isadmin;

	my $langsel = $fb::FORM{'langsel'};
	unless ($langsel) { &fatal_error($fb::txt{'la'}{'83'}); }

	$langsel =~ /^(\w+)$/;
	$langsel = $1;

	my $langcode = $fb::FORM{'langcode'};
	unless ($langcode) { &fatal_error($fb::txt{'la'}{'84'}); }
	
	my $langchosen = $fb::FORM{'langchosen'} || $fb::cf{'sprache'};

	$langchosen =~ /^(\w+)$/;
	$langchosen = $1;

	require "$fb::gl{'datadir'}/language/$langchosen/$langsel.lng";
	
	my @schluessel    = keys %{$fb::txt{$langcode}};
	my @schluesselneu = sort { $a <=> $b } (@schluessel);
	
	# that's where we are going to write the language file to
	my $printline = "";

	foreach my $key (@schluesselneu) {
		my $entry = "txt$key";
		$fb::FORM{$entry} =~ s/\\/\\\\/g;
		$fb::FORM{$entry} =~ s/"/\\"/g;
		$fb::FORM{$entry} =~ s/\n/\\n/g;
		$fb::FORM{$entry} =~ s/\r/\\r/g;
		$fb::FORM{$entry} =~ s/\@/\\@/g;
		$fb::FORM{$entry} =~ s/\{/\\{/g;
		$fb::FORM{$entry} =~ s/\}/\\}/g;
		$fb::FORM{$entry} =~ s/\~/\\~/g;
		if ($fb::FORM{$entry}) {
			$printline .= qq~'$key' => "$fb::FORM{$entry}",\n~;
		}
	}

	# additional global lang file output
	my $printline2 = "";
	
	if ($langsel eq "global") {
		# additional output of months for global language file

		for (my $i = 1 ; $i < 13 ; ++$i) {
			my $entry = "month$i";
			$fb::FORM{$entry} =~ s/\\/\\\\/g;
			$fb::FORM{$entry} =~ s/"/\&quot;/g;
			$fb::FORM{$entry} =~ s/\n//g;
			$fb::FORM{$entry} =~ s/\r//g;
			$fb::FORM{$entry} =~ s/@/\@/g;
			$fb::FORM{$entry} =~ s/{/\{/g;
			$fb::FORM{$entry} =~ s/}/\}/g;
			$fb::FORM{$entry} =~ s/~/\~/g;
			$printline2 .= qq~'$fb::FORM{$entry}',~;
		}
		chop($printline2);

	}

	if ($fb::FORM{'txtnew'}) {
		# new text additions

		my $idnew   = $fb::FORM{'idnew'};
		my $keytest = qq~txt$idnew~;
		
		if ($fb::FORM{$keytest}) {
			&fatal_error($fb::txt{'la'}{'88'});
		}
		if ($idnew =~ m/\D/g) { &fatal_error($fb::txt{'la'}{'89'}); }
		
		$fb::FORM{'txtnew'} =~ s/"/\&quot;/g;
		$fb::FORM{'txtnew'} =~ s/\\/\\\\/g;
		$fb::FORM{'txtnew'} =~ s/\n/\\n/g;
		$fb::FORM{'txtnew'} =~ s/\r/\\r/g;
		$fb::FORM{'txtnew'} =~ s/\@/\\@/g;
		$fb::FORM{'txtnew'} =~ s/\{/\\{/g;
		$fb::FORM{'txtnew'} =~ s/\}/\\}/g;
		$fb::FORM{'txtnew'} =~ s/\~/\\~/g;
		$printline .= qq~'$idnew' => "$fb::FORM{'txtnew'}",\n~;
	}

	# that's the complete lang file string
	my $printwhole = "";

	if ($langsel eq "global") {
		# charset additon for global lang file
		$printwhole .= qq~\n\$fb::cf{'charset'} = qq\~$fb::FORM{'charset'}\~\;\n~;
	}

	$printwhole .= qq~\%{\$fb::txt{'$langcode'}} =(\n$printline);~;

	if ($langsel eq "global") {
		$printwhole .= qq~\n\@{\$fb::txt{'months'}} = ($printline2);~;
	}

	$printwhole .= qq~\n1;~;

	&writefile("$fb::gl{'datadir'}/language/$langchosen/$langsel.lng", $printwhole);

	my $set_location = "$fb::gl{'scriptac'}=sprach;sel=edit;langchosen=$langchosen;langsel=$langsel";
	&redirect($set_location);
}

sub sprach3 {
	
	# handling quick director for main overview page

	&isadmin;

	my $was = $fb::FORM{'was'} || $fb::INFO{'was'};
	my $download = $fb::FORM{'download'} || $fb::INFO{'download'};

	if ($download) {

		if ($was eq "bearbeiten") {

			$fb::INFO{'was'}        = "sprach";
			$fb::INFO{'sel'}        = "edit";
			$fb::INFO{'langsel'}    = "global";
			$fb::INFO{'langchosen'} = $download;
			&sprach;

		}
		elsif ($was eq "herunter") {
			# language file export

			my $dlang     = $download;
			my $unique_id = time;

			my @contents = &opendirectory("$fb::gl{'datadir'}/language/$dlang");

			# stores all language files
			my @languagefiles = "";
			
			foreach my $line (@contents) {
				if (($line ne ".") && ($line ne "..")) {
					my @thistemp = &openfile("$fb::gl{'datadir'}/language/$dlang/$line", "1");
					my $filedeklaration = qq~$pushatlang-$fb::gl{'thisscriptcode'}-$fb::gl{'thisversion'}-$unique_id-language-$dlang-$line-$pushatlang2~;
					push(@languagefiles, $filedeklaration);
					push(@languagefiles, @thistemp);
				}
			}
			my $type = "";
			if (-e "$fb::cf{'bilderdir'}/skins/$fb::cf{'skinchosen'}/lang/$dlang.gif") {
				$type = "gif";
			}
			elsif (-e "$fb::cf{'bilderdir'}/skins/$fb::cf{'skinchosen'}/lang/$dlang.jpg") {
				$type = "jpg";
			}
			elsif (-e "$fb::cf{'bilderdir'}/skins/$fb::cf{'skinchosen'}/lang/$dlang.jpeg") {
				$type = "jpeg";
			}
			elsif (-e "$fb::cf{'bilderdir'}/skins/$fb::cf{'skinchosen'}/lang/$dlang.bmp") {
				$type = "bmp";
			}
			elsif (-e "$fb::cf{'bilderdir'}/skins/$fb::cf{'skinchosen'}/lang/$dlang.png") {
				$type = "png";
			}

			if ($type) {
				my @thistemp = &openfile("$fb::cf{'bilderdir'}/skins/$fb::cf{'skinchosen'}/lang/$dlang.$type", "1");
				my $filedeklaration = qq~$pushatlang-$fb::gl{'thisscriptcode'}-$fb::gl{'thisversion'}-$unique_id-languagegif-$dlang-$dlang.$type-$pushatlang2~;
				push(@languagefiles, $filedeklaration);
				push(@languagefiles, @thistemp);
			}
			&writefile( "$fb::cf{'bilderdir'}/temp/$dlang.lang",undef, "", \@languagefiles, "1" );
			chmod( 0777, "$fb::cf{'bilderdir'}/temp/$dlang.lang" );
		
			# prepare for download

			my @stat = stat("$fb::cf{'bilderdir'}temp/$dlang.lang");
			my $filesize = $stat[7];
			$fb::gl{'thisversion'} =~ s/\.//ig;
			
			my $newfilename = $fb::gl{'thisscriptcode'} . "_" . $fb::gl{'thisversion'} . "_" . $dlang . ".lang";
		
		print "Content-disposition: inline; filename=$newfilename\n";
		print "Content-Length: $filesize\n";
		print "Content-Type: multipart/form-data; name=$newfilename\n\n";

			open( READ, "$fb::cf{'bilderdir'}/temp/$dlang.lang" ) || die;
		binmode READ;
		binmode STDOUT;
		while (<READ>) { print; }
		close(READ);
			&dounlink("$fb::cf{'bilderdir'}/temp/$dlang.lang");
		&database_disconnect;
		exit;
		}
		elsif ($was eq "loesch") {
			# delete a language

			my $loesche = $download;

			my @contents = &opendirectory("$fb::gl{'datadir'}/skins");
			
			# delete language icon from skins
			foreach my $line (@contents) {
				if ((-d "$fb::gl{'datadir'}/skins/$line") && ($line ne ".") && $line ne "..") {
					my $type;
					if (-e "$fb::cf{'bilderdir'}/skins/$line/lang/$loesche.gif") {
						$type = "gif";
					}
					elsif (-e "$fb::cf{'bilderdir'}/skins/$line/lang/$loesche.jpg") {
						$type = "jpg";
					}
					elsif (-e "$fb::cf{'bilderdir'}/skins/$line/lang/$loesche.jpeg") {
						$type = "jpeg";
					}
					elsif (-e "$fb::cf{'bilderdir'}/skins/$line/lang/$loesche.bmp") {
						$type = "bmp";
					}
					elsif (-e "$fb::cf{'bilderdir'}/skins/$line/lang/$loesche.png") {
						$type = "png";
					}
					if ($type) {
						&dounlink("$fb::cf{'bilderdir'}/skins/$line/lang/$loesche.$type");
					}
				}
			}
			
			# delete language files
			my @contents2 = &opendirectory("$fb::gl{'datadir'}/language/$loesche");

			foreach my $line (@contents2) {
				unless (($line eq ".") || ($line eq "..")) {
					&dounlink("$fb::gl{'datadir'}/language/$loesche/$line");
				}
			}
			rmdir("$fb::gl{'datadir'}/language/$loesche");

			my $set_location = "$fb::gl{'scriptac'}=sprach";
			&redirect($set_location);

		}
	}
	if ($fb::FORM{'neulang'}) {
		# this is the creation of a new language pack by copy

		my $neuspr  = $fb::FORM{'neuspr'};
		my $neulang = $fb::FORM{'neulang'} || $fb::cf{'sprache'};

		unless ($fb::FORM{'file'}) { &fatal_error($fb::txt{'la'}{'112'}); }
		unless ($neuspr)           { &fatal_error($fb::txt{'la'}{'92'}); }
		unless ($neuspr =~ m/^[a-z]+$/) {
			&fatal_error("$fb::txt{'la'}{'93'}");
		}
		use File::Copy;
		
		# prepare upload of language button
		my $upload_dir = "$fb::cf{'bilderdir'}/skins/admin/lang";

		my @ext = qw(jpg gif bmp png jpeg);
		require "$fb::gl{'subsdir'}/upload.pl";

		my @fullfile = split(/\./, $fb::FORM{'file'});
		my $changed_filename = "$neuspr.$fullfile[$#fullfile]";

		my $write_file = &upload::uploadcheck($upload_dir, "1", \@ext, $changed_filename);

		my $fixfile = &upload::doupload;
		
		# copy language button to all skins
		my @contents = &opendirectory("$fb::gl{'datadir'}/skins");

		foreach my $line (@contents) {
			if ((-d "$fb::gl{'datadir'}/skins/$line") && ($line ne ".") && $line ne "..") {
				unless (-e "$fb::cf{'bilderdir'}/skins/$line/lang/$fixfile") {
					copy("$fb::cf{'bilderdir'}/skins/admin/lang/$fixfile", "$fb::cf{'bilderdir'}/skins/$line/lang/$fixfile");
				}
			}
		}

		# copy language files from other language

		my @contents2 = &opendirectory("$fb::gl{'datadir'}/language/$neulang");

		mkdir "$fb::gl{'datadir'}/language/$neuspr", 0777;

		foreach my $line (@contents2) {
			my ($name, $extension) = split(/\./, $line);
			if (($extension eq "txt") || ($extension eq "lng")) {
				copy("$fb::gl{'datadir'}/language/$neulang/$line", "$fb::gl{'datadir'}/language/$neuspr/$line");
				chmod(0666, "$fb::gl{'datadir'}/language/$neuspr/$line");
			}
		}

		my $set_location = "$fb::gl{'scriptac'}=sprach;sel=edit;langsel=global;langchosen=$neuspr";
		&redirect($set_location);

	}
	else {
		
		# skin file import

		if ($fb::FORM{'file'}) {

			my $upload_dir = "$fb::cf{'bilderdir'}/temp";

			my @ext = qw(lang);
			require "$fb::gl{'subsdir'}/upload.pl";
			&upload::uploadcheck($upload_dir, "1", \@ext);
			my $fixfile = &upload::doupload;

			my $write_file = "$upload_dir/$fixfile";
			chmod(0777, $write_file);
			
			# the imported language file
			my @result = &openfile("$write_file", "1");

			# split by single files
			my $wholelangfile = join("\n", @result);
			my @langfile = split(/$pushatlang/, $wholelangfile);
			
			
			my ($langfilename, $folder1, $langid, $madedirectories);

			# current file
			my $printthisfile;

			# ids for matching check
			my ($newlangid, $newuniqueid);

			foreach my $line (@langfile) {

				if ($line =~ m/(.*?)$pushatlang2(.*?)/sgi) {
					
					if ($langfilename) { 
						# we are at the next langfile now, write the old one
						if (!&writelangfile($folder1, $langid, $printthisfile, $langfilename)) {
							&dounlink("$write_file");
							my $set_location = qq~$fb::gl{'scriptac'}=sprach3;was=loesch;download=$newlangid~;
							&redirect($set_location);
						}
					}

					my @testlangfile  = split(/$pushatlang2/, $line);
					my $splitline     = $testlangfile[0];
					$printthisfile = $testlangfile[1];
					
					my ($scriptname, $scriptversion, $uniqueid);
					(my $nothing, $scriptname, $scriptversion, $uniqueid, $folder1, $langid, $langfilename) = split(/\-/, $splitline);

					if (($scriptname ne $fb::gl{'thisscriptcode'}) || ($fb::gl{'thisversion'} !~ m/^$scriptversion/i)) {
						# language file is imported from another script version
						&dounlink("$write_file");
						&fatal_error($fb::txt{'la'}{'116'});
					}
					if ($madedirectories) {
						if (($langid ne $newlangid) || ($newuniqueid ne $uniqueid)) {
							# ids do not match
							&dounlink("$write_file");
							my $set_location = qq~$fb::gl{'scriptac'}=sprach3;was=loesch;download=$newlangid~;
							&redirect($set_location);
						}
					}
					else {
						if (-d "$fb::gl{'datadir'}/language/$langid") {
							# language is already existing
							&dounlink("$write_file");
							&fatal_error("$fb::txt{'la'}{'123'} &raquo; $langid");
						}
						mkdir "$fb::gl{'datadir'}/language/$langid", 0777;
						$madedirectories = 1;
					}
					$newlangid   = $langid;
					$newuniqueid = $uniqueid;
				}
			}
			if ($langfilename) {
				if (!&writelangfile($folder1, $langid, $printthisfile, $langfilename)) {
					&dounlink("$write_file");
					my $set_location = qq~$fb::gl{'scriptac'}=sprach3;was=loesch;download=$newlangid~;
					&redirect($set_location);
				}
			}
			else {
				&dounlink("$write_file");
				&fatal_error("$fb::txt{'la'}{'116'}");
			}
			&dounlink("$write_file");
			my $set_location = qq~$fb::gl{'scriptac'}=sprach;sel=edit;langsel=global;langchosen=$langid~;
			&redirect($set_location);

		}
		else {
			my $set_location = "$fb::gl{'scriptac'}=sprach";
			&redirect($set_location);
		}

	}
}

sub writelangfile {

	my $folder1 = $_[0];
	my $langid = $_[1];
	my $printthisfile = $_[2];
	my $langfilename = $_[3];

	if (($folder1 eq "language") && ($langid ne "")) {
		unless (-e "$fb::gl{'datadir'}/language/$langid/$langfilename") {
			$printthisfile =~ s/\r\n/\n/g;
			$printthisfile =~ s/\r/\n/g;
			&writefile("$fb::gl{'datadir'}/language/$langid/$langfilename", $printthisfile);
			chmod(0666, "$fb::gl{'datadir'}/language/$langid/$langfilename");
		}
		return 1;
	}
	elsif (($folder1 eq "languagegif") && ($langid ne "")) {
		
		# write language button for all skins

		my @contents = &opendirectory("$fb::gl{'datadir'}/skins");

		foreach my $line (@contents) {
			if ((-d "$fb::gl{'datadir'}/skins/$line") && ($line ne ".") && ($line ne "..")) {
				unless (-e "$fb::cf{'bilderdir'}/skins/$line/lang/$langfilename") {
					&writefile("$fb::cf{'bilderdir'}/skins/$line/lang/$langfilename", $printthisfile,undef,undef,"1");
					chmod(0666, "$fb::cf{'bilderdir'}/skins/$line/lang/$langfilename");
				}
			}
		}
		return 1;
	}

	return 0;
}
1;
