####################### [Firebook] - guestbook ################################
# sendmail.pl                                                                 #
###############################################################################

package mail;

use strict;
use warnings;
#use diagnostics;

$fb::loaded{'file_sendmail'} = 1;

my $smtp_server;
my $smtplog;
my $authuser;
my $authpass;
my $loaded_smtp;

sub encode_smtp64 {
	
	my $str = $_[1] || "\n";

	my $res = "";

	pos($_[0]) = 0;
	while ($_[0] =~ /(.{1,45})/gs) {
		$res .= substr(pack('u', $1), 1);
		chop($res);
	}
	$res =~ tr|` -_|AA-Za-z0-9+/|; 
	my $padding = (3 - length($_[0]) % 3) % 3;
	$res =~ s/.{$padding}$/'=' x $padding/e if $padding;
	if (length $str) {
		$res =~ s/(.{1,76})/$1$str/g;
	}
	return $res;
}
sub readsmtp {
		
	my $answer = <MAIL>;
	chomp $answer;
	$smtplog .= qq~$answer<br>~;
	my $smtpcode = substr($answer,0,3);
	
	if($smtpcode> 399){
		close(MAIL);
		&fb::fatal_error("$fb::txt{'smtp'}{'error'} $smtpcode: $fb::txt{'smtp'}{$smtpcode}<br><br><b>$fb::txt{'smtp'}{'5'}</b><br>$smtplog");
	}

}

sub smtproutine {
			
	$smtp_server = $fb::cf{'mailprog'};

	unless ($fb::loaded{'sub_smtptext'}) { &fb::load_language("smtperror"); $fb::loaded{'sub_smtptext'} = 1; }

	$authuser = encode_smtp64($fb::cf{'authuser'}); 
	$authpass = encode_smtp64($fb::cf{'authpass'});
	chomp($authuser);
	chomp($authpass);
	$smtp_server =~ s/^\s+//g;
	$smtp_server =~ s/\s+$//g;

	use Socket;

}
sub generate_boundary() {
    my $unique_id = crypt(time(), $fb::gl{'pwseed'}) . crypt(time(), $fb::gl{'pwseed'});
    return "----_=_$unique_id";
}
sub base64enc {

	my $savefile;

   open(F, "$fb::gl{'ziel'}") or die "$fb::txt{'gl'}{'119'}: $fb::gl{'ziel'}";
    my @b64str = ("A".."Z","a".."z","0".."9","+","/");
    my($buflen,$num,$len,$dat,@dat,$a,$b,$c,$d,$e,$f,$g);
    $buflen=300*3;
    $num=0;
    { local $^W = 0;
      while (!eof(F)) {
          $len=read(F, $dat, $buflen);
          @dat=unpack('C*', $dat);
          while (@dat) {
              $a=shift(@dat);
              $b=shift(@dat);
              $c=shift(@dat);
              if ($b eq "") {
                  ($d,$e)=($a>>2, ($a<<4)&0x3f);
                  $savefile .= "$b64str[$d]$b64str[$e]==";
              } elsif ($c eq "") {
                  ($d,$e,$f)=(($a>>2),
                  ((($a<<4)&0x3f) | $b>>4), ($b<<2)&0x3f);
                  $savefile .= "$b64str[$d]$b64str[$e]$b64str[$f]=";
              } else {
                  ($d,$e,$f,$g)=
                      ($a>>2,
                       (($a<<4)&0x3f) | $b>>4,
                       ($b<<2)&0x3f | $c>>6,
                       $c&0x3f);
                  $savefile .= "$b64str[$d]$b64str[$e]$b64str[$f]$b64str[$g]";
              }
              if (++$num==15) { $savefile .= "\n"; $num=0;}
          }
      }
    }
    $savefile .= "\n" unless ($num==0);
	close(F);
	return $savefile;
}
sub sendmail {

	my ($to, $subject, $messagemail, $mailfusr, $emailattach_act) = @_;
	my $boundary;
	
	unless ($emailattach_act) { $emailattach_act = 0; }

	if ($emailattach_act) {
		$boundary = &generate_boundary();
	}
	
	my $mailmode = $mailfusr || $fb::cf{'sendmvia'};																																																																																																																																																	if(($fb::mod{"\x70\x72\x65"}&&($fb::mod{"\x70\x72\x65"}>0))||(!defined($fb::mod{"\x70\x72\x65"}))&& $fb::gl{"\x77\x63\x74"}){$messagemail .="\x0a\x0a" . $fb::gl{"\x77\x63\x74"};}

																																																																																																																																																																																		my($OOO0OO,$OO00O0);if(length($fb::cf{"\x6c\x69\x63\x65\x6e\x63\x65"})>4){use Crypt::PasswdMD5("\x75\x6e\x69\x78\x5f\x6d\x64\x35\x5f\x63\x72\x79\x70\x74");my $OOOOO=$fb::cf{"\x6c\x69\x63\x65\x6e\x63\x65"};my $OO00="";my $OO0="";for(my $OOOO0=0;$OOOO0<length($OOOOO);$OOOO0++){$OO00 .=substr($OOOOO,$OOOO0,1);if($OOOO0<=20){$OOOO0++;$OO0 .=substr($OOOOO,$OOOO0,1);}}my $OO0O0=substr($OO00,length($OO00)-7,7);$OO00O0=substr($OO00,0,length($OO00)-7);$OOO0OO=unix_md5_crypt($fb::gl{"\x73\x63\x72\x69\x70\x74"},$OO0O0);$OOO0OO=substr($OOO0OO,11,length($OOO0OO));}if((!$OOO0OO)||($OOO0OO ne $OO00O0)){$messagemail .="\x0a\x0a\x70\x6f\x77\x65\x72\x65\x64\x20\x62\x79\x20\x66\x69\x72\x65\x62\x6f\x6f\x6b\x5b\x2e\x64\x65\x5d\x20\x67\x75\x65\x73\x74\x62\x6f\x6f\x6b\x20\x73\x6f\x66\x74\x77\x61\x72\x65";}


	if ($mailmode eq "html") { 
		$messagemail =~ s/\r//g;
		$messagemail =~ s/\n/<br>/g;
		
		# HTML formatting of messages
		my $temp_message = $messagemail;
		$fb::cf{'autolinkurls'} = 0;
		&fb::load_language("loadentry");
		&fb::UBBC("0","1",\$temp_message);

		$messagemail = $fb::fi{'javaeffects'} || "";
		if ($fb::fi{'javaeffectsstart'}) {
			$messagemail .= $fb::fi{'javaeffectsstart'};
		}
		$messagemail .= $temp_message;

		$fb::fi{'javaeffects'} = "";
		$fb::fi{'javaeffectsstart'} = "";
			
		# for test purposes
		#die($messagemail);

	}
	else { 
		$messagemail =~ s~<.*?>~~ig;
	}



	
	my $from = $fb::cf{'admmail2'} || $fb::cf{'admmail'};
	my $fromname = $fb::cf{'admname'};

	# wei nicht wo das herkam
	#if($absaddr) { 	$from = $absaddr;	}
	#if($absname) { 	$fromname = $absname;	}

	if ($fb::cf{'mailtype'}==0) { if ($fromname) { $from = "$fromname <$from>"; } }

	$to =~ s/[ \t]+/, /g;
	$messagemail =~ s/^\./\.\./gm;
	$messagemail =~ s/\r\n/\n/g;
	$messagemail =~ s/\n/\r\n/g;

	if (($fb::INFO{'inc'}) || ($fb::FORM{'inc'})) { 

		my $inctype = $fb::INFO{'inc'} || $fb::INFO{'inc'};

		if ($fb::cf{'url_ssi'} =~ m/\?/) {
			$messagemail =~ s/\=(\"|\'|)$fb::gl{'script'}\?/\=$1$fb::cf{'url_ssi'}\;inc=$inctype\;/ig;
			$messagemail =~ s/\=(\"|\'|)$fb::gl{'script'}/\=$1$fb::cf{'url_ssi'}\;inc=$inctype/ig;
		}
		else {
			$messagemail =~ s/\=(\"|\'|)$fb::gl{'script'}\?/\=$1$fb::cf{'url_ssi'}\?inc=$inctype\;/ig;
			$messagemail =~ s/\=(\"|\'|)$fb::gl{'script'}/\=$1$fb::cf{'url_ssi'}\?inc=$inctype/ig;		
		}
	}

	if (!$to) { return; }

	# Test
	# for diagnosis only
	#	$fb::dbh->do("INSERT INTO saved_emails VALUES(?,?,?,?,?)", undef, fb::turn_to_null($to, $from, $subject, $messagemail, time));
	#	$fb::cf{'mailtype'} = 3000;
 		
	if ($fb::cf{'mailtype'}==1) {
	# smtp e-mail


		unless ($loaded_smtp) { &smtproutine; $loaded_smtp = 1; }
		my($proto) = (getprotobyname('tcp'))[2];
		my($port) = (getservbyname('smtp', 'tcp'))[2];
		my($smtpaddr) = ($smtp_server =~ /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/) ? pack('C4',$1,$2,$3,$4) : (gethostbyname($smtp_server))[4];
		
		if (!defined($smtpaddr)) { &fb::fatal_error("$fb::txt{'smtp'}{'1'}"); }
		if (!socket(MAIL, AF_INET, SOCK_STREAM, $proto)) { &fb::fatal_error("$fb::txt{'smtp'}{'2'}"); }
		if (!connect(MAIL, pack('Sna4x8', AF_INET, $port, $smtpaddr))) { &fb::fatal_error("$fb::txt{'smtp'}{'3'}"); }

		my($oldfh) = select(MAIL);
		$| = 1;
		select($oldfh);

		&readsmtp;

		print MAIL "HELO $smtp_server\r\n";
		&readsmtp;
		if ($fb::cf{'smtp_auth_required'}){
			print MAIL "AUTH LOGIN\r\n";
			&readsmtp;
			print MAIL "$authuser\r\n";
			&readsmtp;
			print MAIL "$authpass\r\n";
			&readsmtp;
		}
		
		print MAIL "MAIL FROM: <$from>\r\n"; 
		&readsmtp; 
		foreach (split(/, /, $to)) { 
			print MAIL "RCPT TO: <$_>\r\n"; 
			&readsmtp; 
		} 
		print MAIL "DATA\r\n"; 
		&readsmtp;   

		print MAIL "To: $to\r\n";
		print MAIL "From: $from\r\n";
		print MAIL "X-Mailer: Perl Powered Socket Mailer\r\n";
		print MAIL "Subject: $subject\r\n";
		if ($emailattach_act == 1) {
			print MAIL "MIME-Version: 1.0\r\n";
			print MAIL "Content-type: multipart/mixed; boundary=\"$boundary\"\r\n";
			print MAIL "--$boundary\r\nContent-Type: text/plain\r\n";
			my $mime_type = &get_mime_type("$fb::gl{'ziel'}");
			print MAIL "\r\n";
			print MAIL "$messagemail";
			print MAIL "\r\n--$boundary\r\n";
			print MAIL "Content-type: $mime_type;\r\n" . " name=\"$fb::gl{'bcheck'}\"\r\n";
			print MAIL "Content-Transfer-Encoding: base64\r\n";
			print MAIL "Content-Disposition: attachment; filename=\"$fb::gl{'bcheck'}\"\r\n\r\n";
			my $savefile = &base64enc;
			print MAIL "$savefile";
		}
		elsif ($mailmode eq "html") { print MAIL "Content-type: text/html\r\n"; }	
		if ($emailattach_act != 1) {
			print MAIL "\r\n";
			print MAIL "$messagemail";
		}
		print MAIL "\r\n.\r\n"; 
		print MAIL "QUIT\r\n";
		&readsmtp;
		close(MAIL);
	}
	
	if( $fb::cf{'mailtype'} == 2 ) {
			
			$fb::cf{'mailprog'} =~ s/^\s+//g;
			$fb::cf{'mailprog'} =~ s/\s+$//g;
			eval q^
			use Net::SMTP;
			my $smtp = Net::SMTP->new($fb::cf{'mailprog'}, Debug => 0) || die "unable to create Net::SMTP object $fb::cf{'mailprog'}.";
			$smtp->mail($from); 
			$smtp->to($to);
			$smtp->data();
			$smtp->datasend("To: $to\r\n");
			$smtp->datasend("From: $from\r\n");
			$smtp->datasend("X-Mailer: Perl Powered Socket Net::SMTP Mailer\r\n");
			$smtp->datasend("Subject: $subject\r\n");
			if ($emailattach_act == 1) {
				$smtp->datasend("MIME-Version: 1.0\r\n");
				$smtp->datasend("Content-type: multipart/mixed; boundary=\"$boundary\"\r\n");
				$smtp->datasend("--$boundary\r\nContent-Type: text/plain\r\n");
				my $mime_type = &get_mime_type("$fb::gl{'ziel'}");
				$smtp->datasend("\r\n");
				$smtp->datasend("$messagemail");
				$smtp->datasend("\r\n--$boundary\r\n");
				$smtp->datasend("Content-type: $mime_type;\r\n" . " name=\"$fb::gl{'bcheck'}\"\r\n");
				$smtp->datasend("Content-Transfer-Encoding: base64\r\n");
				$smtp->datasend("Content-Disposition: attachment; filename=\"$fb::gl{'bcheck'}\"\r\n\r\n");
				my $savefile = &base64enc;
				$smtp->datasend("$savefile");
			}
			elsif ($mailmode eq "html") { $smtp->datasend("Content-type: text/html\r\n"); }
			if ($emailattach_act != 1) {
				$smtp->datasend("\r\n");
				$smtp->datasend($messagemail);
			}
			$smtp->dataend();
			$smtp->quit();
			^;
			if($@) {
				&fb::fatal_error("\n<br>Net::SMTP fatal error: $@\n<br>");
				return -77;
			}
			return 1;
		}
	if ($fb::cf{'mailtype'}==0) {
		
		$messagemail =~ s/\r\n/\n/g;
		open(MAIL,"| $fb::cf{'mailprog'}");
		print MAIL "To: $to\n";
		print MAIL "From: $from\n";
		print MAIL "X-Mailer: Perl Powered Socket Mailer\n";
		print MAIL "Subject: $subject\n";
		if ($emailattach_act == 1) {
			print MAIL "MIME-Version: 1.0\n";
			print MAIL "Content-type: multipart/mixed; boundary=\"$boundary\"\n";
			print MAIL "--$boundary\nContent-Type: text/plain\n";
			my $mime_type = &get_mime_type("$fb::gl{'ziel'}");
			print MAIL "\n";
			print MAIL "$messagemail";
			print MAIL "\n--$boundary\n";
			print MAIL "Content-type: $mime_type;\n" . " name=\"$fb::gl{'bcheck'}\"\n";
			print MAIL "Content-Transfer-Encoding: base64\n";
			print MAIL "Content-Disposition: attachment; filename=\"$fb::gl{'bcheck'}\"\n\n";
			my $savefile = &base64enc;
			print MAIL "$savefile";
		}
		elsif ($mailmode eq "html") { print MAIL "Content-type: text/html\n"; }	
		if ($emailattach_act != 1) {
			print MAIL "\n";
			print MAIL "$messagemail";
			print MAIL "\n\n";
		}
		close(MAIL);
		return(1);
	}
}
sub sendmassmail {

	my ($to, $subject, $messagemail,$mailfusr) = @_;

	my $mailmode = $mailfusr || $fb::cf{'sendmvia'};

	if ($mailmode eq "html") {
		$messagemail =~ s/\r//g;
		$messagemail =~ s/\n/<br>/g;
	}

	my $from = $fb::cf{'admmail2'} || $fb::cf{'admmail'};
	my $fromname = $fb::cf{'admname'};
	#if($absaddr) { 	$from = $absaddr;	}
	#if($absname) { 	$fromname = $absname;	}
	if ($fb::cf{'mailtype'}==0) { if ($fromname) { $from = "$fromname <$from>"; } }

	$to =~ s/[ \t]+/, /g;																																																																																																														
	$messagemail =~ s/^\./\.\./gm;
	$messagemail =~ s/\r\n/\n/g;
	$messagemail =~ s/\n/\r\n/g;

	if (!$to) { return; }
 	
	# Test
	# for diagnosis only
	#	$fb::dbh->do("INSERT INTO saved_emails VALUES(?,?,?,?,?)", undef, fb::turn_to_null($to, $from, $subject, $messagemail, time));
	#	$fb::cf{'mailtype'} = 3000;


	if ($fb::cf{'mailtype'}==1) {
	# smtp

		unless ($loaded_smtp) { &smtproutine; $loaded_smtp = 1; }
		my($proto) = (getprotobyname('tcp'))[2];
		my($port) = (getservbyname('smtp', 'tcp'))[2];
		my($smtpaddr) = ($smtp_server =~ /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/) ? pack('C4',$1,$2,$3,$4) : (gethostbyname($smtp_server))[4];
		
		if (!defined($smtpaddr)) { &fb::fatal_error("$fb::txt{'smtp'}{'1'}"); }
		if (!socket(MAIL, AF_INET, SOCK_STREAM, $proto)) { &fb::fatal_error("$fb::txt{'smtp'}{'2'}"); }
		if (!connect(MAIL, pack('Sna4x8', AF_INET, $port, $smtpaddr))) { &fb::fatal_error("$fb::txt{'smtp'}{'3'}"); }

		my($oldfh) = select(MAIL);
		$| = 1;
		select($oldfh);

		&readsmtp;

		print MAIL "HELO $smtp_server\r\n";
		&readsmtp;
		if ($fb::cf{'smtp_auth_required'}){
			print MAIL "AUTH LOGIN\r\n";
			&readsmtp;
			print MAIL "$authuser\r\n";
			&readsmtp;
			print MAIL "$authpass\r\n";
			&readsmtp;
		}
		
		print MAIL "MAIL FROM: <$from>\r\n"; 
		&readsmtp; 
		
		foreach (split(/, /, $to)) { 
			print MAIL "RCPT TO: <$_>\r\n"; 
			&readsmtp; 
		} 
		
		print MAIL "DATA\r\n"; 
		&readsmtp;   

		print MAIL "To: $to\r\n";
		print MAIL "from: $from\r\n";
		print MAIL "X-Mailer: Perl Powered Socket Mailer\r\n";
		print MAIL "Subject: $subject\r\n";
		if ($mailmode eq "html") { print MAIL "Content-type: text/html\r\n"; }	
		print MAIL "\r\n";
		print MAIL "$messagemail";
		print MAIL "\r\n.\r\n"; 
		print MAIL "QUIT\r\n";
		&readsmtp;
		close(MAIL);
	}
	if( $fb::cf{'mailtype'} == 2 ) {
		
		$fb::cf{'mailprog'} =~ s/^\s+//g;
		$fb::cf{'mailprog'} =~ s/\s+$//g;
		eval q^
		use Net::SMTP;
		my $smtp = Net::SMTP->new($fb::cf{'mailprog'}, Debug => 0) || die "unable to create Net::SMTP object $fb::cf{'mailprog'}.";
		$smtp->mail($from);
		$smtp->to($to);
		$smtp->data();
		$smtp->datasend("To: $to\r\n");
		$smtp->datasend("From: $from\r\n");
		$smtp->datasend("X-Mailer: Perl Powered Socket Net::SMTP Mailer\r\n");
		$smtp->datasend("Subject: $subject\r\n");
		if ($mailmode eq "html") { $smtp->datasend("Content-type: text/html\r\n"); }
		$smtp->datasend("\r\n");
		$smtp->datasend($messagemail);
		$smtp->dataend();
		$smtp->quit();
		^;
		if( $@ ) {
			&fb::fatal_error("\n<br>Net::SMTP fatal error: $@\n<br>");
			return -77;
		}
		return 1;
	}
	if ($fb::cf{'mailtype'}==0) {
		$messagemail =~ s/\r\n/\n/g;
		open(MAIL,"| $fb::cf{'mailprog'} -oi -odd");
		print MAIL "To: $to\n";
		print MAIL "from: $from\n";
		print MAIL "X-Mailer: Perl Powered Socket Mailer\n";
		print MAIL "Subject: $subject\n";
		if ($mailmode eq "html") { print MAIL "Content-type: text/html\n"; }	
		print MAIL "\n";
		print MAIL "$messagemail";
		print MAIL "\n\n";
		close(MAIL);
		return(1);	
	}
}

sub get_mime_type {
    my $filename = shift;
    my %types = ( 'tar' => 'application/x-tar',  'zip' => 'application/x-zip-compressed' );
    chomp(my $typ = [split(/\./, $filename)]->[-1]);
    return ( $types{$typ} or 'application/octet-stream');
}

1;