####################### [Firebook] - guestbook ################################
# settings2.pl  		                                                      #
###############################################################################

package fb;

use strict;
use warnings;
#use diagnostics;

&fb::load_language("settings2");

sub einst2 {
		
	&isadmin;

	my $old_db_password = $fb::cf{'db_password'};
	
	# saveaction might store an additional subpage for "do" parameters
	my ($save_action, $save, $save_action2);

	if ($fb::FORM{'save_action'}) { $save_action = $fb::FORM{'save_action'}; }
	if ($fb::FORM{'save_action2'}) { $save_action2 = $fb::FORM{'save_action2'}; }
	
	unless ($fb::FORM{'save'}) { $fb::FORM{'save'} = $save_action2 || $save_action; }
	if ($fb::FORM{'save'}) { $save = $fb::FORM{'save'}; }

	if ($save) {

		foreach my $entry (@{$fb::cf{"onoff_$save"}}) {
			$fb::cf{$entry} = ($fb::FORM{$entry}) ? "1" : "0";
			if (($save eq "einstfields") && ($entry =~ m/wicht/i)) {
					my ($uuuw,$namewas7) = split(/\_/, $entry);
					if ($fb::cf{$entry} == 1) {
						$fb::FORM{"q_".$namewas7} = 1;
						$fb::cf{"q_".$namewas7} = 1;
						$fb::FORM{"f_".$namewas7} = 1;
						$fb::cf{"f_".$namewas7} = 1;
					}
			}
		}

		foreach my $entry (@{$fb::cf{"getvar_$save"}}) {
			$fb::cf{$entry} = $fb::FORM{$entry};
			if ($entry =~ m/^zeich/ig) {
				if ($fb::cf{$entry} =~ m/\D/g) { $fb::cf{$entry} = 0; }
			}
			if ($entry =~ m/^mzeich/ig) {
				if ($fb::cf{$entry} =~ m/\D/g) { $fb::cf{$entry} = 0; }
			}
		}


	}
	else {
		&fatal_error("$fb::txt{'se2'}{'1'}");
	}

	chomp $fb::cf{'browser_access'};
	
	# testing new database connection
	if ($fb::cf{'db_password'} eq "no_change") { $fb::cf{'db_password'} = $old_db_password; }
	my $dbh2 = DBI->connect( "$fb::cf{'db_driver'}:$fb::cf{'db_name'}:$fb::cf{'db_host'}:$fb::cf{'db_port'}",$fb::cf{'db_user'},$fb::cf{'db_password'}, {"PrintError" => 1, "AutoCommit" => 0, "RaiseError" => 1});
	$dbh2->disconnect();

	$fb::cf{'browser_access'} =~ s~\r~~g;
	$fb::cf{'browser_access'} =~ s~\n~|~g;


	# hash of config values to be checked as numbers [id, default value]
	my %check_numbers = (
	 		'pophelp1' => '800',
			'pophelp2' => '500',
			'uplpop1' => '600',
			'uplpop2' => '130',
			'deldays' => '',
			'file2' => '',
			'bigger1' => '',
			'bigger2' => '',
			'older1' => '',
			'dirlimit' => '1000',
			'maxindex' => '7',
			'bildermax' => '15',
			'timeout' => '15',
			'sessionidtime' => '1000',
			'anzahlZeichen' => '80',
	);

	# hash of config values to be checked if not empty [id, default value]
	my %check_values = (
			'setofdatum'=> "0",
			'sessionidtime'=> "0",
	 		'sprache' => "$fb::gl{'sprache2'}",
			'bildermax' => '5',
			'maximumbei' => '500',
			'maximumbei2' => '700',
			'stwidth' => '65',
			'stheight' => '65',
			'timeout' => '15',
			'mailtype' => '0',
			'limit' => '20',
			'dirlimit' => '5000',
		    'anzahlZeichen' => '80',
	);	


	# add settings check for mod values
	foreach my $mod (keys %{$fb::mod{'settings_check'}}) {
		if ($fb::mod{'modules_info'}{$mod}[0] == 1) {
			foreach my $addsett (@{$fb::mod{'settings_check'}{$mod}}) {
				if ($addsett->[1] eq "number") {
					$check_numbers{$addsett->[0]} = $addsett->[2];
				}
				if ($addsett->[1] eq "value") {
					$check_values{$addsett->[0]} = $addsett->[2];
				}
			}
		}
	}

	foreach my $checkfield (keys %check_numbers) {
		if ($fb::cf{$checkfield} =~ m/\D/g) { $fb::cf{$checkfield} = $check_numbers{$checkfield}; }
	}

	if ($fb::cf{'maximumbei'} ne "-1") {
		if ($fb::cf{'maximumbei'} =~ m/\D/g) { $fb::cf{'maximumbei'} = 500; }
	}
	if ($fb::cf{'maximumbei2'} ne "-1") {
		if ($fb::cf{'maximumbei2'} =~ m/\D/g) { $fb::cf{'maximumbei2'} = 700; }
	}

	foreach my $checkfield (keys %check_values) {
		if ($fb::cf{$checkfield} eq "") { $fb::cf{$checkfield} = $check_numbers{$checkfield}; }
	}


	&fatal_error($fb::txt{'se2'}{'2'}) unless($fb::cf{'ordnerurl'});
	&fatal_error($fb::txt{'se2'}{'3'}) unless($fb::cf{'ordnerdir'});
	unless (-e "$fb::cf{'ordnerdir'}/firebook.$fb::gl{'ext'}") { &fatal_error($fb::txt{'se2'}{'4'}); }
	&fatal_error($fb::txt{'se2'}{'5'}) unless($fb::cf{'bilderurl'});
	&fatal_error($fb::txt{'se2'}{'6'}) unless($fb::cf{'bilderdir'});
	unless (-e "$fb::cf{'bilderdir'}") { &fatal_error($fb::txt{'se2'}{'7'}); }
	&fatal_error($fb::txt{'se2'}{'8'}) unless($fb::cf{'maxindex'});
	&fatal_error($fb::txt{'se2'}{'9'}) unless($fb::cf{'fbname'});
	&fatal_error($fb::txt{'se2'}{'9'}) unless($fb::cf{'fbname'});
	&fatal_error($fb::txt{'se2'}{'16'}) unless($fb::cf{'homepage'});
	&fatal_error($fb::txt{'se2'}{'10'}) unless($fb::cf{'admmail'});
	&fatal_error($fb::txt{'se2'}{'15'}) unless($fb::cf{'admmail2'});

	
	unless ( $fb::cf{'admmail'} =~ /^[a-zA-Z0-9]{1}[a-zA-Z0-9\._-]*\@[a-zA-Z0-9_\.-]*[a-zA-Z0-9-aaaccccddeeeee?gggghhiiiiijk?llllnnnooorrrssstttuuuuuuwyzz]{2,}\.[a-z]{2,4}$/) { &fatal_error($fb::txt{'se2'}{'11'}); }
	if ($fb::cf{'admmail2'}) {
		unless ( $fb::cf{'admmail2'} =~ /^[a-zA-Z0-9]{1}[a-zA-Z0-9\._-]*\@[a-zA-Z0-9_\.-]*[a-zA-Z0-9-aaaccccddeeeee?gggghhiiiiijk?llllnnnooorrrssstttuuuuuuwyzz]{2,}\.[a-z]{2,4}$/) { &fatal_error($fb::txt{'se2'}{'11'}); }
	}
	if ( not( $fb::cf{'ordnerurl'} =~ m/^http(s?)\:\/\//i) ) { &fatal_error($fb::txt{'se2'}{'12'}); }
	if ( not( $fb::cf{'bilderurl'} =~ m/^http(s?)\:\/\//i) ) { &fatal_error($fb::txt{'se2'}{'13'}); }
	if ($fb::cf{'sessionidtime'} < 30) { $fb::cf{'sessionidtime'} = 30; }

	&write_settings;
	
	my $set_location;
	
	if ($fb::FORM{'save_do'}) { $save_action2 = $fb::FORM{'save_do'}; }
	if ($save_action2) { $set_location = "$fb::gl{'scriptac'}=$save_action;do=$save_action2"; }
	elsif ($save_action) { $set_location = "$fb::gl{'scriptac'}=$save_action"; }
	else { $set_location = "$fb::gl{'scriptac'}=admin"; }
	&redirect($set_location);

}

sub write_settings {

my $fbinfospl = "";

$fbinfospl .= qq~
################################ FIREBOOK #####################################
# config.pl				                                                      #
###############################################################################
# [Firebook] - guestbook                                                      #
# free-source guestbook software                                              #
# - see licence at http://www.firebook.de/licence  -                          #
# Version:                              6.0                                   #
# Author:                               Karl Tschetschonig                    #
# URL:                                  http://www.firebook.de                #
# E-Mail:                               support\@firebook.de                  #
# =========================================================================== #
# Copyright (c) 2002-2009 by Karl Tschetschonig - All rights reserved!        #
# No redistribution allowed! - Any liability excluded! - Retain this header!  #
###############################################################################

########### Einstellungen
~;
	foreach my $entry (@{$fb::cf{'getvar_all'}}) {
		
		unless (defined $fb::cf{$entry}) { $fb::cf{$entry} = ""; }
		if (($entry eq "modules_gb_passphrase") || ($entry eq "modules_gb_encrypted") || ($entry eq "licence")) {
			$fbinfospl .= qq~\$fb::cf{'$entry'} = '$fb::cf{$entry}';\n~;
		}
		else {
			$fb::cf{$entry} =~ s/\\/\\\\/g;
			$fb::cf{$entry} =~ s/@/\\@/g;
			$fb::cf{$entry} =~ s/"/\&quot;/g;
			$fb::cf{$entry} =~ s/~/\\~/g;
			$fbinfospl .= qq~\$fb::cf{'$entry'} = qq\~$fb::cf{$entry}\~;\n~;
		}
		
	}
	foreach my $entry (@{$fb::cf{'onoff_all'}}) {
		unless ($fb::cf{$entry}) { $fb::cf{$entry} = '0'; }
		$fbinfospl .= qq~\$fb::cf{'$entry'} = qq\~$fb::cf{$entry}\~;\n~;
	}
$fbinfospl .= qq~
########### Einstellungen
1;
~;
	
	&writefile("$fb::cf{'ordnerdir'}/config.pl",$fbinfospl);

}
1;