####################### [Firebook] - guestbook ################################
# skinsystem.pl  	                                                          #
###############################################################################

package fb;

use strict;
use warnings;
#use diagnostics;

my $pushatskin = qq~pushskin-9tuh1i2s3ipsnajsaksidnocjobdnefcvkbthok40iq23uhfoi09gkaj-idreamsexportaygh7e4kjn081mszwhjx643lhgsq~;
my $pushatskin2 = qq~pushskin2-ftehritswi5s4atswksi4n5chogd5e6zuw6o7i67jsdfgavxasdfj4k~;

sub printmenu {
	
	my $bearbeiteskin = $_[0] || "";
	my $was = $_[1] || "";

	# skin options
	my $options2 = "";

	my @contents = &opendirectory("$fb::gl{'datadir'}/skins");

	@contents = sort { uc($a) cmp uc($b) } (@contents);
	foreach my $line (@contents) {
		if (( -d "$fb::gl{'datadir'}/skins/$line" ) && ( ( $line ne "." ) && ( $line ne ".." ))) {
			
			my $selected = "";
			if ( $line eq "admin" ) { next; }
			if ( $line eq $bearbeiteskin ) { $selected = " selected"; }
			$options2 .= qq~<option value=\"$line\"$selected>$line</option>\n~;

		}
	}

	my ($einstc,$cssc,$templatesc) = ("","","");
	my $printnow = "";

	if ( $was eq "skineinst" ) {
		$einstc   = " selected";
		$printnow = $fb::txt{'gl'}{'149'};
	}
	elsif ( $was eq "skincss" ) {
		$cssc     = " selected";
		$printnow = $fb::txt{'gl'}{'96'};
	}
	elsif ( $was eq "skintemplates" ) {
		$templatesc = " selected";
		$printnow   = $fb::txt{'gl'}{'148'};
	}

	if ($printnow) {

		$fb::fi{'main'} .= qq~
			<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>
				<tr><td class=fbcatbg colspan=3><b>$fb::txt{'gl'}{'92'} &raquo; $printnow &raquo; $fb::txt{'sk'}{'15'}: $bearbeiteskin<b></td></tr>

				<tr>
			<td class=fb1 align=center width=120><b>[ <a href="$fb::gl{'scriptac'}=skinsystem">$fb::txt{'sk'}{'7'}</a> ]</b></td>		
				<td class=fb2 align=center>

				<table border=0 cellspacing="0" cellpadding="3"><form action="$fb::gl{'script'}" method="get" name="fiform3">
			$fb::gl{'hiddenscro'} <tr>
				<td align=right><b>$fb::txt{'sk'}{'16'}:</b></td><td><select name="action">
			<option value="skineinst"$einstc>$fb::txt{'gl'}{'149'}</option>
			<option value="skincss"$cssc>$fb::txt{'gl'}{'96'}</option>
			<option value="skintemplates"$templatesc>$fb::txt{'gl'}{'148'}</option>~;
			
			# mod for skin editor
			if ($fb::mod{'modules_info'}{'mod_skine'}[0]) {
				$fb::fi{'main'} .= qq~<option value="mod_skine_skineditor">$fb::txt{'gl'}{'101'}</option>~;
			}
			$fb::fi{'main'} .= qq~
			<option value="smilies">$fb::txt{'gl'}{'93'}</option>~;
			
			# mod for popup smilies
			if ($fb::mod{'modules_info'}{'mod_popsm'}[0]) {
				$fb::fi{'main'} .= qq~<option value="mod_popsm_adminsett">$fb::txt{'gl'}{'131'}</option>~;
			}
			$fb::fi{'main'} .= qq~
			<option value="fileexplorer">$fb::txt{'gl'}{'94'}</option>
			</select>
			</td><td><b>$fb::txt{'sk'}{'17'}</b></td><td><select name=requskin>$options2</select></td>
				<td><input type="submit" name="post" value="$fb::txt{'gl'}{'65'}">	</td>
			</tr></form></table>

			</td><td class=fb1 align=center width=120><b>[ <a target="_blank" href="$fb::gl{'scriptac2'}=;lang=$fb::gl{'sprache2'};skin=$bearbeiteskin">$fb::txt{'sk'}{'52'}</a> ]</b></td></tr></table>	
			<br>
			~;
	}

}

sub syntaxh {
	
	&isadmin;
	
	my $bearbeiteskin = $fb::INFO{'requskin'};
	my $template      = $fb::INFO{'template'};
	
	my @templatefile;
	if ( -e "$fb::gl{'datadir'}/skins/$bearbeiteskin/$template" ) {
		@templatefile = &openfile("$fb::gl{'datadir'}/skins/$bearbeiteskin/$template");
	}
	
	my $workon_template = "";
	foreach (@templatefile) {
		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
		$_ =~ s/\n/<br>/g;
		$_ =~ s/\r//g;
		$_ =~ s/\t/&nbsp; &nbsp;/g;
		$_ =~ s/  /&nbsp; &nbsp;/g;
		$_ =~ s/\'/\\'/g;
		$workon_template .= $_;
	}

	# print syntax highlighting editor

	$fb::fi{'main'} .=
	  qq~<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
			<html>
			<TITLE>$fb::txt{'sk'}{'127'}</TITLE>
			<head>
			<style type="text/css">
			<!--
			input { background-color: transparent; color: #000000; border: 1px solid #000000; font-family: Verdana; font-size: 10px; margin: 1px; }
			#syntaxfenster { position: absolute; top: 0px; left: 32px; z-index: 1; border: 0px; width: expression(eval(body.clientWidth)-32); height: expression(eval(body.clientHeight)-40); }
			.scroll1 { position: absolute; top: 0px; left: 0px; z-index: 3; border: 0px; width: 32px; height: expression(eval(body.clientHeight));  font-family: Courier; font-size: 10px; color: #333333; background-color: #EEEEEE; overflow:hidden; padding-top: 1px; }
			.scroll2 { position: absolute; top: expression(eval(body.clientHeight)-40); left: 0px; z-index: 4; border: 0px; width: 100%; height: 40px;  font-family: Verdana; font-size: 10px; color: #333333; background-color: #EEEEEE; overflow: hidden; padding: 2px; border-width: 1px; border-color: #000000; border-right-style: none; border-top-style: solid; border-bottom-style: none; border-left-style: none;  }
			-->
			</style>
			<script language="javascript">
			<!--
			alert("$fb::txt{'sk'}{'40'}");
			//-->
			</script>

			<script language="jscript">
			<!--
			var savedtemp = '$workon_template';
			window.onload=function(){
				syntaxfenster.document.designMode='On';
			}
			var wordwrap=true;
			var max=1;
			function syntaxhl(){
				syntaxfenster.document.body.onpaste=function(){
					testhtml = window.clipboardData.getData('text');
					newhtml = highlight(testhtml);
					syntaxfenster.document.selection.createRange().pasteHTML('<font color=#000000>'+ newhtml);
					return(false);
				}
				syntaxfenster.document.onkeydown=function(){
					if(syntaxfenster.event.keyCode == 13){
						addhtml(syntaxfenster.document.selection.createRange(),'<BR>');
						return(false);
					}
					else if(syntaxfenster.event.keyCode == 9){
						syntaxfenster.document.selection.createRange().pasteHTML('&nbsp; &nbsp;');
						return(false);
					}
				}
				syntaxfenster.document.onkeypress=function(){
					var olddata = olddatafind();
					var main = syntaxfenster.document.selection.createRange();
					with(olddata){
						if(positionc('<script','<\\/script>','<SCRIPT','<\\/SCRIPT>',olddata)) {
							if((syntaxfenster.event.keyCode == 62) || (syntaxfenster.event.keyCode == 32)){
								var laenge = length;
								if((rechne(olddata,7,laenge)=='<script') || (rechne(olddata,7,laenge)=='<SCRIPT')){ addtag(main,'#006600'); }
							}
						}
						else if(positionc('<style','</style>','<STYLE','</STYLE>',olddata)){
							if((syntaxfenster.event.keyCode == 62) || (syntaxfenster.event.keyCode == 32)){
								var laenge2=length;
								if((rechne(olddata,6,laenge2)=='<style') || (rechne(olddata,6,laenge2)=='<STYLE')) { addtag(main,'#996600'); }
							}
							else if(syntaxfenster.event.keyCode == 123){
								main.pasteHTML('<font color=#666633>{');
								erase();
							}
							else if(lastIndexOf('{') > lastIndexOf('}')){
								var temp=false;
								var testdata = olddata;
								var test=testdata.substring(testdata.lastIndexOf('{'),testdata.length);
								if(test.length-test.lastIndexOf(':')==1) { temp = true; }
								else if(test.lastIndexOf(':') > test.lastIndexOf(';')) { temp = true; }
								if(temp){
									if((syntaxfenster.event.keyCode == 59) || (syntaxfenster.event.keyCode == 125)){
										main.pasteHTML('<font color=#666633>'+fcode(syntaxfenster.event.keyCode));
										erase();
									}
									else{
										main.pasteHTML('<font color=#98AA00>'+fcode(syntaxfenster.event.keyCode));
										erase();
									}
								}
								else{
									main.pasteHTML('<font color=#666633>'+fcode(syntaxfenster.event.keyCode));
									erase();
								}
							}
							else { coloredit('#996600'); }
						}
						else if(lastIndexOf('<') > lastIndexOf('>')){
							var laenge=length;
							if((syntaxfenster.event.keyCode == 32) || (syntaxfenster.event.keyCode == 62)){
								if((rechne(olddata,6,laenge)=='<table') || (rechne(olddata,6,laenge)=='<TABLE') || (rechne(olddata,7,laenge)=='</table') || (rechne(olddata,7,laenge)=='</TABLE')) { addtag(main,'#990066'); }
								else if((rechne(olddata,4,laenge)=='<img') || (rechne(olddata,4,laenge)=='<IMG')) { addtag(main,'#FF9900'); }
								else if((rechne(olddata,9,laenge)=='<firebook') || (rechne(olddata,9,laenge)=='<FIREBOOK')) { addtag(main,'#FF0000'); }
								else if((rechne(olddata,8,laenge)=='<fbinput') || (rechne(olddata,8,laenge)=='<FBINPUT')) { addtag(main,'#FF0000'); }
								else if((rechne(olddata,4,laenge)=='<var') || (rechne(olddata,4,laenge)=='<VAR')) { addtag(main,'#FF0000'); }
								else if((rechne(olddata,5,laenge)=='<fire') || (rechne(olddata,5,laenge)=='<FIRE')) { addtag(main,'#FF0000'); }
								else if((rechne(olddata,7,laenge)=='<txt_gl') || (rechne(olddata,7,laenge)=='<txt_GL')) { addtag(main,'#FF0000'); }
								else if((rechne(olddata,5,laenge)=='<link') || (rechne(olddata,5,laenge)=='<LINK')) { addtag(main,'#996600'); }
								else if((rechne(olddata,5,laenge)=='<form') || (rechne(olddata,5,laenge)=='<FORM') || (rechne(olddata,6,laenge)=='</form') || (rechne(olddata,6,laenge)=='</FORM')) { addtag(main,'#FF00FF'); }
								main.pasteHTML('<font color=#0000FF>'+fcode(syntaxfenster.event.keyCode));
								if(syntaxfenster.event.keyCode == 32) { coloredit('#6699FF'); }
								erase();
							}
							else if(syntaxfenster.event.keyCode == 34){
								main.pasteHTML('<font color=#00AA00>"');
								erase();
							}
							else{
								var temp= false;
								var testdata = olddata;
								var test = testdata.substring(testdata.lastIndexOf('<'),testdata.length);
								if(test.length-test.lastIndexOf('=') == 1) { temp = true; }
								else if((test.lastIndexOf('"') - test.lastIndexOf('=') == 1) || (test.lastIndexOf("'") - test.lastIndexOf('=') == 1)) { temp=true; }
								if(temp){
									main.pasteHTML('<font color=#00AA00>'+fcode(syntaxfenster.event.keyCode));
									coloredit('#00AA00');
									erase();
								}
							}
						}
						else if(syntaxfenster.event.keyCode == 60){
							coloredit('#0000FF');
							main.pasteHTML('<font color=#0000FF>&lt;');
							erase();
						}
						else{
							key = fcode(syntaxfenster.event.keyCode);
							main.pasteHTML('<font color=#000000>'+key);
							erase();
						}
					}
				}
				syntaxfenster.document.onkeyup=function(){
					scrollfenster.scrollTop=syntaxfenster.document.body.scrollTop;
				}
				syntaxfenster.document.body.style.fontFamily="Courier";
				syntaxfenster.document.body.style.fontSize="10px";
				syntaxfenster.document.body.style.text='#000000';
				syntaxfenster.document.body.style.backgroundColor='#FFFFFF';
				syntaxfenster.document.body.style.wordWrap="normal";
				syntaxfenster.document.body.style.whiteSpace = "nowrap";
				syntaxfenster.document.body.style.marginLeft=0;
				syntaxfenster.document.body.style.marginTop=0;
				syntaxfenster.document.body.onscroll=function(){
					scrollfenster.scrollTop=syntaxfenster.document.body.scrollTop;
				}
			}
			function fcode(code){
				return((code==32?'&nbsp;':(code==38?'&':String.fromCharCode(code))));
			}
			function erase(){
				syntaxfenster.event.keyCode = 0;
			}
			function rechne(content,zahla,zahlb){
				return(content.substring(zahlb-zahla,zahlb));
			}
			function coloredit(farbe){
				syntaxfenster.document.execCommand("ForeColor",false,farbe);
			}
			function highlight(x){
				return(
				x.replace(/&lt;.*?&gt;/gi,
				function(x){
					return(
			"<font color=#0000FF>"+x.replace(/(\\w*?)\\=("[^"]*"|'[^']*'|[\\w\\:\\.\\,\\!\\#\\/\\\\\\-\\+\\=\\%\\?\\\$\\(\\)\\;]+)/ig,
			"<font color=#6699FF>\$1=</font><font color=#00AA00>\$2</font>")+"</font>")}).replace(/&lt;(\\/?)\\b(table)\\b/gi,"&lt;\$1<font color=#990066>\$2</font>").replace(/&lt;\\b(img)\\b/gi,"&lt;<font color=#FF9900>\$1</font>").replace(/&lt;firebook(.*?)&gt;/gi,"&lt;<font color=#FF0000>FIREBOOK</font><font color=#000066>\$1</font>&gt;").replace(/&lt;ubbc(.*?)&gt;/gi,"&lt;<font color=#FF0000>ubbc</font><font color=#000066>\$1</font>&gt;").replace(/&lt;fbinput(.*?)&gt;/gi,"&lt;<font color=#FF0000>fbinput</font><font color=#000066>\$1</font>&gt;").replace(/&lt;\\/style&gt;/gi,"<font color=#996600>&lt;\\/style&gt;</font>").replace(/&lt;var(.*?)&gt;/gi,"&lt;<font color=#FF0000>VAR</font><font color=#000066>\$1</font>&gt;").replace(/&lt;(\\/?)fire(.*?)&gt;/gi,"&lt;<font color=#FF0000>\$1FIRE</font><font color=#000066>\$2</font>&gt;").replace(/&lt;txt\\_(.*?)&gt;/gi,"&lt;<font color=#FF0000>txt_</font><font color=#000066>\$1</font>&gt;").replace(/&lt;(\\/?)\\b(form)\\b/gi,"<\$1<font color=#FF00FF>\$2</font>").replace(/&lt;\\b(link)\\b/gi,"&lt;<font color=#996600>\$1</font>").replace(/(&lt;!.*?&gt;)/gi,function(x){return("<font color=#999999>"+x.replace(/&lt;\\/?font[^&gt;]*&gt;/ig,'')+"</font>")}).replace(/&lt;style.*?\\/style&gt;/gi,function(x){ return("<font color=#996600>"+load_style(x)+"</font>")}).replace(/&lt;script.*?&lt;\\/script&gt;/gi,function(x){return("<font color=#006600>"+load_script(x)+"</font>")}).replace(/"MSHTML [\\d\\.]+"/ig,'""'))}
			function load_style(x){ return(x.replace(/&lt;\\/?font[^&gt;]*&gt;/ig,'').replace(/{[^}]*}/ig,function(x){return("<font color=#666633>"+x.replace(/:(( )*[^;]*)(;|<br>|( )+|})/ig,":<font color=#98AA00>\$1</font>\$3")+"</font>")}).replace(/(\\/\\*+.*?\\*\\/)/ig,function(x){return("<font color=#CCCC00>"+x.replace(/&lt;\\/?font[^&gt;]*&gt;/ig,'')+"</font>")}))
			}
			function load_script(x){
			return(x.replace(/<\\/?font[^>]*>/ig,'').replace(/(=|\\()(\\s*\\/(\\\\\\/|\\\\\\\\|[^\\/])*\\/)|("(\\\\\\\\|\\\\"|[^"])*"|'(\\\\\\\\|\\\\'|[^'])*')|\\b(function)\\b|\\b(if|else|with|case|switch|for|while|do|new|var|break|default|Array|true|false|Date|return|Object|Boolean|Number|String|delete|void)\\b|(\\/\\*+.*?\\*\\/|&lt;!.*?<br>|\\/\\/.*?<br>)/ig,"\$1<font color=#00AA00>\$2\$4</font><font color=#0000FF>\$7</font><font color=#6699FF>\$8</font><font color=#663300>\$9</font>"))
			}
			function positionc(a,b,c,d,e){
				return((e.lastIndexOf(a)>e.lastIndexOf(b)) || (e.lastIndexOf(c)>e.lastIndexOf(d)));
			}
			function addhtml(wo,was){
				wo.pasteHTML(was);
				wo.select();
				wo.moveEnd("character", 1);
				wo.moveStart("character", 1);
				wo.collapse(false);
			}
			function addtag(wo,color){
				wo.moveStart('character',-1);
				wo.collapse();
				wo.select();
				coloredit(color);
				wo.moveStart('character',1);
				wo.collapse();
				wo.select();
			}
			function livepopup(){
				popup=window.open("","","width=700,height=500,top="+((screen.height-500)/2-10)+",left="+((screen.width-700)/2-10)+",scrollbars=yes,resizable=yes");
				popup.document.write(syntaxfenster.document.body.innerText);
				popup.document.close();
			}
			function olddatafind(){
				var ausw = syntaxfenster.document.selection.createRange();
				var before = ausw.duplicate();
				ausw.moveToPoint();
				before.setEndPoint("StartToStart",ausw);
				return(before.text)
			}
			function writedata(){
				newhtml = highlight(savedtemp);
				syntaxfenster.document.write(newhtml);
				syntaxfenster.document.close()
			}
			function sendinhalt (){
			uebernehme = syntaxfenster.document.body.innerText;
			opener.document.getElementById("template").value = uebernehme;
			alert("$fb::txt{'sk'}{'42'}");
			self.close();
			opener.document.focus();
			opener.document.getElementById("template").focus();
			}
			function dowordwrap() {
						wo = syntaxfenster.document.body.style;
						if(wordwrap){
							wo.wordWrap = "break-word";
							wo.whiteSpace = "normal";
							wordwrap=false;
						}
						else{
							wo.wordWrap = "normal";
							wo.whiteSpace = "nowrap";
							wordwrap = true;
						}
						return(false);
			}
			//-->
			</script>
			</head>
			<BODY bgcolor="#FFFFFF" leftmargin="0" topmargin="0" scroll="no">
			<div id="scrollfenster" class="scroll1" align="right">~;
			
			# no more than 1500 lines
			for (my $i = 1 ; $i <= 1500 ; ++$i ) {
				$fb::fi{'main'} .= qq~$i:<br>~;
			}

				$fb::fi{'main'} .= qq~</div>
			<iframe contenteditable id="syntaxfenster" name="syntaxfenster" onload="syntaxhl();" frameborder="no"></iframe>
			<div id="scrollfenster2" class="scroll2" align="center">
			<input type="button" value="$fb::txt{'sk'}{'43'}" onclick="livepopup()" accesskey="p"></input>
			<input type="button" value="$fb::txt{'sk'}{'44'}" onclick="dowordwrap()" accesskey="w"></input>
			<input type="button" value="$fb::txt{'sk'}{'41'}" onclick="sendinhalt()" accesskey="s"></input>
			<br>$fb::txt{'sk'}{'129'}

			</div>
			<script language=jscript>
			<!--
			writedata();
			//-->
			</script>
			</BODY>
			</HTML>~;

	print header( -status => "200 OK", -charset => $fb::cf{'charset'} );
	print $fb::fi{'main'};
	&database_disconnect;
	exit;

}

sub skineinst {

	&isadmin;
	my $bearbeiteskin = $fb::INFO{'requskin'} || $fb::cf{'skinchosen'} || "";

	&adminmenu;
	
	# skinsystem extra menu
	&printmenu($bearbeiteskin,"skineinst");

	my %checked;

	foreach my $entry ( @{ $fb::cf{'onoff_skineinst'} } ) {
		$checked{$entry} = ( $fb::cf{$entry} ) ? " checked" : "";
	}

	$fb::fi{'main'} .= qq~

			<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>
		<form action="$fb::gl{'scriptac'}=skinsystem2" method="post" name="fiform">
		<input type=hidden name=was value="skineinst"><input type=hidden name=requskin value="$bearbeiteskin">
		<tr><td class=fb1>
			<b>$fb::txt{'gl'}{'149'} $fb::txt{'sk'}{'17'} <u>$bearbeiteskin</u></b>
		</td></tr>
		<tr><td class=fb2 width="100%">
			
		<table width="100%" border=0 cellspacing="0" cellpadding="3">
		<tr>  
		<td align="right" width="60%"><font size=2><b>$fb::txt{'sk'}{'20'}:</b></font><br><font size=1>$fb::txt{'sk'}{'21'}</font></td>
				<td><font size=2><input type=text name="smiliesrow" size=30 value="$fb::cf{'smiliesrow'}"></font></td>
			  </tr>
			</table>
			</td></tr>
		<tr><td class=fb2 width="100%">
			
		<table width="100%" border=0 cellspacing="0" cellpadding="3">
		<tr>  
		<td align="right" width="60%"><font size=2><b>$fb::txt{'sk'}{'32'}:</b></font><br><font size=1>$fb::txt{'sk'}{'33'}</font></td>
				<td><font size=2><input type=text name="bimage" size=30 value="$fb::cf{'bimage'}"></font></td>
			  </tr>
						<tr>  
		<td align="right"><font size=2><b>$fb::txt{'sk'}{'24'}:</b></font><br><font size=1>$fb::txt{'sk'}{'25'}</font></td>
				<td><font size=2><input type=text name="logourl" size=30 value="$fb::cf{'logourl'}"></font></td>
			  </tr>
						<tr>  
		<td align="right"><font size=2><b>$fb::txt{'sk'}{'26'}:</b></font><br><font size=1>$fb::txt{'sk'}{'27'}</font></td>
				<td><font size=2><input type=text name="logolink" size=30 value="$fb::cf{'logolink'}"></font></td>
			  </tr>
		<tr>  
		<td align="right"><font size=2><b>$fb::txt{'sk'}{'34'}:</b></font><br><font size=1>$fb::txt{'sk'}{'35'}</font></td>
				<td><font size=2><input size=30 type=text name="useonlinehost" value="$fb::cf{'useonlinehost'}"></font></td>
			  </tr>
			</table>
			</td></tr>
		<tr><td class=fb2 width="100%">
			
		<table width="100%" border=0 cellspacing="0" cellpadding="3">


		<tr>  
		<td align="right" width=60%><font size=2><b>$fb::txt{'sk'}{'18'}:</b></font><br><font size=1>$fb::txt{'sk'}{'19'}</font></td>
				<td><font size=2><input type=checkbox name="bewgraphics" value="1"$checked{'bewgraphics'}></font></td>
			  </tr>

		</table></td></tr>
		<tr><td class=fb4 width="100%"><table width="100%" border=0 cellspacing="0" cellpadding="3">
				<tr><td align=center>
				<input type="submit" name="post" value="$fb::txt{'gl'}{'117'}">	
		</td>
			  </tr></table></td></tr></form>
		</table>~;

		&adminschluss;
		&template;

}
sub skincss {

	&isadmin;
	my $bearbeiteskin = $fb::INFO{'requskin'} || $fb::cf{'skinchosen'} || "";

	&adminmenu;
	
	# skinsystem extra menu
	&printmenu($bearbeiteskin,"skincss");


	# we are seperating plain CSS edit and CSS edit with colour pickers and fancy things
	my $was2 = $fb::INFO{'was2'} || "fancy";


	my $prinsert = $fb::INFO{'prinsert'} || "0";

	if ($was2 eq "standard") {
		
		my @csstemplatefile;
		if ($prinsert) {
			@csstemplatefile = &openfile("$fb::gl{'datadir'}/styles/preview.html");
		}
		else {
			@csstemplatefile = &openfile("$fb::gl{'datadir'}/skins/$bearbeiteskin/style.css");
		}

		my $joinedtemp = join( "", @csstemplatefile );

		$fb::fi{'main'} .= qq~
		<script language=javascript>
		<!--
		function WhichClicked(ww) {
			window.document.fiform.waction.value = ww;
		}

		//-->
		</script>					
		
		<table border=0 cellspacing=1 width=100% cellpadding=10 class=fbborder align=center>

		<tr>
		<td class=fb2 align=center><b>[ <a href="$fb::gl{'scriptac'}=skincss;was2=fancy;requskin=$bearbeiteskin">$fb::txt{'sk'}{'131'}</a> ]</b></td>

		<td class=fb1 align=center><b>[ $fb::txt{'sk'}{'130'} ]</b></td></tr>
		</table><br>

		<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>
		<tr><td class=fb1 aign=center>
		<table border=0 cellspacing=0 cellpading=0 width=100%><tr><td></td><td align=center>
		<b>[ <a href="javascript:popUp('$fb::gl{'scriptac'}=syntaxh;requskin=$bearbeiteskin;template=style.css',800,600)">$fb::txt{'sk'}{'128'}</a> ]</b>
		</td>
		</tr></table>
		</td></tr>
		<form action="$fb::gl{'scriptac'}=skinsystem2" method="post" name="fiform">
		<input type=hidden name=was value="skincss"><input type=hidden name="was2" value="standard">
		<input type=hidden name=requskin value="$bearbeiteskin">

		<tr><td class=fb2 align=center>
			<textarea wrap="virtual" id="template" name="template" cols=130 rows=20>~;

		foreach (@csstemplatefile) {
			$_ =~ s/</&lt;/g;
			$_ =~ s/>/&gt;/g;
			$fb::fi{'main'} .= $_;
		}
		#$outputhigh =~ s/\n/<br>/g;
		#$outputhigh =~ s/  /&nbsp;/g;

		$fb::fi{'main'} .= qq~</textarea></td></tr></tr><td class=fb4 align=center>
		<input type="hidden" name="waction" value="post"><input type="submit" name="post" onClick="WhichClicked('post');" value="$fb::txt{'sk'}{'106'}">
		<input type="submit" name="post" onClick="WhichClicked('preview');" value="$fb::txt{'sk'}{'108'}">	
				</td></tr>
		  </form>
		</table>
		~;


	}
	elsif ($was2 eq "fancy") {

		my %css_info;

		unless ( $fb::loaded{'file_getcolors'} ) {
			require "$fb::gl{'subsdir'}/getcolors.pl";
			%css_info = &getcolors;
		}

		#@schriftarten = ("Comic Sans MS, Comic Sans, Cursive", "Arial, Helvetica, Sans-Serif", "Arial, Verdana, Helvetica", "Courier, Courier New, Monospace", "Garamond, Times, Serif", "Georgia, Times, Serif", "Tahoma, Verdana, Arial", "Times, Times New Roman, Serif", "Univers, Arial, Sans-Serif", "Verdana, Lucida, Sans-Serif");
		#@schriftarten2 = ("Comic Sans", "Arial-Helv.", "Arial-Verd", "Courier", "Garamond", "Georgia", "Tahoma", "Times", "Univers", "Verdana");

		$fb::fi{'main'} .= qq~
		<script language=javascript>
		<!--
		function fncIsvalidcolor(hexcolor) { 
		var strPattern = /^#[0-9a-f]{6}\$/i
		return strPattern.test(hexcolor); 
		} 
		function WhichClicked(ww) {
			window.document.fiform.waction.value = ww;
		}
		function update_color(color) {
			var whichcolor = document.getElementById(color).value;
			if (whichcolor == "none") {
				hasit = false;
				document.getElementById(color+"_td").style.backgroundImage='url("$fb::cf{'bilderurl'}/allgemein/halftransparent_red.gif")';
			}
			else if(whichcolor == "transparent") {
				hasit = false;
				document.getElementById(color+"_td").style.backgroundImage='url("$fb::cf{'bilderurl'}/allgemein/halftransparent.gif")';
			}
			else {
			hasit = fncIsvalidcolor(whichcolor);
				if (hasit == true) {
					document.getElementById(color+"_td").style.backgroundColor = whichcolor;
					document.getElementById(color+"_td").style.backgroundImage='';
				}
				else {
					alert("$fb::txt{'sk'}{'65'} " + whichcolor +" $fb::txt{'sk'}{'66'}");
				}
			}
		}	

		//-->
		</script>

		<table border=0 cellspacing=1 width=100% cellpadding=10 class=fbborder align=center>

		<tr>
		<td class=fb1 align=center><b>[ $fb::txt{'sk'}{'131'} ]</b></td>
		<td class=fb2 align=center><b>[ <a href="$fb::gl{'scriptac'}=skincss;was2=standard;requskin=$bearbeiteskin">$fb::txt{'sk'}{'130'}</a> ]</b></td></tr>
		</table><br>

			<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>
				<tr><td class=fb2 align=center>
			
			<table border=0 cellspacing="0" cellpadding="3"><form action="$fb::gl{'script'}" method="get" name="fiform2">
		$fb::gl{'hiddenscro'}
			<input type=hidden name="action" value="skincss"><input type=hidden name="was2" value="fancy"><input type=hidden name=requskin value="$bearbeiteskin">
			<tr>
			<td align=right><b>$fb::txt{'sk'}{'101'}:</b></td><td><select name=loadstyle><option value="">$fb::txt{'sk'}{'102'}</option>
		~;

		# open styles
		my @contents = &opendirectory("$fb::gl{'datadir'}/styles");

		foreach (@contents) {
			my @results = split(/\./, $_);
			if ($results[1] && $results[1] eq "css") {
				my $sel = "";
				if ($fb::INFO{'loadstyle'} && $fb::INFO{'loadstyle'} eq "$results[0]" ) {
					$sel = " selected";
				}
				$fb::fi{'main'} .= qq~<option value="$results[0]"$sel>$results[0]</option>~;
			}
		}

		$fb::fi{'main'} .= qq~</select>
		</td>
			<td><input type="submit" name="post" value="$fb::txt{'gl'}{'65'}">	</td>
		</tr></form></table>

		</td>
			</table><br>

		<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>
		<form action="$fb::gl{'scriptac'}=skinsystem2" method="post" name="fiform">
		<input type=hidden name=was value="skincss"><input type=hidden name="was2" value="fancy">
			<input type=hidden name=requskin value="$bearbeiteskin">
		<tr><td class=fb1 align=center valign=bottom><b>$fb::txt{'sk'}{'53'}</b></td>
			<td class=fbcatbg align=center valign=bottom><b>$fb::txt{'sk'}{'54'}</b></td>
			<td class=fbcatbg align=center valign=bottom><b>$fb::txt{'sk'}{'55'}</b></td>
			<td class=fbcatbg align=center valign=bottom><b>$fb::txt{'sk'}{'59'}</b></td>
			<td class=fbcatbg align=center valign=bottom><b>$fb::txt{'sk'}{'56'}<br>$fb::txt{'sk'}{'58'}</b></td>
			
			<td class=fbcatbg align=center valign=bottom>
		<b>$fb::txt{'sk'}{'60'}<br>$fb::txt{'sk'}{'61'}</b></td>
			</tr>
			<tr><td colspan=6 align=center class=fb3><b>$fb::txt{'sk'}{'62'}</b></td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'63'}</b></td>
			<td class=fb2 align=center>~;

		&getcolor( "body", "bgcolor",$css_info{'background-color'}{'body'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "body", "color", $css_info{'color'}{'body'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>&nbsp;</td>
		<td class=fb2 align=center rowspan=2>~;

		&getfont( "body", $css_info{'font-family'}{'body'} );
		&getsize( "body", $css_info{'font-size'}{'body'} );

		$fb::fi{'main'} .= qq~<br>~;

		&getdeko(
			"body",
			$css_info{'text-decoration'}{'body'},
			$css_info{'font-weight'}{'body'},
			$css_info{'font-style'}{'body'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "body", $css_info{'margin'}{'body'} );

		$fb::fi{'main'} .= qq~<br>~;

		&getpadding( "body", $css_info{'padding'}{'body'} );

		$fb::fi{'main'} .= qq~</td>
		</tr>
		<tr><td class=fb2 colspan=3>~;

		&getbackground( "body", $css_info{'background-image'}{'body'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'73'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "td", "bgcolor", $css_info{'background-color'}{'td'} );

		$fb::fi{'main'} .= qq~</td>
		<td class=fb2 align=center>~;

		&getcolor( "td", "color", $css_info{'color'}{'td'} );

		$fb::fi{'main'} .= qq~
		</td><td class=fb2 align=center>~;

		&getborder( "td", $css_info{'border'}{'td'} );

		$fb::fi{'main'} .= qq~</td>
		<td class=fb2 align=center rowspan=2>~;

		&getfont( "td", $css_info{'font-family'}{'td'} );
		&getsize( "td", $css_info{'font-size'}{'td'} );

		$fb::fi{'main'} .= qq~<br>~;

		&getdeko(
			"td",
			$css_info{'text-decoration'}{'td'},
			$css_info{'font-weight'}{'td'},
			$css_info{'font-style'}{'td'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "td", $css_info{'margin'}{'td'} );

		$fb::fi{'main'} .= qq~<br>~;

		&getpadding( "td", $css_info{'padding'}{'td'} );

		$fb::fi{'main'} .= qq~</td>
		</tr>
		<tr><td class=fb2 colspan=3>~;

		&getbackground( "td", $css_info{'background-image'}{'td'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'74'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "alink", "bgcolor",$css_info{'background-color'}{'alink'} );

		$fb::fi{'main'} .= qq~</td>
		<td class=fb2 align=center>~;

		&getcolor( "alink", "color", $css_info{'color'}{'alink'} );

		$fb::fi{'main'} .= qq~
		</td><td class=fb2 align=center>~;

		&getborder( "alink", $css_info{'border'}{'alink'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getfont( "alink", $css_info{'font-family'}{'alink'} );
		&getsize( "alink", $css_info{'font-size'}{'alink'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"alink",
			$css_info{'text-decoration'}{'alink'},
			$css_info{'font-weight'}{'alink'},
			$css_info{'font-style'}{'alink'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "alink", $css_info{'margin'}{'alink'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "alink", $css_info{'padding'}{'alink'} );

		$fb::fi{'main'} .= qq~</td>
		</tr>
		<tr><td class=fb2 colspan=3>&nbsp;~;

		$fb::fi{'main'} .= qq~</td></tr><tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'75'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "avisited", "bgcolor",$css_info{'background-color'}{'avisited'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "avisited", "color", $css_info{'color'}{'avisited'} );

		$fb::fi{'main'} .= qq~
		</td><td class=fb2 align=center>~;
		
		&getborder( "avisited", $css_info{'border'}{'avisited'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;
		
		&getfont( "avisited", $css_info{'font-family'}{'avisited'} );
		&getsize( "avisited", $css_info{'font-size'}{'avisited'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"avisited",
			$css_info{'text-decoration'}{'avisited'},
			$css_info{'font-weight'}{'avisited'},
			$css_info{'font-style'}{'avisited'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "avisited", $css_info{'margin'}{'avisited'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "avisited", $css_info{'padding'}{'avisited'} );

		$fb::fi{'main'} .= qq~</td>
		</tr>
		<tr><td class=fb2 colspan=3>&nbsp;~;

		$fb::fi{'main'} .= qq~</td></tr><tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'76'}</b></td><td class=fb2 align=center>~;

		&getcolor( "ahover", "bgcolor",$css_info{'background-color'}{'ahover'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "ahover", "color", $css_info{'color'}{'ahover'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "ahover", $css_info{'border'}{'ahover'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;
		
		&getfont( "ahover", $css_info{'font-family'}{'ahover'} );
		&getsize( "ahover", $css_info{'font-size'}{'ahover'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"ahover",
			$css_info{'text-decoration'}{'ahover'},
			$css_info{'font-weight'}{'ahover'},
			$css_info{'font-style'}{'ahover'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "ahover", $css_info{'margin'}{'ahover'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "ahover", $css_info{'padding'}{'ahover'} );

		$fb::fi{'main'} .= qq~</td>
		</tr>
		<tr><td class=fb2 colspan=3>&nbsp;~;

		$fb::fi{'main'} .= qq~</td></tr>
			<tr><td colspan=6 align=center class=fb3><b>$fb::txt{'sk'}{'78'}</b></td></tr>
			<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'79'}</b></td>
				<td class=fb2 align=center>~;

		&getcolor( "fbcatbg", "bgcolor",
		
		$css_info{'background-color'}{'fbcatbg'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "fbcatbg", "color", $css_info{'color'}{'fbcatbg'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "fbcatbg", $css_info{'border'}{'fbcatbg'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;
		
		&getfont( "fbcatbg", $css_info{'font-family'}{'fbcatbg'} );
		&getsize( "fbcatbg", $css_info{'font-size'}{'fbcatbg'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"fbcatbg",
			$css_info{'text-decoration'}{'fbcatbg'},
			$css_info{'font-weight'}{'fbcatbg'},
			$css_info{'font-style'}{'fbcatbg'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "fbcatbg", $css_info{'margin'}{'fbcatbg'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "fbcatbg", $css_info{'padding'}{'fbcatbg'} );

		$fb::fi{'main'} .= qq~</td>
		</tr>
		<tr><td class=fb2 colspan=3>~;

		&getbackground( "fbcatbg",$css_info{'background-image'}{'fbcatbg'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'80'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "fbtitle", "bgcolor",$css_info{'background-color'}{'fbtitle'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "fbtitle", "color", $css_info{'color'}{'fbtitle'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "fbtitle", $css_info{'border'}{'fbtitle'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;
		
		&getfont( "fbtitle", $css_info{'font-family'}{'fbtitle'} );
		&getsize( "fbtitle", $css_info{'font-size'}{'fbtitle'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"fbtitle",
			$css_info{'text-decoration'}{'fbtitle'},
			$css_info{'font-weight'}{'fbtitle'},
			$css_info{'font-style'}{'fbtitle'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "fbtitle", $css_info{'margin'}{'fbtitle'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "fbtitle", $css_info{'padding'}{'fbtitle'} );

		$fb::fi{'main'} .= qq~</td>
		</tr>
		<tr><td class=fb2 colspan=3>~;

		&getbackground( "fbtitle",$css_info{'background-image'}{'fbtitle'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'81'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "fbborder", "bgcolor",$css_info{'background-color'}{'fbborder'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "fbborder", "color", $css_info{'color'}{'fbborder'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "fbborder", $css_info{'border'}{'fbborder'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;
		
		&getfont( "fbborder", $css_info{'font-family'}{'fbborder'} );
		&getsize( "fbborder", $css_info{'font-size'}{'fbborder'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"fbborder",
			$css_info{'text-decoration'}{'fbborder'},
			$css_info{'font-weight'}{'fbborder'},
			$css_info{'font-style'}{'fbborder'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "fbborder", $css_info{'margin'}{'fbborder'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "fbborder", $css_info{'padding'}{'fbborder'} );

		$fb::fi{'main'} .= qq~</td>
		</tr>
		<tr><td class=fb2 colspan=3>~;

		&getbackground( "fbborder",$css_info{'background-image'}{'fbborder'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'82'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "fb3", "bgcolor", $css_info{'background-color'}{'fb3'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "fb3", "color", $css_info{'color'}{'fb3'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "fb3", $css_info{'border'}{'fb3'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;
		
		&getfont( "fb3", $css_info{'font-family'}{'fb3'} );
		&getsize( "fb3", $css_info{'font-size'}{'fb3'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"fb3",
			$css_info{'text-decoration'}{'fb3'},
			$css_info{'font-weight'}{'fb3'},
			$css_info{'font-style'}{'fb3'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "fb3", $css_info{'margin'}{'fb3'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "fb3", $css_info{'padding'}{'fb3'} );

		$fb::fi{'main'} .= qq~</td></tr><tr><td class=fb2 colspan=3>~;

		&getbackground( "fb3", $css_info{'background-image'}{'fb3'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'83'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "fb1", "bgcolor", $css_info{'background-color'}{'fb1'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "fb1", "color", $css_info{'color'}{'fb1'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "fb1", $css_info{'border'}{'fb1'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;
		
		&getfont( "fb1", $css_info{'font-family'}{'fb1'} );
		&getsize( "fb1", $css_info{'font-size'}{'fb1'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"fb1",
			$css_info{'text-decoration'}{'fb1'},
			$css_info{'font-weight'}{'fb1'},
			$css_info{'font-style'}{'fb1'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "fb1", $css_info{'margin'}{'fb1'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "fb1", $css_info{'padding'}{'fb1'} );

		$fb::fi{'main'} .= qq~</td>
		</tr>
		<tr><td class=fb2 colspan=3>~;

		&getbackground( "fb1", $css_info{'background-image'}{'fb1'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'84'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "fb2", "bgcolor", $css_info{'background-color'}{'fb2'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "fb2", "color", $css_info{'color'}{'fb2'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "fb2", $css_info{'border'}{'fb2'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;
		
		&getfont( "fb2", $css_info{'font-family'}{'fb2'} );
		&getsize( "fb2", $css_info{'font-size'}{'fb2'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"fb2",
			$css_info{'text-decoration'}{'fb2'},
			$css_info{'font-weight'}{'fb2'},
			$css_info{'font-style'}{'fb2'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		
		&getmargin( "fb2", $css_info{'margin'}{'fb2'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "fb2", $css_info{'padding'}{'fb2'} );

		$fb::fi{'main'} .= qq~</td></tr><tr><td class=fb2 colspan=3>~;

		&getbackground( "fb2", $css_info{'background-image'}{'fb2'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'85'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "fb4", "bgcolor", $css_info{'background-color'}{'fb4'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "fb4", "color", $css_info{'color'}{'fb4'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "fb4", $css_info{'border'}{'fb4'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getfont( "fb4", $css_info{'font-family'}{'fb4'} );
		&getsize( "fb4", $css_info{'font-size'}{'fb4'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"fb4",
			$css_info{'text-decoration'}{'fb4'},
			$css_info{'font-weight'}{'fb4'},
			$css_info{'font-style'}{'fb4'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "fb4", $css_info{'margin'}{'fb4'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "fb4", $css_info{'padding'}{'fb4'} );

		$fb::fi{'main'} .= qq~</td></tr><tr><td class=fb2 colspan=3>~;

		&getbackground( "fb4", $css_info{'background-image'}{'fb4'} );

		$fb::fi{'main'} .= qq~</td></tr>
			<tr><td colspan=6 align=center class=fb3><b>$fb::txt{'sk'}{'88'}</b></td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'89'}</b></td>
			<td class=fb2 align=center>&nbsp;</td>
			<td class=fb2 align=center>~;

		&getcolor( "hr", "color", $css_info{'color'}{'hr'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>&nbsp;</td>
		<td class=fb2 align=center rowspan=2>&nbsp;</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "hr", $css_info{'margin'}{'hr'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "hr", $css_info{'padding'}{'hr'} );

		$fb::fi{'main'} .= qq~</td>
		</tr>
		<tr><td class=fb2 colspan=3>&nbsp;</td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'90'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "pinned", "bgcolor",$css_info{'background-color'}{'pinned'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "pinned", "color", $css_info{'color'}{'pinned'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "pinned", $css_info{'border'}{'pinned'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getfont( "pinned", $css_info{'font-family'}{'pinned'} );
		&getsize( "pinned", $css_info{'font-size'}{'pinned'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"pinned",
			$css_info{'text-decoration'}{'pinned'},
			$css_info{'font-weight'}{'pinned'},
			$css_info{'font-style'}{'pinned'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "pinned", $css_info{'margin'}{'pinned'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "pinned", $css_info{'padding'}{'pinned'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td class=fb2 colspan=3>~;

		&getbackground( "pinned", $css_info{'background-image'}{'pinned'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'48'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "marked", "bgcolor",$css_info{'background-color'}{'marked'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "marked", "color", $css_info{'color'}{'marked'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "marked", $css_info{'border'}{'marked'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getfont( "marked", $css_info{'font-family'}{'marked'} );
		&getsize( "marked", $css_info{'font-size'}{'marked'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"marked",
			$css_info{'text-decoration'}{'marked'},
			$css_info{'font-weight'}{'marked'},
			$css_info{'font-style'}{'marked'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "marked", $css_info{'margin'}{'marked'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "marked", $css_info{'padding'}{'marked'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td class=fb2 colspan=3>~;

		&getbackground( "marked", $css_info{'background-image'}{'marked'} );

		$fb::fi{'main'} .= qq~</td>	</tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'91'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "fbkomm", "bgcolor",$css_info{'background-color'}{'fbkomm'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "fbkomm", "color", $css_info{'color'}{'fbkomm'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "fbkomm", $css_info{'border'}{'fbkomm'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getfont( "fbkomm", $css_info{'font-family'}{'fbkomm'} );
		&getsize( "fbkomm", $css_info{'font-size'}{'fbkomm'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"fbkomm",
			$css_info{'text-decoration'}{'fbkomm'},
			$css_info{'font-weight'}{'fbkomm'},
			$css_info{'font-style'}{'fbkomm'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "fbkomm", $css_info{'margin'}{'fbkomm'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "fbkomm", $css_info{'padding'}{'fbkomm'} );

		$fb::fi{'main'} .= qq~</td></tr><tr><td class=fb2 colspan=3>~;

		&getbackground( "fbkomm", $css_info{'background-image'}{'fbkomm'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'92'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "quote", "bgcolor",$css_info{'background-color'}{'quote'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "quote", "color", $css_info{'color'}{'quote'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "quote", $css_info{'border'}{'quote'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getfont( "quote", $css_info{'font-family'}{'quote'} );
		&getsize( "quote", $css_info{'font-size'}{'quote'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"quote",
			$css_info{'text-decoration'}{'quote'},
			$css_info{'font-weight'}{'quote'},
			$css_info{'font-style'}{'quote'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "quote", $css_info{'margin'}{'quote'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "quote", $css_info{'padding'}{'quote'} );

		$fb::fi{'main'} .= qq~</td></tr><tr><td class=fb2 colspan=3>~;

		&getbackground( "quote", $css_info{'background-image'}{'quote'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'93'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "ubbca", "bgcolor",$css_info{'background-color'}{'ubbca'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "ubbca", "color", $css_info{'color'}{'ubbca'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "ubbca", $css_info{'border'}{'ubbca'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getfont( "ubbca", $css_info{'font-family'}{'ubbca'} );
		&getsize( "ubbca", $css_info{'font-size'}{'ubbca'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"ubbca",
			$css_info{'text-decoration'}{'ubbca'},
			$css_info{'font-weight'}{'ubbca'},
			$css_info{'font-style'}{'ubbca'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "ubbca", $css_info{'margin'}{'ubbca'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "ubbca", $css_info{'padding'}{'ubbca'} );

		$fb::fi{'main'} .= qq~</td></tr><tr><td class=fb2 colspan=3>~;

		&getbackground( "ubbca", $css_info{'background-image'}{'ubbca'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'94'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "ubbcahover", "bgcolor",$css_info{'background-color'}{'ubbcahover'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "ubbcahover", "color",$css_info{'color'}{'ubbcahover'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "ubbcahover", $css_info{'border'}{'ubbcahover'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getfont( "ubbcahover", $css_info{'font-family'}{'ubbcahover'} );
		&getsize( "ubbcahover", $css_info{'font-size'}{'ubbcahover'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"ubbcahover",
			$css_info{'text-decoration'}{'ubbcahover'},
			$css_info{'font-weight'}{'ubbcahover'},
			$css_info{'font-style'}{'ubbcahover'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "ubbcahover", $css_info{'margin'}{'ubbcahover'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "ubbcahover", $css_info{'padding'}{'ubbcahover'} );

		$fb::fi{'main'} .= qq~</td></tr><tr><td class=fb2 colspan=3>~;

		&getbackground( "ubbcahover",$css_info{'background-image'}{'ubbcahover'} );

		$fb::fi{'main'} .= qq~</td></tr>
		<tr><td colspan=6 align=center class=fb3><b>$fb::txt{'sk'}{'95'}</b></td></tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'95'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "input", "bgcolor",$css_info{'background-color'}{'input'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "input", "color", $css_info{'color'}{'input'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getborder( "input", $css_info{'border'}{'input'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getfont( "input", $css_info{'font-family'}{'input'} );
		&getsize( "input", $css_info{'font-size'}{'input'} );

		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"input",
			$css_info{'text-decoration'}{'input'},
			$css_info{'font-weight'}{'input'},
			$css_info{'font-style'}{'input'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "input", $css_info{'margin'}{'input'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "input", $css_info{'padding'}{'input'} );

		$fb::fi{'main'} .= qq~</td></tr><tr><td class=fb2 colspan=3>~;

		&getbackground( "input", $css_info{'background-image'}{'input'} );

		$fb::fi{'main'} .= qq~</td>	</tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'96'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "textarea", "bgcolor",$css_info{'background-color'}{'textarea'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "textarea", "color", $css_info{'color'}{'textarea'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "textarea", $css_info{'border'}{'textarea'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getfont( "textarea", $css_info{'font-family'}{'textarea'} );
		&getsize( "textarea", $css_info{'font-size'}{'textarea'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"textarea",
			$css_info{'text-decoration'}{'textarea'},
			$css_info{'font-weight'}{'textarea'},
			$css_info{'font-style'}{'textarea'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "textarea", $css_info{'margin'}{'textarea'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "textarea", $css_info{'padding'}{'textarea'} );

		$fb::fi{'main'} .= qq~</td></tr><tr><td class=fb2 colspan=3>~;

		&getbackground( "textarea",$css_info{'background-image'}{'textarea'} );

		$fb::fi{'main'} .= qq~</td>	</tr>
		<tr><td class=fb1 align=center rowspan=2><b>$fb::txt{'sk'}{'97'}</b></td>
		<td class=fb2 align=center>~;

		&getcolor( "select", "bgcolor",$css_info{'background-color'}{'select'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;

		&getcolor( "select", "color", $css_info{'color'}{'select'} );

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center>~;
		
		&getborder( "select", $css_info{'border'}{'select'} );
		
		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getfont( "select", $css_info{'font-family'}{'select'} );
		&getsize( "select", $css_info{'font-size'}{'select'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getdeko(
			"select",
			$css_info{'text-decoration'}{'select'},
			$css_info{'font-weight'}{'select'},
			$css_info{'font-style'}{'select'}
		);

		$fb::fi{'main'} .= qq~</td><td class=fb2 align=center rowspan=2>~;

		&getmargin( "select", $css_info{'margin'}{'select'} );
		
		$fb::fi{'main'} .= qq~<br>~;
		
		&getpadding( "select", $css_info{'padding'}{'select'} );

		$fb::fi{'main'} .= qq~</td></tr><tr><td class=fb2 colspan=3>~;

		&getbackground( "select", $css_info{'background-image'}{'select'} );

		$fb::fi{'main'} .= qq~</td>	</tr>
		<tr><td class=fb4 colspan=6 align=center><input type="hidden" name="waction" value="post"><input type="submit" name="post" onClick="WhichClicked('post');" value="$fb::txt{'sk'}{'106'}">
		<input type="submit" name="post" onClick="WhichClicked('preview');" value="$fb::txt{'sk'}{'108'}">	
		</td></tr></form>	
		</table>~;

	}


	&adminschluss;
	&template;

}

sub skintemplates {

	&isadmin;
	my $bearbeiteskin = $fb::INFO{'requskin'} || $fb::cf{'skinchosen'} || "";

	&adminmenu;
	
	# skinsystem extra menu
	&printmenu($bearbeiteskin,"skintemplates");

	my $opentemp = "template";
	my $templatefreec = "";


	if ($fb::INFO{'templatech'} && $fb::INFO{'templatech'} eq "templatefree") {
		$opentemp      = "templatefree";
		$templatefreec = " selected";
	}

	my @templatefile = &openfile("$fb::gl{'datadir'}/skins/$bearbeiteskin/$opentemp.html");

	my $joinedtemp = join( "", @templatefile );

	$fb::fi{'otherjava'} .= qq~
	<script language= "JavaScript"> 
	<!-- 
	var elementsa =new Array();
	var elementsb =new Array();
	var elementsc =new Array();
	var elementsd =new Array();
	var geschrieben =new Array();
	elementsa[1] = "&lt;FIREBOOK SCRIPT&gt;<br>&lt;FIREBOOK SCRIPTAC&gt;<br>&lt;FIREBOOK SCRIPTACNOSKIN&gt;";
	elementsb[1] = "$fb::txt{'sk'}{'177'}<br>$fb::txt{'sk'}{'178'}<br>$fb::txt{'sk'}{'179'}";
	elementsc[1] = "&lt;FIREBOOK HOMEPAGE&gt;<br>&lt;FIREBOOK BILDERURL&gt;<br>&lt;FIREBOOK BILDERURLSK&gt;";
	elementsd[1] = "$fb::txt{'sk'}{'2'}<br>$fb::txt{'sk'}{'180'}<br>$fb::txt{'sk'}{'181'}";
	elementsa[2] = "&lt;FIREBOOK MENU&gt;<br>&lt;FIREBOOK ADDMSG&gt;<br>&lt;FIREBOOK SHOWENTRYS&gt;<br>&lt;FIREBOOK GUESTMAP&gt;<br>&lt;FIREBOOK REGLINK&gt;<br>&lt;FIREBOOK SILLYSTATS&gt;<br>&lt;FIREBOOK HELPLINK&gt;<br>&lt;FIREBOOK ADMIN&gt;<br>&lt;FIREBOOK ARCHIVLINK&gt;<br>";
	elementsb[2] = "$fb::txt{'sk'}{'183'}<br>$fb::txt{'sk'}{'184'}<br>$fb::txt{'sk'}{'185'}<br>$fb::txt{'sk'}{'186'}<br>$fb::txt{'sk'}{'187'}<br>$fb::txt{'sk'}{'188'}<br>$fb::txt{'sk'}{'189'}<br>$fb::txt{'sk'}{'190'}<br>$fb::txt{'sk'}{'166'}<br>";
	elementsc[2] = "&lt;FIREBOOK JUMP&gt;<br>&lt;FIREBOOK SEARCHFORM&gt;<br>&lt;FIREBOOK LANG&gt;<br>&lt;FIREBOOK LANGBUTT&gt;<br>&lt;FIREBOOK PRINTINFO&gt;<br>&lt;FIREBOOK NEXTPAGE&gt;<br>&lt;FIREBOOK PREVPAGE&gt;<br>&lt;FIREBOOK PAGES&gt;<br>";
	elementsd[2] = "$fb::txt{'sk'}{'191'}<br>$fb::txt{'sk'}{'132'}<br>$fb::txt{'sk'}{'133'}<br>$fb::txt{'sk'}{'134'}<br>$fb::txt{'sk'}{'135'}<br>$fb::txt{'sk'}{'136'}<br>$fb::txt{'sk'}{'137'}<br>$fb::txt{'sk'}{'138'}<br>";
	elementsa[3] = "&lt;FIREBOOK ALLEZUGRIFFE&gt;<br>&lt;FIREBOOK COUNTGESTERN&gt;<br>&lt;FIREBOOK COUNTHEUTE&gt;<br>&lt;FIREBOOK COUNTJETZT&gt;";
	elementsb[3] = "$fb::txt{'sk'}{'140'}<br>$fb::txt{'sk'}{'141'}<br>$fb::txt{'sk'}{'142'}<br>$fb::txt{'sk'}{'143'}";
	elementsc[3] = "&lt;FIREBOOK COUNTGESTERNADMIN&gt;<br>&lt;FIREBOOK COUNTHEUTEADMIN&gt;<br>&lt;FIREBOOK COUNTJETZTADMIN&gt;<br>&lt;FIREBOOK COUNTREST&gt;";
	elementsd[3] = "$fb::txt{'sk'}{'144'}<br>$fb::txt{'sk'}{'145'}<br>$fb::txt{'sk'}{'146'}<br>$fb::txt{'sk'}{'147'}";
	elementsa[4] = "&lt;FIREBOOK FBNAME&gt;<br>&lt;FIREBOOK TITLE&gt;<br>&lt;FIREBOOK LOGO&gt;<br>&lt;FIREBOOK COUNT&gt;<br>&lt;FIREBOOK PAGECOUNT&gt;<br>";
	elementsb[4] = "$fb::txt{'sk'}{'148'}<br>$fb::txt{'sk'}{'149'}<br>$fb::txt{'sk'}{'150'}<br>$fb::txt{'sk'}{'151'}<br>$fb::txt{'sk'}{'152'}";
	elementsc[4] = "&lt;FIREBOOK LASTVERSION&gt;<br>&lt;FIREBOOK VERSION&gt;<br>&lt;FIREBOOK MIDDLERATE&gt;<br>&lt;FIREBOOK RATING&gt;<br>";
	elementsd[4] = "$fb::txt{'sk'}{'153'}<br>$fb::txt{'sk'}{'154'}<br>$fb::txt{'sk'}{'155'}<br>$fb::txt{'sk'}{'156'}";
	elementsa[5] = "&lt;FIREBOOK CSS&gt;<br>&lt;FIREBOOK OTHERJAVA&gt;<br>&lt;FIREBOOK JAVAEFFECTS&gt;<br>&lt;FIREBOOK JAVAEFFECTSSTART&gt;<br>";
	elementsb[5] = "$fb::txt{'sk'}{'167'}<br>$fb::txt{'sk'}{'159'}<br>$fb::txt{'sk'}{'160'}<br>$fb::txt{'sk'}{'161'}";~;
	if ($fb::mod{'modules_info'}{'mod_qrepl'}[0]) {
		$fb::fi{'otherjava'} .= qq~elementsc[5] = "&lt;FIREBOOK QUICKENTRY&gt;<br>&lt;txt_gl [nr]&gt;";
		elementsd[5] = "$fb::txt{'sk'}{'164'}<br>$fb::txt{'sk'}{'168'}";~;
	}
	else {
		$fb::fi{'otherjava'} .= qq~elementsc[5] = "&lt;txt_gl [nr]&gt;";
		elementsd[5] = "$fb::txt{'sk'}{'168'}";~;
	}
	$fb::fi{'otherjava'} .= qq~function schreiben(element) 
	{ 
	if (geschrieben[element] == 1) { loeschen(element) }
	else { 
	document.getElementById("elementa" + element + "").innerHTML = "<font size=1 color=red><i>"+elementsa[element]+"</i></font>"; 
	document.getElementById("elementb" + element + "").innerHTML = "<font size=1>"+elementsb[element]+"</font>"; 
	document.getElementById("elementc" + element + "").innerHTML = "<font size=1 color=red><i>"+elementsc[element]+"</i></font>"; 
	document.getElementById("elementd" + element + "").innerHTML = "<font size=1>"+elementsd[element]+"</font>";
	geschrieben[element] = 1;
	}
	} 

	function loeschen(element) 
	{ 
	document.getElementById("elementa" + element + "").innerHTML = "";
	document.getElementById("elementb" + element + "").innerHTML = "";
	document.getElementById("elementc" + element + "").innerHTML = "";
	document.getElementById("elementd" + element + "").innerHTML = "";
	geschrieben[element] = 0;
	}
	var wrotedata = false;
	function schreiben2() {
		if (wrotedata) {
			document.getElementById("tempcommands").innerHTML = "";
			wrotedata = false;
		}
		else {
			document.getElementById("tempcommands").innerHTML = "<table border=0 cellspacing=0 cellpadding=2 width=100%><tr><td width=140 align=right valign=top><font size=1>$fb::txt{'sk'}{'170'}</font></td><td width=230><font size=1>&lt;<font color=red>FIRE</font> IF<i>(nr)</i>&gt;&lt;<font color=red>VAR</font> <i>(varname)</i>&gt;&lt;<font color=red>/FIRE</font> IF<i>(nr)</i>&gt<br>&lt;<font color=red>FIRE</font> DO<i>(nr)</i>&gt;<br>&nbsp; &nbsp;<i>(html1)</i><br>&lt;/<font color=red>FIRE</font> DO<i>(nr)</i>&gt;<br>&lt;<font color=red>FIRE</font> ELSE<i>(nr)</i>&gt;<br>&nbsp; &nbsp;<i>(html2)</i><br>&lt;<font color=red>/FIRE</font> ELSE<i>(nr)</i>&gt;</font></td><td valign=top><font size=1>$fb::txt{'sk'}{'171'}</font></td></tr></table>";
			wrotedata = true;
		}
	}
	function Formular2()
	  {
		maintag = "<" + "FIREBOOK MAIN" + ">";
		if(document.Formular.template.value.indexOf(maintag) == -1)
		{
		 alert("$fb::txt{'sk'}{'165'}");
		 document.Formular.template.focus();
		 return false;
		}
		  }
	 //-->
	</script>~;

	$fb::fi{'main'} .= qq~<table border=0 cellspacing=1 width=100% cellpadding=2 class=fbborder align=center>~;

	# help menu
	
	my @mytemplatemenu = (
		"$fb::txt{'sk'}{'173'}", "$fb::txt{'sk'}{'176'}",
		"$fb::txt{'sk'}{'182'}", "$fb::txt{'sk'}{'139'}",
		"$fb::txt{'sk'}{'157'}", "$fb::txt{'sk'}{'158'}"
	);
	
	my $counttemp  = 0;
	my $countfirst = 0;
	foreach my $menuitem (@mytemplatemenu) {
		
		my ($pr1,$pr2,$pr3,$pr4,$alink,$alink2)=("","","","","","");
		
		if ( $countfirst != 1 ) {
			$countfirst = 1;
			$pr1 = "<font size=1 color=red><i>&lt;FIREBOOK MAIN&gt;</i></font>";
			$pr2 = "<font size=1>$fb::txt{'sk'}{'174'}</font>";
		}
		else {
			$counttemp++;
			$pr1   = "<div id=elementa$counttemp></div>";
			$pr2   = "<div id=elementb$counttemp></div>";
			$pr3   = "<div id=elementc$counttemp></div>";
			$pr4   = "<div id=elementd$counttemp></div>";
			$alink = qq~<a href="javascript: schreiben('$counttemp');">~;
			$alink2 = "</a>";
		}

		$fb::fi{'main'} .= qq~	<tr>
			<td colspan=4 class=fb1 align=center><b>[ $alink$menuitem$alink2 ]</b></td></tr>
			<tr class=fb2>
			<td align=right valign=top width=28%>$pr1</td>
			<td valign=top width=22%>$pr2</td>
			<td align=right valign=top width=28%>$pr3</td>
			<td valign=top width=22%>$pr4</td></tr>~;

	}

	$fb::fi{'main'} .= qq~
	<tr>
		<td colspan=4 class=fb1 align=center><b>[ <a href="javascript: schreiben2();">$fb::txt{'sk'}{'169'}</a> ]</b></td></tr>
	<tr class=fb2>
		<td align=center valign=top colspan=4>
	<div id=tempcommands></div>
	</td></tr>
	</table><br>
	<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>
	<tr><td class=fb1 aign=center>
	<table border=0 cellspacing=0 cellpading=0 width=100%><tr><td>
	<table align=center border=0 cellspacing=1 cellpadding=2>	
	<form action="$fb::gl{'script'}" method="get" name="fiform2">
	$fb::gl{'hiddenscro'} <input type=hidden name=action value="skintemplates">
		<input type=hidden name=requskin value="$bearbeiteskin">
	<tr>
	<td><b>$fb::txt{'sk'}{'172'}:</b></td>
	<td><select name="templatech">
	<option value="">$fb::txt{'sk'}{'104'}</option>
	<option value="templatefree"$templatefreec>$fb::txt{'sk'}{'105'}</option>
	</select>	</td>
	<td><input type="submit" name="post" value="$fb::txt{'gl'}{'65'}"></td>
	</tr>
	</form>
	</table></td><td align=center>
	<b>[ <a href="javascript:popUp('$fb::gl{'scriptac'}=syntaxh;requskin=$bearbeiteskin;template=$opentemp.html',800,600)">$fb::txt{'sk'}{'128'}</a> ]</b>
		
	</td>
	</tr></table>
	</td></tr>
	<form action="$fb::gl{'scriptac'}=skinsystem2" method="post" name="Formular" onSubmit="return Formular2()">
	<input type=hidden name=was value="skintemplates"><input type=hidden name=requskin value="$bearbeiteskin">
	<input type=hidden name=templatech value="$opentemp">

	<tr><td class=fb2 align=center>
		<textarea wrap="virtual" id="template" name="template" cols=130 rows=20>~;

	foreach (@templatefile) {
		$_ =~ s/</&lt;/g;
		$_ =~ s/>/&gt;/g;
		$fb::fi{'main'} .= $_;
	}
	#$outputhigh =~ s/\n/<br>/g;
	#$outputhigh =~ s/  /&nbsp;/g;

	$fb::fi{'main'} .= qq~</textarea></td></tr></tr><td class=fb4 align=center>
	   <input type="submit" name="post" value="$fb::txt{'sk'}{'192'}">	
			</td></tr>
	  </form>
	</table>
	~;

	&adminschluss;
	&template;


}
sub skinsystem {

	&isadmin;
	my $bearbeiteskin = $fb::INFO{'requskin'} || "";
	my $was           = $fb::INFO{'was'} || "";
	
	# rename a skin
	if ( $was eq "skinrename" ) {

		my $newskinname = $fb::INFO{'newname'};
		
		unless ( $newskinname =~ m/^[a-z]+$/ ) {
			&fatal_error("$fb::txt{'sk'}{'122'}");
		}
		
		if ( $newskinname eq $bearbeiteskin ) {
			my $set_location = qq~$fb::gl{'scriptac'}=skinsystem~;
			&redirect($set_location);
		}
		# skin name exists already
		if (( -d "$fb::gl{'datadir'}/skins/$newskinname" ) || ( -d "$fb::cf{'bilderdir'}/skins/$newskinname" )) {
			&fatal_error("$fb::txt{'sk'}{'113'} &raquo; $newskinname");
		}
		else { # rename approved

			rename(
				"$fb::gl{'datadir'}/skins/$bearbeiteskin",
				"$fb::gl{'datadir'}/skins/$newskinname"
			);
			rename(
				"$fb::cf{'bilderdir'}/skins/$bearbeiteskin",
				"$fb::cf{'bilderdir'}/skins/$newskinname"
			);

			if ( $bearbeiteskin eq $fb::cf{'skinchosen'} ) {
				
				# change config
				my @infospl = &openfile("$fb::cf{'ordnerdir'}/config.pl");
				
				my $printback = "";

				foreach my $line (@infospl) {
					if ($line =~ m/^\$fb::cf{'skinchosen'} \= qq\~(.*?)\~\;/ig) {
						$printback .= qq~\$fb::cf{'skinchosen'} \= qq\~$newskinname\~\;\n~;
					}
					else { $printback .= $line; }
				}
				&writefile( "$fb::cf{'ordnerdir'}/config.pl", $printback );
			}
		}
		my $set_location = qq~$fb::gl{'scriptac'}=skinsystem~;
		&redirect($set_location);
	}
	elsif ( $was eq "skindelete" ) { # skin deletion

		if ( $bearbeiteskin eq $fb::cf{'skinchosen'} ) {
			&fatal_error( $fb::txt{'sk'}{'124'} );
		}
		
		# remove skin html contents
		my @contents = &opendirectory("$fb::gl{'datadir'}/skins/$bearbeiteskin");

		foreach (@contents) {
			if (($_ ne ".") && ($_ ne "..")) {
				&dounlink("$fb::gl{'datadir'}/skins/$bearbeiteskin/$_");
			}
		}
		rmdir("$fb::gl{'datadir'}/skins/$bearbeiteskin");
		
		# remove skin graphical contents
		my @contents2 = &opendirectory("$fb::cf{'bilderdir'}/skins/$bearbeiteskin");

		foreach my $line (@contents2) {
			if (( -d "$fb::cf{'bilderdir'}/skins/$bearbeiteskin/$line" ) && ( $line ne "." ) && ( $line ne ".." ))	{
				
				#sub directory
				my @contents3 = &opendirectory("$fb::cf{'bilderdir'}/skins/$bearbeiteskin/$line");

				foreach my $line2 (@contents3) {
					if (( $line2 ne "." ) && ( $line2 ne ".." )) {
						&dounlink("$fb::cf{'bilderdir'}/skins/$bearbeiteskin/$line/$line2");
					}
				}
				rmdir("$fb::cf{'bilderdir'}/skins/$bearbeiteskin/$line");
			}
		}
		rmdir("$fb::cf{'bilderdir'}/skins/$bearbeiteskin");

		my $set_location = qq~$fb::gl{'scriptac'}=skinsystem~;
		&redirect($set_location);

	}
	elsif ( $was eq "skinexport" ) { # skin export

		my $unique_id = time;

		my @contents = &opendirectory("$fb::gl{'datadir'}/skins/$bearbeiteskin");
		
		# stores all the files
		my @skinfiles = "";
		
		# html files first
		foreach my $line (@contents) {
			if (($line ne ".") && ($line ne "..")) {
				my @thistemp =  &openfile( "$fb::gl{'datadir'}/skins/$bearbeiteskin/$line","1" );
				my $filedeklaration = qq~$pushatskin-$fb::gl{'thisscriptcode'}-$fb::gl{'thisversion'}-$unique_id-data-skins-$bearbeiteskin-$line-$pushatskin2~;
				push( @skinfiles, $filedeklaration );
				push( @skinfiles, @thistemp );
			}
		}
		
		# now image files
		my @contents2 = &opendirectory("$fb::cf{'bilderdir'}/skins/$bearbeiteskin");

		foreach my $line (@contents2) {
			if (( -d "$fb::cf{'bilderdir'}/skins/$bearbeiteskin/$line" ) && ( $line ne "." ) && ( $line ne ".." )) {

				my @contents3 = &opendirectory("$fb::cf{'bilderdir'}/skins/$bearbeiteskin/$line");

				foreach my $line2 (@contents3) {
					if (( $line2 ne "." ) && ( $line2 ne ".." )) {
					
						my @thistemp = &openfile("$fb::cf{'bilderdir'}/skins/$bearbeiteskin/$line/$line2","1");
						my $filedeklaration = qq~$pushatskin-$fb::gl{'thisscriptcode'}-$fb::gl{'thisversion'}-$unique_id-bilder-$bearbeiteskin-$line-$line2-$pushatskin2~;
						push( @skinfiles, $filedeklaration );
						push( @skinfiles, @thistemp );

					}
				}
			}
		}

		# write skin file
		&writefile( "$fb::cf{'bilderdir'}/temp/$bearbeiteskin.skin",undef, "", \@skinfiles, "1" );
		chmod( 0777, "$fb::cf{'bilderdir'}/temp/$bearbeiteskin.skin" );
		
		# now send it to the browser

		my @stat = stat("$fb::cf{'bilderdir'}/temp/$bearbeiteskin.skin");
		my $filesize = $stat[7];
		$fb::gl{'thisversion'} =~ s/\.//ig;
		
		my $newfilename = $fb::gl{'thisscriptcode'} . "_" . $fb::gl{'thisversion'} . "_" . $bearbeiteskin . ".skin";

		print "Content-disposition: inline; filename=$newfilename\n";
		print "Content-Length: $filesize\n";
		print "Content-Type: multipart/form-data; name=$newfilename\n\n";

		open( READ, "$fb::cf{'bilderdir'}/temp/$bearbeiteskin.skin" ) || die;
		binmode READ;
		binmode STDOUT;
		while (<READ>) { print; }
		close(READ);
		&dounlink("$fb::cf{'bilderdir'}/temp/$bearbeiteskin.skin");
		&database_disconnect;
		exit;

	}
	elsif ($was eq "colorpicker") { # colour picker popup window

		my $openwhat = $fb::INFO{'insert'};
		my $trtext   = $fb::txt{'sk'}{'99'};
		my $tr2text  = $fb::txt{'sk'}{'100'};

		$fb::fi{'main'} .= qq~<div id="colorbox" name="colorbox" width=100% height=100% align=center></div>
			<script language=javascript>
			<!--
			var whatopen = "$openwhat"; 
			function writeRow() {
				var cells = 17;
				var str = "";
				var ar = new Array("#330000","#333300","#336600","#339900","#33CC00","#33FF00","#66FF00","#66CC00","#669900","#666600","#663300","#660000","#FF0000","#FF3300","#FF6600","#FF9900","#FFCC00","#FFFF00","#330033","#333333","#336633","#339933","#33CC33","#33FF33","#66FF33","#66CC33","#669933","#666633","#663333","#660033","#FF0033","#FF3333","#FF6633","#FF9933","#FFCC33","#FFFF33","#330066","#333366","#336666","#339966","#33CC66","#33FF66","#66FF66","#66CC66","#669966","#666666","#663366","#660066","#FF0066","#FF3366","#FF6666","#FF9966","#FFCC66","#FFFF66","#330099","#333399","#336699","#339999","#33CC99","#33FF99","#66FF99","#66CC99","#669999","#666699","#663399","#660099","#FF0099","#FF3399","#FF6699","#FF9999","#FFCC99","#FFFF99","#3300CC","#3333CC","#3366CC","#3399CC","#33CCCC","#33FFCC","#66FFCC","#66CCCC","#6699CC","#6666CC","#6633CC","#6600CC","#FF00CC","#FF33CC","#FF66CC","#FF99CC","#FFCCCC","#FFFFCC","#3300FF","#3333FF","#3366FF","#3399FF","#33CCFF","#33FFFF","#66FFFF","#66CCFF","#6699FF","#6666FF","#6633FF","#6600FF","#FF00FF","#FF33FF","#FF66FF","#FF99FF","#FFCCFF","#FFFFFF","#0000FF","#0033FF","#0066FF","#0099FF","#00CCFF","#00FFFF","#99FFFF","#99CCFF","#9999FF","#9966FF","#9933FF","#9900FF","#CC00FF","#CC33FF","#CC66FF","#CC99FF","#CCCCFF","#CCFFFF","#0000CC","#0033CC","#0066CC","#0099CC","#00CCCC","#00FFCC","#99FFCC","#99CCCC","#9999CC","#9966CC","#9933CC","#9900CC","#CC00CC","#CC33CC","#CC66CC","#CC99CC","#CCCCCC","#CCFFCC","#000099","#003399","#006699","#009999","#00CC99","#00FF99","#99FF99","#99CC99","#999999","#996699","#993399","#990099","#CC0099","#CC3399","#CC6699","#CC9999","#CCCC99","#CCFF99","#000066","#003366","#006666","#009966","#00CC66","#00FF66","#99FF66","#99CC66","#999966","#996666","#993366","#990066","#CC0066","#CC3366","#CC6666","#CC9966","#CCCC66","#CCFF66","#000033","#003333","#006633","#009933","#00CC33","#00FF33","#99FF33","#99CC33","#999933","#996633","#993333","#990033","#CC0033","#CC3333","#CC6633","#CC9933","#CCCC33","#CCFF33","#000000","#003300","#006600","#009900","#00CC00","#00FF00","#99FF00","#99CC00","#999900","#996600","#993300","#990000","#CC0000","#CC3300","#CC6600","#CC9900","#CCCC00","#CCFF00","#000000","#111111","#222222","#333333","#444444","#555555","#666666","#777777","#888888","#999999","#9A9A9A","#AAAAAA","#BBBBBB","#CCCCCC","#DDDDDD","#EEEEEE","#EFEFEF","#FFFFFF");
				str += '<table cellspacing="1" cellpadding="0" border=0>';
				for (var i=0; i<ar.length; ) {
					str += "<tr>"
					for (var j=0; j<=cells && i<ar.length; j++) {
						str += "<td bgcolor='"  + ar[i] +  "' width=10 height=10><img width=10 height=10 src='$fb::cf{'bilderurl'}/allgemein/transparent.gif' title='"  + ar[i] +  "' alt='"  + ar[i] +  "' border='0' onmouseover=this.style.cursor='pointer' onclick='writecolor(\\""+ar[i]+"\\")'></td>";
						i++;
					}
					str += "</tr>";
				}
				str += "<tr><td background='$fb::cf{'bilderurl'}/allgemein/halftransparent.gif' colspan=9 height=10><img width='100%' height=10 src='$fb::cf{'bilderurl'}/allgemein/transparent.gif' title='$trtext' alt='$trtext' border='0' onmouseover=this.style.cursor='pointer' onclick='writecolor(\\"transparent\\")'></td><td background='$fb::cf{'bilderurl'}/allgemein/halftransparent_red.gif' colspan=9 height=10><img width='100%' height=10 src='$fb::cf{'bilderurl'}/allgemein/transparent.gif' alt='$tr2text' border='0' onmouseover=this.style.cursor='pointer' onclick='writecolor(\\"none\\")'></td></tr>";
				str+='</table>';
				document.getElementById("colorbox").innerHTML = str;
			}
			function writecolor(color) {
			if (color == "none") {
				opener.document.getElementById(whatopen+"_td").style.backgroundImage='url("$fb::cf{'bilderurl'}/allgemein/halftransparent_red.gif")';
			}
			else if (color == "transparent") {
				opener.document.getElementById(whatopen+"_td").style.backgroundImage='url("$fb::cf{'bilderurl'}/allgemein/halftransparent.gif")';
			}
			else {
				opener.document.getElementById(whatopen+"_td").style.backgroundColor = color;
				opener.document.getElementById(whatopen+"_td").style.backgroundImage='';
			}
				opener.document.getElementById(whatopen).value = color;  
				opener.document.getElementById(whatopen).focus();
				self.close();
			}
			writeRow();

			-->
			</script>
			~;

		&freetemp;
		exit;

	}
	else {

		# ALL STANDARD ACTIONS GO HERE

		&adminmenu;

			# main page of skinsystem

			$fb::fi{'otherjava'} .=
			  qq~<script language="JavaScript1.2" type="text/javascript">
				<!--
				function deleteconfirm(deleteskin, deletepath) {
						if (confirm("$fb::txt{'sk'}{'126'} "+ deleteskin +" $fb::txt{'sk'}{'98'}")) {
							window.location.href='$fb::gl{'scriptac'}=' + deletepath;
						}
				}
				function renameconfirm(oldskin, renamepath) {
					txt=window.prompt ("$fb::txt{'sk'}{'46'} "+ oldskin +" $fb::txt{'sk'}{'47'}",oldskin);
					if (txt != "" && txt != null) {
					window.location.href='$fb::gl{'scriptac'}=' + renamepath + ';newname=' + txt;
					}
				}
				-->
				</script>~;

			$fb::fi{'main'} .= qq~
			<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>
				<tr><td class=fbcatbg colspan=3><b>$fb::txt{'gl'}{'92'}<b></td></tr>
			<tr><td class=fb1 width=33% align=center><b>$fb::txt{'sk'}{'7'}</b></td>
			<td class=fb2 width=33% align=center><a href="$fb::gl{'scriptac'}=newskin;was=erstellen"><b>$fb::txt{'sk'}{'6'}</b></a></td>
			<td class=fb2 width=33% align=center><a href="$fb::gl{'scriptac'}=newskin;was=import"><b>$fb::txt{'sk'}{'1'}</b></a></td>	
			</tr>
			<tr><td colspan=3 class=fb2 align=center><font size=1>$fb::txt{'sk'}{'13'}</font></td></tr>
			<form action="$fb::gl{'scriptac'}=einst2" method="post" name="fiform">
				<input type=hidden name="save_action" value="skinsystem">
			<tr><td colspan=3 class=fb2 align=center><br>
			~;

			my @contents = &opendirectory("$fb::gl{'datadir'}/skins");

			foreach my $line (@contents) {
				if (( -d "$fb::gl{'datadir'}/skins/$line" ) && (( $line ne "." ) && ( $line ne ".." )))	{
					
					my $selected = "";
					if ( $line eq "admin" ) { next; }
					if ( $line eq $fb::cf{'skinchosen'} ) {
						$selected = " checked";
					}

					$fb::fi{'main'} .= qq~<table border=0 cellspacing=1 cellpadding=2 width=90% class=fbborder>
							<tr><td class=fbcatbg colspan=3><u><b>$fb::txt{'sk'}{'8'}</b></u>: <b>$line</b></td>
						<td class=fbcatbg align=center>$fb::txt{'sk'}{'11'}</td>	
						</tr>
							<tr><td class=fb1>
						<table border=0 cellspacing=0 cellpadding=8 width=100%><tr>
							<td>		
						<b><li><a href="$fb::gl{'scriptac'}=skineinst;requskin=$line">$fb::txt{'gl'}{'149'}</a> 
						   <li><a href="$fb::gl{'scriptac'}=skincss;requskin=$line">$fb::txt{'gl'}{'96'}</a>
						   <li><a href="$fb::gl{'scriptac'}=skintemplates;requskin=$line">$fb::txt{'gl'}{'148'}</a>
							</b></td><td><b>~;
			
			# mod for skin editor
			if ($fb::mod{'modules_info'}{'mod_skine'}[0]) {
				$fb::fi{'main'} .= qq~<li><a href="$fb::gl{'scriptac'}=mod_skine_skineditor;requskin=$line">$fb::txt{'gl'}{'101'}</a>~;
			}
			$fb::fi{'main'} .= qq~
							<li><a href="$fb::gl{'scriptac'}=smilies;requskin=$line">$fb::txt{'gl'}{'93'}</a>~;
			
			# mod for popup smileys
			if ($fb::mod{'modules_info'}{'mod_popsm'}[0]) {
				$fb::fi{'main'} .= qq~<li><a href="$fb::gl{'scriptac'}=mod_popsm_adminsett;requskin=$line">$fb::txt{'gl'}{'131'}</a>~;
			}
			$fb::fi{'main'} .= qq~
							<li><a href="$fb::gl{'scriptac'}=fileexplorer;go2=skinopen_$line">$fb::txt{'gl'}{'94'}</a></b>
							</td></tr></table>
						</td>
							<td class=fb2 align=center>
							<table border=0 cellspacing=0 cellpadding=0><tr><td><b>&raquo; <a target="_blank" href="$fb::gl{'scriptac'}=skinsystem;was=skinexport;requskin=$line">$fb::txt{'sk'}{'9'}</a><br>
							&raquo; <a href="javascript: deleteconfirm('$line','skinsystem;was=skindelete;requskin=$line')">$fb::txt{'sk'}{'10'}</a><br>
							&raquo; <a href="javascript: renameconfirm('$line','skinsystem;was=skinrename;requskin=$line')">$fb::txt{'sk'}{'45'}</a></b>
						</td></tr></table>	
						</td>
				<td class=fb2 align=center rowspan=2><b><a target="_blank" href="$fb::gl{'scriptac2'}=;lang=$fb::gl{'sprache2'};skin=$line">$fb::txt{'sk'}{'52'}</a></b></td>
						<td class=fb1 align=center><input value="$line" name="skinchosen" type="Radio"$selected></td>
						</tr></table><br>	
						~;
				}
			}

			$fb::fi{'main'} .= qq~</td></tr>
			<tr><td class=fb4 colspan=3 align=center><input type="submit" name="post" value="$fb::txt{'sk'}{'14'}"></td></tr></form>	
			</table>	
			~;


		&adminschluss;
		&template;
	}
}

sub getsize {

	my $type  = $_[0];
	my $value = $_[1] || "";
	
	# 
	#	$fb::fi{'main'} .= qq~<select name="fontsize_$type">~;
	#	$fb::fi{'main'} .= qq~<option value="">$fb::txt{'sk'}{'77'}</option>~;
	#	for ($i = 1; $i <= 21; ++$i){
	#		$size = $i."px";
	#		$sizepr = $i." px";
	#		if ($size eq $value) { $sel = " selected"; } else { $sel = ""; }
	#		$fb::fi{'main'} .= qq~<option value="$size"$sel>$sizepr</option>~;
	#	}
	#	$fb::fi{'main'} .= qq~</select>~;

	$fb::fi{'main'} .= qq~<input type=text size=5 name="fontsize_$type" value="$value">~;

}

sub getfont {

	my $type  = $_[0];
	my $value = $_[1] || "";

#	$fb::fi{'main'} .= qq~<select name="fontfamily_$type"><option value="">$fb::txt{'sk'}{'57'}</option>~;
#	$countsel = 1;
#	$sel = 0;

#	foreach $schrift (@schriftarten) {
#		if ($schrift eq $value) { $sel = $countsel; }
#		$countsel++;
#	}
#	unless ($sel) {
#		($origschrift, $andere) = split(/\,/, $value);
#		$countsel = 1;
#	if ($origschrift) {
#		foreach $schrift (@schriftarten) {
#			($thisschrift, $andere) = split(/\,/, $schrift);
#			if ($thisschrift =~ m/$origschrift/i) { $sel = $countsel; }
#			$countsel++;
#		}
#	}
#	}
#
#	$countsel = 1;
#	$countf = 0;
#		foreach $schrift (@schriftarten) {
#			if ($countsel == $sel) { $thissel = " selected"; } else { $thissel = ""; }
#		$fb::fi{'main'} .= qq~<option value="$schrift"$thissel>$schriftarten2[$countf]</option>~;
#		$countsel++;
#		$countf++;
#		}

	#
	#	$fb::fi{'main'} .= qq~</select>~;

	$fb::fi{'main'} .= qq~<input type=text size=20 name="fontfamily_$type" value="$value" alt="$fb::txt{'sk'}{'56'}" title="$fb::txt{'sk'}{'56'}">~;

}

sub getdeko {

	my $type         = $_[0];
	my $value_deco   = $_[1];
	my $value_weight = $_[2];
	my $value_style  = $_[3];
	
	my ($all,$underlinec,$boldc,$italicc,$italic_boldc,$underline_italicc,$underline_boldc) = ("","","","","","","");

	if ($value_deco && $value_deco   eq "underline") { $underlinec = " selected"; }
	if ($value_weight && $value_weight eq "bold")      { $boldc      = " selected"; }
	if ($value_style && $value_style  eq "italic")    { $italicc    = " selected"; }

	if ( $underlinec && $boldc && $italicc ) {
		$all        = " selected";
		$underlinec = "";
		$boldc      = "";
		$italicc    = "";
	}
	elsif ( $italicc && $boldc ) {
		$italic_boldc = " selected";
		$italicc      = "";
		$boldc        = "";
	}
	elsif ( $underlinec && $italicc ) {
		$underline_italicc = " selected";
		$underlinec        = "";
		$italicc           = "";
	}
	elsif ( $underlinec && $boldc ) {
		$underline_boldc = " selected";
		$underlinec      = "";
		$boldc           = "";
	}

	$fb::fi{'main'} .= qq~<select name="fontdeko_$type"><option value="none">$fb::txt{'sk'}{'67'}</option>
		<option value="bold"$boldc>$fb::txt{'sk'}{'69'}</option>
		<option value="italic"$italicc>$fb::txt{'sk'}{'70'}</option>
		<option value="underline"$underlinec>$fb::txt{'sk'}{'68'}</option>
		<option value="bold_italic"$italic_boldc>$fb::txt{'sk'}{'69'} + $fb::txt{'sk'}{'70'}</option>
		<option value="bold_underline"$underline_boldc>$fb::txt{'sk'}{'69'} + $fb::txt{'sk'}{'68'}</option>
		<option value="underline_italic"$underline_italicc>$fb::txt{'sk'}{'68'} + $fb::txt{'sk'}{'70'}</option>
		<option value="all"$all>$fb::txt{'sk'}{'71'}</option></select>~;

}

sub getmargin {

	my $type  = $_[0];
	my $value = $_[1] || "";

	$fb::fi{'main'} .= qq~<select name="margin_$type"><option value="">$fb::txt{'sk'}{'77'}</option>~;
	for (my $i = 0 ; $i <= 10 ; ++$i ) {

		my $size   = $i . "px";
		my $sizepr = $i . " px";
		my $sel = ( $size eq $value ) ? " selected" : "";

		$fb::fi{'main'} .= qq~<option value="$size"$sel>$sizepr</option>~;

	}
	$fb::fi{'main'} .= qq~</select>~;
}

sub getpadding {

	my $type  = $_[0];
	my $value = $_[1] || "";

	$fb::fi{'main'} .= qq~<select name="padding_$type"><option value="">$fb::txt{'sk'}{'77'}</option>~;
	for (my $i = 0 ; $i <= 10 ; ++$i ) {

		my $size   = $i . "px";
		my $sizepr = $i . " px";
		my $sel = ( $size eq $value ) ? " selected" : "";

		$fb::fi{'main'} .= qq~<option value="$size"$sel>$sizepr</option>~;

	}
	$fb::fi{'main'} .= qq~</select>~;
}

sub getcolor {

	my $type  = $_[0];
	my $wo    = $_[1];
	my $value = $_[2];

	unless ($value) { $value = "none"; }

	$fb::fi{'main'} .=
	    "<input type=text size=5 name=$wo"
	  . "_$type id=\"$wo"
	  . "_$type\" value=\"$value\" onchange=\"update_color('$wo"
	  . "_$type')\"><div id=\"$wo"
	  . "_$type" . "_td\"";
	
	my $addstyle = "";
	if ( $value eq "none" ) {
		$addstyle = qq~ background-image: url($fb::cf{'bilderurl'}/allgemein/halftransparent_red.gif);~;
	}
	elsif ( $value eq "transparent" ) {
		$addstyle = qq~ background-image: url($fb::cf{'bilderurl'}/allgemein/halftransparent.gif);~;
	}

	$fb::fi{'main'} .= qq~ STYLE="DISPLAY: inline; border: 1px solid #000066; padding: 2px; margin: 1px; background-color: $value;$addstyle">
	<a href="javascript:popUp('$fb::gl{'scriptac'}=skinsystem;was=colorpicker;insert=$wo~;
	$fb::fi{'main'} .= qq~_$type',225,165)"><img src="$fb::cf{'bilderurl'}/allgemein/transparent.gif" width=12 heigth=12 border=0 title="$fb::txt{'sk'}{'64'}" alt="$fb::txt{'sk'}{'64'}"></a></div>
	~;

}

sub getbackground {

	my $type  = $_[0];
	my $value = $_[1] || "";

	$fb::fi{'main'} .= qq~
	<table border=0 cellspacing=0 cellpadding=2><tr><td><u>$fb::txt{'sk'}{'72'}</u></td><td><input type=text size=40 name="background_$type" value="$value"></td></tr></table>~;

}

sub getborder {

	my $type  = $_[0];
	my $value = $_[1] || "";

	my ($px, $art, $color) = split(/ /, $value);

	unless ($art) { $art = "";	}

	unless ($color) { $color = "none"; }

	$fb::fi{'main'} .= qq~<select name="borderpx_$type"><option value="">$fb::txt{'sk'}{'77'}</option>~;
	
	for (my $i = 1 ; $i <= 10 ; ++$i) {
		my $size   = $i . "px";
		my $sizepr = $i . " px";

		my $sel = ($px && ($size eq $px) ) ? "selected" : "";

		$fb::fi{'main'} .= qq~<option value="$size"$sel>$sizepr</option>~;

	}
	$fb::fi{'main'} .= qq~</select>~;
	
	my $dottedc = ( $art eq "dotted" ) ? " selected" : "";
	my $solidc = ( $art eq "solid" ) ? " selected": "";

	$fb::fi{'main'} .= qq~
	<select name="bordertyp_$type"><option value="">$fb::txt{'sk'}{'77'}</option>
	<option value="solid"$solidc>$fb::txt{'sk'}{'87'}</option><option value="dotted"$dottedc>$fb::txt{'sk'}{'86'}</option></select>~;

	$fb::fi{'main'} .=
	    "<input type=text size=5 name=bordercol"
	  . "_$type id=\"bordercol"
	  . "_$type\" value=\"$color\" onchange=\"update_color('bordercol"
	  . "_$type')\"><div id=\"bordercol"
	  . "_$type" . "_td\"";
	
	my $addstyle = "";
	if ( $color eq "none" ) {
		$addstyle = qq~ background-image: url($fb::cf{'bilderurl'}/allgemein/halftransparent_red.gif);~;
	}
	elsif ( $color eq "transparent" ) {
		$addstyle = qq~ background-image: url($fb::cf{'bilderurl'}/allgemein/halftransparent.gif);~;
	}

	$fb::fi{'main'} .= qq~ STYLE="DISPLAY: inline; border: 1px solid #000066; padding: 2px; margin: 1px; background-color: $color;$addstyle">
	<a href="javascript:popUp('$fb::gl{'scriptac'}=skinsystem;was=colorpicker;insert=bordercol~;
	$fb::fi{'main'} .= qq~_$type',225,165)"><img src="$fb::cf{'bilderurl'}/allgemein/transparent.gif" width=12 heigth=12 border=0 title="$fb::txt{'sk'}{'64'}" alt="$fb::txt{'sk'}{'64'}"></a></div>~;

}

sub writeskinfile {

	my $folder1 = $_[0];
	my $folder2 = $_[1];
	my $folder3 = $_[2];
	my $skinname = $_[3];
	my $skinfilename = $_[4];
	my $printthisfile = $_[5];
	my $write_file = $_[6];

	if ( ( $folder1 eq "data" ) && ( $folder2 eq "skins" ) ) {
		unless ( -e "$fb::gl{'datadir'}/skins/$skinname/$skinfilename" ) {
			$printthisfile =~ s/\r\n/\n/g;
			$printthisfile =~ s/\r/\n/g;
			&writefile("$fb::gl{'datadir'}/skins/$skinname/$skinfilename",$printthisfile);
			chmod(0666, "$fb::gl{'datadir'}/skins/$skinname/$skinfilename");
		}
	}
	elsif (( $folder1 eq "bilder" ) && ( $folder3 ne "" )) {
		unless (-d "$fb::cf{'bilderdir'}/skins/$skinname/$folder3") {
			mkdir "$fb::cf{'bilderdir'}/skins/$skinname/$folder3", 0777;
		}
		unless (-e "$fb::cf{'bilderdir'}/skins/$skinname/$folder3/$skinfilename" ) {
			&writefile("$fb::cf{'bilderdir'}/skins/$skinname/$folder3/$skinfilename",$printthisfile,undef,undef,"1" );
			chmod( 0666,"$fb::cf{'bilderdir'}/skins/$skinname/$folder3/$skinfilename" );
		}
	}
	else {
		&dounlink("$write_file");
		my $set_location = qq~$fb::gl{'scriptac'}=skinsystem;was=skindelete;requskin=$skinname~;
		&redirect($set_location);
	}

}

sub newskin {

	my $was = $fb::INFO{'was'} || $fb::FORM{'was'};
	
	&isadmin;

	if ($was eq "newcopy") {

		# copy new skin from existing
		
		my $newskinname = $fb::FORM{'newskinname'};
		# skin name already taken
		if (( -d "$fb::gl{'datadir'}/skins/$newskinname" )|| ( -d "$fb::cf{'bilderdir'}/skins/$newskinname" ) )	{
			&fatal_error("$fb::txt{'sk'}{'113'} &raquo; $newskinname");
		}
		unless ( $newskinname =~ m/^[a-z]+$/ ) {
			&fatal_error("$fb::txt{'sk'}{'122'}");
		}
		
		my $sk1a = $fb::FORM{'sk1a'} || $fb::cf{'skinchosen'};
		my $sk1  = $fb::FORM{'sk1'}  || $fb::cf{'skinchosen'};
		my $sk2  = $fb::FORM{'sk2'}  || $fb::cf{'skinchosen'};
		my $sk3  = $fb::FORM{'sk3'}  || $fb::cf{'skinchosen'};
		my $sk4  = $fb::FORM{'sk4'}  || $fb::cf{'skinchosen'};

		mkdir "$fb::gl{'datadir'}/skins/$newskinname",   0777;
		mkdir "$fb::cf{'bilderdir'}/skins/$newskinname", 0777;

		use File::Copy;
		copy(
			"$fb::gl{'datadir'}/skins/$sk1a/config.pl",
			"$fb::gl{'datadir'}/skins/$newskinname/config.pl"
		);
		copy(
			"$fb::gl{'datadir'}/skins/$sk1/template.html",
			"$fb::gl{'datadir'}/skins/$newskinname/template.html"
		);
		copy(
			"$fb::gl{'datadir'}/skins/$sk1/templatefree.html",
			"$fb::gl{'datadir'}/skins/$newskinname/templatefree.html"
		);
		chmod( 0666,"$fb::gl{'datadir'}/skins/$newskinname/config.pl" );
		chmod( 0666,"$fb::gl{'datadir'}/skins/$newskinname/template.html" );
		chmod( 0666,"$fb::gl{'datadir'}/skins/$newskinname/templatefree.html" );

		my @contents = &opendirectory("$fb::gl{'datadir'}/skins/$sk2");

		foreach my $line (@contents) {
			unless ( ( $line eq "." ) || ( $line eq ".." ) || ( $line eq "template.html" )
				|| ( $line eq "templatefree.html" ) || ( $line eq "config.pl" ) ) {
				copy(
					"$fb::gl{'datadir'}/skins/$sk2/$line",
					"$fb::gl{'datadir'}/skins/$newskinname/$line"
				);
				chmod( 0666, "$fb::gl{'datadir'}/skins/$newskinname/$line" );
			}
		}

		my @contents2 = &opendirectory("$fb::cf{'bilderdir'}/skins/$sk3");

		foreach my $line (@contents2) {
			
			my $hereskin = "";
			
			if (   ( $line eq "allgemein" ) || ( $line eq "bewertung" )
				|| ( $line eq "flags" ) || ( $line eq "lang" ) ) {
				$hereskin = $sk3;
			}
			elsif (( $line eq "headsmilies" ) || ( $line eq "postsmilies" ))
			{
				$hereskin = $sk4;
			}
			if ($hereskin) {
				unless ( -d "$fb::cf{'bilderdir'}/skins/$newskinname/$line" ) {
					mkdir "$fb::cf{'bilderdir'}/skins/$newskinname/$line", 0777;
				}

				my @contents3 = &opendirectory("$fb::cf{'bilderdir'}/skins/$hereskin/$line");

				foreach my $line2 (@contents3) {
					copy( "$fb::cf{'bilderdir'}/skins/$hereskin/$line/$line2",
						"$fb::cf{'bilderdir'}/skins/$newskinname/$line/$line2"
					);
					chmod( 0666,"$fb::cf{'bilderdir'}/skins/$newskinname/$line/$line2");
				}
			}
		}

		my $set_location = qq~$fb::gl{'scriptac'}=skineinst;requskin=$newskinname~;
		&redirect($set_location);

	}
	elsif ( $was eq "newimport" ) {
	
		# import skin from exported file

		if ( $fb::FORM{'file'} ) {
			
			# first upload file
			my $upload_dir = "$fb::cf{'bilderdir'}/temp";

			my @ext = qw(skin);
			require "$fb::gl{'subsdir'}/upload.pl";
			&upload::uploadcheck( $upload_dir, "1", \@ext );
			
			my $fixfile;
			$fixfile = &upload::doupload;

			my $write_file = "$upload_dir/$fixfile";
			chmod(0777, $write_file);
			
			# open skin file

			my @result = &openfile( "$write_file", "1" );

			my $wholeskinfile = join("\n", @result);

			my @skinfiles = split( /$pushatskin/, $wholeskinfile );
			
			# stores filename from file actually processed
			my $skinfilename;
			
			# created directories
			my $madedirectories = 0;

			my $newskinname = "";
			my $newuniqueid = "";
			
			# name of new skin
			my $skinname = "";
			
			# current file
			my $printthisfile;

			my ($folder1,$folder2,$folder3) = ("","","");

			foreach my $line (@skinfiles) {

				if ( $line =~ m/(.*?)$pushatskin2(.*?)/sgi ) {
					# we have a valid file

					if ($skinfilename) {
						&writeskinfile($folder1,$folder2,$folder3,$skinname,$skinfilename,$printthisfile,$write_file);
					}

					my @testskinfile  = split( /$pushatskin2/, $line );
					my $splitline = $testskinfile[0];
					
					$printthisfile = "";
					$printthisfile = $testskinfile[1];
					
					my ($scriptname, $scriptversion, $uniqueid);

					(my $nothing, $scriptname, $scriptversion, $uniqueid, $folder1, $folder2, $folder3, $skinfilename) = split( /\-/, $splitline );
					if ( $folder1 eq "data" )   { $skinname = $folder3; }
					elsif ( $folder1 eq "bilder" ) { $skinname = $folder2; }
					unless (($scriptname eq $fb::gl{'thisscriptcode'})&& ($scriptversion eq $fb::gl{'thisversion'})) {
						# skin import comes from wrong script version
						&dounlink("$write_file");
						&fatal_error($fb::txt{'sk'}{'112'});
					}
					if ($madedirectories) {
						if (($skinname ne $newskinname) || ($newuniqueid ne $uniqueid)) {
							&dounlink("$write_file");
							my $set_location = qq~$fb::gl{'scriptac'}=skinsystem;was=skindelete;requskin=$newskinname~;
							&redirect($set_location);
						}
					}
					else {
						if (( -d "$fb::gl{'datadir'}/skins/$skinname" ) || ( -d "$fb::cf{'bilderdir'}/skins/$skinname" )) {
							&dounlink("$write_file");
							&fatal_error("$fb::txt{'sk'}{'113'} &raquo; $skinname");
						}
						mkdir "$fb::gl{'datadir'}/skins/$skinname",   0777;
						mkdir "$fb::cf{'bilderdir'}/skins/$skinname", 0777;
						$madedirectories = 1;
					}
					$newskinname = $skinname;
					$newuniqueid = $uniqueid;
				}
			}

			if ($skinfilename) {
				&writeskinfile($folder1,$folder2,$folder3,$skinname,$skinfilename,$printthisfile,$write_file);
			}
			else {
				&dounlink("$write_file");
				&fatal_error("$fb::txt{'sk'}{'112'}");
			}

			&dounlink("$write_file");
			my $set_location = qq~$fb::gl{'scriptac'}=skineinst;requskin=$skinname~;
			&redirect($set_location);
		}
		else {
			my $set_location = qq~$fb::gl{'scriptac'}=newskin~;
			&redirect($set_location);
		}

	}
	else {

		&adminmenu;

		if ( $was eq "import" ) {
			# import skin menu

			$fb::fi{'main'} .= qq~
			<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>
				<form action="$fb::gl{'scriptac'}=newskin;was=newimport" method="post" name="fiform" ENCTYPE="multipart/form-data">
			<tr><td class=fbcatbg colspan=3><b>$fb::txt{'gl'}{'92'}<b></td></tr>
			<tr><td class=fb2 width=33% align=center><a href="$fb::gl{'scriptac'}=skinsystem"><b>$fb::txt{'sk'}{'7'}</b></a></td>
			<td class=fb2 width=33% align=center><a href="$fb::gl{'scriptac'}=newskin;was=erstellen"><b>$fb::txt{'sk'}{'6'}</b></a></td>
			<td class=fb1 width=33% align=center><b>$fb::txt{'sk'}{'1'}</b></td>	
			</tr>
			<tr><td colspan=3 class=fb2 align=center><font size=1>$fb::txt{'sk'}{'12'}</font></td></tr>

			<tr><td class=fb2 colspan=3 align=center>
				<br>
				<table border=0 cellspacing=0 cellpadding=0 width=100%>
					<tr>
						<td valign="top" colspan=2 align=center>
						$fb::txt{'sk'}{'125'}<br>&nbsp;
							</td>
											</tr>
							<tr>
							<td valign="top" width="30%" align=right>
						<b>$fb::txt{'sk'}{'114'}:</b>&nbsp;
					</td>
					<td><input type="file" name="file" size="49"></td>
				</tr>
				<tr>
					<td align="right"></td>
					<td><font size="1">$fb::txt{'sk'}{'111'}</font></td>
				</tr>
						</table>
					<br>
				</td></tr>
				<tr><td class=fb4 colspan=3 align=center><input type="submit" name="post" value="$fb::txt{'sk'}{'1'}"></td>
								</tr></form>					
					</table>~;
		}
		else {

			# copy skin from existing skins

			my @contents = &opendirectory("$fb::gl{'datadir'}/skins");
			@contents = sort { uc($a) cmp uc($b) } (@contents);
			
			# skin options
			my $options2 = "";

			foreach my $line (@contents) {
				if (( -d "$fb::gl{'datadir'}/skins/$line" ) && (( $line ne "." ) && ( $line ne ".." ))) {
					
					if ( $line eq "admin" ) { next; }
					my $selected = ( $line eq $fb::cf{'skinchosen'} ) ? " selected" : "";

					$options2 .= qq~<option value=\"$line\"$selected>$line</option>\n~;
				}
			}

			$fb::fi{'main'} .= qq~
			<table align=center width="100%" border=0 cellspacing=1 cellpadding=2 class=fbborder>
				<form action="$fb::gl{'scriptac'}=newskin;was=newcopy" method="post" name="fiform" ENCTYPE="multipart/form-data">
			<tr><td class=fbcatbg colspan=3><b>$fb::txt{'gl'}{'92'}<b></td></tr>
			<tr><td class=fb2 width=33% align=center><a href="$fb::gl{'scriptac'}=skinsystem"><b>$fb::txt{'sk'}{'7'}</b></a></td>
			<td class=fb1 width=33% align=center><b>$fb::txt{'sk'}{'6'}</b></td>
			<td class=fb2 width=33% align=center><a href="$fb::gl{'scriptac'}=newskin;was=import"><b>$fb::txt{'sk'}{'1'}</b></a></td>	
			</tr>
			<tr><td colspan=3 class=fb2 align=center><font size=1>$fb::txt{'sk'}{'115'}</font></td></tr>
			<tr><td class=fb2 colspan=3 align=center>
				<br>
					<table border=0 cellspacing=0 cellpadding=2 width=100%>
						<tr>
							<td valign="top" width="50%" align=right>
								<b>$fb::txt{'sk'}{'120'}:</b><br>
								<font size=1>$fb::txt{'sk'}{'121'}</font>
							</td>
							<td><input type=text name=newskinname value=""></td>
						</tr>
						<tr>
							<td valign="top" width="50%" align=right>
								<b>$fb::txt{'sk'}{'123'}:</b>
							</td>
							<td><select name=sk1a>$options2</select></td>
						</tr>
						<tr>
							<td valign="top" width="50%" align=right>
								<b>$fb::txt{'sk'}{'116'}:</b>
							</td>
							<td><select name=sk1>$options2</select></td>
						</tr>
						<tr>
							<td valign="top" width="50%" align=right>
								<b>$fb::txt{'sk'}{'117'}:</b>
							</td>
							<td><select name=sk2>$options2</select></td>
						</tr>
						<tr>
							<td valign="top" width="50%" align=right>
								<b>$fb::txt{'sk'}{'118'}:</b>
							</td>
							<td><select name=sk3>$options2</select></td>
						</tr>
						<tr>
							<td valign="top" width="50%" align=right>
								<b>$fb::txt{'sk'}{'119'}:</b>
							</td>
							<td><select name=sk4>$options2</select></td>
						</tr>
				</table>
				<br>
			</td></tr>
			<tr><td class=fb4 colspan=3 align=center><input type="submit" name="post" value="$fb::txt{'sk'}{'6'}"></td>
							</tr></form>		
			</table>~;

		}

		&adminschluss;
		&template;
	}
}
1;
