####################### [Firebook] - guestbook ################################
# ubbcjs.pl  			                                                      #
###############################################################################

package fb;

use strict;
use warnings;
#use diagnostics;

&fb::load_language("ubbcjs");
$fb::loaded{'file_ubbcjs'} = 1;

sub ubbcjs {

	my $context = $_[0] || "1"; # 1=messages, 2=others

	my $ubbcjs;
	

	# Achtung regex im Javascript muss Sonderzeichen doppelt auszeichnen -> \s --> \\s ; \n --> \\n usw;
	$ubbcjs .= qq~
<script type="text/javascript">
<!--
var nothingSelectedBox = false;
var nothingSelectedBox2 = false;
var weakBrowser = false;
function WhichClicked(ww) {
	window.document.fiform.waction.value = ww;
}
function submitonce(theform) {
	if (document.all || document.getElementById) {
		for (i=0;i<theform.length;i++) {
			var tempobj=theform.elements[i];
			if(tempobj.type.toLowerCase()=="submit"||tempobj.type.toLowerCase()=="reset") {
				tempobj.disabled=true;
			}
		}
	}
}
window.onload = function () {
 if (document.getElementById("submit")) {
	 document.getElementById("submit").disabled = false;
 }
 if (document.getElementById("preview")) {
	 document.getElementById("preview").disabled = false;
 }
}
function storeCaret(text) { 
	if (text.createTextRange) text.caretPos = document.selection.createRange().duplicate();
}
function nothingSelected() {
	if (nothingSelectedBox == false) {
		alert("$fb::txt{'js'}{'21'}");
		nothingSelectedBox = true;
	}
}
function AddSelText(bbopen, bbclose, whatopen, bbmiddle) {

	if (bbclose.length == 0) { bbclose = bbopen; bbopen = ""; }
	var exampleString = "";
	if (bbopen.length > 0) {
		exampleString = "$fb::txt{'js'}{'23'}";
	}
	if (whatopen == "") { whatopen = "message"; }
	
	if (document.getElementById(whatopen).setSelectionRange) {

		var selectionStart = document.getElementById(whatopen).selectionStart;
		var selectionEnd = document.getElementById(whatopen).selectionEnd;
		var selectionEnd2 = selectionEnd;
		if (selectionStart == selectionEnd) {

			if (bbmiddle) {
				return false;
			}
			
			if (exampleString != "") { nothingSelected();		}

			bbclose = exampleString + bbclose;
			selectionEnd2 = selectionEnd + exampleString.length;
		}

		var replaceString = "";
		
		if (bbmiddle) {
			var string = document.getElementById(whatopen).value.substring(selectionStart, selectionEnd);
			var singleElements = string.split("\\n");
		    
			for (index in singleElements) {
			  replaceString += bbmiddle + singleElements[index] + "\\n";
			  selectionEnd2 = selectionEnd2 + bbmiddle.length;
		    } 
			replaceString = bbopen + replaceString + bbclose;

		}
		else {
			replaceString = bbopen + document.getElementById(whatopen).value.substring(selectionStart, selectionEnd) + bbclose;
		}

		var bbopenLength = bbopen.length;

		document.getElementById(whatopen).value = document.getElementById(whatopen).value.substring(0, selectionStart) + replaceString + document.getElementById(whatopen).value.substring(selectionEnd);
		if (exampleString == "") {
			document.getElementById(whatopen).setSelectionRange(selectionEnd+bbclose.length, selectionEnd+bbclose.length);
		}
		else {
			document.getElementById(whatopen).setSelectionRange(selectionStart + bbopenLength, selectionEnd2 + bbopenLength);
		}

	}
	else if (document.selection) {
			
		   document.getElementById(whatopen).focus();

		   var range = document.selection.createRange();

			   var oldText = range.text;
			   if (oldText == "") {
				   	if (bbmiddle) {
						return false;
					}
					oldText = exampleString;
					if (exampleString != "") { nothingSelected();		}
			   }
				
				var moveStartNumber = 0;
				if (bbmiddle) {
					var string = oldText;
					var singleElements = string.split("\\n");
					
					var replaceString = "";
					var countlength = 0;
					for (index in singleElements) {
					  replaceString += bbmiddle + singleElements[index] + "\\n";
					  countlength = countlength + bbmiddle.length + singleElements[index].length;
					} 
					range.text = bbopen + replaceString + bbclose;
					moveStartNumber = -countlength -bbclose.length - 1;
				}
				else {
				   range.text = bbopen + oldText + bbclose; 
				   moveStartNumber = -(oldText + bbclose).length;
				}
				if (exampleString != "") {
				   range.moveStart('character', moveStartNumber); 
				   range.moveEnd('character', - bbclose.length); 
				}
			   range.select(); 
	}
	else if (document.getElementById(whatopen).caretPos) {

		var thisText = document.getElementById(whatopen).caretPos.text;
		if (thisText == "") { 
			if (bbmiddle) {
				return false;
			}
			if (exampleString != "") { nothingSelected();		} thisText = exampleString; 
		}
		if (bbmiddle) {
			var string = thisText;
			var singleElements = string.split("\\n");
			
			var replaceString = "";
			for (index in singleElements) {
			  replaceString += bbmiddle + singleElements[index] + "\\n";
			} 
			document.getElementById(whatopen).caretPos.text = bbopen + replaceString + bbclose;
		}
		else {
			document.getElementById(whatopen).caretPos.text = bbopen + thisText + bbclose;
		}
		document.getElementById(whatopen).caretPos.select();
	}
	else { 
		if (bbmiddle) {
			return false;
		}
		if (weakBrowser == false) {
			alert("$fb::txt{'js'}{'22'}");
			weakBrowser = true;
		}
		document.getElementById(whatopen).value += bbopen + exampleString + bbclose;
	}
	document.getElementById(whatopen).focus();
	return true;
}
function AddSelTextUrl(bbopen, bbclose, whatopen) {
	var theurl = '';
	var exampleString = "$fb::txt{'js'}{'25'}";

	if (whatopen == "") { whatopen = "message"; }
	if (document.getElementById(whatopen).setSelectionRange) {
		var selectionStart = document.getElementById(whatopen).selectionStart;
		var selectionEnd = document.getElementById(whatopen).selectionEnd;
		var bbopenLength = bbopen.length;
		var selectionEnd2 = selectionEnd;
		if (selectionStart == selectionEnd) { 
			bbopen = bbopen + exampleString;
			selectionEnd2 = selectionEnd + exampleString.length;
		}

		var tmpString = document.getElementById(whatopen).value.substring(selectionStart, selectionEnd);
		spliturl=tmpString.replace(/\\s*(.+?)\\s*\$/i, "\$1");
		spliturl = spliturl.split(" ");
		theurl = spliturl[0];
		if ( spliturl.length > 1 && (theurl.match(/www./) || theurl.match(/\@/)) ) {
			bbopenLength = bbopenLength + theurl.length;
			replaceString = bbopen + theurl + bbclose;
		}
		else replaceString = bbopen + tmpString + bbclose;
		document.getElementById(whatopen).value = document.getElementById(whatopen).value.substring(0, selectionStart) + replaceString + document.getElementById(whatopen).value.substring(selectionEnd);
		document.getElementById(whatopen).setSelectionRange(selectionStart +bbopenLength, selectionEnd2 + bbopenLength);
	}
	else if (document.selection) {
			
		   document.getElementById(whatopen).focus();
		   var range = document.selection.createRange();
		
			   var oldText = range.text; 
			   if (oldText == "") { 
				   oldText = exampleString;
			   }

				spliturl=oldText.replace(/\\s*(.+?)\\s*\$/i, "\$1");
				spliturl = spliturl.split(" ");
				theurl = spliturl[0];
				if ( spliturl.length > 1 && (theurl.match(/www./) || theurl.match(/\@/)) ) {
					oldText = theurl;
				}

			   range.text = bbopen + oldText + bbclose; 
			   range.moveStart('character', -(oldText + bbclose).length); 
			   range.moveEnd('character', - bbclose.length); 
			   range.select(); 
	}
	else if (document.getElementById(whatopen).caretPos) {
		var thisText = document.getElementById(whatopen).caretPos.text;
		if (thisText == "") { thisText = exampleString; }
		
		tmpString=thisText.replace(/\\s*(.+?)\\s*\$/i, "\$1");
		spliturl = tmpString.split(" ");
		theurl = spliturl[0];
		if ( spliturl.length > 1 && (theurl.match(/www./) || theurl.match(/\\@/)) ) {
		document.getElementById(whatopen).caretPos.text = bbopen + theurl + bbclose;
		}
		else document.getElementById(whatopen).caretPos.text = bbopen + tmpString + bbclose;
		document.getElementById(whatopen).caretPos.select();
	}

	else document.getElementById(whatopen).value += bbopen + bbclose;
	document.getElementById(whatopen).focus()

}
function AddText2(text, whatopen) {
	if (whatopen == "") { whatopen = "message"; }
	AddSelText(""," " + text + " ",whatopen);
}
var allValid = true;
var allNum = "";
var checkOK = "0123456789";
function checknumber (checkStr) {
	allValid = true;
	allNum = "";
	for (i = 0; i < checkStr.length; i++)
	{
		ch = checkStr.charAt(i);
		for (j = 0; j < checkOK.length; j++)
		if (ch == checkOK.charAt(j))
		break;
		if (j == checkOK.length)
		{
			allValid = false;
			break;
		}
	allNum += ch;
	}	
}
var emailcheck = new RegExp("^[a-zA-Z0-9]{1}[a-zA-Z0-9\._-]*\@[a-zA-Z0-9_\.-]*[a-zA-Z0-9-aaaccccddeeeee?gggghhiiiiijk?llllnnnooorrrssstttuuuuuuwyzz]{2,}\.[a-z]{2,4}\$");

var CSS = "</TITLE>\\n";
~;

	if ($fb::cf{'actjavacheck'}) {
		
		$ubbcjs .= qq~function testform() {\n~;
		
		my ($ebene2ak, $ebene1ak) = ("0","0");
		my @allwichtigs;

		$fb::cf{'wicht_message'} = 1;
		$fb::cf{'wicht_messagek'} = 1;
		
		# mod_comm addon
		if ($fb::gl{'action'} =~ m/mod_comm_comments/i) { 
			$ebene2ak = 1;
			@allwichtigs = qw/wicht_namek wicht_emailk wicht_messagek/;
		}
		else { 
			$ebene1ak = 1;
			@allwichtigs = qw/wicht_betreff wicht_name wicht_email wicht_url wicht_ort wicht_state wicht_bewertung wicht_icq wicht_aim wicht_yim wicht_msn wicht_skype wicht_jabber wicht_message wicht_file/;
		}
		foreach my $wichtentr (@allwichtigs) {

			my ($unwichtig,$namewas) = split(/\_/, $wichtentr);
			
			my ($showalert,$showname);
			
			if (($namewas eq "name") || ($namewas eq "namek")) {  
				$namewas = "name"; 
				$showalert = qq~$fb::txt{'js'}{'1'}~; 
				$showname = qq~$fb::txt{'gl'}{'28'}~; 
			}
			elsif (($namewas eq "message") || ($namewas eq "messagek")) { 
				$namewas = "message"; 
				$showname = qq~$fb::txt{'gl'}{'36'}~; 
				$showalert = qq~$fb::txt{'js'}{'10'}~; 
			}
			elsif (($namewas eq "email") || ($namewas eq "emailk")) { 
				$namewas = "email"; 
				$showalert = qq~$fb::txt{'js'}{'2'}~; 
				$showname = qq~$fb::txt{'gl'}{'29'}~; 
			}
			elsif ($namewas eq "betreff") { 
				$showalert = qq~$fb::txt{'js'}{'3'}~; 
				$showname = qq~$fb::txt{'gl'}{'30'}~; 
			}
			else { 
				if ($namewas eq "ort") { $showname = qq~$fb::txt{'gl'}{'32'}~; }
				elsif ($namewas eq "icq") { $showname = qq~$fb::txt{'gl'}{'18'}~; }
				elsif ($namewas eq "aim") { $showname = qq~$fb::txt{'gl'}{'19'}~; }
				elsif ($namewas eq "yim") { $showname = qq~$fb::txt{'gl'}{'20'}~; }
				elsif ($namewas eq "msn") { $showname = qq~$fb::txt{'gl'}{'21'}~; }
				elsif ($namewas eq "skype") { $showname = qq~$fb::txt{'gl'}{'146'}~; }
				elsif ($namewas eq "jabber") { $showname = qq~$fb::txt{'gl'}{'22'}~; }
				elsif ($namewas eq "state") { $showname = qq~$fb::txt{'gl'}{'121'}~; }
				elsif ($namewas eq "url") { $showname = qq~$fb::txt{'gl'}{'31'}~; }
				elsif ($namewas eq "state") { $showname = qq~$fb::txt{'gl'}{'121'}~; }
				elsif ($namewas eq "bewertung") { $showname = qq~$fb::txt{'gl'}{'34'}~; }
				elsif ($namewas eq "file") { $showname = qq~$fb::txt{'gl'}{'73'}~; }
				elsif ($namewas eq "message") { $showname = qq~$fb::txt{'gl'}{'36'}~; }
				else { $showname = uc($namewas); }
				$showalert = "$fb::txt{'js'}{'4'} $showname $fb::txt{'js'}{'5'}!"; 
			}
			# testing
			#if (!defined($fb::cf{"q_".$namewas})) { die($namewas);}
			if (($fb::cf{$wichtentr} == 1) || ($fb::cf{"zeich_$namewas"} && $fb::cf{"zeich_$namewas"} > 0)) {
				$ubbcjs .= qq~if (document.getElementById("$namewas")) {\n ~;
			}

			if ($fb::cf{"$wichtentr"} == 1) {
				
				if ($namewas eq "bewertung") {
					$ubbcjs .= qq~if (document.fiform.$namewas.value == "0") {\n~;
				}
				elsif ($namewas eq "state") {
					$ubbcjs .= qq~if (document.fiform.$namewas.value == "none") {\n~;
				}
				elsif ($namewas eq "file") {
					$ubbcjs .= qq~if ((document.fiform.file.value == "") && ((document.fiform.file2.value == "nonew") || (document.fiform.file2.value == "newupload"))) {\n~;
				}
				else { $ubbcjs .= qq~if (document.fiform.$namewas.value == "") {\n~; }

				$ubbcjs .= qq~ alert("$showalert")
 document.fiform.$namewas.focus()
 return false
}\n~;

			}
			if (($fb::cf{"zeich_$namewas"} && $fb::cf{"zeich_$namewas"} > 0)) {
				
				my $showalert2 = qq~$fb::txt{'js'}{'6'} $showname $fb::txt{'js'}{'7'} $fb::cf{"zeich_$namewas"} $fb::txt{'js'}{'8'}!~;
				$ubbcjs .= qq~if (document.fiform.$namewas.value && document.fiform.$namewas.value.length < $fb::cf{"zeich_$namewas"}) {\n
 alert("$showalert2")
 document.fiform.$namewas.focus()
 return false
}\n~;
			}
			if (($fb::cf{$wichtentr} == 1) || ($fb::cf{"zeich_$namewas"} && $fb::cf{"zeich_$namewas"} > 0)) {
				$ubbcjs .= qq~}\n~;
			}

		}

## allgemeingltige JS Anforderungen
		$ubbcjs .= qq~
if (document.getElementById("email")) {
if (document.fiform.email.value != "") {
if(emailcheck.test(document.fiform.email.value) == false) 
    {
     alert("$fb::txt{'js'}{'9'}");
     document.fiform.email.focus();
     return false;
    }
}
}~;


		if ($fb::cf{'f_url'} == 1) {

			$ubbcjs .= qq~
if (document.getElementById("url")) {
if (document.fiform.url.value != "") {
if((document.fiform.url.value.indexOf('http\:\//') == -1) && (document.fiform.url.value.indexOf('https\:\//') == -1))
    {
     alert("$fb::txt{'js'}{'11'}");
     document.fiform.url.focus();
     return false;
    }
}\n
}\n~;

		}


		if ($fb::cf{'f_icq'} == 1) {

			$ubbcjs .= qq~if (document.getElementById("icq")) {
if (document.fiform.icq.value != "") {
var thisStr = document.fiform.icq.value;
checknumber(thisStr);
	if (!allValid)
	{
	alert("$fb::txt{'js'}{'12'}");
	document.fiform.icq.focus();
	return (false);
	}
}
}\n~;
		}


	
		# here is the interface to module ubbc js addons 
		
		if ($fb::mod{'action_modules'}{'ubbcjs_addon'}) {
			foreach my $mod (@{$fb::mod{'action_modules'}{'ubbcjs_addon'}}) {
				if ($fb::mod{'modules_info'}{$mod->[0]}[0] == 1) {
					unless ($fb::loaded{$mod->[1]}) {
						require "$fb::gl{'subsdir'}/$mod->[1].pl";
						$fb::loaded{$mod->[1]} = 1;
					}
					$ubbcjs .= $mod->[2]->();
				}
			}
		}


		# mod_comm addon
		# code not necessary for previews
		if (($fb::gl{'action'} !~ m/edit/i) && ($fb::gl{'action'} !~ m/mod_comm_commentsedit/i)) {
			if($fb::cf{'message_val_check'}) {
				$ubbcjs .= qq~
if ((document.fiform.verification.value == "") && (window.document.fiform.waction.value != "preview")) {
		alert("$fb::txt{'js'}{'19'}")
		document.fiform.verification.focus()
		return false
}
~;
			}
		}

		$ubbcjs .= qq~return true;\n~;
		$ubbcjs .= qq~}\n~;

	}

	unless ($fb::fi{'css'}) {
		$fb::fi{'css'} = join('', &openfile("$fb::gl{'datadir'}/skins/$fb::gl{'skin'}/style.css"));
	}

	my @css = split(/\n/, $fb::fi{'css'});

	foreach (@css) {
		$_ =~ s/"/'/ig;
		$_ =~ s/\n//ig;
		$_ =~ s/\r//ig;
		if ($_) { $ubbcjs .= qq~CSS += "$_\\n";\n~; }
	}

	$ubbcjs .= qq~CSS += "<script language='javascript'>\\n";\n~;
	$ubbcjs .= qq~CSS += "<!--\\nfunction AddSel2Text(bbopen, bbclose) {\\n	var exampleString = \\"\\";\\n	if (bbclose.length == 0) { bbclose = bbopen; bbopen = \\"\\"; }\\n	if (bbopen.length > 0) {\\n		myRE = new RegExp(\\"email\\", \\"i\\");\\n		if (bbopen.match(myRE)) {\\n			exampleString = \\"$fb::txt{'js'}{'24'}\\";\\n		}\\n		else {\\n			exampleString = \\"$fb::txt{'js'}{'23'}\\";\\n		}\\n	}\\n	\\n	if (opener.document.getElementById(whatopen).setSelectionRange) {\\n		var selectionStart = opener.document.getElementById(whatopen).selectionStart;\\n		var selectionEnd = opener.document.getElementById(whatopen).selectionEnd;\\n		var bbopenLength = bbopen.length;\\n		var selectionEnd2 = selectionEnd;\\n		if (selectionStart == selectionEnd) { \\n			bbopen = bbopen + exampleString;\\n			selectionEnd2 = selectionEnd + exampleString.length;\\n		}\\n		var replaceString = bbopen + opener.document.getElementById(whatopen).value.substring(selectionStart, selectionEnd) + bbclose;\\n		\\n		opener.document.getElementById(whatopen).value = opener.document.getElementById(whatopen).value.substring(0, selectionStart) + replaceString + opener.document.getElementById(whatopen).value.substring(selectionEnd);\\n		if (exampleString == \\"\\") {\\n		opener.document.getElementById(whatopen).setSelectionRange(selectionEnd+bbclose.length, selectionEnd+bbclose.length);\\n		}\\n		else {\\n		opener.document.getElementById(whatopen).setSelectionRange(selectionStart + bbopenLength, selectionEnd2 + bbopenLength);\\n		}\\n	}\\n	else if (opener.document.selection) {\\n			\\n		   opener.document.getElementById(whatopen).focus();\\n\\n		   var range = opener.document.selection.createRange();\\n		\\n			   var oldText = range.text; \\n			   if (oldText == \\"\\") { \\n					   oldText = exampleString;\\n			   }\\n			   range.text = bbopen + oldText + bbclose; \\n			   if (exampleString != \\"\\") {\\n			   range.moveStart('character', -(oldText + bbclose).length); \\n			   range.moveEnd('character', - bbclose.length); \\n			   }\\n			   range.select(); \\n	}\\n	else if (opener.document.getElementById(whatopen).caretPos) {\\n		var thisText = opener.document.getElementById(whatopen).caretPos.text;\\n		if (thisText == \\"\\") { thisText = exampleString; }\\n		opener.document.getElementById(whatopen).caretPos.text = bbopen + thisText + bbclose;\\n		opener.document.getElementById(whatopen).caretPos.select();\\n	}\\n	else { \\n		opener.document.getElementById(whatopen).value += bbopen + exampleString + bbclose;\\n	}\\n	opener.document.getElementById(whatopen).focus()\\n}\\n";\n~;
	$ubbcjs .= qq~CSS2 = "function AddSel2TextUrl(bbopen, bbclose) {\\nvar theurl = '';\\nvar exampleString = \\"$fb::txt{'js'}{'25'}\\";\\n    if (opener.document.getElementById(whatopen).setSelectionRange) {\\n		var selectionStart = opener.document.getElementById(whatopen).selectionStart;\\n		var selectionEnd = opener.document.getElementById(whatopen).selectionEnd;\\n		var bbopenLength = bbopen.length;\\n		var selectionEnd2 = selectionEnd;\\n		if (selectionStart == selectionEnd) { \\n			bbopen = bbopen + exampleString;\\n			selectionEnd2 = selectionEnd + exampleString.length;\\n		}\\n\\n		var tmpString = opener.document.getElementById(whatopen).value.substring(selectionStart, selectionEnd);\\n		spliturl=tmpString.replace(/\\s*(.+?)\\s*\$/i, \\"\$1\\");\\n		spliturl = spliturl.split(\\" \\");\\n		theurl = spliturl[0];\\n		if ( spliturl.length > 1 && (theurl.match(/www./) || theurl.match(/\@/)) ) {\\n			bbopenLength = bbopenLength + theurl.length;\\n			replaceString = bbopen + theurl + bbclose;\\n		}\\n		else replaceString = bbopen + tmpString + bbclose;\\n		opener.document.getElementById(whatopen).value = opener.document.getElementById(whatopen).value.substring(0, selectionStart) + replaceString + opener.document.getElementById(whatopen).value.substring(selectionEnd);\\n		opener.document.getElementById(whatopen).setSelectionRange(selectionStart +bbopenLength, selectionEnd2 + bbopenLength);\\n	}\\n	else if (opener.document.selection) {\\n			\\n		   opener.document.getElementById(whatopen).focus();\\n		   var range = opener.document.selection.createRange();\\n				\\n			   var oldText = range.text;\\n			   if (oldText == \\"\\") { \\n				   oldText = exampleString;\\n			   }\\n				\\n				spliturl=oldText.replace(/\\s*(.+?)\\s*\$/i, \\"\$1\\");\\n				spliturl = spliturl.split(\\" \\");\\n				theurl = spliturl[0];\\n				if ( spliturl.length > 1 && (theurl.match(/www./) || theurl.match(/\@/)) ) {\\n					oldText = theurl;\\n				}\\n\\n			   range.text = bbopen + oldText + bbclose; \\n			   range.moveStart('character', -(oldText + bbclose).length); \\n			   range.moveEnd('character', - bbclose.length); \\n			   range.select(); \\n	}\\n	else if (opener.document.getElementById(whatopen).caretPos) {\\n		var thisText = document.getElementById(whatopen).caretPos.text;\\n		if (thisText == \\"\\") { thisText = exampleString; }\\n		\\n		tmpString=thisText.replace(/\\s*(.+?)\\s*\$/i, \\"\$1\\");\\n		spliturl = tmpString.split(\\" \\");\\n		theurl = spliturl[0];\\n		if ( spliturl.length > 1 && (theurl.match(/www./) || theurl.match(/\\@/)) ) {\\n				opener.document.getElementById(whatopen).caretPos.text = bbopen + theurl + bbclose;\\n		}\\n		else opener.document.getElementById(whatopen).caretPos.text = bbopen + tmpString + bbclose;\\n		opener.document.getElementById(whatopen).caretPos.select();\\n	}\\n	else opener.document.getElementById(whatopen).value += bbopen + bbclose;\\n	}\\n\\n";\n~;
	$ubbcjs .= qq~CSS3 = "-->\\n";\n~;
	$ubbcjs .= qq~CSS3 += "<\\/script>\\n";\n~;
	$ubbcjs .= qq~var CONTENT2 = "</td></tr></table></td></tr></form></table></BODY></HTML>";
var CONTENT3 = "</td></tr><tr><td class=fb1 align=center>\\n";
var CONTENT4 = "</td></tr><tr><td class=fb2 align=center>\\n";
var CONTENT5 = "<tr><td align=center><table border=0 cellspacing=1 class=fbborder cellpadding=2><tr><td class=fb1 align=center>";
var CONTENT6 = "opener.document.getElementById(whatopen).focus();\\nself.close();\\n}\\n-->\\n<\\/script>\\n</HEAD><BODY><table border=0 cellspacing=0 cellpadding=0 width=100% height=100%>";
~;

	my $ubbccloseit = qq~pop = window.open("","","width=340,height=150,toolbar=0,scrollbars=1");
pop.document.open();
pop.focus();
pop.document.write(CONTENT);
pop.document.close();~;

	if ($fb::cf{'ubbc'} == 1) {

		# read UBBC lines
		my $sth = $fb::dbh->prepare("SELECT * FROM $fb::cf{'db_prefix'}" . "ubbcinput");
		$sth->execute() or save_db_error(DBI->errstr);

		while(my (@splitinput) = $sth->fetchrow_array) {
			
			# mod_comm addon
			my $erlaubt = 0;
			if (($context == 2) && ($splitinput[12] == 1)) { $erlaubt = 1; }
			elsif (($context != 2) && ($splitinput[11] == 1)) { $erlaubt = 1; }

			if ($erlaubt == 1) {

			if ($splitinput[6] eq "seltext") {
				if ($splitinput[4] eq "button") {

					$ubbcjs .= qq~function $splitinput[0](whatopen) {\n~;
					my ($split1, $split2) = split(/%text%/, $splitinput[3]);
							
						
						if ($splitinput[18]) {	# url
							$ubbcjs .= qq~\nAddSelTextUrl("$split1","$split2",whatopen);\n~; 	
						}
						else { 	$ubbcjs .= qq~AddSelText("$split1","$split2",whatopen);\n~; }
				
				}
				elsif (($splitinput[4] eq "buttondropdown") || ($splitinput[4] eq "dropdown")) {
					
					$ubbcjs .= qq~function $splitinput[0](add_$splitinput[0],whatopen) {\n~;

					if (!$splitinput[15] || $splitinput[15] eq "") {
						
						my ($split1, $split2) = split(/%text%/, $splitinput[3]);
						$split1 =~ s~%opt(\d+)%~"+add_$splitinput[0]+"~isg;
						
						if ($splitinput[18] == 1) {	$ubbcjs .= qq~AddSelTextUrl("$split1","$split2",whatopen);\n~; 	}
						else { 	$ubbcjs .= qq~AddSelText("$split1","$split2",whatopen);\n~; }
			
						if ($splitinput[4] eq "dropdown") {
							
							$ubbcjs .= qq~document.getElementById("select_$splitinput[0]").options[0].selected = true;\n~;
						}
						else {
							$ubbcjs .= qq~fiHideMenu('$splitinput[0]_'+whatopen)\n~;
						}
					}
				}
				else {
					$ubbcjs .= qq~function $splitinput[0](add_$splitinput[0],whatopen) {\n~;
				}

			}
			elsif ($splitinput[6] eq "optrow") {

				$ubbcjs .= qq~function $splitinput[0](whatopen) {\n~;
				my ($split1, $split2) = split(/%optrow%/, $splitinput[3]);
				my ($invisibl, $visibl) = split(/\/, $splitinput[9]);
				
				$visibl =~ s~%optrowcount%~"+a_$splitinput[0]+"~isg;

				$ubbcjs .= qq~var AddTxtZ = "";
	var txt = " ";
	var a_$splitinput[0] = 1;
	if (AddSelText("$split1","$split2",whatopen,"$splitinput[10]")) {
		return;
	}
	while ((txt != "") && (txt != null)){
	txt=window.prompt ("$visibl","$invisibl");
			a_$splitinput[0] = a_$splitinput[0] + 1;
		if (txt != "" && txt != null) {
		  AddTxtZ=AddTxtZ + "$splitinput[10]" + txt + "\\n";
		}
	  }
		AddTxt= "$split1" + AddTxtZ + "$split2";
		if ((AddTxt != "$split2$split2") && (AddTxt != "$split1$splitinput[10] null$split2")){ AddSelText("", AddTxt,whatopen); }~;
			
			}
			elsif ($splitinput[6] eq "colorbox") { 
				$ubbcjs .= qq~function $splitinput[0](add_$splitinput[0],whatopen) {\n~;
				
				if ($splitinput[4] eq "buttondropdown") {
					$ubbcjs .= qq~fiHideMenu('$splitinput[0]_'+whatopen)\n~;
				}

				my ($split1, $split2) = split(/%text%/, $splitinput[3]);
				$split1 =~ s~%opt(\d+)%~"+add_$splitinput[0]+"~isg;
				$ubbcjs .= qq~AddSelText("$split1","$split2",whatopen);\n~;
			}
			elsif ($splitinput[6] eq "popup") {
				
				unless ($splitinput[13]) {

					$ubbcjs .= qq~function $splitinput[0](whatopen) {\n~;

					if ($splitinput[4] eq "buttondropdown") {
						$ubbcjs .= qq~fiHideMenu('$splitinput[0]_'+whatopen)\n~;
					}

					
					my $printcontent = ""; 
					$printcontent .= qq~<HTML><HEAD><TITLE>$fb::txt{'js'}{'18'} - $splitinput[2]" + CSS + "~;
					if ($splitinput[18]) { $printcontent .= qq~" + CSS2 + "~; }
					$printcontent .= qq~" + CSS3 + "<script language='javascript'>\\n<!--\\nvar whatopen = '"+ whatopen +"';\\n~;
					$printcontent .= qq~function senddata_$splitinput[0]() {\\n~;

					my @popups = split(/\$/, $splitinput[9]);

					my $countbox = 1;

					foreach $_ (@popups) {
						my ($quest1, $box4) = split(/\*/, $_);
						if ($box4) {

							if ($splitinput[8]) {
								$printcontent .= qq~var add_$box4 = document.form_$splitinput[0].$box4.options[document.form_$splitinput[0].$box4.selectedIndex].value;\\n~;
							}
							else { 
							$printcontent .= qq~var add_opt$countbox =  document.form_$splitinput[0].opt$countbox.value;\\n~;
							}

							$countbox++;
						}
					}

					my ($split1, $split2) = split(/%text%/, $splitinput[3]);
					$split1 =~ s~%opt(\d+)%~\\"+add_opt$1+\\"~isg;

					# there must not be a right side -> e.g. [hr=opt1,opt2] ; here we have one [code=opt1]%text%[/code]
					if ($split2) { $split2 =~ s~%opt(\d+)%~\\"+add_opt$1+\\"~isg; }
					else { $split2 = ""; }

					if ($splitinput[18]) {
						$printcontent .= qq~AddSel2TextUrl(\\"$split1\\",\\"$split2\\");\\n~;
					}
					else {
						$printcontent .= qq~AddSel2Text(\\"$split1\\",\\"$split2\\");\\n~;
					}

					$printcontent .= qq~" + CONTENT6 + "<form onSubmit='return senddata_$splitinput[0]();' NAME='form_$splitinput[0]'>" + CONTENT5 + "~;

					$countbox = 1;
					my $countedb = 0;


					foreach (@popups) {
						
						my ($quest, $box2) = split(/\*/, $_);
						
						$printcontent .= qq~$quest:" + CONTENT4 + "\\n~;
						
						if ($box2) {

							if ($box2 =~ m~opt(\d+)~) {
								$countedb = $1;
								$countedb--;
							}

							if ($splitinput[8]) {
								
								my @formdata = split(/\$/, $splitinput[8]);
								
								my @formdata2 = split(/\*/, $formdata[$countedb]);
								$printcontent .= qq~<select name=$box2>\\n~;

								foreach (@formdata2) {
									my ($invisibl, $visibl) = split(/\/, $_);
									$printcontent .= qq~<option value='$invisibl'>$visibl</option>\\n~;
								}
								$printcontent .= qq~</select>~;
							}
							else {
								$printcontent .= qq~<input type=text name=opt$countbox value='$box2'>\\n~;
							}
							
							$printcontent .= qq~" + CONTENT3 + "~;
						}

						$countbox++;
					}
				
					$printcontent .= qq~<INPUT type='submit' name='go' value='$fb::txt{'gl'}{'65'}'>~;
					$ubbcjs .= qq~CONTENT = "$printcontent" + CONTENT2;\n$ubbccloseit\n~;


				}
				else {

					$ubbcjs .= qq~function $splitinput[0](add_$splitinput[0],whatopen) {\n~;
				
					if ($splitinput[4] eq "buttondropdown") {
						$ubbcjs .= qq~fiHideMenu('$splitinput[0]_'+whatopen)\n~;
					}


			
					my @actives = "";
					if ($splitinput[16]) { @actives = split(/\*/, $splitinput[16]); }
					my (@options, @options2,@options3);
					if ($splitinput[13]) { @options = split(/\$/, $splitinput[13]); }
					if ($splitinput[14]) { @options2 = split(/\/, $splitinput[14]); }
					if ($splitinput[15]) { @options3 = split(/\/, $splitinput[15]); }


					my @effdata = split(/\*/, $splitinput[8]);
					my $countf = 0;

					foreach (@effdata) {
						
						my $enable;

						if (($splitinput[16] ne "") && ($actives[$countf])) { $enable = 1; }
						elsif (($splitinput[16] ne "") && (!$actives[$countf])) { $enable = 0; }
						else { $enable = 1; }

						if ($enable == 1) {

							my ($invisibleff, $visibleff) = split(/\/, $_);

							$ubbcjs .= qq~if (add_$splitinput[0] == "$invisibleff") {\n~;

							if ($options[$countf]) {

								my @popups = split(/\*/, $options[$countf]);
								
								my $printcontent = qq~<HTML><HEAD><TITLE>$fb::txt{'js'}{'18'} - $splitinput[2] - $visibleff" + CSS + "~;
								
								if ($splitinput[18] == 1) { $printcontent .= qq~" + CSS2 + "~; }
								
								$printcontent .= qq~" + CSS3 + "<script language='javascript'>\\n<!--\\nvar whatopen = '"+ whatopen +"';\\nfunction senddata_$invisibleff() {\\n~;

								my $countbox = 1;
								
								foreach (@popups) {
									
									my ($quest1, $box4) = split(/\/, $_);

									if ($box4) {

										if ($options2[$countf] && ($options2[$countf] =~ m/opt/ig)) {
											$printcontent .= qq~var add_$box4 = document.form_$invisibleff.$box4.options[document.form_$invisibleff.$box4.selectedIndex].value;\\n~;
										}
										else { 
											$printcontent .= qq~var add_opt$countbox =  document.form_$invisibleff.opt$countbox.value;\\n~;
										}

										$countbox++;
									}
								}

								my ($split1, $split2) = split(/%text%/, $options3[$countf]);
								unless ($split1) { $split1 = ""; }
								unless ($split2) { $split2 = ""; }

								$split1 =~ s~%opt(\d+)%~\\"+add_opt$1+\\"~isg;
								$split2 =~ s~%opt(\d+)%~\\"+add_opt$1+\\"~isg;
								$printcontent .= qq~AddSel2Text(\\"$split1\\",\\"$split2\\");\\n" + CONTENT6 + "<form onSubmit='return senddata_$invisibleff();' NAME='form_$invisibleff'>" + CONTENT5 + "~;
								
								$countbox = 1;
								my $countedb = 0;

								foreach (@popups) {

									my ($quest, $box2) = split(/\/, $_);
									
									$printcontent .= qq~$quest:" + CONTENT4 + "\\n~;
									
									if ($box2) {

										if ($box2 =~ m~opt(\d+)~) {
											$countedb = $1;
											$countedb--;
										}

										if (length($options2[$countf]) > 5) {

											my @effformdata = split(/\$/, $options2[$countf]);
											my @effformdata2 = split(/\*/, $effformdata[$countedb]);

											$printcontent .= qq~<select name=$box2>\\n~;

											foreach (@effformdata2) {
												
												my ($invisibl, $visibl) = split(/\/, $_);
												$printcontent .= qq~<option value='$invisibl'>$visibl</option>\\n~;
											
											}
											$printcontent .= qq~</select>~;

										}
										else { 
											$printcontent .= qq~<input type=text name=opt$countbox value='$box2'>\\n~;

										}
										$printcontent .= qq~" + CONTENT3 + "~;
									}

									$countbox++;
								}
								
								$printcontent .= qq~<INPUT type='submit' name='go' value='$fb::txt{'gl'}{'65'}'>~;
								$ubbcjs .= qq~CONTENT = "$printcontent" + CONTENT2;\n$ubbccloseit\n~;
								
							}
							else {

								my ($split1, $split2) = split(/%text%/, $options3[$countf]);
								$split1 =~ s~%opt(\d+)%~"+add_$splitinput[0]+"~isg;
								if ($splitinput[18] == 1) {	$ubbcjs .= qq~AddSelTextUrl("$split1","$split2",whatopen);\n~; 	}
								else { 	$ubbcjs .= qq~AddSelText("$split1","$split2",whatopen);\n~; }
							}

							
							$ubbcjs .= qq~}\n~;

						}
							
						$countf++;

						
					}

				}

			}
			if ($splitinput[6] eq "help") { }
			else { $ubbcjs .= qq~}\n~; }
			
		}
	}
}

	$ubbcjs .= qq~\n//-->\n</script>~;
	return $ubbcjs;
}
1;